
/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class AttestationInfo extends NSObject {

	static alloc(): AttestationInfo; // inherited from NSObject

	static new(): AttestationInfo; // inherited from NSObject

	certificationDeclaration: NSData;

	challenge: NSData;

	dac: NSData;

	elements: NSData;

	elementsSignature: NSData;

	firmwareInfo: NSData;

	nonce: NSData;

	pai: NSData;

	constructor(o: { challenge: NSData; nonce: NSData; elements: NSData; elementsSignature: NSData; dac: NSData; pai: NSData; certificationDeclaration: NSData; firmwareInfo: NSData; });

	initWithChallengeNonceElementsElementsSignatureDacPaiCertificationDeclarationFirmwareInfo(challenge: NSData, nonce: NSData, elements: NSData, elementsSignature: NSData, dac: NSData, pai: NSData, certificationDeclaration: NSData, firmwareInfo: NSData): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class CSRInfo extends NSObject {

	static alloc(): CSRInfo; // inherited from NSObject

	static new(): CSRInfo; // inherited from NSObject

	csr: NSData;

	elements: NSData;

	elementsSignature: NSData;

	nonce: NSData;

	constructor(o: { nonce: NSData; elements: NSData; elementsSignature: NSData; csr: NSData; });

	initWithNonceElementsElementsSignatureCsr(nonce: NSData, elements: NSData, elementsSignature: NSData, csr: NSData): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRAccessControlAuthMode {

	PASE = 1,

	CASE = 2,

	Group = 3
}

/**
 * @since 16.1
 */
declare const enum MTRAccessControlChangeType {

	Changed = 0,

	Added = 1,

	Removed = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRAccessControlClusterAccessControlEntry extends MTRAccessControlClusterAccessControlEntryStruct {

	static alloc(): MTRAccessControlClusterAccessControlEntry; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlEntry; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare class MTRAccessControlClusterAccessControlEntryChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRAccessControlClusterAccessControlEntryChangedEvent; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlEntryChangedEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	adminNodeID: number;

	/**
	 * @since 16.1
	 */
	adminPasscodeID: number;

	/**
	 * @since 16.1
	 */
	changeType: number;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	latestValue: MTRAccessControlClusterAccessControlEntryStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRAccessControlClusterAccessControlEntryStruct extends NSObject implements NSCopying {

	static alloc(): MTRAccessControlClusterAccessControlEntryStruct; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlEntryStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	authMode: number;

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	/**
	 * @since 16.4
	 */
	privilege: number;

	/**
	 * @since 16.4
	 */
	subjects: NSArray<any>;

	/**
	 * @since 16.4
	 */
	targets: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAccessControlClusterAccessControlExtensionChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRAccessControlClusterAccessControlExtensionChangedEvent; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlExtensionChangedEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	adminNodeID: number;

	/**
	 * @since 16.1
	 */
	adminPasscodeID: number;

	/**
	 * @since 16.1
	 */
	changeType: number;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	latestValue: MTRAccessControlClusterAccessControlExtensionStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRAccessControlClusterAccessControlExtensionStruct extends NSObject implements NSCopying {

	static alloc(): MTRAccessControlClusterAccessControlExtensionStruct; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlExtensionStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	data: NSData;

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare class MTRAccessControlClusterAccessControlTargetStruct extends NSObject implements NSCopying {

	static alloc(): MTRAccessControlClusterAccessControlTargetStruct; // inherited from NSObject

	static new(): MTRAccessControlClusterAccessControlTargetStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	cluster: number;

	/**
	 * @since 17.0
	 */
	deviceType: number;

	/**
	 * @since 17.0
	 */
	endpoint: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRAccessControlClusterExtensionEntry extends MTRAccessControlClusterAccessControlExtensionStruct {

	static alloc(): MTRAccessControlClusterExtensionEntry; // inherited from NSObject

	static new(): MTRAccessControlClusterExtensionEntry; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRAccessControlClusterTarget extends MTRAccessControlClusterAccessControlTargetStruct {

	static alloc(): MTRAccessControlClusterTarget; // inherited from NSObject

	static new(): MTRAccessControlClusterTarget; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare const enum MTRAccessControlEntryAuthMode {

	PASE = 1,

	CASE = 2,

	Group = 3
}

/**
 * @since 16.4
 */
declare const enum MTRAccessControlEntryPrivilege {

	View = 1,

	ProxyView = 2,

	Operate = 3,

	Manage = 4,

	Administer = 5
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRAccessControlPrivilege {

	View = 1,

	ProxyView = 2,

	Operate = 3,

	Manage = 4,

	Administer = 5
}

/**
 * @since 17.6
 */
declare class MTRAccessGrant extends NSObject implements NSCopying {

	static accessGrantForAllNodesWithPrivilege(privilege: MTRAccessControlEntryPrivilege): MTRAccessGrant;

	static accessGrantForCASEAuthenticatedTagPrivilege(caseAuthenticatedTag: number, privilege: MTRAccessControlEntryPrivilege): MTRAccessGrant;

	static accessGrantForGroupIDPrivilege(groupID: number, privilege: MTRAccessControlEntryPrivilege): MTRAccessGrant;

	static accessGrantForNodeIDPrivilege(nodeID: number, privilege: MTRAccessControlEntryPrivilege): MTRAccessGrant;

	static alloc(): MTRAccessGrant; // inherited from NSObject

	static new(): MTRAccessGrant; // inherited from NSObject

	readonly authenticationMode: MTRAccessControlEntryAuthMode;

	readonly grantedPrivilege: MTRAccessControlEntryPrivilege;

	readonly subjectID: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAccountLoginClusterGetSetupPINParams extends NSObject implements NSCopying {

	static alloc(): MTRAccountLoginClusterGetSetupPINParams; // inherited from NSObject

	static new(): MTRAccountLoginClusterGetSetupPINParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	tempAccountIdentifier: string;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAccountLoginClusterGetSetupPINResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRAccountLoginClusterGetSetupPINResponseParams; // inherited from NSObject

	static new(): MTRAccountLoginClusterGetSetupPINResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	setupPIN: string;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRAccountLoginClusterLoginParams extends NSObject implements NSCopying {

	static alloc(): MTRAccountLoginClusterLoginParams; // inherited from NSObject

	static new(): MTRAccountLoginClusterLoginParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	setupPIN: string;

	/**
	 * @since 16.1
	 */
	tempAccountIdentifier: string;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAccountLoginClusterLogoutParams extends NSObject implements NSCopying {

	static alloc(): MTRAccountLoginClusterLogoutParams; // inherited from NSObject

	static new(): MTRAccountLoginClusterLogoutParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRActionsActionError {

	Unknown = 0,

	Interrupted = 1
}

/**
 * @since 16.1
 */
declare const enum MTRActionsActionState {

	Inactive = 0,

	Active = 1,

	Paused = 2,

	Disabled = 3
}

/**
 * @since 16.1
 */
declare const enum MTRActionsActionType {

	Other = 0,

	Scene = 1,

	Sequence = 2,

	Automation = 3,

	Exception = 4,

	Notification = 5,

	Alarm = 6
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterActionFailedEvent extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterActionFailedEvent; // inherited from NSObject

	static new(): MTRActionsClusterActionFailedEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	error: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	/**
	 * @since 16.1
	 */
	newState: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterActionStruct extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterActionStruct; // inherited from NSObject

	static new(): MTRActionsClusterActionStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	endpointListID: number;

	/**
	 * @since 16.1
	 */
	name: string;

	/**
	 * @since 16.1
	 */
	state: number;

	/**
	 * @since 16.1
	 */
	supportedCommands: number;

	/**
	 * @since 16.1
	 */
	type: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterDisableActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterDisableActionParams; // inherited from NSObject

	static new(): MTRActionsClusterDisableActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterDisableActionWithDurationParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterDisableActionWithDurationParams; // inherited from NSObject

	static new(): MTRActionsClusterDisableActionWithDurationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	duration: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterEnableActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterEnableActionParams; // inherited from NSObject

	static new(): MTRActionsClusterEnableActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterEnableActionWithDurationParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterEnableActionWithDurationParams; // inherited from NSObject

	static new(): MTRActionsClusterEnableActionWithDurationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	duration: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterEndpointListStruct extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterEndpointListStruct; // inherited from NSObject

	static new(): MTRActionsClusterEndpointListStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	endpointListID: number;

	/**
	 * @since 16.1
	 */
	endpoints: NSArray<any>;

	/**
	 * @since 16.1
	 */
	name: string;

	/**
	 * @since 16.1
	 */
	type: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterInstantActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterInstantActionParams; // inherited from NSObject

	static new(): MTRActionsClusterInstantActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterInstantActionWithTransitionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterInstantActionWithTransitionParams; // inherited from NSObject

	static new(): MTRActionsClusterInstantActionWithTransitionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterPauseActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterPauseActionParams; // inherited from NSObject

	static new(): MTRActionsClusterPauseActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterPauseActionWithDurationParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterPauseActionWithDurationParams; // inherited from NSObject

	static new(): MTRActionsClusterPauseActionWithDurationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	duration: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterResumeActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterResumeActionParams; // inherited from NSObject

	static new(): MTRActionsClusterResumeActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterStartActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterStartActionParams; // inherited from NSObject

	static new(): MTRActionsClusterStartActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterStartActionWithDurationParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterStartActionWithDurationParams; // inherited from NSObject

	static new(): MTRActionsClusterStartActionWithDurationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	duration: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterStateChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterStateChangedEvent; // inherited from NSObject

	static new(): MTRActionsClusterStateChangedEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	/**
	 * @since 16.1
	 */
	newState: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRActionsClusterStopActionParams extends NSObject implements NSCopying {

	static alloc(): MTRActionsClusterStopActionParams; // inherited from NSObject

	static new(): MTRActionsClusterStopActionParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	actionID: number;

	/**
	 * @since 16.1
	 */
	invokeID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRActionsCommandBits {

	InstantAction = 1,

	InstantActionWithTransition = 2,

	StartAction = 4,

	StartActionWithDuration = 8,

	StopAction = 16,

	PauseAction = 32,

	PauseActionWithDuration = 64,

	ResumeAction = 128,

	EnableAction = 256,

	EnableActionWithDuration = 512,

	DisableAction = 1024,

	DisableActionWithDuration = 2048
}

/**
 * @since 16.1
 */
declare const enum MTRActionsEndpointListType {

	Other = 0,

	Room = 1,

	Zone = 2
}

/**
 * @since 17.6
 */
declare const enum MTRActivatedCarbonFilterMonitoringChangeIndication {

	OK = 0,

	Warning = 1,

	Critical = 2
}

/**
 * @since 17.6
 */
declare class MTRActivatedCarbonFilterMonitoringClusterReplacementProductStruct extends NSObject implements NSCopying {

	static alloc(): MTRActivatedCarbonFilterMonitoringClusterReplacementProductStruct; // inherited from NSObject

	static new(): MTRActivatedCarbonFilterMonitoringClusterReplacementProductStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	productIdentifierType: number;

	/**
	 * @since 17.6
	 */
	productIdentifierValue: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRActivatedCarbonFilterMonitoringClusterResetConditionParams extends NSObject implements NSCopying {

	static alloc(): MTRActivatedCarbonFilterMonitoringClusterResetConditionParams; // inherited from NSObject

	static new(): MTRActivatedCarbonFilterMonitoringClusterResetConditionParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRActivatedCarbonFilterMonitoringDegradationDirection {

	Up = 0,

	Down = 1
}

/**
 * @since 17.6
 */
declare const enum MTRActivatedCarbonFilterMonitoringFeature {

	Condition = 1,

	Warning = 2,

	ReplacementProductList = 4
}

/**
 * @since 17.6
 */
declare const enum MTRActivatedCarbonFilterMonitoringProductIdentifierType {

	UPC = 0,

	GTIN8 = 1,

	EAN = 2,

	GTIN14 = 3,

	OEM = 4
}

/**
 * @since 16.1
 */
declare class MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams extends NSObject implements NSCopying {

	static alloc(): MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams; // inherited from NSObject

	static new(): MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	commissioningTimeout: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAdministratorCommissioningClusterOpenCommissioningWindowParams extends NSObject implements NSCopying {

	static alloc(): MTRAdministratorCommissioningClusterOpenCommissioningWindowParams; // inherited from NSObject

	static new(): MTRAdministratorCommissioningClusterOpenCommissioningWindowParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	commissioningTimeout: number;

	/**
	 * @since 16.1
	 */
	discriminator: number;

	/**
	 * @since 16.1
	 */
	iterations: number;

	/**
	 * @since 16.4
	 */
	pakePasscodeVerifier: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pakeVerifier: NSData;

	/**
	 * @since 16.1
	 */
	salt: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAdministratorCommissioningClusterRevokeCommissioningParams extends NSObject implements NSCopying {

	static alloc(): MTRAdministratorCommissioningClusterRevokeCommissioningParams; // inherited from NSObject

	static new(): MTRAdministratorCommissioningClusterRevokeCommissioningParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRAdministratorCommissioningCommissioningWindowStatus {

	WindowNotOpen = 0,

	EnhancedWindowOpen = 1,

	BasicWindowOpen = 2
}

/**
 * @since 17.4
 */
declare const enum MTRAdministratorCommissioningFeature {

	Basic = 1
}

/**
 * @since 16.1
 */
declare const enum MTRAdministratorCommissioningStatusCode {

	Busy = 2,

	PAKEParameterError = 3,

	WindowNotOpen = 4
}

/**
 * @since 17.6
 */
declare const enum MTRAirQuality {

	Unknown = 0,

	Good = 1,

	Fair = 2,

	Moderate = 3,

	Poor = 4,

	VeryPoor = 5,

	ExtremelyPoor = 6
}

/**
 * @since 17.6
 */
declare const enum MTRAirQualityFeature {

	Fair = 1,

	Moderate = 2,

	VeryPoor = 4,

	ExtremelyPoor = 8
}

/**
 * @since 16.1
 */
declare const enum MTRApplicationBasicApplicationStatus {

	Stopped = 0,

	ActiveVisibleFocus = 1,

	ActiveHidden = 2,

	ActiveVisibleNotFocus = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRApplicationBasicClusterApplicationBasicApplication extends MTRApplicationBasicClusterApplicationStruct {

	static alloc(): MTRApplicationBasicClusterApplicationBasicApplication; // inherited from NSObject

	static new(): MTRApplicationBasicClusterApplicationBasicApplication; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRApplicationBasicClusterApplicationStruct extends NSObject implements NSCopying {

	static alloc(): MTRApplicationBasicClusterApplicationStruct; // inherited from NSObject

	static new(): MTRApplicationBasicClusterApplicationStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	applicationID: string;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	applicationId: string;

	/**
	 * @since 16.4
	 */
	catalogVendorID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	catalogVendorId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRApplicationLauncherClusterApplication extends MTRApplicationLauncherClusterApplicationStruct {

	static alloc(): MTRApplicationLauncherClusterApplication; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterApplication; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRApplicationLauncherClusterApplicationEP extends MTRApplicationLauncherClusterApplicationEPStruct {

	static alloc(): MTRApplicationLauncherClusterApplicationEP; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterApplicationEP; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRApplicationLauncherClusterApplicationEPStruct extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterApplicationEPStruct; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterApplicationEPStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	application: MTRApplicationLauncherClusterApplicationStruct;

	/**
	 * @since 16.4
	 */
	endpoint: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRApplicationLauncherClusterApplicationStruct extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterApplicationStruct; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterApplicationStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	applicationID: string;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	applicationId: string;

	/**
	 * @since 16.4
	 */
	catalogVendorID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	catalogVendorId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRApplicationLauncherClusterHideAppParams extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterHideAppParams; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterHideAppParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	application: MTRApplicationLauncherClusterApplicationStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRApplicationLauncherClusterLaunchAppParams extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterLaunchAppParams; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterLaunchAppParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	application: MTRApplicationLauncherClusterApplicationStruct;

	/**
	 * @since 16.1
	 */
	data: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRApplicationLauncherClusterLauncherResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterLauncherResponseParams; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterLauncherResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	data: NSData;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRApplicationLauncherClusterStopAppParams extends NSObject implements NSCopying {

	static alloc(): MTRApplicationLauncherClusterStopAppParams; // inherited from NSObject

	static new(): MTRApplicationLauncherClusterStopAppParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	application: MTRApplicationLauncherClusterApplicationStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRApplicationLauncherFeature {

	ApplicationPlatform = 1
}

/**
 * @since 16.1
 */
declare const enum MTRApplicationLauncherStatus {

	Success = 0,

	AppNotAvailable = 1,

	SystemBusy = 2,

	PendingUserApproval = 3,

	Downloading = 4,

	Installing = 5
}

/**
 * @since 16.1
 */
declare var MTRArrayValueType: string;

/**
 * @since 16.1
 * @deprecated 17.2
 */
declare class MTRAsyncCallbackQueueWorkItem extends NSObject {

	static alloc(): MTRAsyncCallbackQueueWorkItem; // inherited from NSObject

	static new(): MTRAsyncCallbackQueueWorkItem; // inherited from NSObject

	cancelHandler: () => void;

	readyHandler: (p1: any, p2: number) => void;

	constructor(o: { queue: NSObject & OS_dispatch_queue; });

	endWork(): void;

	initWithQueue(queue: NSObject & OS_dispatch_queue): this;

	retryWork(): void;
}

/**
 * @since 16.1
 * @deprecated 17.2
 */
declare class MTRAsyncCallbackWorkQueue extends NSObject {

	static alloc(): MTRAsyncCallbackWorkQueue; // inherited from NSObject

	static new(): MTRAsyncCallbackWorkQueue; // inherited from NSObject

	constructor(o: { context: any; queue: NSObject & OS_dispatch_queue; });

	enqueueWorkItem(item: MTRAsyncCallbackQueueWorkItem): void;

	initWithContextQueue(context: any, queue: NSObject & OS_dispatch_queue): this;

	invalidate(): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRAttributeCacheContainer extends NSObject {

	static alloc(): MTRAttributeCacheContainer; // inherited from NSObject

	static new(): MTRAttributeCacheContainer; // inherited from NSObject

	readAttributeWithEndpointIdClusterIdAttributeIdClientQueueCompletion(endpointId: number, clusterId: number, attributeId: number, clientQueue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;
}

declare const enum MTRAttributeIDType {

	ClusterGlobalAttributeGeneratedCommandListID = 65528,

	ClusterGlobalAttributeAcceptedCommandListID = 65529,

	ClusterGlobalAttributeAttributeListID = 65531,

	ClusterGlobalAttributeFeatureMapID = 65532,

	ClusterGlobalAttributeClusterRevisionID = 65533,

	AttributeIDTypeGlobalAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeGlobalAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeGlobalAttributeEventListID = 65530,

	AttributeIDTypeGlobalAttributeAttributeListID = 65531,

	AttributeIDTypeGlobalAttributeFeatureMapID = 65532,

	AttributeIDTypeGlobalAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAppleDeviceInformationAttributeSupportsTapToUnlockID = 0,

	AttributeIDTypeClusterAppleDeviceInformationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAppleDeviceInformationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAppleDeviceInformationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAppleDeviceInformationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAppleDeviceInformationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAppleLockClusterAttributeIntentDetectionID = 0,

	AttributeIDTypeClusterAppleLockClusterAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAppleLockClusterAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAppleLockClusterAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAppleLockClusterAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAppleLockClusterAttributeClusterRevisionID = 65533,

	ClusterIdentifyAttributeIdentifyTimeID = 0,

	ClusterIdentifyAttributeIdentifyTypeID = 1,

	ClusterIdentifyAttributeGeneratedCommandListID = 65528,

	ClusterIdentifyAttributeAcceptedCommandListID = 65529,

	ClusterIdentifyAttributeAttributeListID = 65531,

	ClusterIdentifyAttributeFeatureMapID = 65532,

	ClusterIdentifyAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterIdentifyAttributeIdentifyTimeID = 0,

	AttributeIDTypeClusterIdentifyAttributeIdentifyTypeID = 1,

	AttributeIDTypeClusterIdentifyAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterIdentifyAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterIdentifyAttributeEventListID = 65530,

	AttributeIDTypeClusterIdentifyAttributeAttributeListID = 65531,

	AttributeIDTypeClusterIdentifyAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterIdentifyAttributeClusterRevisionID = 65533,

	ClusterGroupsAttributeNameSupportID = 0,

	ClusterGroupsAttributeGeneratedCommandListID = 65528,

	ClusterGroupsAttributeAcceptedCommandListID = 65529,

	ClusterGroupsAttributeAttributeListID = 65531,

	ClusterGroupsAttributeFeatureMapID = 65532,

	ClusterGroupsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterGroupsAttributeNameSupportID = 0,

	AttributeIDTypeClusterGroupsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterGroupsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterGroupsAttributeEventListID = 65530,

	AttributeIDTypeClusterGroupsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterGroupsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterGroupsAttributeClusterRevisionID = 65533,

	ClusterOnOffAttributeOnOffID = 0,

	ClusterOnOffAttributeGlobalSceneControlID = 16384,

	ClusterOnOffAttributeOnTimeID = 16385,

	ClusterOnOffAttributeOffWaitTimeID = 16386,

	ClusterOnOffAttributeStartUpOnOffID = 16387,

	ClusterOnOffAttributeGeneratedCommandListID = 65528,

	ClusterOnOffAttributeAcceptedCommandListID = 65529,

	ClusterOnOffAttributeAttributeListID = 65531,

	ClusterOnOffAttributeFeatureMapID = 65532,

	ClusterOnOffAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOnOffAttributeOnOffID = 0,

	AttributeIDTypeClusterOnOffAttributeGlobalSceneControlID = 16384,

	AttributeIDTypeClusterOnOffAttributeOnTimeID = 16385,

	AttributeIDTypeClusterOnOffAttributeOffWaitTimeID = 16386,

	AttributeIDTypeClusterOnOffAttributeStartUpOnOffID = 16387,

	AttributeIDTypeClusterOnOffAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOnOffAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOnOffAttributeEventListID = 65530,

	AttributeIDTypeClusterOnOffAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOnOffAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOnOffAttributeClusterRevisionID = 65533,

	ClusterLevelControlAttributeCurrentLevelID = 0,

	ClusterLevelControlAttributeRemainingTimeID = 1,

	ClusterLevelControlAttributeMinLevelID = 2,

	ClusterLevelControlAttributeMaxLevelID = 3,

	ClusterLevelControlAttributeCurrentFrequencyID = 4,

	ClusterLevelControlAttributeMinFrequencyID = 5,

	ClusterLevelControlAttributeMaxFrequencyID = 6,

	ClusterLevelControlAttributeOptionsID = 15,

	ClusterLevelControlAttributeOnOffTransitionTimeID = 16,

	ClusterLevelControlAttributeOnLevelID = 17,

	ClusterLevelControlAttributeOnTransitionTimeID = 18,

	ClusterLevelControlAttributeOffTransitionTimeID = 19,

	ClusterLevelControlAttributeDefaultMoveRateID = 20,

	ClusterLevelControlAttributeStartUpCurrentLevelID = 16384,

	ClusterLevelControlAttributeGeneratedCommandListID = 65528,

	ClusterLevelControlAttributeAcceptedCommandListID = 65529,

	ClusterLevelControlAttributeAttributeListID = 65531,

	ClusterLevelControlAttributeFeatureMapID = 65532,

	ClusterLevelControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLevelControlAttributeCurrentLevelID = 0,

	AttributeIDTypeClusterLevelControlAttributeRemainingTimeID = 1,

	AttributeIDTypeClusterLevelControlAttributeMinLevelID = 2,

	AttributeIDTypeClusterLevelControlAttributeMaxLevelID = 3,

	AttributeIDTypeClusterLevelControlAttributeCurrentFrequencyID = 4,

	AttributeIDTypeClusterLevelControlAttributeMinFrequencyID = 5,

	AttributeIDTypeClusterLevelControlAttributeMaxFrequencyID = 6,

	AttributeIDTypeClusterLevelControlAttributeOptionsID = 15,

	AttributeIDTypeClusterLevelControlAttributeOnOffTransitionTimeID = 16,

	AttributeIDTypeClusterLevelControlAttributeOnLevelID = 17,

	AttributeIDTypeClusterLevelControlAttributeOnTransitionTimeID = 18,

	AttributeIDTypeClusterLevelControlAttributeOffTransitionTimeID = 19,

	AttributeIDTypeClusterLevelControlAttributeDefaultMoveRateID = 20,

	AttributeIDTypeClusterLevelControlAttributeStartUpCurrentLevelID = 16384,

	AttributeIDTypeClusterLevelControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLevelControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLevelControlAttributeEventListID = 65530,

	AttributeIDTypeClusterLevelControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLevelControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLevelControlAttributeClusterRevisionID = 65533,

	ClusterPulseWidthModulationAttributeGeneratedCommandListID = 65528,

	ClusterPulseWidthModulationAttributeAcceptedCommandListID = 65529,

	ClusterPulseWidthModulationAttributeAttributeListID = 65531,

	ClusterPulseWidthModulationAttributeFeatureMapID = 65532,

	ClusterPulseWidthModulationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPulseWidthModulationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPulseWidthModulationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPulseWidthModulationAttributeEventListID = 65530,

	AttributeIDTypeClusterPulseWidthModulationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPulseWidthModulationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPulseWidthModulationAttributeClusterRevisionID = 65533,

	ClusterDescriptorAttributeDeviceTypeListID = 0,

	ClusterDescriptorAttributeDeviceListID = 0,

	ClusterDescriptorAttributeServerListID = 1,

	ClusterDescriptorAttributeClientListID = 2,

	ClusterDescriptorAttributePartsListID = 3,

	ClusterDescriptorAttributeGeneratedCommandListID = 65528,

	ClusterDescriptorAttributeAcceptedCommandListID = 65529,

	ClusterDescriptorAttributeAttributeListID = 65531,

	ClusterDescriptorAttributeFeatureMapID = 65532,

	ClusterDescriptorAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDescriptorAttributeDeviceTypeListID = 0,

	AttributeIDTypeClusterDescriptorAttributeServerListID = 1,

	AttributeIDTypeClusterDescriptorAttributeClientListID = 2,

	AttributeIDTypeClusterDescriptorAttributePartsListID = 3,

	AttributeIDTypeClusterDescriptorAttributeTagListID = 4,

	AttributeIDTypeClusterDescriptorAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDescriptorAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDescriptorAttributeEventListID = 65530,

	AttributeIDTypeClusterDescriptorAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDescriptorAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDescriptorAttributeClusterRevisionID = 65533,

	ClusterBindingAttributeBindingID = 0,

	ClusterBindingAttributeGeneratedCommandListID = 65528,

	ClusterBindingAttributeAcceptedCommandListID = 65529,

	ClusterBindingAttributeAttributeListID = 65531,

	ClusterBindingAttributeFeatureMapID = 65532,

	ClusterBindingAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBindingAttributeBindingID = 0,

	AttributeIDTypeClusterBindingAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBindingAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBindingAttributeEventListID = 65530,

	AttributeIDTypeClusterBindingAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBindingAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBindingAttributeClusterRevisionID = 65533,

	ClusterAccessControlAttributeAclID = 0,

	ClusterAccessControlAttributeExtensionID = 1,

	ClusterAccessControlAttributeSubjectsPerAccessControlEntryID = 2,

	ClusterAccessControlAttributeTargetsPerAccessControlEntryID = 3,

	ClusterAccessControlAttributeAccessControlEntriesPerFabricID = 4,

	ClusterAccessControlAttributeGeneratedCommandListID = 65528,

	ClusterAccessControlAttributeAcceptedCommandListID = 65529,

	ClusterAccessControlAttributeAttributeListID = 65531,

	ClusterAccessControlAttributeFeatureMapID = 65532,

	ClusterAccessControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAccessControlAttributeACLID = 0,

	AttributeIDTypeClusterAccessControlAttributeExtensionID = 1,

	AttributeIDTypeClusterAccessControlAttributeSubjectsPerAccessControlEntryID = 2,

	AttributeIDTypeClusterAccessControlAttributeTargetsPerAccessControlEntryID = 3,

	AttributeIDTypeClusterAccessControlAttributeAccessControlEntriesPerFabricID = 4,

	AttributeIDTypeClusterAccessControlAttributeCommissioningARLID = 5,

	AttributeIDTypeClusterAccessControlAttributeARLID = 6,

	AttributeIDTypeClusterAccessControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAccessControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAccessControlAttributeEventListID = 65530,

	AttributeIDTypeClusterAccessControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAccessControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAccessControlAttributeClusterRevisionID = 65533,

	ClusterActionsAttributeActionListID = 0,

	ClusterActionsAttributeEndpointListsID = 1,

	ClusterActionsAttributeSetupURLID = 2,

	ClusterActionsAttributeGeneratedCommandListID = 65528,

	ClusterActionsAttributeAcceptedCommandListID = 65529,

	ClusterActionsAttributeAttributeListID = 65531,

	ClusterActionsAttributeFeatureMapID = 65532,

	ClusterActionsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterActionsAttributeActionListID = 0,

	AttributeIDTypeClusterActionsAttributeEndpointListsID = 1,

	AttributeIDTypeClusterActionsAttributeSetupURLID = 2,

	AttributeIDTypeClusterActionsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterActionsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterActionsAttributeEventListID = 65530,

	AttributeIDTypeClusterActionsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterActionsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterActionsAttributeClusterRevisionID = 65533,

	ClusterBasicAttributeDataModelRevisionID = 0,

	ClusterBasicAttributeVendorNameID = 1,

	ClusterBasicAttributeVendorIDID = 2,

	ClusterBasicAttributeProductNameID = 3,

	ClusterBasicAttributeProductIDID = 4,

	ClusterBasicAttributeNodeLabelID = 5,

	ClusterBasicAttributeLocationID = 6,

	ClusterBasicAttributeHardwareVersionID = 7,

	ClusterBasicAttributeHardwareVersionStringID = 8,

	ClusterBasicAttributeSoftwareVersionID = 9,

	ClusterBasicAttributeSoftwareVersionStringID = 10,

	ClusterBasicAttributeManufacturingDateID = 11,

	ClusterBasicAttributePartNumberID = 12,

	ClusterBasicAttributeProductURLID = 13,

	ClusterBasicAttributeProductLabelID = 14,

	ClusterBasicAttributeSerialNumberID = 15,

	ClusterBasicAttributeLocalConfigDisabledID = 16,

	ClusterBasicAttributeReachableID = 17,

	ClusterBasicAttributeUniqueIDID = 18,

	ClusterBasicAttributeCapabilityMinimaID = 19,

	ClusterBasicAttributeGeneratedCommandListID = 65528,

	ClusterBasicAttributeAcceptedCommandListID = 65529,

	ClusterBasicAttributeAttributeListID = 65531,

	ClusterBasicAttributeFeatureMapID = 65532,

	ClusterBasicAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBasicInformationAttributeDataModelRevisionID = 0,

	AttributeIDTypeClusterBasicInformationAttributeVendorNameID = 1,

	AttributeIDTypeClusterBasicInformationAttributeVendorIDID = 2,

	AttributeIDTypeClusterBasicInformationAttributeProductNameID = 3,

	AttributeIDTypeClusterBasicInformationAttributeProductIDID = 4,

	AttributeIDTypeClusterBasicInformationAttributeNodeLabelID = 5,

	AttributeIDTypeClusterBasicInformationAttributeLocationID = 6,

	AttributeIDTypeClusterBasicInformationAttributeHardwareVersionID = 7,

	AttributeIDTypeClusterBasicInformationAttributeHardwareVersionStringID = 8,

	AttributeIDTypeClusterBasicInformationAttributeSoftwareVersionID = 9,

	AttributeIDTypeClusterBasicInformationAttributeSoftwareVersionStringID = 10,

	AttributeIDTypeClusterBasicInformationAttributeManufacturingDateID = 11,

	AttributeIDTypeClusterBasicInformationAttributePartNumberID = 12,

	AttributeIDTypeClusterBasicInformationAttributeProductURLID = 13,

	AttributeIDTypeClusterBasicInformationAttributeProductLabelID = 14,

	AttributeIDTypeClusterBasicInformationAttributeSerialNumberID = 15,

	AttributeIDTypeClusterBasicInformationAttributeLocalConfigDisabledID = 16,

	AttributeIDTypeClusterBasicInformationAttributeReachableID = 17,

	AttributeIDTypeClusterBasicInformationAttributeUniqueIDID = 18,

	AttributeIDTypeClusterBasicInformationAttributeCapabilityMinimaID = 19,

	AttributeIDTypeClusterBasicInformationAttributeProductAppearanceID = 20,

	AttributeIDTypeClusterBasicInformationAttributeSpecificationVersionID = 21,

	AttributeIDTypeClusterBasicInformationAttributeMaxPathsPerInvokeID = 22,

	AttributeIDTypeClusterBasicInformationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBasicInformationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBasicInformationAttributeEventListID = 65530,

	AttributeIDTypeClusterBasicInformationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBasicInformationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBasicInformationAttributeClusterRevisionID = 65533,

	ClusterOtaSoftwareUpdateProviderAttributeGeneratedCommandListID = 65528,

	ClusterOtaSoftwareUpdateProviderAttributeAcceptedCommandListID = 65529,

	ClusterOtaSoftwareUpdateProviderAttributeAttributeListID = 65531,

	ClusterOtaSoftwareUpdateProviderAttributeFeatureMapID = 65532,

	ClusterOtaSoftwareUpdateProviderAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeEventListID = 65530,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOTASoftwareUpdateProviderAttributeClusterRevisionID = 65533,

	ClusterOtaSoftwareUpdateRequestorAttributeDefaultOtaProvidersID = 0,

	ClusterOtaSoftwareUpdateRequestorAttributeUpdatePossibleID = 1,

	ClusterOtaSoftwareUpdateRequestorAttributeUpdateStateID = 2,

	ClusterOtaSoftwareUpdateRequestorAttributeUpdateStateProgressID = 3,

	ClusterOtaSoftwareUpdateRequestorAttributeGeneratedCommandListID = 65528,

	ClusterOtaSoftwareUpdateRequestorAttributeAcceptedCommandListID = 65529,

	ClusterOtaSoftwareUpdateRequestorAttributeAttributeListID = 65531,

	ClusterOtaSoftwareUpdateRequestorAttributeFeatureMapID = 65532,

	ClusterOtaSoftwareUpdateRequestorAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeDefaultOTAProvidersID = 0,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeUpdatePossibleID = 1,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeUpdateStateID = 2,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeUpdateStateProgressID = 3,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeEventListID = 65530,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOTASoftwareUpdateRequestorAttributeClusterRevisionID = 65533,

	ClusterLocalizationConfigurationAttributeActiveLocaleID = 0,

	ClusterLocalizationConfigurationAttributeSupportedLocalesID = 1,

	ClusterLocalizationConfigurationAttributeGeneratedCommandListID = 65528,

	ClusterLocalizationConfigurationAttributeAcceptedCommandListID = 65529,

	ClusterLocalizationConfigurationAttributeAttributeListID = 65531,

	ClusterLocalizationConfigurationAttributeFeatureMapID = 65532,

	ClusterLocalizationConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLocalizationConfigurationAttributeActiveLocaleID = 0,

	AttributeIDTypeClusterLocalizationConfigurationAttributeSupportedLocalesID = 1,

	AttributeIDTypeClusterLocalizationConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLocalizationConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLocalizationConfigurationAttributeEventListID = 65530,

	AttributeIDTypeClusterLocalizationConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLocalizationConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLocalizationConfigurationAttributeClusterRevisionID = 65533,

	ClusterTimeFormatLocalizationAttributeHourFormatID = 0,

	ClusterTimeFormatLocalizationAttributeActiveCalendarTypeID = 1,

	ClusterTimeFormatLocalizationAttributeSupportedCalendarTypesID = 2,

	ClusterTimeFormatLocalizationAttributeGeneratedCommandListID = 65528,

	ClusterTimeFormatLocalizationAttributeAcceptedCommandListID = 65529,

	ClusterTimeFormatLocalizationAttributeAttributeListID = 65531,

	ClusterTimeFormatLocalizationAttributeFeatureMapID = 65532,

	ClusterTimeFormatLocalizationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeHourFormatID = 0,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeActiveCalendarTypeID = 1,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeSupportedCalendarTypesID = 2,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeEventListID = 65530,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTimeFormatLocalizationAttributeClusterRevisionID = 65533,

	ClusterUnitLocalizationAttributeTemperatureUnitID = 0,

	ClusterUnitLocalizationAttributeGeneratedCommandListID = 65528,

	ClusterUnitLocalizationAttributeAcceptedCommandListID = 65529,

	ClusterUnitLocalizationAttributeAttributeListID = 65531,

	ClusterUnitLocalizationAttributeFeatureMapID = 65532,

	ClusterUnitLocalizationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterUnitLocalizationAttributeTemperatureUnitID = 0,

	AttributeIDTypeClusterUnitLocalizationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterUnitLocalizationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterUnitLocalizationAttributeEventListID = 65530,

	AttributeIDTypeClusterUnitLocalizationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterUnitLocalizationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterUnitLocalizationAttributeClusterRevisionID = 65533,

	ClusterPowerSourceConfigurationAttributeSourcesID = 0,

	ClusterPowerSourceConfigurationAttributeGeneratedCommandListID = 65528,

	ClusterPowerSourceConfigurationAttributeAcceptedCommandListID = 65529,

	ClusterPowerSourceConfigurationAttributeAttributeListID = 65531,

	ClusterPowerSourceConfigurationAttributeFeatureMapID = 65532,

	ClusterPowerSourceConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeSourcesID = 0,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeEventListID = 65530,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPowerSourceConfigurationAttributeClusterRevisionID = 65533,

	ClusterPowerSourceAttributeStatusID = 0,

	ClusterPowerSourceAttributeOrderID = 1,

	ClusterPowerSourceAttributeDescriptionID = 2,

	ClusterPowerSourceAttributeWiredAssessedInputVoltageID = 3,

	ClusterPowerSourceAttributeWiredAssessedInputFrequencyID = 4,

	ClusterPowerSourceAttributeWiredCurrentTypeID = 5,

	ClusterPowerSourceAttributeWiredAssessedCurrentID = 6,

	ClusterPowerSourceAttributeWiredNominalVoltageID = 7,

	ClusterPowerSourceAttributeWiredMaximumCurrentID = 8,

	ClusterPowerSourceAttributeWiredPresentID = 9,

	ClusterPowerSourceAttributeActiveWiredFaultsID = 10,

	ClusterPowerSourceAttributeBatVoltageID = 11,

	ClusterPowerSourceAttributeBatPercentRemainingID = 12,

	ClusterPowerSourceAttributeBatTimeRemainingID = 13,

	ClusterPowerSourceAttributeBatChargeLevelID = 14,

	ClusterPowerSourceAttributeBatReplacementNeededID = 15,

	ClusterPowerSourceAttributeBatReplaceabilityID = 16,

	ClusterPowerSourceAttributeBatPresentID = 17,

	ClusterPowerSourceAttributeActiveBatFaultsID = 18,

	ClusterPowerSourceAttributeBatReplacementDescriptionID = 19,

	ClusterPowerSourceAttributeBatCommonDesignationID = 20,

	ClusterPowerSourceAttributeBatANSIDesignationID = 21,

	ClusterPowerSourceAttributeBatIECDesignationID = 22,

	ClusterPowerSourceAttributeBatApprovedChemistryID = 23,

	ClusterPowerSourceAttributeBatCapacityID = 24,

	ClusterPowerSourceAttributeBatQuantityID = 25,

	ClusterPowerSourceAttributeBatChargeStateID = 26,

	ClusterPowerSourceAttributeBatTimeToFullChargeID = 27,

	ClusterPowerSourceAttributeBatFunctionalWhileChargingID = 28,

	ClusterPowerSourceAttributeBatChargingCurrentID = 29,

	ClusterPowerSourceAttributeActiveBatChargeFaultsID = 30,

	ClusterPowerSourceAttributeGeneratedCommandListID = 65528,

	ClusterPowerSourceAttributeAcceptedCommandListID = 65529,

	ClusterPowerSourceAttributeAttributeListID = 65531,

	ClusterPowerSourceAttributeFeatureMapID = 65532,

	ClusterPowerSourceAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPowerSourceAttributeStatusID = 0,

	AttributeIDTypeClusterPowerSourceAttributeOrderID = 1,

	AttributeIDTypeClusterPowerSourceAttributeDescriptionID = 2,

	AttributeIDTypeClusterPowerSourceAttributeWiredAssessedInputVoltageID = 3,

	AttributeIDTypeClusterPowerSourceAttributeWiredAssessedInputFrequencyID = 4,

	AttributeIDTypeClusterPowerSourceAttributeWiredCurrentTypeID = 5,

	AttributeIDTypeClusterPowerSourceAttributeWiredAssessedCurrentID = 6,

	AttributeIDTypeClusterPowerSourceAttributeWiredNominalVoltageID = 7,

	AttributeIDTypeClusterPowerSourceAttributeWiredMaximumCurrentID = 8,

	AttributeIDTypeClusterPowerSourceAttributeWiredPresentID = 9,

	AttributeIDTypeClusterPowerSourceAttributeActiveWiredFaultsID = 10,

	AttributeIDTypeClusterPowerSourceAttributeBatVoltageID = 11,

	AttributeIDTypeClusterPowerSourceAttributeBatPercentRemainingID = 12,

	AttributeIDTypeClusterPowerSourceAttributeBatTimeRemainingID = 13,

	AttributeIDTypeClusterPowerSourceAttributeBatChargeLevelID = 14,

	AttributeIDTypeClusterPowerSourceAttributeBatReplacementNeededID = 15,

	AttributeIDTypeClusterPowerSourceAttributeBatReplaceabilityID = 16,

	AttributeIDTypeClusterPowerSourceAttributeBatPresentID = 17,

	AttributeIDTypeClusterPowerSourceAttributeActiveBatFaultsID = 18,

	AttributeIDTypeClusterPowerSourceAttributeBatReplacementDescriptionID = 19,

	AttributeIDTypeClusterPowerSourceAttributeBatCommonDesignationID = 20,

	AttributeIDTypeClusterPowerSourceAttributeBatANSIDesignationID = 21,

	AttributeIDTypeClusterPowerSourceAttributeBatIECDesignationID = 22,

	AttributeIDTypeClusterPowerSourceAttributeBatApprovedChemistryID = 23,

	AttributeIDTypeClusterPowerSourceAttributeBatCapacityID = 24,

	AttributeIDTypeClusterPowerSourceAttributeBatQuantityID = 25,

	AttributeIDTypeClusterPowerSourceAttributeBatChargeStateID = 26,

	AttributeIDTypeClusterPowerSourceAttributeBatTimeToFullChargeID = 27,

	AttributeIDTypeClusterPowerSourceAttributeBatFunctionalWhileChargingID = 28,

	AttributeIDTypeClusterPowerSourceAttributeBatChargingCurrentID = 29,

	AttributeIDTypeClusterPowerSourceAttributeActiveBatChargeFaultsID = 30,

	AttributeIDTypeClusterPowerSourceAttributeEndpointListID = 31,

	AttributeIDTypeClusterPowerSourceAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPowerSourceAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPowerSourceAttributeEventListID = 65530,

	AttributeIDTypeClusterPowerSourceAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPowerSourceAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPowerSourceAttributeClusterRevisionID = 65533,

	ClusterGeneralCommissioningAttributeBreadcrumbID = 0,

	ClusterGeneralCommissioningAttributeBasicCommissioningInfoID = 1,

	ClusterGeneralCommissioningAttributeRegulatoryConfigID = 2,

	ClusterGeneralCommissioningAttributeLocationCapabilityID = 3,

	ClusterGeneralCommissioningAttributeSupportsConcurrentConnectionID = 4,

	ClusterGeneralCommissioningAttributeGeneratedCommandListID = 65528,

	ClusterGeneralCommissioningAttributeAcceptedCommandListID = 65529,

	ClusterGeneralCommissioningAttributeAttributeListID = 65531,

	ClusterGeneralCommissioningAttributeFeatureMapID = 65532,

	ClusterGeneralCommissioningAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterGeneralCommissioningAttributeBreadcrumbID = 0,

	AttributeIDTypeClusterGeneralCommissioningAttributeBasicCommissioningInfoID = 1,

	AttributeIDTypeClusterGeneralCommissioningAttributeRegulatoryConfigID = 2,

	AttributeIDTypeClusterGeneralCommissioningAttributeLocationCapabilityID = 3,

	AttributeIDTypeClusterGeneralCommissioningAttributeSupportsConcurrentConnectionID = 4,

	AttributeIDTypeClusterGeneralCommissioningAttributeTCAcceptedVersionID = 5,

	AttributeIDTypeClusterGeneralCommissioningAttributeTCMinRequiredVersionID = 6,

	AttributeIDTypeClusterGeneralCommissioningAttributeTCAcknowledgementsID = 7,

	AttributeIDTypeClusterGeneralCommissioningAttributeTCAcknowledgementsRequiredID = 8,

	AttributeIDTypeClusterGeneralCommissioningAttributeTCUpdateDeadlineID = 9,

	AttributeIDTypeClusterGeneralCommissioningAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterGeneralCommissioningAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterGeneralCommissioningAttributeEventListID = 65530,

	AttributeIDTypeClusterGeneralCommissioningAttributeAttributeListID = 65531,

	AttributeIDTypeClusterGeneralCommissioningAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterGeneralCommissioningAttributeClusterRevisionID = 65533,

	ClusterNetworkCommissioningAttributeMaxNetworksID = 0,

	ClusterNetworkCommissioningAttributeNetworksID = 1,

	ClusterNetworkCommissioningAttributeScanMaxTimeSecondsID = 2,

	ClusterNetworkCommissioningAttributeConnectMaxTimeSecondsID = 3,

	ClusterNetworkCommissioningAttributeInterfaceEnabledID = 4,

	ClusterNetworkCommissioningAttributeLastNetworkingStatusID = 5,

	ClusterNetworkCommissioningAttributeLastNetworkIDID = 6,

	ClusterNetworkCommissioningAttributeLastConnectErrorValueID = 7,

	ClusterNetworkCommissioningAttributeGeneratedCommandListID = 65528,

	ClusterNetworkCommissioningAttributeAcceptedCommandListID = 65529,

	ClusterNetworkCommissioningAttributeAttributeListID = 65531,

	ClusterNetworkCommissioningAttributeFeatureMapID = 65532,

	ClusterNetworkCommissioningAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterNetworkCommissioningAttributeMaxNetworksID = 0,

	AttributeIDTypeClusterNetworkCommissioningAttributeNetworksID = 1,

	AttributeIDTypeClusterNetworkCommissioningAttributeScanMaxTimeSecondsID = 2,

	AttributeIDTypeClusterNetworkCommissioningAttributeConnectMaxTimeSecondsID = 3,

	AttributeIDTypeClusterNetworkCommissioningAttributeInterfaceEnabledID = 4,

	AttributeIDTypeClusterNetworkCommissioningAttributeLastNetworkingStatusID = 5,

	AttributeIDTypeClusterNetworkCommissioningAttributeLastNetworkIDID = 6,

	AttributeIDTypeClusterNetworkCommissioningAttributeLastConnectErrorValueID = 7,

	AttributeIDTypeClusterNetworkCommissioningAttributeSupportedWiFiBandsID = 8,

	AttributeIDTypeClusterNetworkCommissioningAttributeSupportedThreadFeaturesID = 9,

	AttributeIDTypeClusterNetworkCommissioningAttributeThreadVersionID = 10,

	AttributeIDTypeClusterNetworkCommissioningAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterNetworkCommissioningAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterNetworkCommissioningAttributeEventListID = 65530,

	AttributeIDTypeClusterNetworkCommissioningAttributeAttributeListID = 65531,

	AttributeIDTypeClusterNetworkCommissioningAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterNetworkCommissioningAttributeClusterRevisionID = 65533,

	ClusterDiagnosticLogsAttributeGeneratedCommandListID = 65528,

	ClusterDiagnosticLogsAttributeAcceptedCommandListID = 65529,

	ClusterDiagnosticLogsAttributeAttributeListID = 65531,

	ClusterDiagnosticLogsAttributeFeatureMapID = 65532,

	ClusterDiagnosticLogsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDiagnosticLogsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDiagnosticLogsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDiagnosticLogsAttributeEventListID = 65530,

	AttributeIDTypeClusterDiagnosticLogsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDiagnosticLogsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDiagnosticLogsAttributeClusterRevisionID = 65533,

	ClusterGeneralDiagnosticsAttributeNetworkInterfacesID = 0,

	ClusterGeneralDiagnosticsAttributeRebootCountID = 1,

	ClusterGeneralDiagnosticsAttributeUpTimeID = 2,

	ClusterGeneralDiagnosticsAttributeTotalOperationalHoursID = 3,

	ClusterGeneralDiagnosticsAttributeBootReasonsID = 4,

	ClusterGeneralDiagnosticsAttributeActiveHardwareFaultsID = 5,

	ClusterGeneralDiagnosticsAttributeActiveRadioFaultsID = 6,

	ClusterGeneralDiagnosticsAttributeActiveNetworkFaultsID = 7,

	ClusterGeneralDiagnosticsAttributeTestEventTriggersEnabledID = 8,

	ClusterGeneralDiagnosticsAttributeGeneratedCommandListID = 65528,

	ClusterGeneralDiagnosticsAttributeAcceptedCommandListID = 65529,

	ClusterGeneralDiagnosticsAttributeAttributeListID = 65531,

	ClusterGeneralDiagnosticsAttributeFeatureMapID = 65532,

	ClusterGeneralDiagnosticsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeNetworkInterfacesID = 0,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeRebootCountID = 1,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeUpTimeID = 2,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeTotalOperationalHoursID = 3,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeBootReasonID = 4,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeActiveHardwareFaultsID = 5,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeActiveRadioFaultsID = 6,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeActiveNetworkFaultsID = 7,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeTestEventTriggersEnabledID = 8,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeEventListID = 65530,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterGeneralDiagnosticsAttributeClusterRevisionID = 65533,

	ClusterSoftwareDiagnosticsAttributeThreadMetricsID = 0,

	ClusterSoftwareDiagnosticsAttributeCurrentHeapFreeID = 1,

	ClusterSoftwareDiagnosticsAttributeCurrentHeapUsedID = 2,

	ClusterSoftwareDiagnosticsAttributeCurrentHeapHighWatermarkID = 3,

	ClusterSoftwareDiagnosticsAttributeGeneratedCommandListID = 65528,

	ClusterSoftwareDiagnosticsAttributeAcceptedCommandListID = 65529,

	ClusterSoftwareDiagnosticsAttributeAttributeListID = 65531,

	ClusterSoftwareDiagnosticsAttributeFeatureMapID = 65532,

	ClusterSoftwareDiagnosticsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeThreadMetricsID = 0,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeCurrentHeapFreeID = 1,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeCurrentHeapUsedID = 2,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeCurrentHeapHighWatermarkID = 3,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeEventListID = 65530,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterSoftwareDiagnosticsAttributeClusterRevisionID = 65533,

	ClusterThreadNetworkDiagnosticsAttributeChannelID = 0,

	ClusterThreadNetworkDiagnosticsAttributeRoutingRoleID = 1,

	ClusterThreadNetworkDiagnosticsAttributeNetworkNameID = 2,

	ClusterThreadNetworkDiagnosticsAttributePanIdID = 3,

	ClusterThreadNetworkDiagnosticsAttributeExtendedPanIdID = 4,

	ClusterThreadNetworkDiagnosticsAttributeMeshLocalPrefixID = 5,

	ClusterThreadNetworkDiagnosticsAttributeOverrunCountID = 6,

	ClusterThreadNetworkDiagnosticsAttributeNeighborTableListID = 7,

	ClusterThreadNetworkDiagnosticsAttributeRouteTableListID = 8,

	ClusterThreadNetworkDiagnosticsAttributePartitionIdID = 9,

	ClusterThreadNetworkDiagnosticsAttributeWeightingID = 10,

	ClusterThreadNetworkDiagnosticsAttributeDataVersionID = 11,

	ClusterThreadNetworkDiagnosticsAttributeStableDataVersionID = 12,

	ClusterThreadNetworkDiagnosticsAttributeLeaderRouterIdID = 13,

	ClusterThreadNetworkDiagnosticsAttributeDetachedRoleCountID = 14,

	ClusterThreadNetworkDiagnosticsAttributeChildRoleCountID = 15,

	ClusterThreadNetworkDiagnosticsAttributeRouterRoleCountID = 16,

	ClusterThreadNetworkDiagnosticsAttributeLeaderRoleCountID = 17,

	ClusterThreadNetworkDiagnosticsAttributeAttachAttemptCountID = 18,

	ClusterThreadNetworkDiagnosticsAttributePartitionIdChangeCountID = 19,

	ClusterThreadNetworkDiagnosticsAttributeBetterPartitionAttachAttemptCountID = 20,

	ClusterThreadNetworkDiagnosticsAttributeParentChangeCountID = 21,

	ClusterThreadNetworkDiagnosticsAttributeTxTotalCountID = 22,

	ClusterThreadNetworkDiagnosticsAttributeTxUnicastCountID = 23,

	ClusterThreadNetworkDiagnosticsAttributeTxBroadcastCountID = 24,

	ClusterThreadNetworkDiagnosticsAttributeTxAckRequestedCountID = 25,

	ClusterThreadNetworkDiagnosticsAttributeTxAckedCountID = 26,

	ClusterThreadNetworkDiagnosticsAttributeTxNoAckRequestedCountID = 27,

	ClusterThreadNetworkDiagnosticsAttributeTxDataCountID = 28,

	ClusterThreadNetworkDiagnosticsAttributeTxDataPollCountID = 29,

	ClusterThreadNetworkDiagnosticsAttributeTxBeaconCountID = 30,

	ClusterThreadNetworkDiagnosticsAttributeTxBeaconRequestCountID = 31,

	ClusterThreadNetworkDiagnosticsAttributeTxOtherCountID = 32,

	ClusterThreadNetworkDiagnosticsAttributeTxRetryCountID = 33,

	ClusterThreadNetworkDiagnosticsAttributeTxDirectMaxRetryExpiryCountID = 34,

	ClusterThreadNetworkDiagnosticsAttributeTxIndirectMaxRetryExpiryCountID = 35,

	ClusterThreadNetworkDiagnosticsAttributeTxErrCcaCountID = 36,

	ClusterThreadNetworkDiagnosticsAttributeTxErrAbortCountID = 37,

	ClusterThreadNetworkDiagnosticsAttributeTxErrBusyChannelCountID = 38,

	ClusterThreadNetworkDiagnosticsAttributeRxTotalCountID = 39,

	ClusterThreadNetworkDiagnosticsAttributeRxUnicastCountID = 40,

	ClusterThreadNetworkDiagnosticsAttributeRxBroadcastCountID = 41,

	ClusterThreadNetworkDiagnosticsAttributeRxDataCountID = 42,

	ClusterThreadNetworkDiagnosticsAttributeRxDataPollCountID = 43,

	ClusterThreadNetworkDiagnosticsAttributeRxBeaconCountID = 44,

	ClusterThreadNetworkDiagnosticsAttributeRxBeaconRequestCountID = 45,

	ClusterThreadNetworkDiagnosticsAttributeRxOtherCountID = 46,

	ClusterThreadNetworkDiagnosticsAttributeRxAddressFilteredCountID = 47,

	ClusterThreadNetworkDiagnosticsAttributeRxDestAddrFilteredCountID = 48,

	ClusterThreadNetworkDiagnosticsAttributeRxDuplicatedCountID = 49,

	ClusterThreadNetworkDiagnosticsAttributeRxErrNoFrameCountID = 50,

	ClusterThreadNetworkDiagnosticsAttributeRxErrUnknownNeighborCountID = 51,

	ClusterThreadNetworkDiagnosticsAttributeRxErrInvalidSrcAddrCountID = 52,

	ClusterThreadNetworkDiagnosticsAttributeRxErrSecCountID = 53,

	ClusterThreadNetworkDiagnosticsAttributeRxErrFcsCountID = 54,

	ClusterThreadNetworkDiagnosticsAttributeRxErrOtherCountID = 55,

	ClusterThreadNetworkDiagnosticsAttributeActiveTimestampID = 56,

	ClusterThreadNetworkDiagnosticsAttributePendingTimestampID = 57,

	ClusterThreadNetworkDiagnosticsAttributeDelayID = 58,

	ClusterThreadNetworkDiagnosticsAttributeSecurityPolicyID = 59,

	ClusterThreadNetworkDiagnosticsAttributeChannelPage0MaskID = 60,

	ClusterThreadNetworkDiagnosticsAttributeOperationalDatasetComponentsID = 61,

	ClusterThreadNetworkDiagnosticsAttributeActiveNetworkFaultsListID = 62,

	ClusterThreadNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	ClusterThreadNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	ClusterThreadNetworkDiagnosticsAttributeAttributeListID = 65531,

	ClusterThreadNetworkDiagnosticsAttributeFeatureMapID = 65532,

	ClusterThreadNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeChannelID = 0,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRoutingRoleID = 1,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeNetworkNameID = 2,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributePanIdID = 3,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeExtendedPanIdID = 4,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeMeshLocalPrefixID = 5,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeOverrunCountID = 6,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeNeighborTableID = 7,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRouteTableID = 8,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributePartitionIdID = 9,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeWeightingID = 10,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeDataVersionID = 11,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeStableDataVersionID = 12,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeLeaderRouterIdID = 13,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeDetachedRoleCountID = 14,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeChildRoleCountID = 15,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRouterRoleCountID = 16,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeLeaderRoleCountID = 17,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeAttachAttemptCountID = 18,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributePartitionIdChangeCountID = 19,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeBetterPartitionAttachAttemptCountID = 20,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeParentChangeCountID = 21,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxTotalCountID = 22,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxUnicastCountID = 23,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxBroadcastCountID = 24,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxAckRequestedCountID = 25,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxAckedCountID = 26,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxNoAckRequestedCountID = 27,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxDataCountID = 28,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxDataPollCountID = 29,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxBeaconCountID = 30,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxBeaconRequestCountID = 31,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxOtherCountID = 32,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxRetryCountID = 33,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxDirectMaxRetryExpiryCountID = 34,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxIndirectMaxRetryExpiryCountID = 35,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxErrCcaCountID = 36,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxErrAbortCountID = 37,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeTxErrBusyChannelCountID = 38,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxTotalCountID = 39,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxUnicastCountID = 40,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxBroadcastCountID = 41,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxDataCountID = 42,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxDataPollCountID = 43,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxBeaconCountID = 44,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxBeaconRequestCountID = 45,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxOtherCountID = 46,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxAddressFilteredCountID = 47,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxDestAddrFilteredCountID = 48,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxDuplicatedCountID = 49,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrNoFrameCountID = 50,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrUnknownNeighborCountID = 51,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrInvalidSrcAddrCountID = 52,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrSecCountID = 53,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrFcsCountID = 54,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeRxErrOtherCountID = 55,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeActiveTimestampID = 56,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributePendingTimestampID = 57,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeDelayID = 58,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeSecurityPolicyID = 59,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeChannelPage0MaskID = 60,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeOperationalDatasetComponentsID = 61,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeActiveNetworkFaultsListID = 62,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeEventListID = 65530,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterThreadNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	ClusterWiFiNetworkDiagnosticsAttributeBssidID = 0,

	ClusterWiFiNetworkDiagnosticsAttributeSecurityTypeID = 1,

	ClusterWiFiNetworkDiagnosticsAttributeWiFiVersionID = 2,

	ClusterWiFiNetworkDiagnosticsAttributeChannelNumberID = 3,

	ClusterWiFiNetworkDiagnosticsAttributeRssiID = 4,

	ClusterWiFiNetworkDiagnosticsAttributeBeaconLostCountID = 5,

	ClusterWiFiNetworkDiagnosticsAttributeBeaconRxCountID = 6,

	ClusterWiFiNetworkDiagnosticsAttributePacketMulticastRxCountID = 7,

	ClusterWiFiNetworkDiagnosticsAttributePacketMulticastTxCountID = 8,

	ClusterWiFiNetworkDiagnosticsAttributePacketUnicastRxCountID = 9,

	ClusterWiFiNetworkDiagnosticsAttributePacketUnicastTxCountID = 10,

	ClusterWiFiNetworkDiagnosticsAttributeCurrentMaxRateID = 11,

	ClusterWiFiNetworkDiagnosticsAttributeOverrunCountID = 12,

	ClusterWiFiNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	ClusterWiFiNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	ClusterWiFiNetworkDiagnosticsAttributeAttributeListID = 65531,

	ClusterWiFiNetworkDiagnosticsAttributeFeatureMapID = 65532,

	ClusterWiFiNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeBSSIDID = 0,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeSecurityTypeID = 1,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeWiFiVersionID = 2,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeChannelNumberID = 3,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeRSSIID = 4,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeBeaconLostCountID = 5,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeBeaconRxCountID = 6,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributePacketMulticastRxCountID = 7,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributePacketMulticastTxCountID = 8,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributePacketUnicastRxCountID = 9,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributePacketUnicastTxCountID = 10,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeCurrentMaxRateID = 11,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeOverrunCountID = 12,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeEventListID = 65530,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWiFiNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	ClusterEthernetNetworkDiagnosticsAttributePHYRateID = 0,

	ClusterEthernetNetworkDiagnosticsAttributeFullDuplexID = 1,

	ClusterEthernetNetworkDiagnosticsAttributePacketRxCountID = 2,

	ClusterEthernetNetworkDiagnosticsAttributePacketTxCountID = 3,

	ClusterEthernetNetworkDiagnosticsAttributeTxErrCountID = 4,

	ClusterEthernetNetworkDiagnosticsAttributeCollisionCountID = 5,

	ClusterEthernetNetworkDiagnosticsAttributeOverrunCountID = 6,

	ClusterEthernetNetworkDiagnosticsAttributeCarrierDetectID = 7,

	ClusterEthernetNetworkDiagnosticsAttributeTimeSinceResetID = 8,

	ClusterEthernetNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	ClusterEthernetNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	ClusterEthernetNetworkDiagnosticsAttributeAttributeListID = 65531,

	ClusterEthernetNetworkDiagnosticsAttributeFeatureMapID = 65532,

	ClusterEthernetNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributePHYRateID = 0,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeFullDuplexID = 1,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributePacketRxCountID = 2,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributePacketTxCountID = 3,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeTxErrCountID = 4,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeCollisionCountID = 5,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeOverrunCountID = 6,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeCarrierDetectID = 7,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeTimeSinceResetID = 8,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeEventListID = 65530,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterEthernetNetworkDiagnosticsAttributeClusterRevisionID = 65533,

	ClusterTimeSynchronizationAttributeUTCTimeID = 0,

	ClusterTimeSynchronizationAttributeGranularityID = 1,

	ClusterTimeSynchronizationAttributeTimeSourceID = 2,

	ClusterTimeSynchronizationAttributeTrustedTimeNodeIdID = 3,

	ClusterTimeSynchronizationAttributeDefaultNtpID = 4,

	ClusterTimeSynchronizationAttributeTimeZoneID = 5,

	ClusterTimeSynchronizationAttributeDstOffsetID = 6,

	ClusterTimeSynchronizationAttributeLocalTimeID = 7,

	ClusterTimeSynchronizationAttributeTimeZoneDatabaseID = 8,

	ClusterTimeSynchronizationAttributeNtpServerPortID = 9,

	ClusterTimeSynchronizationAttributeGeneratedCommandListID = 65528,

	ClusterTimeSynchronizationAttributeAcceptedCommandListID = 65529,

	ClusterTimeSynchronizationAttributeAttributeListID = 65531,

	ClusterTimeSynchronizationAttributeFeatureMapID = 65532,

	ClusterTimeSynchronizationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTimeSynchronizationAttributeUTCTimeID = 0,

	AttributeIDTypeClusterTimeSynchronizationAttributeGranularityID = 1,

	AttributeIDTypeClusterTimeSynchronizationAttributeTimeSourceID = 2,

	AttributeIDTypeClusterTimeSynchronizationAttributeTrustedTimeSourceID = 3,

	AttributeIDTypeClusterTimeSynchronizationAttributeTrustedTimeNodeIdID = 3,

	AttributeIDTypeClusterTimeSynchronizationAttributeDefaultNTPID = 4,

	AttributeIDTypeClusterTimeSynchronizationAttributeDefaultNtpID = 4,

	AttributeIDTypeClusterTimeSynchronizationAttributeTimeZoneID = 5,

	AttributeIDTypeClusterTimeSynchronizationAttributeDSTOffsetID = 6,

	AttributeIDTypeClusterTimeSynchronizationAttributeDstOffsetID = 6,

	AttributeIDTypeClusterTimeSynchronizationAttributeLocalTimeID = 7,

	AttributeIDTypeClusterTimeSynchronizationAttributeTimeZoneDatabaseID = 8,

	AttributeIDTypeClusterTimeSynchronizationAttributeNTPServerAvailableID = 9,

	AttributeIDTypeClusterTimeSynchronizationAttributeNtpServerPortID = 9,

	AttributeIDTypeClusterTimeSynchronizationAttributeTimeZoneListMaxSizeID = 10,

	AttributeIDTypeClusterTimeSynchronizationAttributeDSTOffsetListMaxSizeID = 11,

	AttributeIDTypeClusterTimeSynchronizationAttributeSupportsDNSResolveID = 12,

	AttributeIDTypeClusterTimeSynchronizationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTimeSynchronizationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTimeSynchronizationAttributeEventListID = 65530,

	AttributeIDTypeClusterTimeSynchronizationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTimeSynchronizationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTimeSynchronizationAttributeClusterRevisionID = 65533,

	ClusterBridgedDeviceBasicAttributeVendorNameID = 1,

	ClusterBridgedDeviceBasicAttributeVendorIDID = 2,

	ClusterBridgedDeviceBasicAttributeProductNameID = 3,

	ClusterBridgedDeviceBasicAttributeNodeLabelID = 5,

	ClusterBridgedDeviceBasicAttributeHardwareVersionID = 7,

	ClusterBridgedDeviceBasicAttributeHardwareVersionStringID = 8,

	ClusterBridgedDeviceBasicAttributeSoftwareVersionID = 9,

	ClusterBridgedDeviceBasicAttributeSoftwareVersionStringID = 10,

	ClusterBridgedDeviceBasicAttributeManufacturingDateID = 11,

	ClusterBridgedDeviceBasicAttributePartNumberID = 12,

	ClusterBridgedDeviceBasicAttributeProductURLID = 13,

	ClusterBridgedDeviceBasicAttributeProductLabelID = 14,

	ClusterBridgedDeviceBasicAttributeSerialNumberID = 15,

	ClusterBridgedDeviceBasicAttributeReachableID = 17,

	ClusterBridgedDeviceBasicAttributeUniqueIDID = 18,

	ClusterBridgedDeviceBasicAttributeGeneratedCommandListID = 65528,

	ClusterBridgedDeviceBasicAttributeAcceptedCommandListID = 65529,

	ClusterBridgedDeviceBasicAttributeAttributeListID = 65531,

	ClusterBridgedDeviceBasicAttributeFeatureMapID = 65532,

	ClusterBridgedDeviceBasicAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeVendorNameID = 1,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeVendorIDID = 2,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeProductNameID = 3,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeProductIDID = 4,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeNodeLabelID = 5,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeHardwareVersionID = 7,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeHardwareVersionStringID = 8,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeSoftwareVersionID = 9,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeSoftwareVersionStringID = 10,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeManufacturingDateID = 11,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributePartNumberID = 12,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeProductURLID = 13,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeProductLabelID = 14,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeSerialNumberID = 15,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeReachableID = 17,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeUniqueIDID = 18,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeProductAppearanceID = 20,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeEventListID = 65530,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBridgedDeviceBasicInformationAttributeClusterRevisionID = 65533,

	ClusterSwitchAttributeNumberOfPositionsID = 0,

	ClusterSwitchAttributeCurrentPositionID = 1,

	ClusterSwitchAttributeMultiPressMaxID = 2,

	ClusterSwitchAttributeGeneratedCommandListID = 65528,

	ClusterSwitchAttributeAcceptedCommandListID = 65529,

	ClusterSwitchAttributeAttributeListID = 65531,

	ClusterSwitchAttributeFeatureMapID = 65532,

	ClusterSwitchAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterSwitchAttributeNumberOfPositionsID = 0,

	AttributeIDTypeClusterSwitchAttributeCurrentPositionID = 1,

	AttributeIDTypeClusterSwitchAttributeMultiPressMaxID = 2,

	AttributeIDTypeClusterSwitchAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterSwitchAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterSwitchAttributeEventListID = 65530,

	AttributeIDTypeClusterSwitchAttributeAttributeListID = 65531,

	AttributeIDTypeClusterSwitchAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterSwitchAttributeClusterRevisionID = 65533,

	ClusterAdministratorCommissioningAttributeWindowStatusID = 0,

	ClusterAdministratorCommissioningAttributeAdminFabricIndexID = 1,

	ClusterAdministratorCommissioningAttributeAdminVendorIdID = 2,

	ClusterAdministratorCommissioningAttributeGeneratedCommandListID = 65528,

	ClusterAdministratorCommissioningAttributeAcceptedCommandListID = 65529,

	ClusterAdministratorCommissioningAttributeAttributeListID = 65531,

	ClusterAdministratorCommissioningAttributeFeatureMapID = 65532,

	ClusterAdministratorCommissioningAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAdministratorCommissioningAttributeWindowStatusID = 0,

	AttributeIDTypeClusterAdministratorCommissioningAttributeAdminFabricIndexID = 1,

	AttributeIDTypeClusterAdministratorCommissioningAttributeAdminVendorIdID = 2,

	AttributeIDTypeClusterAdministratorCommissioningAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAdministratorCommissioningAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAdministratorCommissioningAttributeEventListID = 65530,

	AttributeIDTypeClusterAdministratorCommissioningAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAdministratorCommissioningAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAdministratorCommissioningAttributeClusterRevisionID = 65533,

	ClusterOperationalCredentialsAttributeNOCsID = 0,

	ClusterOperationalCredentialsAttributeFabricsID = 1,

	ClusterOperationalCredentialsAttributeSupportedFabricsID = 2,

	ClusterOperationalCredentialsAttributeCommissionedFabricsID = 3,

	ClusterOperationalCredentialsAttributeTrustedRootCertificatesID = 4,

	ClusterOperationalCredentialsAttributeCurrentFabricIndexID = 5,

	ClusterOperationalCredentialsAttributeGeneratedCommandListID = 65528,

	ClusterOperationalCredentialsAttributeAcceptedCommandListID = 65529,

	ClusterOperationalCredentialsAttributeAttributeListID = 65531,

	ClusterOperationalCredentialsAttributeFeatureMapID = 65532,

	ClusterOperationalCredentialsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOperationalCredentialsAttributeNOCsID = 0,

	AttributeIDTypeClusterOperationalCredentialsAttributeFabricsID = 1,

	AttributeIDTypeClusterOperationalCredentialsAttributeSupportedFabricsID = 2,

	AttributeIDTypeClusterOperationalCredentialsAttributeCommissionedFabricsID = 3,

	AttributeIDTypeClusterOperationalCredentialsAttributeTrustedRootCertificatesID = 4,

	AttributeIDTypeClusterOperationalCredentialsAttributeCurrentFabricIndexID = 5,

	AttributeIDTypeClusterOperationalCredentialsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOperationalCredentialsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOperationalCredentialsAttributeEventListID = 65530,

	AttributeIDTypeClusterOperationalCredentialsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOperationalCredentialsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOperationalCredentialsAttributeClusterRevisionID = 65533,

	ClusterGroupKeyManagementAttributeGroupKeyMapID = 0,

	ClusterGroupKeyManagementAttributeGroupTableID = 1,

	ClusterGroupKeyManagementAttributeMaxGroupsPerFabricID = 2,

	ClusterGroupKeyManagementAttributeMaxGroupKeysPerFabricID = 3,

	ClusterGroupKeyManagementAttributeGeneratedCommandListID = 65528,

	ClusterGroupKeyManagementAttributeAcceptedCommandListID = 65529,

	ClusterGroupKeyManagementAttributeAttributeListID = 65531,

	ClusterGroupKeyManagementAttributeFeatureMapID = 65532,

	ClusterGroupKeyManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterGroupKeyManagementAttributeGroupKeyMapID = 0,

	AttributeIDTypeClusterGroupKeyManagementAttributeGroupTableID = 1,

	AttributeIDTypeClusterGroupKeyManagementAttributeMaxGroupsPerFabricID = 2,

	AttributeIDTypeClusterGroupKeyManagementAttributeMaxGroupKeysPerFabricID = 3,

	AttributeIDTypeClusterGroupKeyManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterGroupKeyManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterGroupKeyManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterGroupKeyManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterGroupKeyManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterGroupKeyManagementAttributeClusterRevisionID = 65533,

	ClusterFixedLabelAttributeLabelListID = 0,

	ClusterFixedLabelAttributeGeneratedCommandListID = 65528,

	ClusterFixedLabelAttributeAcceptedCommandListID = 65529,

	ClusterFixedLabelAttributeAttributeListID = 65531,

	ClusterFixedLabelAttributeFeatureMapID = 65532,

	ClusterFixedLabelAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterFixedLabelAttributeLabelListID = 0,

	AttributeIDTypeClusterFixedLabelAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterFixedLabelAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterFixedLabelAttributeEventListID = 65530,

	AttributeIDTypeClusterFixedLabelAttributeAttributeListID = 65531,

	AttributeIDTypeClusterFixedLabelAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterFixedLabelAttributeClusterRevisionID = 65533,

	ClusterUserLabelAttributeLabelListID = 0,

	ClusterUserLabelAttributeGeneratedCommandListID = 65528,

	ClusterUserLabelAttributeAcceptedCommandListID = 65529,

	ClusterUserLabelAttributeAttributeListID = 65531,

	ClusterUserLabelAttributeFeatureMapID = 65532,

	ClusterUserLabelAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterUserLabelAttributeLabelListID = 0,

	AttributeIDTypeClusterUserLabelAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterUserLabelAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterUserLabelAttributeEventListID = 65530,

	AttributeIDTypeClusterUserLabelAttributeAttributeListID = 65531,

	AttributeIDTypeClusterUserLabelAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterUserLabelAttributeClusterRevisionID = 65533,

	ClusterBooleanStateAttributeStateValueID = 0,

	ClusterBooleanStateAttributeGeneratedCommandListID = 65528,

	ClusterBooleanStateAttributeAcceptedCommandListID = 65529,

	ClusterBooleanStateAttributeAttributeListID = 65531,

	ClusterBooleanStateAttributeFeatureMapID = 65532,

	ClusterBooleanStateAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBooleanStateAttributeStateValueID = 0,

	AttributeIDTypeClusterBooleanStateAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBooleanStateAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBooleanStateAttributeEventListID = 65530,

	AttributeIDTypeClusterBooleanStateAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBooleanStateAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBooleanStateAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterICDManagementAttributeIdleModeDurationID = 0,

	AttributeIDTypeClusterICDManagementAttributeActiveModeDurationID = 1,

	AttributeIDTypeClusterICDManagementAttributeActiveModeThresholdID = 2,

	AttributeIDTypeClusterICDManagementAttributeRegisteredClientsID = 3,

	AttributeIDTypeClusterICDManagementAttributeICDCounterID = 4,

	AttributeIDTypeClusterICDManagementAttributeClientsSupportedPerFabricID = 5,

	AttributeIDTypeClusterICDManagementAttributeUserActiveModeTriggerHintID = 6,

	AttributeIDTypeClusterICDManagementAttributeUserActiveModeTriggerInstructionID = 7,

	AttributeIDTypeClusterICDManagementAttributeOperatingModeID = 8,

	AttributeIDTypeClusterICDManagementAttributeMaximumCheckInBackOffID = 9,

	AttributeIDTypeClusterICDManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterICDManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterICDManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterICDManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterICDManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterICDManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTimerAttributeSetTimeID = 0,

	AttributeIDTypeClusterTimerAttributeTimeRemainingID = 1,

	AttributeIDTypeClusterTimerAttributeTimerStateID = 2,

	AttributeIDTypeClusterTimerAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTimerAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTimerAttributeEventListID = 65530,

	AttributeIDTypeClusterTimerAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTimerAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTimerAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributePhaseListID = 0,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeCurrentPhaseID = 1,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeCountdownTimeID = 2,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeOperationalStateListID = 3,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeOperationalStateID = 4,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeOperationalErrorID = 5,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeEventListID = 65530,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOvenCavityOperationalStateAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOvenModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterOvenModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterOvenModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterOvenModeAttributeOnModeID = 3,

	AttributeIDTypeClusterOvenModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOvenModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOvenModeAttributeEventListID = 65530,

	AttributeIDTypeClusterOvenModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOvenModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOvenModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLaundryDryerControlsAttributeSupportedDrynessLevelsID = 0,

	AttributeIDTypeClusterLaundryDryerControlsAttributeSelectedDrynessLevelID = 1,

	AttributeIDTypeClusterLaundryDryerControlsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLaundryDryerControlsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLaundryDryerControlsAttributeEventListID = 65530,

	AttributeIDTypeClusterLaundryDryerControlsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLaundryDryerControlsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLaundryDryerControlsAttributeClusterRevisionID = 65533,

	ClusterModeSelectAttributeDescriptionID = 0,

	ClusterModeSelectAttributeStandardNamespaceID = 1,

	ClusterModeSelectAttributeSupportedModesID = 2,

	ClusterModeSelectAttributeCurrentModeID = 3,

	ClusterModeSelectAttributeStartUpModeID = 4,

	ClusterModeSelectAttributeOnModeID = 5,

	ClusterModeSelectAttributeGeneratedCommandListID = 65528,

	ClusterModeSelectAttributeAcceptedCommandListID = 65529,

	ClusterModeSelectAttributeAttributeListID = 65531,

	ClusterModeSelectAttributeFeatureMapID = 65532,

	ClusterModeSelectAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterModeSelectAttributeDescriptionID = 0,

	AttributeIDTypeClusterModeSelectAttributeStandardNamespaceID = 1,

	AttributeIDTypeClusterModeSelectAttributeSupportedModesID = 2,

	AttributeIDTypeClusterModeSelectAttributeCurrentModeID = 3,

	AttributeIDTypeClusterModeSelectAttributeStartUpModeID = 4,

	AttributeIDTypeClusterModeSelectAttributeOnModeID = 5,

	AttributeIDTypeClusterModeSelectAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterModeSelectAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterModeSelectAttributeEventListID = 65530,

	AttributeIDTypeClusterModeSelectAttributeAttributeListID = 65531,

	AttributeIDTypeClusterModeSelectAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterModeSelectAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLaundryWasherModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterLaundryWasherModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterLaundryWasherModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterLaundryWasherModeAttributeOnModeID = 3,

	AttributeIDTypeClusterLaundryWasherModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLaundryWasherModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLaundryWasherModeAttributeEventListID = 65530,

	AttributeIDTypeClusterLaundryWasherModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLaundryWasherModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLaundryWasherModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeOnModeID = 3,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeEventListID = 65530,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLaundryWasherControlsAttributeSpinSpeedsID = 0,

	AttributeIDTypeClusterLaundryWasherControlsAttributeSpinSpeedCurrentID = 1,

	AttributeIDTypeClusterLaundryWasherControlsAttributeNumberOfRinsesID = 2,

	AttributeIDTypeClusterLaundryWasherControlsAttributeSupportedRinsesID = 3,

	AttributeIDTypeClusterLaundryWasherControlsAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLaundryWasherControlsAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLaundryWasherControlsAttributeEventListID = 65530,

	AttributeIDTypeClusterLaundryWasherControlsAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLaundryWasherControlsAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLaundryWasherControlsAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRVCRunModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterRVCRunModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterRVCRunModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRVCRunModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRVCRunModeAttributeEventListID = 65530,

	AttributeIDTypeClusterRVCRunModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRVCRunModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRVCRunModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRVCCleanModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterRVCCleanModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterRVCCleanModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRVCCleanModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRVCCleanModeAttributeEventListID = 65530,

	AttributeIDTypeClusterRVCCleanModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRVCCleanModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRVCCleanModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTemperatureControlAttributeTemperatureSetpointID = 0,

	AttributeIDTypeClusterTemperatureControlAttributeMinTemperatureID = 1,

	AttributeIDTypeClusterTemperatureControlAttributeMaxTemperatureID = 2,

	AttributeIDTypeClusterTemperatureControlAttributeStepID = 3,

	AttributeIDTypeClusterTemperatureControlAttributeSelectedTemperatureLevelID = 4,

	AttributeIDTypeClusterTemperatureControlAttributeSupportedTemperatureLevelsID = 5,

	AttributeIDTypeClusterTemperatureControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTemperatureControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTemperatureControlAttributeEventListID = 65530,

	AttributeIDTypeClusterTemperatureControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTemperatureControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTemperatureControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeMaskID = 0,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeStateID = 2,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeSupportedID = 3,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeEventListID = 65530,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRefrigeratorAlarmAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDishwasherModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterDishwasherModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterDishwasherModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterDishwasherModeAttributeOnModeID = 3,

	AttributeIDTypeClusterDishwasherModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDishwasherModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDishwasherModeAttributeEventListID = 65530,

	AttributeIDTypeClusterDishwasherModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDishwasherModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDishwasherModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAirQualityAttributeAirQualityID = 0,

	AttributeIDTypeClusterAirQualityAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAirQualityAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAirQualityAttributeEventListID = 65530,

	AttributeIDTypeClusterAirQualityAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAirQualityAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAirQualityAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterSmokeCOAlarmAttributeExpressedStateID = 0,

	AttributeIDTypeClusterSmokeCOAlarmAttributeSmokeStateID = 1,

	AttributeIDTypeClusterSmokeCOAlarmAttributeCOStateID = 2,

	AttributeIDTypeClusterSmokeCOAlarmAttributeBatteryAlertID = 3,

	AttributeIDTypeClusterSmokeCOAlarmAttributeDeviceMutedID = 4,

	AttributeIDTypeClusterSmokeCOAlarmAttributeTestInProgressID = 5,

	AttributeIDTypeClusterSmokeCOAlarmAttributeHardwareFaultAlertID = 6,

	AttributeIDTypeClusterSmokeCOAlarmAttributeEndOfServiceAlertID = 7,

	AttributeIDTypeClusterSmokeCOAlarmAttributeInterconnectSmokeAlarmID = 8,

	AttributeIDTypeClusterSmokeCOAlarmAttributeInterconnectCOAlarmID = 9,

	AttributeIDTypeClusterSmokeCOAlarmAttributeContaminationStateID = 10,

	AttributeIDTypeClusterSmokeCOAlarmAttributeSmokeSensitivityLevelID = 11,

	AttributeIDTypeClusterSmokeCOAlarmAttributeExpiryDateID = 12,

	AttributeIDTypeClusterSmokeCOAlarmAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterSmokeCOAlarmAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterSmokeCOAlarmAttributeEventListID = 65530,

	AttributeIDTypeClusterSmokeCOAlarmAttributeAttributeListID = 65531,

	AttributeIDTypeClusterSmokeCOAlarmAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterSmokeCOAlarmAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDishwasherAlarmAttributeMaskID = 0,

	AttributeIDTypeClusterDishwasherAlarmAttributeLatchID = 1,

	AttributeIDTypeClusterDishwasherAlarmAttributeStateID = 2,

	AttributeIDTypeClusterDishwasherAlarmAttributeSupportedID = 3,

	AttributeIDTypeClusterDishwasherAlarmAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDishwasherAlarmAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDishwasherAlarmAttributeEventListID = 65530,

	AttributeIDTypeClusterDishwasherAlarmAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDishwasherAlarmAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDishwasherAlarmAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeEventListID = 65530,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterMicrowaveOvenModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeCookTimeID = 0,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeMaxCookTimeID = 1,

	AttributeIDTypeClusterMicrowaveOvenControlAttributePowerSettingID = 2,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeMinPowerID = 3,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeMaxPowerID = 4,

	AttributeIDTypeClusterMicrowaveOvenControlAttributePowerStepID = 5,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeSupportedWattsID = 6,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeSelectedWattIndexID = 7,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeWattRatingID = 8,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeEventListID = 65530,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterMicrowaveOvenControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOperationalStateAttributePhaseListID = 0,

	AttributeIDTypeClusterOperationalStateAttributeCurrentPhaseID = 1,

	AttributeIDTypeClusterOperationalStateAttributeCountdownTimeID = 2,

	AttributeIDTypeClusterOperationalStateAttributeOperationalStateListID = 3,

	AttributeIDTypeClusterOperationalStateAttributeOperationalStateID = 4,

	AttributeIDTypeClusterOperationalStateAttributeOperationalErrorID = 5,

	AttributeIDTypeClusterOperationalStateAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOperationalStateAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOperationalStateAttributeEventListID = 65530,

	AttributeIDTypeClusterOperationalStateAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOperationalStateAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOperationalStateAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRVCOperationalStateAttributePhaseListID = 0,

	AttributeIDTypeClusterRVCOperationalStateAttributeCurrentPhaseID = 1,

	AttributeIDTypeClusterRVCOperationalStateAttributeCountdownTimeID = 2,

	AttributeIDTypeClusterRVCOperationalStateAttributeOperationalStateListID = 3,

	AttributeIDTypeClusterRVCOperationalStateAttributeOperationalStateID = 4,

	AttributeIDTypeClusterRVCOperationalStateAttributeOperationalErrorID = 5,

	AttributeIDTypeClusterRVCOperationalStateAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRVCOperationalStateAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRVCOperationalStateAttributeEventListID = 65530,

	AttributeIDTypeClusterRVCOperationalStateAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRVCOperationalStateAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRVCOperationalStateAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterScenesManagementAttributeLastConfiguredByID = 0,

	AttributeIDTypeClusterScenesManagementAttributeSceneTableSizeID = 1,

	AttributeIDTypeClusterScenesManagementAttributeFabricSceneInfoID = 2,

	AttributeIDTypeClusterScenesManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterScenesManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterScenesManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterScenesManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterScenesManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterScenesManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeConditionID = 0,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeDegradationDirectionID = 1,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeChangeIndicationID = 2,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeInPlaceIndicatorID = 3,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeLastChangedTimeID = 4,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeReplacementProductListID = 5,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeEventListID = 65530,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeAttributeListID = 65531,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterHEPAFilterMonitoringAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeConditionID = 0,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeDegradationDirectionID = 1,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeChangeIndicationID = 2,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeInPlaceIndicatorID = 3,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeLastChangedTimeID = 4,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeReplacementProductListID = 5,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeEventListID = 65530,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeAttributeListID = 65531,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterActivatedCarbonFilterMonitoringAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeCurrentSensitivityLevelID = 0,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeSupportedSensitivityLevelsID = 1,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeDefaultSensitivityLevelID = 2,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAlarmsActiveID = 3,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAlarmsSuppressedID = 4,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAlarmsEnabledID = 5,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAlarmsSupportedID = 6,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeSensorFaultID = 7,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeEventListID = 65530,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBooleanStateConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeOpenDurationID = 0,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeDefaultOpenDurationID = 1,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeAutoCloseTimeID = 2,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeRemainingDurationID = 3,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeCurrentStateID = 4,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeTargetStateID = 5,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeCurrentLevelID = 6,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeTargetLevelID = 7,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeDefaultOpenLevelID = 8,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeValveFaultID = 9,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeLevelStepID = 10,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeEventListID = 65530,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterValveConfigurationAndControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributePowerModeID = 0,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeNumberOfMeasurementTypesID = 1,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeAccuracyID = 2,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeRangesID = 3,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeVoltageID = 4,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeActiveCurrentID = 5,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeReactiveCurrentID = 6,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeApparentCurrentID = 7,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeActivePowerID = 8,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeReactivePowerID = 9,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeApparentPowerID = 10,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeRMSVoltageID = 11,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeRMSCurrentID = 12,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeRMSPowerID = 13,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeFrequencyID = 14,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeHarmonicCurrentsID = 15,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeHarmonicPhasesID = 16,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributePowerFactorID = 17,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeNeutralCurrentID = 18,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterElectricalPowerMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeAccuracyID = 0,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeCumulativeEnergyImportedID = 1,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeCumulativeEnergyExportedID = 2,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributePeriodicEnergyImportedID = 3,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributePeriodicEnergyExportedID = 4,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeCumulativeEnergyResetID = 5,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterElectricalEnergyMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWaterHeaterManagementAttributeHeaterTypesID = 0,

	AttributeIDTypeClusterWaterHeaterManagementAttributeHeatDemandID = 1,

	AttributeIDTypeClusterWaterHeaterManagementAttributeTankVolumeID = 2,

	AttributeIDTypeClusterWaterHeaterManagementAttributeEstimatedHeatRequiredID = 3,

	AttributeIDTypeClusterWaterHeaterManagementAttributeTankPercentageID = 4,

	AttributeIDTypeClusterWaterHeaterManagementAttributeBoostStateID = 5,

	AttributeIDTypeClusterWaterHeaterManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWaterHeaterManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWaterHeaterManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterWaterHeaterManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWaterHeaterManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWaterHeaterManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeLoadControlProgramsID = 0,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeNumberOfLoadControlProgramsID = 1,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeEventsID = 2,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeActiveEventsID = 3,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeNumberOfEventsPerProgramID = 4,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeNumberOfTransitionsID = 5,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeDefaultRandomStartID = 6,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeDefaultRandomDurationID = 7,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeEventListID = 65530,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDemandResponseLoadControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterMessagesAttributeMessagesID = 0,

	AttributeIDTypeClusterMessagesAttributeActiveMessageIDsID = 1,

	AttributeIDTypeClusterMessagesAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterMessagesAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterMessagesAttributeEventListID = 65530,

	AttributeIDTypeClusterMessagesAttributeAttributeListID = 65531,

	AttributeIDTypeClusterMessagesAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterMessagesAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeESATypeID = 0,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeESACanGenerateID = 1,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeESAStateID = 2,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeAbsMinPowerID = 3,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeAbsMaxPowerID = 4,

	AttributeIDTypeClusterDeviceEnergyManagementAttributePowerAdjustmentCapabilityID = 5,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeForecastID = 6,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeOptOutStateID = 7,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDeviceEnergyManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterEnergyEVSEAttributeStateID = 0,

	AttributeIDTypeClusterEnergyEVSEAttributeSupplyStateID = 1,

	AttributeIDTypeClusterEnergyEVSEAttributeFaultStateID = 2,

	AttributeIDTypeClusterEnergyEVSEAttributeChargingEnabledUntilID = 3,

	AttributeIDTypeClusterEnergyEVSEAttributeDischargingEnabledUntilID = 4,

	AttributeIDTypeClusterEnergyEVSEAttributeCircuitCapacityID = 5,

	AttributeIDTypeClusterEnergyEVSEAttributeMinimumChargeCurrentID = 6,

	AttributeIDTypeClusterEnergyEVSEAttributeMaximumChargeCurrentID = 7,

	AttributeIDTypeClusterEnergyEVSEAttributeMaximumDischargeCurrentID = 8,

	AttributeIDTypeClusterEnergyEVSEAttributeUserMaximumChargeCurrentID = 9,

	AttributeIDTypeClusterEnergyEVSEAttributeRandomizationDelayWindowID = 10,

	AttributeIDTypeClusterEnergyEVSEAttributeNextChargeStartTimeID = 35,

	AttributeIDTypeClusterEnergyEVSEAttributeNextChargeTargetTimeID = 36,

	AttributeIDTypeClusterEnergyEVSEAttributeNextChargeRequiredEnergyID = 37,

	AttributeIDTypeClusterEnergyEVSEAttributeNextChargeTargetSoCID = 38,

	AttributeIDTypeClusterEnergyEVSEAttributeApproximateEVEfficiencyID = 39,

	AttributeIDTypeClusterEnergyEVSEAttributeStateOfChargeID = 48,

	AttributeIDTypeClusterEnergyEVSEAttributeBatteryCapacityID = 49,

	AttributeIDTypeClusterEnergyEVSEAttributeVehicleIDID = 50,

	AttributeIDTypeClusterEnergyEVSEAttributeSessionIDID = 64,

	AttributeIDTypeClusterEnergyEVSEAttributeSessionDurationID = 65,

	AttributeIDTypeClusterEnergyEVSEAttributeSessionEnergyChargedID = 66,

	AttributeIDTypeClusterEnergyEVSEAttributeSessionEnergyDischargedID = 67,

	AttributeIDTypeClusterEnergyEVSEAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterEnergyEVSEAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterEnergyEVSEAttributeEventListID = 65530,

	AttributeIDTypeClusterEnergyEVSEAttributeAttributeListID = 65531,

	AttributeIDTypeClusterEnergyEVSEAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterEnergyEVSEAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterEnergyPreferenceAttributeEnergyBalancesID = 0,

	AttributeIDTypeClusterEnergyPreferenceAttributeCurrentEnergyBalanceID = 1,

	AttributeIDTypeClusterEnergyPreferenceAttributeEnergyPrioritiesID = 2,

	AttributeIDTypeClusterEnergyPreferenceAttributeLowPowerModeSensitivitiesID = 3,

	AttributeIDTypeClusterEnergyPreferenceAttributeCurrentLowPowerModeSensitivityID = 4,

	AttributeIDTypeClusterEnergyPreferenceAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterEnergyPreferenceAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterEnergyPreferenceAttributeEventListID = 65530,

	AttributeIDTypeClusterEnergyPreferenceAttributeAttributeListID = 65531,

	AttributeIDTypeClusterEnergyPreferenceAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterEnergyPreferenceAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPowerTopologyAttributeAvailableEndpointsID = 0,

	AttributeIDTypeClusterPowerTopologyAttributeActiveEndpointsID = 1,

	AttributeIDTypeClusterPowerTopologyAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPowerTopologyAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPowerTopologyAttributeEventListID = 65530,

	AttributeIDTypeClusterPowerTopologyAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPowerTopologyAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPowerTopologyAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterEnergyEVSEModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterEnergyEVSEModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterEnergyEVSEModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterEnergyEVSEModeAttributeOnModeID = 3,

	AttributeIDTypeClusterEnergyEVSEModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterEnergyEVSEModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterEnergyEVSEModeAttributeEventListID = 65530,

	AttributeIDTypeClusterEnergyEVSEModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterEnergyEVSEModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterEnergyEVSEModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWaterHeaterModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterWaterHeaterModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterWaterHeaterModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterWaterHeaterModeAttributeOnModeID = 3,

	AttributeIDTypeClusterWaterHeaterModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWaterHeaterModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWaterHeaterModeAttributeEventListID = 65530,

	AttributeIDTypeClusterWaterHeaterModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWaterHeaterModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWaterHeaterModeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeSupportedModesID = 0,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeCurrentModeID = 1,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeStartUpModeID = 2,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeOnModeID = 3,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeEventListID = 65530,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDeviceEnergyManagementModeAttributeClusterRevisionID = 65533,

	ClusterDoorLockAttributeLockStateID = 0,

	ClusterDoorLockAttributeLockTypeID = 1,

	ClusterDoorLockAttributeActuatorEnabledID = 2,

	ClusterDoorLockAttributeDoorStateID = 3,

	ClusterDoorLockAttributeDoorOpenEventsID = 4,

	ClusterDoorLockAttributeDoorClosedEventsID = 5,

	ClusterDoorLockAttributeOpenPeriodID = 6,

	ClusterDoorLockAttributeNumberOfTotalUsersSupportedID = 17,

	ClusterDoorLockAttributeNumberOfPINUsersSupportedID = 18,

	ClusterDoorLockAttributeNumberOfRFIDUsersSupportedID = 19,

	ClusterDoorLockAttributeNumberOfWeekDaySchedulesSupportedPerUserID = 20,

	ClusterDoorLockAttributeNumberOfYearDaySchedulesSupportedPerUserID = 21,

	ClusterDoorLockAttributeNumberOfHolidaySchedulesSupportedID = 22,

	ClusterDoorLockAttributeMaxPINCodeLengthID = 23,

	ClusterDoorLockAttributeMinPINCodeLengthID = 24,

	ClusterDoorLockAttributeMaxRFIDCodeLengthID = 25,

	ClusterDoorLockAttributeMinRFIDCodeLengthID = 26,

	ClusterDoorLockAttributeCredentialRulesSupportID = 27,

	ClusterDoorLockAttributeNumberOfCredentialsSupportedPerUserID = 28,

	ClusterDoorLockAttributeLanguageID = 33,

	ClusterDoorLockAttributeLEDSettingsID = 34,

	ClusterDoorLockAttributeAutoRelockTimeID = 35,

	ClusterDoorLockAttributeSoundVolumeID = 36,

	ClusterDoorLockAttributeOperatingModeID = 37,

	ClusterDoorLockAttributeSupportedOperatingModesID = 38,

	ClusterDoorLockAttributeDefaultConfigurationRegisterID = 39,

	ClusterDoorLockAttributeEnableLocalProgrammingID = 40,

	ClusterDoorLockAttributeEnableOneTouchLockingID = 41,

	ClusterDoorLockAttributeEnableInsideStatusLEDID = 42,

	ClusterDoorLockAttributeEnablePrivacyModeButtonID = 43,

	ClusterDoorLockAttributeLocalProgrammingFeaturesID = 44,

	ClusterDoorLockAttributeWrongCodeEntryLimitID = 48,

	ClusterDoorLockAttributeUserCodeTemporaryDisableTimeID = 49,

	ClusterDoorLockAttributeSendPINOverTheAirID = 50,

	ClusterDoorLockAttributeRequirePINforRemoteOperationID = 51,

	ClusterDoorLockAttributeExpiringUserTimeoutID = 53,

	ClusterDoorLockAttributeGeneratedCommandListID = 65528,

	ClusterDoorLockAttributeAcceptedCommandListID = 65529,

	ClusterDoorLockAttributeAttributeListID = 65531,

	ClusterDoorLockAttributeFeatureMapID = 65532,

	ClusterDoorLockAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDoorLockAttributeLockStateID = 0,

	AttributeIDTypeClusterDoorLockAttributeLockTypeID = 1,

	AttributeIDTypeClusterDoorLockAttributeActuatorEnabledID = 2,

	AttributeIDTypeClusterDoorLockAttributeDoorStateID = 3,

	AttributeIDTypeClusterDoorLockAttributeDoorOpenEventsID = 4,

	AttributeIDTypeClusterDoorLockAttributeDoorClosedEventsID = 5,

	AttributeIDTypeClusterDoorLockAttributeOpenPeriodID = 6,

	AttributeIDTypeClusterDoorLockAttributeNumberOfTotalUsersSupportedID = 17,

	AttributeIDTypeClusterDoorLockAttributeNumberOfPINUsersSupportedID = 18,

	AttributeIDTypeClusterDoorLockAttributeNumberOfRFIDUsersSupportedID = 19,

	AttributeIDTypeClusterDoorLockAttributeNumberOfWeekDaySchedulesSupportedPerUserID = 20,

	AttributeIDTypeClusterDoorLockAttributeNumberOfYearDaySchedulesSupportedPerUserID = 21,

	AttributeIDTypeClusterDoorLockAttributeNumberOfHolidaySchedulesSupportedID = 22,

	AttributeIDTypeClusterDoorLockAttributeMaxPINCodeLengthID = 23,

	AttributeIDTypeClusterDoorLockAttributeMinPINCodeLengthID = 24,

	AttributeIDTypeClusterDoorLockAttributeMaxRFIDCodeLengthID = 25,

	AttributeIDTypeClusterDoorLockAttributeMinRFIDCodeLengthID = 26,

	AttributeIDTypeClusterDoorLockAttributeCredentialRulesSupportID = 27,

	AttributeIDTypeClusterDoorLockAttributeNumberOfCredentialsSupportedPerUserID = 28,

	AttributeIDTypeClusterDoorLockAttributeLanguageID = 33,

	AttributeIDTypeClusterDoorLockAttributeLEDSettingsID = 34,

	AttributeIDTypeClusterDoorLockAttributeAutoRelockTimeID = 35,

	AttributeIDTypeClusterDoorLockAttributeSoundVolumeID = 36,

	AttributeIDTypeClusterDoorLockAttributeOperatingModeID = 37,

	AttributeIDTypeClusterDoorLockAttributeSupportedOperatingModesID = 38,

	AttributeIDTypeClusterDoorLockAttributeDefaultConfigurationRegisterID = 39,

	AttributeIDTypeClusterDoorLockAttributeEnableLocalProgrammingID = 40,

	AttributeIDTypeClusterDoorLockAttributeEnableOneTouchLockingID = 41,

	AttributeIDTypeClusterDoorLockAttributeEnableInsideStatusLEDID = 42,

	AttributeIDTypeClusterDoorLockAttributeEnablePrivacyModeButtonID = 43,

	AttributeIDTypeClusterDoorLockAttributeLocalProgrammingFeaturesID = 44,

	AttributeIDTypeClusterDoorLockAttributeWrongCodeEntryLimitID = 48,

	AttributeIDTypeClusterDoorLockAttributeUserCodeTemporaryDisableTimeID = 49,

	AttributeIDTypeClusterDoorLockAttributeSendPINOverTheAirID = 50,

	AttributeIDTypeClusterDoorLockAttributeRequirePINforRemoteOperationID = 51,

	AttributeIDTypeClusterDoorLockAttributeExpiringUserTimeoutID = 53,

	AttributeIDTypeClusterDoorLockAttributeAliroReaderVerificationKeyID = 128,

	AttributeIDTypeClusterDoorLockAttributeAliroReaderGroupIdentifierID = 129,

	AttributeIDTypeClusterDoorLockAttributeAliroReaderGroupSubIdentifierID = 130,

	AttributeIDTypeClusterDoorLockAttributeAliroExpeditedTransactionSupportedProtocolVersionsID = 131,

	AttributeIDTypeClusterDoorLockAttributeAliroGroupResolvingKeyID = 132,

	AttributeIDTypeClusterDoorLockAttributeAliroSupportedBLEUWBProtocolVersionsID = 133,

	AttributeIDTypeClusterDoorLockAttributeAliroBLEAdvertisingVersionID = 134,

	AttributeIDTypeClusterDoorLockAttributeNumberOfAliroCredentialIssuerKeysSupportedID = 135,

	AttributeIDTypeClusterDoorLockAttributeNumberOfAliroEndpointKeysSupportedID = 136,

	AttributeIDTypeClusterDoorLockAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterDoorLockAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterDoorLockAttributeEventListID = 65530,

	AttributeIDTypeClusterDoorLockAttributeAttributeListID = 65531,

	AttributeIDTypeClusterDoorLockAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterDoorLockAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroReaderVerificationKeyID = 323551232,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroReaderGroupIdentifierID = 323551233,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroReaderGroupSubIdentifierID = 323551234,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroExpeditedTransactionSupportedProtocolVersionsID = 323551235,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroGroupResolvingKeyID = 323551236,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroSupportedBLEUWBProtocolVersionsID = 323551237,

	AttributeIDTypeClusterDoorLockAttributeAppleAliroBLEAdvertisingVersionID = 323551238,

	AttributeIDTypeClusterDoorLockAttributeAppleNumberOfAliroCredentialIssuerKeysSupportedID = 323551239,

	AttributeIDTypeClusterDoorLockAttributeAppleNumberOfAliroEndpointKeysSupportedID = 323551240,

	ClusterWindowCoveringAttributeTypeID = 0,

	ClusterWindowCoveringAttributePhysicalClosedLimitLiftID = 1,

	ClusterWindowCoveringAttributePhysicalClosedLimitTiltID = 2,

	ClusterWindowCoveringAttributeCurrentPositionLiftID = 3,

	ClusterWindowCoveringAttributeCurrentPositionTiltID = 4,

	ClusterWindowCoveringAttributeNumberOfActuationsLiftID = 5,

	ClusterWindowCoveringAttributeNumberOfActuationsTiltID = 6,

	ClusterWindowCoveringAttributeConfigStatusID = 7,

	ClusterWindowCoveringAttributeCurrentPositionLiftPercentageID = 8,

	ClusterWindowCoveringAttributeCurrentPositionTiltPercentageID = 9,

	ClusterWindowCoveringAttributeOperationalStatusID = 10,

	ClusterWindowCoveringAttributeTargetPositionLiftPercent100thsID = 11,

	ClusterWindowCoveringAttributeTargetPositionTiltPercent100thsID = 12,

	ClusterWindowCoveringAttributeEndProductTypeID = 13,

	ClusterWindowCoveringAttributeCurrentPositionLiftPercent100thsID = 14,

	ClusterWindowCoveringAttributeCurrentPositionTiltPercent100thsID = 15,

	ClusterWindowCoveringAttributeInstalledOpenLimitLiftID = 16,

	ClusterWindowCoveringAttributeInstalledClosedLimitLiftID = 17,

	ClusterWindowCoveringAttributeInstalledOpenLimitTiltID = 18,

	ClusterWindowCoveringAttributeInstalledClosedLimitTiltID = 19,

	ClusterWindowCoveringAttributeModeID = 23,

	ClusterWindowCoveringAttributeSafetyStatusID = 26,

	ClusterWindowCoveringAttributeGeneratedCommandListID = 65528,

	ClusterWindowCoveringAttributeAcceptedCommandListID = 65529,

	ClusterWindowCoveringAttributeAttributeListID = 65531,

	ClusterWindowCoveringAttributeFeatureMapID = 65532,

	ClusterWindowCoveringAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWindowCoveringAttributeTypeID = 0,

	AttributeIDTypeClusterWindowCoveringAttributePhysicalClosedLimitLiftID = 1,

	AttributeIDTypeClusterWindowCoveringAttributePhysicalClosedLimitTiltID = 2,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionLiftID = 3,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionTiltID = 4,

	AttributeIDTypeClusterWindowCoveringAttributeNumberOfActuationsLiftID = 5,

	AttributeIDTypeClusterWindowCoveringAttributeNumberOfActuationsTiltID = 6,

	AttributeIDTypeClusterWindowCoveringAttributeConfigStatusID = 7,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionLiftPercentageID = 8,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionTiltPercentageID = 9,

	AttributeIDTypeClusterWindowCoveringAttributeOperationalStatusID = 10,

	AttributeIDTypeClusterWindowCoveringAttributeTargetPositionLiftPercent100thsID = 11,

	AttributeIDTypeClusterWindowCoveringAttributeTargetPositionTiltPercent100thsID = 12,

	AttributeIDTypeClusterWindowCoveringAttributeEndProductTypeID = 13,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionLiftPercent100thsID = 14,

	AttributeIDTypeClusterWindowCoveringAttributeCurrentPositionTiltPercent100thsID = 15,

	AttributeIDTypeClusterWindowCoveringAttributeInstalledOpenLimitLiftID = 16,

	AttributeIDTypeClusterWindowCoveringAttributeInstalledClosedLimitLiftID = 17,

	AttributeIDTypeClusterWindowCoveringAttributeInstalledOpenLimitTiltID = 18,

	AttributeIDTypeClusterWindowCoveringAttributeInstalledClosedLimitTiltID = 19,

	AttributeIDTypeClusterWindowCoveringAttributeModeID = 23,

	AttributeIDTypeClusterWindowCoveringAttributeSafetyStatusID = 26,

	AttributeIDTypeClusterWindowCoveringAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWindowCoveringAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWindowCoveringAttributeEventListID = 65530,

	AttributeIDTypeClusterWindowCoveringAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWindowCoveringAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWindowCoveringAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterServiceAreaAttributeSupportedAreasID = 0,

	AttributeIDTypeClusterServiceAreaAttributeSupportedMapsID = 1,

	AttributeIDTypeClusterServiceAreaAttributeSelectedAreasID = 2,

	AttributeIDTypeClusterServiceAreaAttributeCurrentAreaID = 3,

	AttributeIDTypeClusterServiceAreaAttributeEstimatedEndTimeID = 4,

	AttributeIDTypeClusterServiceAreaAttributeProgressID = 5,

	AttributeIDTypeClusterServiceAreaAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterServiceAreaAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterServiceAreaAttributeEventListID = 65530,

	AttributeIDTypeClusterServiceAreaAttributeAttributeListID = 65531,

	AttributeIDTypeClusterServiceAreaAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterServiceAreaAttributeClusterRevisionID = 65533,

	ClusterPumpConfigurationAndControlAttributeMaxPressureID = 0,

	ClusterPumpConfigurationAndControlAttributeMaxSpeedID = 1,

	ClusterPumpConfigurationAndControlAttributeMaxFlowID = 2,

	ClusterPumpConfigurationAndControlAttributeMinConstPressureID = 3,

	ClusterPumpConfigurationAndControlAttributeMaxConstPressureID = 4,

	ClusterPumpConfigurationAndControlAttributeMinCompPressureID = 5,

	ClusterPumpConfigurationAndControlAttributeMaxCompPressureID = 6,

	ClusterPumpConfigurationAndControlAttributeMinConstSpeedID = 7,

	ClusterPumpConfigurationAndControlAttributeMaxConstSpeedID = 8,

	ClusterPumpConfigurationAndControlAttributeMinConstFlowID = 9,

	ClusterPumpConfigurationAndControlAttributeMaxConstFlowID = 10,

	ClusterPumpConfigurationAndControlAttributeMinConstTempID = 11,

	ClusterPumpConfigurationAndControlAttributeMaxConstTempID = 12,

	ClusterPumpConfigurationAndControlAttributePumpStatusID = 16,

	ClusterPumpConfigurationAndControlAttributeEffectiveOperationModeID = 17,

	ClusterPumpConfigurationAndControlAttributeEffectiveControlModeID = 18,

	ClusterPumpConfigurationAndControlAttributeCapacityID = 19,

	ClusterPumpConfigurationAndControlAttributeSpeedID = 20,

	ClusterPumpConfigurationAndControlAttributeLifetimeRunningHoursID = 21,

	ClusterPumpConfigurationAndControlAttributePowerID = 22,

	ClusterPumpConfigurationAndControlAttributeLifetimeEnergyConsumedID = 23,

	ClusterPumpConfigurationAndControlAttributeOperationModeID = 32,

	ClusterPumpConfigurationAndControlAttributeControlModeID = 33,

	ClusterPumpConfigurationAndControlAttributeGeneratedCommandListID = 65528,

	ClusterPumpConfigurationAndControlAttributeAcceptedCommandListID = 65529,

	ClusterPumpConfigurationAndControlAttributeAttributeListID = 65531,

	ClusterPumpConfigurationAndControlAttributeFeatureMapID = 65532,

	ClusterPumpConfigurationAndControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxPressureID = 0,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxSpeedID = 1,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxFlowID = 2,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMinConstPressureID = 3,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxConstPressureID = 4,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMinCompPressureID = 5,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxCompPressureID = 6,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMinConstSpeedID = 7,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxConstSpeedID = 8,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMinConstFlowID = 9,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxConstFlowID = 10,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMinConstTempID = 11,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeMaxConstTempID = 12,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributePumpStatusID = 16,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeEffectiveOperationModeID = 17,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeEffectiveControlModeID = 18,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeCapacityID = 19,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeSpeedID = 20,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeLifetimeRunningHoursID = 21,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributePowerID = 22,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeLifetimeEnergyConsumedID = 23,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeOperationModeID = 32,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeControlModeID = 33,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeEventListID = 65530,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPumpConfigurationAndControlAttributeClusterRevisionID = 65533,

	ClusterThermostatAttributeLocalTemperatureID = 0,

	ClusterThermostatAttributeOutdoorTemperatureID = 1,

	ClusterThermostatAttributeOccupancyID = 2,

	ClusterThermostatAttributeAbsMinHeatSetpointLimitID = 3,

	ClusterThermostatAttributeAbsMaxHeatSetpointLimitID = 4,

	ClusterThermostatAttributeAbsMinCoolSetpointLimitID = 5,

	ClusterThermostatAttributeAbsMaxCoolSetpointLimitID = 6,

	ClusterThermostatAttributePICoolingDemandID = 7,

	ClusterThermostatAttributePIHeatingDemandID = 8,

	ClusterThermostatAttributeHVACSystemTypeConfigurationID = 9,

	ClusterThermostatAttributeLocalTemperatureCalibrationID = 16,

	ClusterThermostatAttributeOccupiedCoolingSetpointID = 17,

	ClusterThermostatAttributeOccupiedHeatingSetpointID = 18,

	ClusterThermostatAttributeUnoccupiedCoolingSetpointID = 19,

	ClusterThermostatAttributeUnoccupiedHeatingSetpointID = 20,

	ClusterThermostatAttributeMinHeatSetpointLimitID = 21,

	ClusterThermostatAttributeMaxHeatSetpointLimitID = 22,

	ClusterThermostatAttributeMinCoolSetpointLimitID = 23,

	ClusterThermostatAttributeMaxCoolSetpointLimitID = 24,

	ClusterThermostatAttributeMinSetpointDeadBandID = 25,

	ClusterThermostatAttributeRemoteSensingID = 26,

	ClusterThermostatAttributeControlSequenceOfOperationID = 27,

	ClusterThermostatAttributeSystemModeID = 28,

	ClusterThermostatAttributeThermostatRunningModeID = 30,

	ClusterThermostatAttributeStartOfWeekID = 32,

	ClusterThermostatAttributeNumberOfWeeklyTransitionsID = 33,

	ClusterThermostatAttributeNumberOfDailyTransitionsID = 34,

	ClusterThermostatAttributeTemperatureSetpointHoldID = 35,

	ClusterThermostatAttributeTemperatureSetpointHoldDurationID = 36,

	ClusterThermostatAttributeThermostatProgrammingOperationModeID = 37,

	ClusterThermostatAttributeThermostatRunningStateID = 41,

	ClusterThermostatAttributeSetpointChangeSourceID = 48,

	ClusterThermostatAttributeSetpointChangeAmountID = 49,

	ClusterThermostatAttributeSetpointChangeSourceTimestampID = 50,

	ClusterThermostatAttributeOccupiedSetbackID = 52,

	ClusterThermostatAttributeOccupiedSetbackMinID = 53,

	ClusterThermostatAttributeOccupiedSetbackMaxID = 54,

	ClusterThermostatAttributeUnoccupiedSetbackID = 55,

	ClusterThermostatAttributeUnoccupiedSetbackMinID = 56,

	ClusterThermostatAttributeUnoccupiedSetbackMaxID = 57,

	ClusterThermostatAttributeEmergencyHeatDeltaID = 58,

	ClusterThermostatAttributeACTypeID = 64,

	ClusterThermostatAttributeACCapacityID = 65,

	ClusterThermostatAttributeACRefrigerantTypeID = 66,

	ClusterThermostatAttributeACCompressorTypeID = 67,

	ClusterThermostatAttributeACErrorCodeID = 68,

	ClusterThermostatAttributeACLouverPositionID = 69,

	ClusterThermostatAttributeACCoilTemperatureID = 70,

	ClusterThermostatAttributeACCapacityformatID = 71,

	ClusterThermostatAttributeGeneratedCommandListID = 65528,

	ClusterThermostatAttributeAcceptedCommandListID = 65529,

	ClusterThermostatAttributeAttributeListID = 65531,

	ClusterThermostatAttributeFeatureMapID = 65532,

	ClusterThermostatAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterThermostatAttributeLocalTemperatureID = 0,

	AttributeIDTypeClusterThermostatAttributeOutdoorTemperatureID = 1,

	AttributeIDTypeClusterThermostatAttributeOccupancyID = 2,

	AttributeIDTypeClusterThermostatAttributeAbsMinHeatSetpointLimitID = 3,

	AttributeIDTypeClusterThermostatAttributeAbsMaxHeatSetpointLimitID = 4,

	AttributeIDTypeClusterThermostatAttributeAbsMinCoolSetpointLimitID = 5,

	AttributeIDTypeClusterThermostatAttributeAbsMaxCoolSetpointLimitID = 6,

	AttributeIDTypeClusterThermostatAttributePICoolingDemandID = 7,

	AttributeIDTypeClusterThermostatAttributePIHeatingDemandID = 8,

	AttributeIDTypeClusterThermostatAttributeHVACSystemTypeConfigurationID = 9,

	AttributeIDTypeClusterThermostatAttributeLocalTemperatureCalibrationID = 16,

	AttributeIDTypeClusterThermostatAttributeOccupiedCoolingSetpointID = 17,

	AttributeIDTypeClusterThermostatAttributeOccupiedHeatingSetpointID = 18,

	AttributeIDTypeClusterThermostatAttributeUnoccupiedCoolingSetpointID = 19,

	AttributeIDTypeClusterThermostatAttributeUnoccupiedHeatingSetpointID = 20,

	AttributeIDTypeClusterThermostatAttributeMinHeatSetpointLimitID = 21,

	AttributeIDTypeClusterThermostatAttributeMaxHeatSetpointLimitID = 22,

	AttributeIDTypeClusterThermostatAttributeMinCoolSetpointLimitID = 23,

	AttributeIDTypeClusterThermostatAttributeMaxCoolSetpointLimitID = 24,

	AttributeIDTypeClusterThermostatAttributeMinSetpointDeadBandID = 25,

	AttributeIDTypeClusterThermostatAttributeRemoteSensingID = 26,

	AttributeIDTypeClusterThermostatAttributeControlSequenceOfOperationID = 27,

	AttributeIDTypeClusterThermostatAttributeSystemModeID = 28,

	AttributeIDTypeClusterThermostatAttributeThermostatRunningModeID = 30,

	AttributeIDTypeClusterThermostatAttributeStartOfWeekID = 32,

	AttributeIDTypeClusterThermostatAttributeNumberOfWeeklyTransitionsID = 33,

	AttributeIDTypeClusterThermostatAttributeNumberOfDailyTransitionsID = 34,

	AttributeIDTypeClusterThermostatAttributeTemperatureSetpointHoldID = 35,

	AttributeIDTypeClusterThermostatAttributeTemperatureSetpointHoldDurationID = 36,

	AttributeIDTypeClusterThermostatAttributeThermostatProgrammingOperationModeID = 37,

	AttributeIDTypeClusterThermostatAttributeThermostatRunningStateID = 41,

	AttributeIDTypeClusterThermostatAttributeSetpointChangeSourceID = 48,

	AttributeIDTypeClusterThermostatAttributeSetpointChangeAmountID = 49,

	AttributeIDTypeClusterThermostatAttributeSetpointChangeSourceTimestampID = 50,

	AttributeIDTypeClusterThermostatAttributeOccupiedSetbackID = 52,

	AttributeIDTypeClusterThermostatAttributeOccupiedSetbackMinID = 53,

	AttributeIDTypeClusterThermostatAttributeOccupiedSetbackMaxID = 54,

	AttributeIDTypeClusterThermostatAttributeUnoccupiedSetbackID = 55,

	AttributeIDTypeClusterThermostatAttributeUnoccupiedSetbackMinID = 56,

	AttributeIDTypeClusterThermostatAttributeUnoccupiedSetbackMaxID = 57,

	AttributeIDTypeClusterThermostatAttributeEmergencyHeatDeltaID = 58,

	AttributeIDTypeClusterThermostatAttributeACTypeID = 64,

	AttributeIDTypeClusterThermostatAttributeACCapacityID = 65,

	AttributeIDTypeClusterThermostatAttributeACRefrigerantTypeID = 66,

	AttributeIDTypeClusterThermostatAttributeACCompressorTypeID = 67,

	AttributeIDTypeClusterThermostatAttributeACErrorCodeID = 68,

	AttributeIDTypeClusterThermostatAttributeACLouverPositionID = 69,

	AttributeIDTypeClusterThermostatAttributeACCoilTemperatureID = 70,

	AttributeIDTypeClusterThermostatAttributeACCapacityformatID = 71,

	AttributeIDTypeClusterThermostatAttributePresetTypesID = 72,

	AttributeIDTypeClusterThermostatAttributeScheduleTypesID = 73,

	AttributeIDTypeClusterThermostatAttributeNumberOfPresetsID = 74,

	AttributeIDTypeClusterThermostatAttributeNumberOfSchedulesID = 75,

	AttributeIDTypeClusterThermostatAttributeNumberOfScheduleTransitionsID = 76,

	AttributeIDTypeClusterThermostatAttributeNumberOfScheduleTransitionPerDayID = 77,

	AttributeIDTypeClusterThermostatAttributeActivePresetHandleID = 78,

	AttributeIDTypeClusterThermostatAttributeActiveScheduleHandleID = 79,

	AttributeIDTypeClusterThermostatAttributePresetsID = 80,

	AttributeIDTypeClusterThermostatAttributeSchedulesID = 81,

	AttributeIDTypeClusterThermostatAttributeSetpointHoldExpiryTimestampID = 82,

	AttributeIDTypeClusterThermostatAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterThermostatAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterThermostatAttributeEventListID = 65530,

	AttributeIDTypeClusterThermostatAttributeAttributeListID = 65531,

	AttributeIDTypeClusterThermostatAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterThermostatAttributeClusterRevisionID = 65533,

	ClusterFanControlAttributeFanModeID = 0,

	ClusterFanControlAttributeFanModeSequenceID = 1,

	ClusterFanControlAttributePercentSettingID = 2,

	ClusterFanControlAttributePercentCurrentID = 3,

	ClusterFanControlAttributeSpeedMaxID = 4,

	ClusterFanControlAttributeSpeedSettingID = 5,

	ClusterFanControlAttributeSpeedCurrentID = 6,

	ClusterFanControlAttributeRockSupportID = 7,

	ClusterFanControlAttributeRockSettingID = 8,

	ClusterFanControlAttributeWindSupportID = 9,

	ClusterFanControlAttributeWindSettingID = 10,

	ClusterFanControlAttributeGeneratedCommandListID = 65528,

	ClusterFanControlAttributeAcceptedCommandListID = 65529,

	ClusterFanControlAttributeAttributeListID = 65531,

	ClusterFanControlAttributeFeatureMapID = 65532,

	ClusterFanControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterFanControlAttributeFanModeID = 0,

	AttributeIDTypeClusterFanControlAttributeFanModeSequenceID = 1,

	AttributeIDTypeClusterFanControlAttributePercentSettingID = 2,

	AttributeIDTypeClusterFanControlAttributePercentCurrentID = 3,

	AttributeIDTypeClusterFanControlAttributeSpeedMaxID = 4,

	AttributeIDTypeClusterFanControlAttributeSpeedSettingID = 5,

	AttributeIDTypeClusterFanControlAttributeSpeedCurrentID = 6,

	AttributeIDTypeClusterFanControlAttributeRockSupportID = 7,

	AttributeIDTypeClusterFanControlAttributeRockSettingID = 8,

	AttributeIDTypeClusterFanControlAttributeWindSupportID = 9,

	AttributeIDTypeClusterFanControlAttributeWindSettingID = 10,

	AttributeIDTypeClusterFanControlAttributeAirflowDirectionID = 11,

	AttributeIDTypeClusterFanControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterFanControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterFanControlAttributeEventListID = 65530,

	AttributeIDTypeClusterFanControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterFanControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterFanControlAttributeClusterRevisionID = 65533,

	ClusterThermostatUserInterfaceConfigurationAttributeTemperatureDisplayModeID = 0,

	ClusterThermostatUserInterfaceConfigurationAttributeKeypadLockoutID = 1,

	ClusterThermostatUserInterfaceConfigurationAttributeScheduleProgrammingVisibilityID = 2,

	ClusterThermostatUserInterfaceConfigurationAttributeGeneratedCommandListID = 65528,

	ClusterThermostatUserInterfaceConfigurationAttributeAcceptedCommandListID = 65529,

	ClusterThermostatUserInterfaceConfigurationAttributeAttributeListID = 65531,

	ClusterThermostatUserInterfaceConfigurationAttributeFeatureMapID = 65532,

	ClusterThermostatUserInterfaceConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeTemperatureDisplayModeID = 0,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeKeypadLockoutID = 1,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeScheduleProgrammingVisibilityID = 2,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeEventListID = 65530,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterThermostatUserInterfaceConfigurationAttributeClusterRevisionID = 65533,

	ClusterColorControlAttributeCurrentHueID = 0,

	ClusterColorControlAttributeCurrentSaturationID = 1,

	ClusterColorControlAttributeRemainingTimeID = 2,

	ClusterColorControlAttributeCurrentXID = 3,

	ClusterColorControlAttributeCurrentYID = 4,

	ClusterColorControlAttributeDriftCompensationID = 5,

	ClusterColorControlAttributeCompensationTextID = 6,

	ClusterColorControlAttributeColorTemperatureMiredsID = 7,

	ClusterColorControlAttributeColorModeID = 8,

	ClusterColorControlAttributeOptionsID = 15,

	ClusterColorControlAttributeNumberOfPrimariesID = 16,

	ClusterColorControlAttributePrimary1XID = 17,

	ClusterColorControlAttributePrimary1YID = 18,

	ClusterColorControlAttributePrimary1IntensityID = 19,

	ClusterColorControlAttributePrimary2XID = 21,

	ClusterColorControlAttributePrimary2YID = 22,

	ClusterColorControlAttributePrimary2IntensityID = 23,

	ClusterColorControlAttributePrimary3XID = 25,

	ClusterColorControlAttributePrimary3YID = 26,

	ClusterColorControlAttributePrimary3IntensityID = 27,

	ClusterColorControlAttributePrimary4XID = 32,

	ClusterColorControlAttributePrimary4YID = 33,

	ClusterColorControlAttributePrimary4IntensityID = 34,

	ClusterColorControlAttributePrimary5XID = 36,

	ClusterColorControlAttributePrimary5YID = 37,

	ClusterColorControlAttributePrimary5IntensityID = 38,

	ClusterColorControlAttributePrimary6XID = 40,

	ClusterColorControlAttributePrimary6YID = 41,

	ClusterColorControlAttributePrimary6IntensityID = 42,

	ClusterColorControlAttributeWhitePointXID = 48,

	ClusterColorControlAttributeWhitePointYID = 49,

	ClusterColorControlAttributeColorPointRXID = 50,

	ClusterColorControlAttributeColorPointRYID = 51,

	ClusterColorControlAttributeColorPointRIntensityID = 52,

	ClusterColorControlAttributeColorPointGXID = 54,

	ClusterColorControlAttributeColorPointGYID = 55,

	ClusterColorControlAttributeColorPointGIntensityID = 56,

	ClusterColorControlAttributeColorPointBXID = 58,

	ClusterColorControlAttributeColorPointBYID = 59,

	ClusterColorControlAttributeColorPointBIntensityID = 60,

	ClusterColorControlAttributeEnhancedCurrentHueID = 16384,

	ClusterColorControlAttributeEnhancedColorModeID = 16385,

	ClusterColorControlAttributeColorLoopActiveID = 16386,

	ClusterColorControlAttributeColorLoopDirectionID = 16387,

	ClusterColorControlAttributeColorLoopTimeID = 16388,

	ClusterColorControlAttributeColorLoopStartEnhancedHueID = 16389,

	ClusterColorControlAttributeColorLoopStoredEnhancedHueID = 16390,

	ClusterColorControlAttributeColorCapabilitiesID = 16394,

	ClusterColorControlAttributeColorTempPhysicalMinMiredsID = 16395,

	ClusterColorControlAttributeColorTempPhysicalMaxMiredsID = 16396,

	ClusterColorControlAttributeCoupleColorTempToLevelMinMiredsID = 16397,

	ClusterColorControlAttributeStartUpColorTemperatureMiredsID = 16400,

	ClusterColorControlAttributeGeneratedCommandListID = 65528,

	ClusterColorControlAttributeAcceptedCommandListID = 65529,

	ClusterColorControlAttributeAttributeListID = 65531,

	ClusterColorControlAttributeFeatureMapID = 65532,

	ClusterColorControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterColorControlAttributeCurrentHueID = 0,

	AttributeIDTypeClusterColorControlAttributeCurrentSaturationID = 1,

	AttributeIDTypeClusterColorControlAttributeRemainingTimeID = 2,

	AttributeIDTypeClusterColorControlAttributeCurrentXID = 3,

	AttributeIDTypeClusterColorControlAttributeCurrentYID = 4,

	AttributeIDTypeClusterColorControlAttributeDriftCompensationID = 5,

	AttributeIDTypeClusterColorControlAttributeCompensationTextID = 6,

	AttributeIDTypeClusterColorControlAttributeColorTemperatureMiredsID = 7,

	AttributeIDTypeClusterColorControlAttributeColorModeID = 8,

	AttributeIDTypeClusterColorControlAttributeOptionsID = 15,

	AttributeIDTypeClusterColorControlAttributeNumberOfPrimariesID = 16,

	AttributeIDTypeClusterColorControlAttributePrimary1XID = 17,

	AttributeIDTypeClusterColorControlAttributePrimary1YID = 18,

	AttributeIDTypeClusterColorControlAttributePrimary1IntensityID = 19,

	AttributeIDTypeClusterColorControlAttributePrimary2XID = 21,

	AttributeIDTypeClusterColorControlAttributePrimary2YID = 22,

	AttributeIDTypeClusterColorControlAttributePrimary2IntensityID = 23,

	AttributeIDTypeClusterColorControlAttributePrimary3XID = 25,

	AttributeIDTypeClusterColorControlAttributePrimary3YID = 26,

	AttributeIDTypeClusterColorControlAttributePrimary3IntensityID = 27,

	AttributeIDTypeClusterColorControlAttributePrimary4XID = 32,

	AttributeIDTypeClusterColorControlAttributePrimary4YID = 33,

	AttributeIDTypeClusterColorControlAttributePrimary4IntensityID = 34,

	AttributeIDTypeClusterColorControlAttributePrimary5XID = 36,

	AttributeIDTypeClusterColorControlAttributePrimary5YID = 37,

	AttributeIDTypeClusterColorControlAttributePrimary5IntensityID = 38,

	AttributeIDTypeClusterColorControlAttributePrimary6XID = 40,

	AttributeIDTypeClusterColorControlAttributePrimary6YID = 41,

	AttributeIDTypeClusterColorControlAttributePrimary6IntensityID = 42,

	AttributeIDTypeClusterColorControlAttributeWhitePointXID = 48,

	AttributeIDTypeClusterColorControlAttributeWhitePointYID = 49,

	AttributeIDTypeClusterColorControlAttributeColorPointRXID = 50,

	AttributeIDTypeClusterColorControlAttributeColorPointRYID = 51,

	AttributeIDTypeClusterColorControlAttributeColorPointRIntensityID = 52,

	AttributeIDTypeClusterColorControlAttributeColorPointGXID = 54,

	AttributeIDTypeClusterColorControlAttributeColorPointGYID = 55,

	AttributeIDTypeClusterColorControlAttributeColorPointGIntensityID = 56,

	AttributeIDTypeClusterColorControlAttributeColorPointBXID = 58,

	AttributeIDTypeClusterColorControlAttributeColorPointBYID = 59,

	AttributeIDTypeClusterColorControlAttributeColorPointBIntensityID = 60,

	AttributeIDTypeClusterColorControlAttributeEnhancedCurrentHueID = 16384,

	AttributeIDTypeClusterColorControlAttributeEnhancedColorModeID = 16385,

	AttributeIDTypeClusterColorControlAttributeColorLoopActiveID = 16386,

	AttributeIDTypeClusterColorControlAttributeColorLoopDirectionID = 16387,

	AttributeIDTypeClusterColorControlAttributeColorLoopTimeID = 16388,

	AttributeIDTypeClusterColorControlAttributeColorLoopStartEnhancedHueID = 16389,

	AttributeIDTypeClusterColorControlAttributeColorLoopStoredEnhancedHueID = 16390,

	AttributeIDTypeClusterColorControlAttributeColorCapabilitiesID = 16394,

	AttributeIDTypeClusterColorControlAttributeColorTempPhysicalMinMiredsID = 16395,

	AttributeIDTypeClusterColorControlAttributeColorTempPhysicalMaxMiredsID = 16396,

	AttributeIDTypeClusterColorControlAttributeCoupleColorTempToLevelMinMiredsID = 16397,

	AttributeIDTypeClusterColorControlAttributeStartUpColorTemperatureMiredsID = 16400,

	AttributeIDTypeClusterColorControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterColorControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterColorControlAttributeEventListID = 65530,

	AttributeIDTypeClusterColorControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterColorControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterColorControlAttributeClusterRevisionID = 65533,

	ClusterBallastConfigurationAttributePhysicalMinLevelID = 0,

	ClusterBallastConfigurationAttributePhysicalMaxLevelID = 1,

	ClusterBallastConfigurationAttributeBallastStatusID = 2,

	ClusterBallastConfigurationAttributeMinLevelID = 16,

	ClusterBallastConfigurationAttributeMaxLevelID = 17,

	ClusterBallastConfigurationAttributeIntrinsicBalanceFactorID = 20,

	ClusterBallastConfigurationAttributeBallastFactorAdjustmentID = 21,

	ClusterBallastConfigurationAttributeLampQuantityID = 32,

	ClusterBallastConfigurationAttributeLampTypeID = 48,

	ClusterBallastConfigurationAttributeLampManufacturerID = 49,

	ClusterBallastConfigurationAttributeLampRatedHoursID = 50,

	ClusterBallastConfigurationAttributeLampBurnHoursID = 51,

	ClusterBallastConfigurationAttributeLampAlarmModeID = 52,

	ClusterBallastConfigurationAttributeLampBurnHoursTripPointID = 53,

	ClusterBallastConfigurationAttributeGeneratedCommandListID = 65528,

	ClusterBallastConfigurationAttributeAcceptedCommandListID = 65529,

	ClusterBallastConfigurationAttributeAttributeListID = 65531,

	ClusterBallastConfigurationAttributeFeatureMapID = 65532,

	ClusterBallastConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBallastConfigurationAttributePhysicalMinLevelID = 0,

	AttributeIDTypeClusterBallastConfigurationAttributePhysicalMaxLevelID = 1,

	AttributeIDTypeClusterBallastConfigurationAttributeBallastStatusID = 2,

	AttributeIDTypeClusterBallastConfigurationAttributeMinLevelID = 16,

	AttributeIDTypeClusterBallastConfigurationAttributeMaxLevelID = 17,

	AttributeIDTypeClusterBallastConfigurationAttributeIntrinsicBallastFactorID = 20,

	AttributeIDTypeClusterBallastConfigurationAttributeBallastFactorAdjustmentID = 21,

	AttributeIDTypeClusterBallastConfigurationAttributeLampQuantityID = 32,

	AttributeIDTypeClusterBallastConfigurationAttributeLampTypeID = 48,

	AttributeIDTypeClusterBallastConfigurationAttributeLampManufacturerID = 49,

	AttributeIDTypeClusterBallastConfigurationAttributeLampRatedHoursID = 50,

	AttributeIDTypeClusterBallastConfigurationAttributeLampBurnHoursID = 51,

	AttributeIDTypeClusterBallastConfigurationAttributeLampAlarmModeID = 52,

	AttributeIDTypeClusterBallastConfigurationAttributeLampBurnHoursTripPointID = 53,

	AttributeIDTypeClusterBallastConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBallastConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBallastConfigurationAttributeEventListID = 65530,

	AttributeIDTypeClusterBallastConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBallastConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBallastConfigurationAttributeClusterRevisionID = 65533,

	ClusterIlluminanceMeasurementAttributeMeasuredValueID = 0,

	ClusterIlluminanceMeasurementAttributeMinMeasuredValueID = 1,

	ClusterIlluminanceMeasurementAttributeMaxMeasuredValueID = 2,

	ClusterIlluminanceMeasurementAttributeToleranceID = 3,

	ClusterIlluminanceMeasurementAttributeLightSensorTypeID = 4,

	ClusterIlluminanceMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterIlluminanceMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterIlluminanceMeasurementAttributeAttributeListID = 65531,

	ClusterIlluminanceMeasurementAttributeFeatureMapID = 65532,

	ClusterIlluminanceMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeToleranceID = 3,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeLightSensorTypeID = 4,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterIlluminanceMeasurementAttributeClusterRevisionID = 65533,

	ClusterTemperatureMeasurementAttributeMeasuredValueID = 0,

	ClusterTemperatureMeasurementAttributeMinMeasuredValueID = 1,

	ClusterTemperatureMeasurementAttributeMaxMeasuredValueID = 2,

	ClusterTemperatureMeasurementAttributeToleranceID = 3,

	ClusterTemperatureMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterTemperatureMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterTemperatureMeasurementAttributeAttributeListID = 65531,

	ClusterTemperatureMeasurementAttributeFeatureMapID = 65532,

	ClusterTemperatureMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTemperatureMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterTemperatureMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterTemperatureMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterTemperatureMeasurementAttributeToleranceID = 3,

	AttributeIDTypeClusterTemperatureMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTemperatureMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTemperatureMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterTemperatureMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTemperatureMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTemperatureMeasurementAttributeClusterRevisionID = 65533,

	ClusterPressureMeasurementAttributeMeasuredValueID = 0,

	ClusterPressureMeasurementAttributeMinMeasuredValueID = 1,

	ClusterPressureMeasurementAttributeMaxMeasuredValueID = 2,

	ClusterPressureMeasurementAttributeToleranceID = 3,

	ClusterPressureMeasurementAttributeScaledValueID = 16,

	ClusterPressureMeasurementAttributeMinScaledValueID = 17,

	ClusterPressureMeasurementAttributeMaxScaledValueID = 18,

	ClusterPressureMeasurementAttributeScaledToleranceID = 19,

	ClusterPressureMeasurementAttributeScaleID = 20,

	ClusterPressureMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterPressureMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterPressureMeasurementAttributeAttributeListID = 65531,

	ClusterPressureMeasurementAttributeFeatureMapID = 65532,

	ClusterPressureMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPressureMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterPressureMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterPressureMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterPressureMeasurementAttributeToleranceID = 3,

	AttributeIDTypeClusterPressureMeasurementAttributeScaledValueID = 16,

	AttributeIDTypeClusterPressureMeasurementAttributeMinScaledValueID = 17,

	AttributeIDTypeClusterPressureMeasurementAttributeMaxScaledValueID = 18,

	AttributeIDTypeClusterPressureMeasurementAttributeScaledToleranceID = 19,

	AttributeIDTypeClusterPressureMeasurementAttributeScaleID = 20,

	AttributeIDTypeClusterPressureMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPressureMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPressureMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterPressureMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPressureMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPressureMeasurementAttributeClusterRevisionID = 65533,

	ClusterFlowMeasurementAttributeMeasuredValueID = 0,

	ClusterFlowMeasurementAttributeMinMeasuredValueID = 1,

	ClusterFlowMeasurementAttributeMaxMeasuredValueID = 2,

	ClusterFlowMeasurementAttributeToleranceID = 3,

	ClusterFlowMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterFlowMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterFlowMeasurementAttributeAttributeListID = 65531,

	ClusterFlowMeasurementAttributeFeatureMapID = 65532,

	ClusterFlowMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterFlowMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterFlowMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterFlowMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterFlowMeasurementAttributeToleranceID = 3,

	AttributeIDTypeClusterFlowMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterFlowMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterFlowMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterFlowMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterFlowMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterFlowMeasurementAttributeClusterRevisionID = 65533,

	ClusterRelativeHumidityMeasurementAttributeMeasuredValueID = 0,

	ClusterRelativeHumidityMeasurementAttributeMinMeasuredValueID = 1,

	ClusterRelativeHumidityMeasurementAttributeMaxMeasuredValueID = 2,

	ClusterRelativeHumidityMeasurementAttributeToleranceID = 3,

	ClusterRelativeHumidityMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterRelativeHumidityMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterRelativeHumidityMeasurementAttributeAttributeListID = 65531,

	ClusterRelativeHumidityMeasurementAttributeFeatureMapID = 65532,

	ClusterRelativeHumidityMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeToleranceID = 3,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRelativeHumidityMeasurementAttributeClusterRevisionID = 65533,

	ClusterOccupancySensingAttributeOccupancyID = 0,

	ClusterOccupancySensingAttributeOccupancySensorTypeID = 1,

	ClusterOccupancySensingAttributeOccupancySensorTypeBitmapID = 2,

	ClusterOccupancySensingAttributePirOccupiedToUnoccupiedDelayID = 16,

	ClusterOccupancySensingAttributePirUnoccupiedToOccupiedDelayID = 17,

	ClusterOccupancySensingAttributePirUnoccupiedToOccupiedThresholdID = 18,

	ClusterOccupancySensingAttributeUltrasonicOccupiedToUnoccupiedDelayID = 32,

	ClusterOccupancySensingAttributeUltrasonicUnoccupiedToOccupiedDelayID = 33,

	ClusterOccupancySensingAttributeUltrasonicUnoccupiedToOccupiedThresholdID = 34,

	ClusterOccupancySensingAttributePhysicalContactOccupiedToUnoccupiedDelayID = 48,

	ClusterOccupancySensingAttributePhysicalContactUnoccupiedToOccupiedDelayID = 49,

	ClusterOccupancySensingAttributePhysicalContactUnoccupiedToOccupiedThresholdID = 50,

	ClusterOccupancySensingAttributeGeneratedCommandListID = 65528,

	ClusterOccupancySensingAttributeAcceptedCommandListID = 65529,

	ClusterOccupancySensingAttributeAttributeListID = 65531,

	ClusterOccupancySensingAttributeFeatureMapID = 65532,

	ClusterOccupancySensingAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOccupancySensingAttributeOccupancyID = 0,

	AttributeIDTypeClusterOccupancySensingAttributeOccupancySensorTypeID = 1,

	AttributeIDTypeClusterOccupancySensingAttributeOccupancySensorTypeBitmapID = 2,

	AttributeIDTypeClusterOccupancySensingAttributeHoldTimeID = 3,

	AttributeIDTypeClusterOccupancySensingAttributeHoldTimeLimitsID = 4,

	AttributeIDTypeClusterOccupancySensingAttributePIROccupiedToUnoccupiedDelayID = 16,

	AttributeIDTypeClusterOccupancySensingAttributePIRUnoccupiedToOccupiedDelayID = 17,

	AttributeIDTypeClusterOccupancySensingAttributePIRUnoccupiedToOccupiedThresholdID = 18,

	AttributeIDTypeClusterOccupancySensingAttributeUltrasonicOccupiedToUnoccupiedDelayID = 32,

	AttributeIDTypeClusterOccupancySensingAttributeUltrasonicUnoccupiedToOccupiedDelayID = 33,

	AttributeIDTypeClusterOccupancySensingAttributeUltrasonicUnoccupiedToOccupiedThresholdID = 34,

	AttributeIDTypeClusterOccupancySensingAttributePhysicalContactOccupiedToUnoccupiedDelayID = 48,

	AttributeIDTypeClusterOccupancySensingAttributePhysicalContactUnoccupiedToOccupiedDelayID = 49,

	AttributeIDTypeClusterOccupancySensingAttributePhysicalContactUnoccupiedToOccupiedThresholdID = 50,

	AttributeIDTypeClusterOccupancySensingAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOccupancySensingAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOccupancySensingAttributeEventListID = 65530,

	AttributeIDTypeClusterOccupancySensingAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOccupancySensingAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOccupancySensingAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterCarbonMonoxideConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterCarbonDioxideConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterNitrogenDioxideConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOzoneConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPM25ConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterFormaldehydeConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPM1ConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterPM10ConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTotalVolatileOrganicCompoundsConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeMeasuredValueID = 0,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeMinMeasuredValueID = 1,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeMaxMeasuredValueID = 2,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributePeakMeasuredValueID = 3,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributePeakMeasuredValueWindowID = 4,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeAverageMeasuredValueID = 5,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeAverageMeasuredValueWindowID = 6,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeUncertaintyID = 7,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeMeasurementUnitID = 8,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeMeasurementMediumID = 9,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeLevelValueID = 10,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeEventListID = 65530,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterRadonConcentrationMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeSSIDID = 0,

	AttributeIDTypeClusterWiFiNetworkManagementAttributePassphraseSurrogateID = 1,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWiFiNetworkManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeBorderRouterNameID = 0,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeBorderAgentIDID = 1,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeThreadVersionID = 2,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeInterfaceEnabledID = 3,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeActiveDatasetTimestampID = 4,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributePendingDatasetTimestampID = 5,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterThreadBorderRouterManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributePreferredExtendedPanIDID = 0,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeThreadNetworksID = 1,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeThreadNetworkTableSizeID = 2,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeEventListID = 65530,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeAttributeListID = 65531,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterThreadNetworkDirectoryAttributeClusterRevisionID = 65533,

	ClusterWakeOnLanAttributeMACAddressID = 0,

	ClusterWakeOnLanAttributeGeneratedCommandListID = 65528,

	ClusterWakeOnLanAttributeAcceptedCommandListID = 65529,

	ClusterWakeOnLanAttributeAttributeListID = 65531,

	ClusterWakeOnLanAttributeFeatureMapID = 65532,

	ClusterWakeOnLanAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWakeOnLANAttributeMACAddressID = 0,

	AttributeIDTypeClusterWakeOnLANAttributeLinkLocalAddressID = 1,

	AttributeIDTypeClusterWakeOnLANAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWakeOnLANAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWakeOnLANAttributeEventListID = 65530,

	AttributeIDTypeClusterWakeOnLANAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWakeOnLANAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWakeOnLANAttributeClusterRevisionID = 65533,

	ClusterChannelAttributeChannelListID = 0,

	ClusterChannelAttributeLineupID = 1,

	ClusterChannelAttributeCurrentChannelID = 2,

	ClusterChannelAttributeGeneratedCommandListID = 65528,

	ClusterChannelAttributeAcceptedCommandListID = 65529,

	ClusterChannelAttributeAttributeListID = 65531,

	ClusterChannelAttributeFeatureMapID = 65532,

	ClusterChannelAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterChannelAttributeChannelListID = 0,

	AttributeIDTypeClusterChannelAttributeLineupID = 1,

	AttributeIDTypeClusterChannelAttributeCurrentChannelID = 2,

	AttributeIDTypeClusterChannelAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterChannelAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterChannelAttributeEventListID = 65530,

	AttributeIDTypeClusterChannelAttributeAttributeListID = 65531,

	AttributeIDTypeClusterChannelAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterChannelAttributeClusterRevisionID = 65533,

	ClusterTargetNavigatorAttributeTargetListID = 0,

	ClusterTargetNavigatorAttributeCurrentTargetID = 1,

	ClusterTargetNavigatorAttributeGeneratedCommandListID = 65528,

	ClusterTargetNavigatorAttributeAcceptedCommandListID = 65529,

	ClusterTargetNavigatorAttributeAttributeListID = 65531,

	ClusterTargetNavigatorAttributeFeatureMapID = 65532,

	ClusterTargetNavigatorAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterTargetNavigatorAttributeTargetListID = 0,

	AttributeIDTypeClusterTargetNavigatorAttributeCurrentTargetID = 1,

	AttributeIDTypeClusterTargetNavigatorAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterTargetNavigatorAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterTargetNavigatorAttributeEventListID = 65530,

	AttributeIDTypeClusterTargetNavigatorAttributeAttributeListID = 65531,

	AttributeIDTypeClusterTargetNavigatorAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterTargetNavigatorAttributeClusterRevisionID = 65533,

	ClusterMediaPlaybackAttributeCurrentStateID = 0,

	ClusterMediaPlaybackAttributeStartTimeID = 1,

	ClusterMediaPlaybackAttributeDurationID = 2,

	ClusterMediaPlaybackAttributeSampledPositionID = 3,

	ClusterMediaPlaybackAttributePlaybackSpeedID = 4,

	ClusterMediaPlaybackAttributeSeekRangeEndID = 5,

	ClusterMediaPlaybackAttributeSeekRangeStartID = 6,

	ClusterMediaPlaybackAttributeGeneratedCommandListID = 65528,

	ClusterMediaPlaybackAttributeAcceptedCommandListID = 65529,

	ClusterMediaPlaybackAttributeAttributeListID = 65531,

	ClusterMediaPlaybackAttributeFeatureMapID = 65532,

	ClusterMediaPlaybackAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterMediaPlaybackAttributeCurrentStateID = 0,

	AttributeIDTypeClusterMediaPlaybackAttributeStartTimeID = 1,

	AttributeIDTypeClusterMediaPlaybackAttributeDurationID = 2,

	AttributeIDTypeClusterMediaPlaybackAttributeSampledPositionID = 3,

	AttributeIDTypeClusterMediaPlaybackAttributePlaybackSpeedID = 4,

	AttributeIDTypeClusterMediaPlaybackAttributeSeekRangeEndID = 5,

	AttributeIDTypeClusterMediaPlaybackAttributeSeekRangeStartID = 6,

	AttributeIDTypeClusterMediaPlaybackAttributeActiveAudioTrackID = 7,

	AttributeIDTypeClusterMediaPlaybackAttributeAvailableAudioTracksID = 8,

	AttributeIDTypeClusterMediaPlaybackAttributeActiveTextTrackID = 9,

	AttributeIDTypeClusterMediaPlaybackAttributeAvailableTextTracksID = 10,

	AttributeIDTypeClusterMediaPlaybackAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterMediaPlaybackAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterMediaPlaybackAttributeEventListID = 65530,

	AttributeIDTypeClusterMediaPlaybackAttributeAttributeListID = 65531,

	AttributeIDTypeClusterMediaPlaybackAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterMediaPlaybackAttributeClusterRevisionID = 65533,

	ClusterMediaInputAttributeInputListID = 0,

	ClusterMediaInputAttributeCurrentInputID = 1,

	ClusterMediaInputAttributeGeneratedCommandListID = 65528,

	ClusterMediaInputAttributeAcceptedCommandListID = 65529,

	ClusterMediaInputAttributeAttributeListID = 65531,

	ClusterMediaInputAttributeFeatureMapID = 65532,

	ClusterMediaInputAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterMediaInputAttributeInputListID = 0,

	AttributeIDTypeClusterMediaInputAttributeCurrentInputID = 1,

	AttributeIDTypeClusterMediaInputAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterMediaInputAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterMediaInputAttributeEventListID = 65530,

	AttributeIDTypeClusterMediaInputAttributeAttributeListID = 65531,

	AttributeIDTypeClusterMediaInputAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterMediaInputAttributeClusterRevisionID = 65533,

	ClusterLowPowerAttributeGeneratedCommandListID = 65528,

	ClusterLowPowerAttributeAcceptedCommandListID = 65529,

	ClusterLowPowerAttributeAttributeListID = 65531,

	ClusterLowPowerAttributeFeatureMapID = 65532,

	ClusterLowPowerAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterLowPowerAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterLowPowerAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterLowPowerAttributeEventListID = 65530,

	AttributeIDTypeClusterLowPowerAttributeAttributeListID = 65531,

	AttributeIDTypeClusterLowPowerAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterLowPowerAttributeClusterRevisionID = 65533,

	ClusterKeypadInputAttributeGeneratedCommandListID = 65528,

	ClusterKeypadInputAttributeAcceptedCommandListID = 65529,

	ClusterKeypadInputAttributeAttributeListID = 65531,

	ClusterKeypadInputAttributeFeatureMapID = 65532,

	ClusterKeypadInputAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterKeypadInputAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterKeypadInputAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterKeypadInputAttributeEventListID = 65530,

	AttributeIDTypeClusterKeypadInputAttributeAttributeListID = 65531,

	AttributeIDTypeClusterKeypadInputAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterKeypadInputAttributeClusterRevisionID = 65533,

	ClusterContentLauncherAttributeAcceptHeaderID = 0,

	ClusterContentLauncherAttributeSupportedStreamingProtocolsID = 1,

	ClusterContentLauncherAttributeGeneratedCommandListID = 65528,

	ClusterContentLauncherAttributeAcceptedCommandListID = 65529,

	ClusterContentLauncherAttributeAttributeListID = 65531,

	ClusterContentLauncherAttributeFeatureMapID = 65532,

	ClusterContentLauncherAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterContentLauncherAttributeAcceptHeaderID = 0,

	AttributeIDTypeClusterContentLauncherAttributeSupportedStreamingProtocolsID = 1,

	AttributeIDTypeClusterContentLauncherAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterContentLauncherAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterContentLauncherAttributeEventListID = 65530,

	AttributeIDTypeClusterContentLauncherAttributeAttributeListID = 65531,

	AttributeIDTypeClusterContentLauncherAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterContentLauncherAttributeClusterRevisionID = 65533,

	ClusterAudioOutputAttributeOutputListID = 0,

	ClusterAudioOutputAttributeCurrentOutputID = 1,

	ClusterAudioOutputAttributeGeneratedCommandListID = 65528,

	ClusterAudioOutputAttributeAcceptedCommandListID = 65529,

	ClusterAudioOutputAttributeAttributeListID = 65531,

	ClusterAudioOutputAttributeFeatureMapID = 65532,

	ClusterAudioOutputAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAudioOutputAttributeOutputListID = 0,

	AttributeIDTypeClusterAudioOutputAttributeCurrentOutputID = 1,

	AttributeIDTypeClusterAudioOutputAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAudioOutputAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAudioOutputAttributeEventListID = 65530,

	AttributeIDTypeClusterAudioOutputAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAudioOutputAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAudioOutputAttributeClusterRevisionID = 65533,

	ClusterApplicationLauncherAttributeCatalogListID = 0,

	ClusterApplicationLauncherAttributeCurrentAppID = 1,

	ClusterApplicationLauncherAttributeGeneratedCommandListID = 65528,

	ClusterApplicationLauncherAttributeAcceptedCommandListID = 65529,

	ClusterApplicationLauncherAttributeAttributeListID = 65531,

	ClusterApplicationLauncherAttributeFeatureMapID = 65532,

	ClusterApplicationLauncherAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterApplicationLauncherAttributeCatalogListID = 0,

	AttributeIDTypeClusterApplicationLauncherAttributeCurrentAppID = 1,

	AttributeIDTypeClusterApplicationLauncherAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterApplicationLauncherAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterApplicationLauncherAttributeEventListID = 65530,

	AttributeIDTypeClusterApplicationLauncherAttributeAttributeListID = 65531,

	AttributeIDTypeClusterApplicationLauncherAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterApplicationLauncherAttributeClusterRevisionID = 65533,

	ClusterApplicationBasicAttributeVendorNameID = 0,

	ClusterApplicationBasicAttributeVendorIDID = 1,

	ClusterApplicationBasicAttributeApplicationNameID = 2,

	ClusterApplicationBasicAttributeProductIDID = 3,

	ClusterApplicationBasicAttributeApplicationID = 4,

	ClusterApplicationBasicAttributeStatusID = 5,

	ClusterApplicationBasicAttributeApplicationVersionID = 6,

	ClusterApplicationBasicAttributeAllowedVendorListID = 7,

	ClusterApplicationBasicAttributeGeneratedCommandListID = 65528,

	ClusterApplicationBasicAttributeAcceptedCommandListID = 65529,

	ClusterApplicationBasicAttributeAttributeListID = 65531,

	ClusterApplicationBasicAttributeFeatureMapID = 65532,

	ClusterApplicationBasicAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterApplicationBasicAttributeVendorNameID = 0,

	AttributeIDTypeClusterApplicationBasicAttributeVendorIDID = 1,

	AttributeIDTypeClusterApplicationBasicAttributeApplicationNameID = 2,

	AttributeIDTypeClusterApplicationBasicAttributeProductIDID = 3,

	AttributeIDTypeClusterApplicationBasicAttributeApplicationID = 4,

	AttributeIDTypeClusterApplicationBasicAttributeStatusID = 5,

	AttributeIDTypeClusterApplicationBasicAttributeApplicationVersionID = 6,

	AttributeIDTypeClusterApplicationBasicAttributeAllowedVendorListID = 7,

	AttributeIDTypeClusterApplicationBasicAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterApplicationBasicAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterApplicationBasicAttributeEventListID = 65530,

	AttributeIDTypeClusterApplicationBasicAttributeAttributeListID = 65531,

	AttributeIDTypeClusterApplicationBasicAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterApplicationBasicAttributeClusterRevisionID = 65533,

	ClusterAccountLoginAttributeGeneratedCommandListID = 65528,

	ClusterAccountLoginAttributeAcceptedCommandListID = 65529,

	ClusterAccountLoginAttributeAttributeListID = 65531,

	ClusterAccountLoginAttributeFeatureMapID = 65532,

	ClusterAccountLoginAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterAccountLoginAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterAccountLoginAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterAccountLoginAttributeEventListID = 65530,

	AttributeIDTypeClusterAccountLoginAttributeAttributeListID = 65531,

	AttributeIDTypeClusterAccountLoginAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterAccountLoginAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterContentControlAttributeEnabledID = 0,

	AttributeIDTypeClusterContentControlAttributeOnDemandRatingsID = 1,

	AttributeIDTypeClusterContentControlAttributeOnDemandRatingThresholdID = 2,

	AttributeIDTypeClusterContentControlAttributeScheduledContentRatingsID = 3,

	AttributeIDTypeClusterContentControlAttributeScheduledContentRatingThresholdID = 4,

	AttributeIDTypeClusterContentControlAttributeScreenDailyTimeID = 5,

	AttributeIDTypeClusterContentControlAttributeRemainingScreenTimeID = 6,

	AttributeIDTypeClusterContentControlAttributeBlockUnratedID = 7,

	AttributeIDTypeClusterContentControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterContentControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterContentControlAttributeEventListID = 65530,

	AttributeIDTypeClusterContentControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterContentControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterContentControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterContentAppObserverAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterContentAppObserverAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterContentAppObserverAttributeEventListID = 65530,

	AttributeIDTypeClusterContentAppObserverAttributeAttributeListID = 65531,

	AttributeIDTypeClusterContentAppObserverAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterContentAppObserverAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterZoneManagementAttributeSupportedZoneSourcesID = 0,

	AttributeIDTypeClusterZoneManagementAttributeZonesID = 1,

	AttributeIDTypeClusterZoneManagementAttributeTimeControlID = 2,

	AttributeIDTypeClusterZoneManagementAttributeSensitivityID = 3,

	AttributeIDTypeClusterZoneManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterZoneManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterZoneManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterZoneManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterZoneManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterZoneManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMaxConcurrentVideoEncodersID = 0,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMaxEncodedPixelRateID = 1,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeVideoSensorParamsID = 2,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeNightVisionCapableID = 3,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMinViewportID = 4,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeRateDistortionTradeOffPointsID = 5,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMaxPreRollBufferSizeID = 6,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneCapabilitiesID = 7,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSpeakerCapabilitiesID = 8,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeTwoWayTalkSupportID = 9,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSupportedSnapshotParamsID = 10,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMaxNetworkBandwidthID = 11,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeCurrentFrameRateID = 12,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeHDRModeEnabledID = 13,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeCurrentVideoCodecsID = 14,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeCurrentSnapshotConfigID = 15,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeFabricsUsingCameraID = 16,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAllocatedVideoStreamsID = 17,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAllocatedAudioStreamsID = 18,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAllocatedSnapshotStreamsID = 19,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeRankedVideoStreamPrioritiesListID = 20,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSoftRecordingPrivacyModeEnabledID = 21,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSoftLivestreamPrivacyModeEnabledID = 22,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeHardPrivacyModeOnID = 23,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeNightVisionID = 24,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeNightVisionIllumID = 25,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAWBEnabledID = 26,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAutoShutterSpeedEnabledID = 27,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAutoISOEnabledID = 28,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeViewportID = 29,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSpeakerMutedID = 30,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSpeakerVolumeLevelID = 31,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSpeakerMaxLevelID = 32,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeSpeakerMinLevelID = 33,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneMutedID = 34,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneVolumeLevelID = 35,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneMaxLevelID = 36,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneMinLevelID = 37,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeMicrophoneAGCEnabledID = 38,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeImageRotationID = 39,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeImageFlipHorizontalID = 40,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeImageFlipVerticalID = 41,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeLocalVideoRecordingEnabledID = 42,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeLocalSnapshotRecordingEnabledID = 43,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeStatusLightEnabledID = 44,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeStatusLightBrightnessID = 45,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeDepthSensorStatusID = 46,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeEventListID = 65530,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterCameraAVStreamManagementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeCurrentSessionsID = 0,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeEventListID = 65530,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWebRTCTransportProviderAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeCurrentSessionsID = 0,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeEventListID = 65530,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeAttributeListID = 65531,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterWebRTCTransportRequestorAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterChimeAttributeInstalledChimeSoundsID = 0,

	AttributeIDTypeClusterChimeAttributeActiveChimeIDID = 1,

	AttributeIDTypeClusterChimeAttributeEnabledID = 2,

	AttributeIDTypeClusterChimeAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterChimeAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterChimeAttributeEventListID = 65530,

	AttributeIDTypeClusterChimeAttributeAttributeListID = 65531,

	AttributeIDTypeClusterChimeAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterChimeAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterEcosystemInformationAttributeDeviceDirectoryID = 0,

	AttributeIDTypeClusterEcosystemInformationAttributeLocationDirectoryID = 1,

	AttributeIDTypeClusterEcosystemInformationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterEcosystemInformationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterEcosystemInformationAttributeEventListID = 65530,

	AttributeIDTypeClusterEcosystemInformationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterEcosystemInformationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterEcosystemInformationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterCommissionerControlAttributeSupportedDeviceCategoriesID = 0,

	AttributeIDTypeClusterCommissionerControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterCommissionerControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterCommissionerControlAttributeEventListID = 65530,

	AttributeIDTypeClusterCommissionerControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterCommissionerControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterCommissionerControlAttributeClusterRevisionID = 65533,

	ClusterTestClusterAttributeBooleanID = 0,

	ClusterTestClusterAttributeBitmap8ID = 1,

	ClusterTestClusterAttributeBitmap16ID = 2,

	ClusterTestClusterAttributeBitmap32ID = 3,

	ClusterTestClusterAttributeBitmap64ID = 4,

	ClusterTestClusterAttributeInt8uID = 5,

	ClusterTestClusterAttributeInt16uID = 6,

	ClusterTestClusterAttributeInt24uID = 7,

	ClusterTestClusterAttributeInt32uID = 8,

	ClusterTestClusterAttributeInt40uID = 9,

	ClusterTestClusterAttributeInt48uID = 10,

	ClusterTestClusterAttributeInt56uID = 11,

	ClusterTestClusterAttributeInt64uID = 12,

	ClusterTestClusterAttributeInt8sID = 13,

	ClusterTestClusterAttributeInt16sID = 14,

	ClusterTestClusterAttributeInt24sID = 15,

	ClusterTestClusterAttributeInt32sID = 16,

	ClusterTestClusterAttributeInt40sID = 17,

	ClusterTestClusterAttributeInt48sID = 18,

	ClusterTestClusterAttributeInt56sID = 19,

	ClusterTestClusterAttributeInt64sID = 20,

	ClusterTestClusterAttributeEnum8ID = 21,

	ClusterTestClusterAttributeEnum16ID = 22,

	ClusterTestClusterAttributeFloatSingleID = 23,

	ClusterTestClusterAttributeFloatDoubleID = 24,

	ClusterTestClusterAttributeOctetStringID = 25,

	ClusterTestClusterAttributeListInt8uID = 26,

	ClusterTestClusterAttributeListOctetStringID = 27,

	ClusterTestClusterAttributeListStructOctetStringID = 28,

	ClusterTestClusterAttributeLongOctetStringID = 29,

	ClusterTestClusterAttributeCharStringID = 30,

	ClusterTestClusterAttributeLongCharStringID = 31,

	ClusterTestClusterAttributeEpochUsID = 32,

	ClusterTestClusterAttributeEpochSID = 33,

	ClusterTestClusterAttributeVendorIdID = 34,

	ClusterTestClusterAttributeListNullablesAndOptionalsStructID = 35,

	ClusterTestClusterAttributeEnumAttrID = 36,

	ClusterTestClusterAttributeStructAttrID = 37,

	ClusterTestClusterAttributeRangeRestrictedInt8uID = 38,

	ClusterTestClusterAttributeRangeRestrictedInt8sID = 39,

	ClusterTestClusterAttributeRangeRestrictedInt16uID = 40,

	ClusterTestClusterAttributeRangeRestrictedInt16sID = 41,

	ClusterTestClusterAttributeListLongOctetStringID = 42,

	ClusterTestClusterAttributeListFabricScopedID = 43,

	ClusterTestClusterAttributeTimedWriteBooleanID = 48,

	ClusterTestClusterAttributeGeneralErrorBooleanID = 49,

	ClusterTestClusterAttributeClusterErrorBooleanID = 50,

	ClusterTestClusterAttributeUnsupportedID = 255,

	ClusterTestClusterAttributeNullableBooleanID = 16384,

	ClusterTestClusterAttributeNullableBitmap8ID = 16385,

	ClusterTestClusterAttributeNullableBitmap16ID = 16386,

	ClusterTestClusterAttributeNullableBitmap32ID = 16387,

	ClusterTestClusterAttributeNullableBitmap64ID = 16388,

	ClusterTestClusterAttributeNullableInt8uID = 16389,

	ClusterTestClusterAttributeNullableInt16uID = 16390,

	ClusterTestClusterAttributeNullableInt24uID = 16391,

	ClusterTestClusterAttributeNullableInt32uID = 16392,

	ClusterTestClusterAttributeNullableInt40uID = 16393,

	ClusterTestClusterAttributeNullableInt48uID = 16394,

	ClusterTestClusterAttributeNullableInt56uID = 16395,

	ClusterTestClusterAttributeNullableInt64uID = 16396,

	ClusterTestClusterAttributeNullableInt8sID = 16397,

	ClusterTestClusterAttributeNullableInt16sID = 16398,

	ClusterTestClusterAttributeNullableInt24sID = 16399,

	ClusterTestClusterAttributeNullableInt32sID = 16400,

	ClusterTestClusterAttributeNullableInt40sID = 16401,

	ClusterTestClusterAttributeNullableInt48sID = 16402,

	ClusterTestClusterAttributeNullableInt56sID = 16403,

	ClusterTestClusterAttributeNullableInt64sID = 16404,

	ClusterTestClusterAttributeNullableEnum8ID = 16405,

	ClusterTestClusterAttributeNullableEnum16ID = 16406,

	ClusterTestClusterAttributeNullableFloatSingleID = 16407,

	ClusterTestClusterAttributeNullableFloatDoubleID = 16408,

	ClusterTestClusterAttributeNullableOctetStringID = 16409,

	ClusterTestClusterAttributeNullableCharStringID = 16414,

	ClusterTestClusterAttributeNullableEnumAttrID = 16420,

	ClusterTestClusterAttributeNullableStructID = 16421,

	ClusterTestClusterAttributeNullableRangeRestrictedInt8uID = 16422,

	ClusterTestClusterAttributeNullableRangeRestrictedInt8sID = 16423,

	ClusterTestClusterAttributeNullableRangeRestrictedInt16uID = 16424,

	ClusterTestClusterAttributeNullableRangeRestrictedInt16sID = 16425,

	ClusterTestClusterAttributeWriteOnlyInt8uID = 16426,

	ClusterTestClusterAttributeGeneratedCommandListID = 65528,

	ClusterTestClusterAttributeAcceptedCommandListID = 65529,

	ClusterTestClusterAttributeAttributeListID = 65531,

	ClusterTestClusterAttributeFeatureMapID = 65532,

	ClusterTestClusterAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterUnitTestingAttributeBooleanID = 0,

	AttributeIDTypeClusterUnitTestingAttributeBitmap8ID = 1,

	AttributeIDTypeClusterUnitTestingAttributeBitmap16ID = 2,

	AttributeIDTypeClusterUnitTestingAttributeBitmap32ID = 3,

	AttributeIDTypeClusterUnitTestingAttributeBitmap64ID = 4,

	AttributeIDTypeClusterUnitTestingAttributeInt8uID = 5,

	AttributeIDTypeClusterUnitTestingAttributeInt16uID = 6,

	AttributeIDTypeClusterUnitTestingAttributeInt24uID = 7,

	AttributeIDTypeClusterUnitTestingAttributeInt32uID = 8,

	AttributeIDTypeClusterUnitTestingAttributeInt40uID = 9,

	AttributeIDTypeClusterUnitTestingAttributeInt48uID = 10,

	AttributeIDTypeClusterUnitTestingAttributeInt56uID = 11,

	AttributeIDTypeClusterUnitTestingAttributeInt64uID = 12,

	AttributeIDTypeClusterUnitTestingAttributeInt8sID = 13,

	AttributeIDTypeClusterUnitTestingAttributeInt16sID = 14,

	AttributeIDTypeClusterUnitTestingAttributeInt24sID = 15,

	AttributeIDTypeClusterUnitTestingAttributeInt32sID = 16,

	AttributeIDTypeClusterUnitTestingAttributeInt40sID = 17,

	AttributeIDTypeClusterUnitTestingAttributeInt48sID = 18,

	AttributeIDTypeClusterUnitTestingAttributeInt56sID = 19,

	AttributeIDTypeClusterUnitTestingAttributeInt64sID = 20,

	AttributeIDTypeClusterUnitTestingAttributeEnum8ID = 21,

	AttributeIDTypeClusterUnitTestingAttributeEnum16ID = 22,

	AttributeIDTypeClusterUnitTestingAttributeFloatSingleID = 23,

	AttributeIDTypeClusterUnitTestingAttributeFloatDoubleID = 24,

	AttributeIDTypeClusterUnitTestingAttributeOctetStringID = 25,

	AttributeIDTypeClusterUnitTestingAttributeListInt8uID = 26,

	AttributeIDTypeClusterUnitTestingAttributeListOctetStringID = 27,

	AttributeIDTypeClusterUnitTestingAttributeListStructOctetStringID = 28,

	AttributeIDTypeClusterUnitTestingAttributeLongOctetStringID = 29,

	AttributeIDTypeClusterUnitTestingAttributeCharStringID = 30,

	AttributeIDTypeClusterUnitTestingAttributeLongCharStringID = 31,

	AttributeIDTypeClusterUnitTestingAttributeEpochUsID = 32,

	AttributeIDTypeClusterUnitTestingAttributeEpochSID = 33,

	AttributeIDTypeClusterUnitTestingAttributeVendorIdID = 34,

	AttributeIDTypeClusterUnitTestingAttributeListNullablesAndOptionalsStructID = 35,

	AttributeIDTypeClusterUnitTestingAttributeEnumAttrID = 36,

	AttributeIDTypeClusterUnitTestingAttributeStructAttrID = 37,

	AttributeIDTypeClusterUnitTestingAttributeRangeRestrictedInt8uID = 38,

	AttributeIDTypeClusterUnitTestingAttributeRangeRestrictedInt8sID = 39,

	AttributeIDTypeClusterUnitTestingAttributeRangeRestrictedInt16uID = 40,

	AttributeIDTypeClusterUnitTestingAttributeRangeRestrictedInt16sID = 41,

	AttributeIDTypeClusterUnitTestingAttributeListLongOctetStringID = 42,

	AttributeIDTypeClusterUnitTestingAttributeListFabricScopedID = 43,

	AttributeIDTypeClusterUnitTestingAttributeTimedWriteBooleanID = 48,

	AttributeIDTypeClusterUnitTestingAttributeGeneralErrorBooleanID = 49,

	AttributeIDTypeClusterUnitTestingAttributeClusterErrorBooleanID = 50,

	AttributeIDTypeClusterUnitTestingAttributeGlobalEnumID = 51,

	AttributeIDTypeClusterUnitTestingAttributeGlobalStructID = 52,

	AttributeIDTypeClusterUnitTestingAttributeUnsupportedID = 255,

	AttributeIDTypeClusterUnitTestingAttributeReadFailureCodeID = 12288,

	AttributeIDTypeClusterUnitTestingAttributeFailureInt32UID = 12289,

	AttributeIDTypeClusterUnitTestingAttributeNullableBooleanID = 16384,

	AttributeIDTypeClusterUnitTestingAttributeNullableBitmap8ID = 16385,

	AttributeIDTypeClusterUnitTestingAttributeNullableBitmap16ID = 16386,

	AttributeIDTypeClusterUnitTestingAttributeNullableBitmap32ID = 16387,

	AttributeIDTypeClusterUnitTestingAttributeNullableBitmap64ID = 16388,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt8uID = 16389,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt16uID = 16390,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt24uID = 16391,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt32uID = 16392,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt40uID = 16393,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt48uID = 16394,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt56uID = 16395,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt64uID = 16396,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt8sID = 16397,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt16sID = 16398,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt24sID = 16399,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt32sID = 16400,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt40sID = 16401,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt48sID = 16402,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt56sID = 16403,

	AttributeIDTypeClusterUnitTestingAttributeNullableInt64sID = 16404,

	AttributeIDTypeClusterUnitTestingAttributeNullableEnum8ID = 16405,

	AttributeIDTypeClusterUnitTestingAttributeNullableEnum16ID = 16406,

	AttributeIDTypeClusterUnitTestingAttributeNullableFloatSingleID = 16407,

	AttributeIDTypeClusterUnitTestingAttributeNullableFloatDoubleID = 16408,

	AttributeIDTypeClusterUnitTestingAttributeNullableOctetStringID = 16409,

	AttributeIDTypeClusterUnitTestingAttributeNullableCharStringID = 16414,

	AttributeIDTypeClusterUnitTestingAttributeNullableEnumAttrID = 16420,

	AttributeIDTypeClusterUnitTestingAttributeNullableStructID = 16421,

	AttributeIDTypeClusterUnitTestingAttributeNullableRangeRestrictedInt8uID = 16422,

	AttributeIDTypeClusterUnitTestingAttributeNullableRangeRestrictedInt8sID = 16423,

	AttributeIDTypeClusterUnitTestingAttributeNullableRangeRestrictedInt16uID = 16424,

	AttributeIDTypeClusterUnitTestingAttributeNullableRangeRestrictedInt16sID = 16425,

	AttributeIDTypeClusterUnitTestingAttributeWriteOnlyInt8uID = 16426,

	AttributeIDTypeClusterUnitTestingAttributeNullableGlobalEnumID = 16435,

	AttributeIDTypeClusterUnitTestingAttributeNullableGlobalStructID = 16436,

	AttributeIDTypeClusterUnitTestingAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterUnitTestingAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterUnitTestingAttributeEventListID = 65530,

	AttributeIDTypeClusterUnitTestingAttributeAttributeListID = 65531,

	AttributeIDTypeClusterUnitTestingAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterUnitTestingAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterUnitTestingAttributeMeiInt8uID = 4294070017,

	AttributeIDTypeClusterSampleMEIAttributeFlipFlopID = 0,

	AttributeIDTypeClusterSampleMEIAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterSampleMEIAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterSampleMEIAttributeEventListID = 65530,

	AttributeIDTypeClusterSampleMEIAttributeAttributeListID = 65531,

	AttributeIDTypeClusterSampleMEIAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterSampleMEIAttributeClusterRevisionID = 65533,

	ClusterBarrierControlAttributeBarrierMovingStateID = 1,

	ClusterBarrierControlAttributeBarrierSafetyStatusID = 2,

	ClusterBarrierControlAttributeBarrierCapabilitiesID = 3,

	ClusterBarrierControlAttributeBarrierOpenEventsID = 4,

	ClusterBarrierControlAttributeBarrierCloseEventsID = 5,

	ClusterBarrierControlAttributeBarrierCommandOpenEventsID = 6,

	ClusterBarrierControlAttributeBarrierCommandCloseEventsID = 7,

	ClusterBarrierControlAttributeBarrierOpenPeriodID = 8,

	ClusterBarrierControlAttributeBarrierClosePeriodID = 9,

	ClusterBarrierControlAttributeBarrierPositionID = 10,

	ClusterBarrierControlAttributeGeneratedCommandListID = 65528,

	ClusterBarrierControlAttributeAcceptedCommandListID = 65529,

	ClusterBarrierControlAttributeAttributeListID = 65531,

	ClusterBarrierControlAttributeFeatureMapID = 65532,

	ClusterBarrierControlAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBarrierControlAttributeBarrierMovingStateID = 1,

	AttributeIDTypeClusterBarrierControlAttributeBarrierSafetyStatusID = 2,

	AttributeIDTypeClusterBarrierControlAttributeBarrierCapabilitiesID = 3,

	AttributeIDTypeClusterBarrierControlAttributeBarrierOpenEventsID = 4,

	AttributeIDTypeClusterBarrierControlAttributeBarrierCloseEventsID = 5,

	AttributeIDTypeClusterBarrierControlAttributeBarrierCommandOpenEventsID = 6,

	AttributeIDTypeClusterBarrierControlAttributeBarrierCommandCloseEventsID = 7,

	AttributeIDTypeClusterBarrierControlAttributeBarrierOpenPeriodID = 8,

	AttributeIDTypeClusterBarrierControlAttributeBarrierClosePeriodID = 9,

	AttributeIDTypeClusterBarrierControlAttributeBarrierPositionID = 10,

	AttributeIDTypeClusterBarrierControlAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBarrierControlAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBarrierControlAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBarrierControlAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBarrierControlAttributeClusterRevisionID = 65533,

	ClusterBinaryInputBasicAttributeActiveTextID = 4,

	ClusterBinaryInputBasicAttributeDescriptionID = 28,

	ClusterBinaryInputBasicAttributeInactiveTextID = 46,

	ClusterBinaryInputBasicAttributeOutOfServiceID = 81,

	ClusterBinaryInputBasicAttributePolarityID = 84,

	ClusterBinaryInputBasicAttributePresentValueID = 85,

	ClusterBinaryInputBasicAttributeReliabilityID = 103,

	ClusterBinaryInputBasicAttributeStatusFlagsID = 111,

	ClusterBinaryInputBasicAttributeApplicationTypeID = 256,

	ClusterBinaryInputBasicAttributeGeneratedCommandListID = 65528,

	ClusterBinaryInputBasicAttributeAcceptedCommandListID = 65529,

	ClusterBinaryInputBasicAttributeAttributeListID = 65531,

	ClusterBinaryInputBasicAttributeFeatureMapID = 65532,

	ClusterBinaryInputBasicAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterBinaryInputBasicAttributeActiveTextID = 4,

	AttributeIDTypeClusterBinaryInputBasicAttributeDescriptionID = 28,

	AttributeIDTypeClusterBinaryInputBasicAttributeInactiveTextID = 46,

	AttributeIDTypeClusterBinaryInputBasicAttributeOutOfServiceID = 81,

	AttributeIDTypeClusterBinaryInputBasicAttributePolarityID = 84,

	AttributeIDTypeClusterBinaryInputBasicAttributePresentValueID = 85,

	AttributeIDTypeClusterBinaryInputBasicAttributeReliabilityID = 103,

	AttributeIDTypeClusterBinaryInputBasicAttributeStatusFlagsID = 111,

	AttributeIDTypeClusterBinaryInputBasicAttributeApplicationTypeID = 256,

	AttributeIDTypeClusterBinaryInputBasicAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterBinaryInputBasicAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterBinaryInputBasicAttributeAttributeListID = 65531,

	AttributeIDTypeClusterBinaryInputBasicAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterBinaryInputBasicAttributeClusterRevisionID = 65533,

	ClusterElectricalMeasurementAttributeMeasurementTypeID = 0,

	ClusterElectricalMeasurementAttributeDcVoltageID = 256,

	ClusterElectricalMeasurementAttributeDcVoltageMinID = 257,

	ClusterElectricalMeasurementAttributeDcVoltageMaxID = 258,

	ClusterElectricalMeasurementAttributeDcCurrentID = 259,

	ClusterElectricalMeasurementAttributeDcCurrentMinID = 260,

	ClusterElectricalMeasurementAttributeDcCurrentMaxID = 261,

	ClusterElectricalMeasurementAttributeDcPowerID = 262,

	ClusterElectricalMeasurementAttributeDcPowerMinID = 263,

	ClusterElectricalMeasurementAttributeDcPowerMaxID = 264,

	ClusterElectricalMeasurementAttributeDcVoltageMultiplierID = 512,

	ClusterElectricalMeasurementAttributeDcVoltageDivisorID = 513,

	ClusterElectricalMeasurementAttributeDcCurrentMultiplierID = 514,

	ClusterElectricalMeasurementAttributeDcCurrentDivisorID = 515,

	ClusterElectricalMeasurementAttributeDcPowerMultiplierID = 516,

	ClusterElectricalMeasurementAttributeDcPowerDivisorID = 517,

	ClusterElectricalMeasurementAttributeAcFrequencyID = 768,

	ClusterElectricalMeasurementAttributeAcFrequencyMinID = 769,

	ClusterElectricalMeasurementAttributeAcFrequencyMaxID = 770,

	ClusterElectricalMeasurementAttributeNeutralCurrentID = 771,

	ClusterElectricalMeasurementAttributeTotalActivePowerID = 772,

	ClusterElectricalMeasurementAttributeTotalReactivePowerID = 773,

	ClusterElectricalMeasurementAttributeTotalApparentPowerID = 774,

	ClusterElectricalMeasurementAttributeMeasured1stHarmonicCurrentID = 775,

	ClusterElectricalMeasurementAttributeMeasured3rdHarmonicCurrentID = 776,

	ClusterElectricalMeasurementAttributeMeasured5thHarmonicCurrentID = 777,

	ClusterElectricalMeasurementAttributeMeasured7thHarmonicCurrentID = 778,

	ClusterElectricalMeasurementAttributeMeasured9thHarmonicCurrentID = 779,

	ClusterElectricalMeasurementAttributeMeasured11thHarmonicCurrentID = 780,

	ClusterElectricalMeasurementAttributeMeasuredPhase1stHarmonicCurrentID = 781,

	ClusterElectricalMeasurementAttributeMeasuredPhase3rdHarmonicCurrentID = 782,

	ClusterElectricalMeasurementAttributeMeasuredPhase5thHarmonicCurrentID = 783,

	ClusterElectricalMeasurementAttributeMeasuredPhase7thHarmonicCurrentID = 784,

	ClusterElectricalMeasurementAttributeMeasuredPhase9thHarmonicCurrentID = 785,

	ClusterElectricalMeasurementAttributeMeasuredPhase11thHarmonicCurrentID = 786,

	ClusterElectricalMeasurementAttributeAcFrequencyMultiplierID = 1024,

	ClusterElectricalMeasurementAttributeAcFrequencyDivisorID = 1025,

	ClusterElectricalMeasurementAttributePowerMultiplierID = 1026,

	ClusterElectricalMeasurementAttributePowerDivisorID = 1027,

	ClusterElectricalMeasurementAttributeHarmonicCurrentMultiplierID = 1028,

	ClusterElectricalMeasurementAttributePhaseHarmonicCurrentMultiplierID = 1029,

	ClusterElectricalMeasurementAttributeInstantaneousVoltageID = 1280,

	ClusterElectricalMeasurementAttributeInstantaneousLineCurrentID = 1281,

	ClusterElectricalMeasurementAttributeInstantaneousActiveCurrentID = 1282,

	ClusterElectricalMeasurementAttributeInstantaneousReactiveCurrentID = 1283,

	ClusterElectricalMeasurementAttributeInstantaneousPowerID = 1284,

	ClusterElectricalMeasurementAttributeRmsVoltageID = 1285,

	ClusterElectricalMeasurementAttributeRmsVoltageMinID = 1286,

	ClusterElectricalMeasurementAttributeRmsVoltageMaxID = 1287,

	ClusterElectricalMeasurementAttributeRmsCurrentID = 1288,

	ClusterElectricalMeasurementAttributeRmsCurrentMinID = 1289,

	ClusterElectricalMeasurementAttributeRmsCurrentMaxID = 1290,

	ClusterElectricalMeasurementAttributeActivePowerID = 1291,

	ClusterElectricalMeasurementAttributeActivePowerMinID = 1292,

	ClusterElectricalMeasurementAttributeActivePowerMaxID = 1293,

	ClusterElectricalMeasurementAttributeReactivePowerID = 1294,

	ClusterElectricalMeasurementAttributeApparentPowerID = 1295,

	ClusterElectricalMeasurementAttributePowerFactorID = 1296,

	ClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodID = 1297,

	ClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterID = 1299,

	ClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodID = 1300,

	ClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodID = 1301,

	ClusterElectricalMeasurementAttributeRmsVoltageSagPeriodID = 1302,

	ClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodID = 1303,

	ClusterElectricalMeasurementAttributeAcVoltageMultiplierID = 1536,

	ClusterElectricalMeasurementAttributeAcVoltageDivisorID = 1537,

	ClusterElectricalMeasurementAttributeAcCurrentMultiplierID = 1538,

	ClusterElectricalMeasurementAttributeAcCurrentDivisorID = 1539,

	ClusterElectricalMeasurementAttributeAcPowerMultiplierID = 1540,

	ClusterElectricalMeasurementAttributeAcPowerDivisorID = 1541,

	ClusterElectricalMeasurementAttributeOverloadAlarmsMaskID = 1792,

	ClusterElectricalMeasurementAttributeVoltageOverloadID = 1793,

	ClusterElectricalMeasurementAttributeCurrentOverloadID = 1794,

	ClusterElectricalMeasurementAttributeAcOverloadAlarmsMaskID = 2048,

	ClusterElectricalMeasurementAttributeAcVoltageOverloadID = 2049,

	ClusterElectricalMeasurementAttributeAcCurrentOverloadID = 2050,

	ClusterElectricalMeasurementAttributeAcActivePowerOverloadID = 2051,

	ClusterElectricalMeasurementAttributeAcReactivePowerOverloadID = 2052,

	ClusterElectricalMeasurementAttributeAverageRmsOverVoltageID = 2053,

	ClusterElectricalMeasurementAttributeAverageRmsUnderVoltageID = 2054,

	ClusterElectricalMeasurementAttributeRmsExtremeOverVoltageID = 2055,

	ClusterElectricalMeasurementAttributeRmsExtremeUnderVoltageID = 2056,

	ClusterElectricalMeasurementAttributeRmsVoltageSagID = 2057,

	ClusterElectricalMeasurementAttributeRmsVoltageSwellID = 2058,

	ClusterElectricalMeasurementAttributeLineCurrentPhaseBID = 2305,

	ClusterElectricalMeasurementAttributeActiveCurrentPhaseBID = 2306,

	ClusterElectricalMeasurementAttributeReactiveCurrentPhaseBID = 2307,

	ClusterElectricalMeasurementAttributeRmsVoltagePhaseBID = 2309,

	ClusterElectricalMeasurementAttributeRmsVoltageMinPhaseBID = 2310,

	ClusterElectricalMeasurementAttributeRmsVoltageMaxPhaseBID = 2311,

	ClusterElectricalMeasurementAttributeRmsCurrentPhaseBID = 2312,

	ClusterElectricalMeasurementAttributeRmsCurrentMinPhaseBID = 2313,

	ClusterElectricalMeasurementAttributeRmsCurrentMaxPhaseBID = 2314,

	ClusterElectricalMeasurementAttributeActivePowerPhaseBID = 2315,

	ClusterElectricalMeasurementAttributeActivePowerMinPhaseBID = 2316,

	ClusterElectricalMeasurementAttributeActivePowerMaxPhaseBID = 2317,

	ClusterElectricalMeasurementAttributeReactivePowerPhaseBID = 2318,

	ClusterElectricalMeasurementAttributeApparentPowerPhaseBID = 2319,

	ClusterElectricalMeasurementAttributePowerFactorPhaseBID = 2320,

	ClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodPhaseBID = 2321,

	ClusterElectricalMeasurementAttributeAverageRmsOverVoltageCounterPhaseBID = 2322,

	ClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterPhaseBID = 2323,

	ClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodPhaseBID = 2324,

	ClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodPhaseBID = 2325,

	ClusterElectricalMeasurementAttributeRmsVoltageSagPeriodPhaseBID = 2326,

	ClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodPhaseBID = 2327,

	ClusterElectricalMeasurementAttributeLineCurrentPhaseCID = 2561,

	ClusterElectricalMeasurementAttributeActiveCurrentPhaseCID = 2562,

	ClusterElectricalMeasurementAttributeReactiveCurrentPhaseCID = 2563,

	ClusterElectricalMeasurementAttributeRmsVoltagePhaseCID = 2565,

	ClusterElectricalMeasurementAttributeRmsVoltageMinPhaseCID = 2566,

	ClusterElectricalMeasurementAttributeRmsVoltageMaxPhaseCID = 2567,

	ClusterElectricalMeasurementAttributeRmsCurrentPhaseCID = 2568,

	ClusterElectricalMeasurementAttributeRmsCurrentMinPhaseCID = 2569,

	ClusterElectricalMeasurementAttributeRmsCurrentMaxPhaseCID = 2570,

	ClusterElectricalMeasurementAttributeActivePowerPhaseCID = 2571,

	ClusterElectricalMeasurementAttributeActivePowerMinPhaseCID = 2572,

	ClusterElectricalMeasurementAttributeActivePowerMaxPhaseCID = 2573,

	ClusterElectricalMeasurementAttributeReactivePowerPhaseCID = 2574,

	ClusterElectricalMeasurementAttributeApparentPowerPhaseCID = 2575,

	ClusterElectricalMeasurementAttributePowerFactorPhaseCID = 2576,

	ClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodPhaseCID = 2577,

	ClusterElectricalMeasurementAttributeAverageRmsOverVoltageCounterPhaseCID = 2578,

	ClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterPhaseCID = 2579,

	ClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodPhaseCID = 2580,

	ClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodPhaseCID = 2581,

	ClusterElectricalMeasurementAttributeRmsVoltageSagPeriodPhaseCID = 2582,

	ClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodPhaseCID = 2583,

	ClusterElectricalMeasurementAttributeGeneratedCommandListID = 65528,

	ClusterElectricalMeasurementAttributeAcceptedCommandListID = 65529,

	ClusterElectricalMeasurementAttributeAttributeListID = 65531,

	ClusterElectricalMeasurementAttributeFeatureMapID = 65532,

	ClusterElectricalMeasurementAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasurementTypeID = 0,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcVoltageID = 256,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcVoltageMinID = 257,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcVoltageMaxID = 258,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcCurrentID = 259,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcCurrentMinID = 260,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcCurrentMaxID = 261,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcPowerID = 262,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcPowerMinID = 263,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcPowerMaxID = 264,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcVoltageMultiplierID = 512,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcVoltageDivisorID = 513,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcCurrentMultiplierID = 514,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcCurrentDivisorID = 515,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcPowerMultiplierID = 516,

	AttributeIDTypeClusterElectricalMeasurementAttributeDcPowerDivisorID = 517,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcFrequencyID = 768,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcFrequencyMinID = 769,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcFrequencyMaxID = 770,

	AttributeIDTypeClusterElectricalMeasurementAttributeNeutralCurrentID = 771,

	AttributeIDTypeClusterElectricalMeasurementAttributeTotalActivePowerID = 772,

	AttributeIDTypeClusterElectricalMeasurementAttributeTotalReactivePowerID = 773,

	AttributeIDTypeClusterElectricalMeasurementAttributeTotalApparentPowerID = 774,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured1stHarmonicCurrentID = 775,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured3rdHarmonicCurrentID = 776,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured5thHarmonicCurrentID = 777,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured7thHarmonicCurrentID = 778,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured9thHarmonicCurrentID = 779,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasured11thHarmonicCurrentID = 780,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase1stHarmonicCurrentID = 781,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase3rdHarmonicCurrentID = 782,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase5thHarmonicCurrentID = 783,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase7thHarmonicCurrentID = 784,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase9thHarmonicCurrentID = 785,

	AttributeIDTypeClusterElectricalMeasurementAttributeMeasuredPhase11thHarmonicCurrentID = 786,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcFrequencyMultiplierID = 1024,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcFrequencyDivisorID = 1025,

	AttributeIDTypeClusterElectricalMeasurementAttributePowerMultiplierID = 1026,

	AttributeIDTypeClusterElectricalMeasurementAttributePowerDivisorID = 1027,

	AttributeIDTypeClusterElectricalMeasurementAttributeHarmonicCurrentMultiplierID = 1028,

	AttributeIDTypeClusterElectricalMeasurementAttributePhaseHarmonicCurrentMultiplierID = 1029,

	AttributeIDTypeClusterElectricalMeasurementAttributeInstantaneousVoltageID = 1280,

	AttributeIDTypeClusterElectricalMeasurementAttributeInstantaneousLineCurrentID = 1281,

	AttributeIDTypeClusterElectricalMeasurementAttributeInstantaneousActiveCurrentID = 1282,

	AttributeIDTypeClusterElectricalMeasurementAttributeInstantaneousReactiveCurrentID = 1283,

	AttributeIDTypeClusterElectricalMeasurementAttributeInstantaneousPowerID = 1284,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageID = 1285,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMinID = 1286,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMaxID = 1287,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentID = 1288,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMinID = 1289,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMaxID = 1290,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerID = 1291,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMinID = 1292,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMaxID = 1293,

	AttributeIDTypeClusterElectricalMeasurementAttributeReactivePowerID = 1294,

	AttributeIDTypeClusterElectricalMeasurementAttributeApparentPowerID = 1295,

	AttributeIDTypeClusterElectricalMeasurementAttributePowerFactorID = 1296,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodID = 1297,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterID = 1299,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodID = 1300,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodID = 1301,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSagPeriodID = 1302,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodID = 1303,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcVoltageMultiplierID = 1536,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcVoltageDivisorID = 1537,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcCurrentMultiplierID = 1538,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcCurrentDivisorID = 1539,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcPowerMultiplierID = 1540,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcPowerDivisorID = 1541,

	AttributeIDTypeClusterElectricalMeasurementAttributeOverloadAlarmsMaskID = 1792,

	AttributeIDTypeClusterElectricalMeasurementAttributeVoltageOverloadID = 1793,

	AttributeIDTypeClusterElectricalMeasurementAttributeCurrentOverloadID = 1794,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcOverloadAlarmsMaskID = 2048,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcVoltageOverloadID = 2049,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcCurrentOverloadID = 2050,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcActivePowerOverloadID = 2051,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcReactivePowerOverloadID = 2052,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsOverVoltageID = 2053,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsUnderVoltageID = 2054,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeOverVoltageID = 2055,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeUnderVoltageID = 2056,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSagID = 2057,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSwellID = 2058,

	AttributeIDTypeClusterElectricalMeasurementAttributeLineCurrentPhaseBID = 2305,

	AttributeIDTypeClusterElectricalMeasurementAttributeActiveCurrentPhaseBID = 2306,

	AttributeIDTypeClusterElectricalMeasurementAttributeReactiveCurrentPhaseBID = 2307,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltagePhaseBID = 2309,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMinPhaseBID = 2310,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMaxPhaseBID = 2311,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentPhaseBID = 2312,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMinPhaseBID = 2313,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMaxPhaseBID = 2314,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerPhaseBID = 2315,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMinPhaseBID = 2316,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMaxPhaseBID = 2317,

	AttributeIDTypeClusterElectricalMeasurementAttributeReactivePowerPhaseBID = 2318,

	AttributeIDTypeClusterElectricalMeasurementAttributeApparentPowerPhaseBID = 2319,

	AttributeIDTypeClusterElectricalMeasurementAttributePowerFactorPhaseBID = 2320,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodPhaseBID = 2321,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsOverVoltageCounterPhaseBID = 2322,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterPhaseBID = 2323,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodPhaseBID = 2324,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodPhaseBID = 2325,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSagPeriodPhaseBID = 2326,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodPhaseBID = 2327,

	AttributeIDTypeClusterElectricalMeasurementAttributeLineCurrentPhaseCID = 2561,

	AttributeIDTypeClusterElectricalMeasurementAttributeActiveCurrentPhaseCID = 2562,

	AttributeIDTypeClusterElectricalMeasurementAttributeReactiveCurrentPhaseCID = 2563,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltagePhaseCID = 2565,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMinPhaseCID = 2566,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageMaxPhaseCID = 2567,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentPhaseCID = 2568,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMinPhaseCID = 2569,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsCurrentMaxPhaseCID = 2570,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerPhaseCID = 2571,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMinPhaseCID = 2572,

	AttributeIDTypeClusterElectricalMeasurementAttributeActivePowerMaxPhaseCID = 2573,

	AttributeIDTypeClusterElectricalMeasurementAttributeReactivePowerPhaseCID = 2574,

	AttributeIDTypeClusterElectricalMeasurementAttributeApparentPowerPhaseCID = 2575,

	AttributeIDTypeClusterElectricalMeasurementAttributePowerFactorPhaseCID = 2576,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsVoltageMeasurementPeriodPhaseCID = 2577,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsOverVoltageCounterPhaseCID = 2578,

	AttributeIDTypeClusterElectricalMeasurementAttributeAverageRmsUnderVoltageCounterPhaseCID = 2579,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeOverVoltagePeriodPhaseCID = 2580,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsExtremeUnderVoltagePeriodPhaseCID = 2581,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSagPeriodPhaseCID = 2582,

	AttributeIDTypeClusterElectricalMeasurementAttributeRmsVoltageSwellPeriodPhaseCID = 2583,

	AttributeIDTypeClusterElectricalMeasurementAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterElectricalMeasurementAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterElectricalMeasurementAttributeAttributeListID = 65531,

	AttributeIDTypeClusterElectricalMeasurementAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterElectricalMeasurementAttributeClusterRevisionID = 65533,

	ClusterOnOffSwitchConfigurationAttributeSwitchTypeID = 0,

	ClusterOnOffSwitchConfigurationAttributeSwitchActionsID = 16,

	ClusterOnOffSwitchConfigurationAttributeGeneratedCommandListID = 65528,

	ClusterOnOffSwitchConfigurationAttributeAcceptedCommandListID = 65529,

	ClusterOnOffSwitchConfigurationAttributeAttributeListID = 65531,

	ClusterOnOffSwitchConfigurationAttributeFeatureMapID = 65532,

	ClusterOnOffSwitchConfigurationAttributeClusterRevisionID = 65533,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeSwitchTypeID = 0,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeSwitchActionsID = 16,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeGeneratedCommandListID = 65528,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeAcceptedCommandListID = 65529,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeAttributeListID = 65531,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeFeatureMapID = 65532,

	AttributeIDTypeClusterOnOffSwitchConfigurationAttributeClusterRevisionID = 65533
}

/**
 * @since 17.6
 */
declare function MTRAttributeNameForID(clusterID: MTRClusterIDType, attributeID: MTRAttributeIDType): string;

/**
 * @since 16.1
 */
declare class MTRAttributePath extends MTRClusterPath implements NSSecureCoding {

	static alloc(): MTRAttributePath; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static attributePathWithEndpointIDClusterIDAttributeID(endpointID: number, clusterID: number, attributeID: number): MTRAttributePath;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static attributePathWithEndpointIdClusterIdAttributeId(endpointId: number, clusterId: number, attributeId: number): MTRAttributePath;

	static new(): MTRAttributePath; // inherited from NSObject

	readonly attribute: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 16.1
 */
declare var MTRAttributePathKey: string;

/**
 * @since 16.1
 */
declare class MTRAttributeReport extends NSObject {

	static alloc(): MTRAttributeReport; // inherited from NSObject

	static new(): MTRAttributeReport; // inherited from NSObject

	readonly error: NSError;

	readonly path: MTRAttributePath;

	readonly value: any;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.0
 */
declare class MTRAttributeRequestPath extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTRAttributeRequestPath; // inherited from NSObject

	static new(): MTRAttributeRequestPath; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	static requestPathWithEndpointIDClusterIDAttributeID(endpointID: number, clusterID: number, attributeID: number): MTRAttributeRequestPath;

	/**
	 * @since 17.0
	 */
	readonly attribute: number;

	/**
	 * @since 17.0
	 */
	readonly cluster: number;

	/**
	 * @since 17.0
	 */
	readonly endpoint: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRAudioOutputClusterOutputInfo extends MTRAudioOutputClusterOutputInfoStruct {

	static alloc(): MTRAudioOutputClusterOutputInfo; // inherited from NSObject

	static new(): MTRAudioOutputClusterOutputInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRAudioOutputClusterOutputInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRAudioOutputClusterOutputInfoStruct; // inherited from NSObject

	static new(): MTRAudioOutputClusterOutputInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	index: number;

	/**
	 * @since 16.4
	 */
	name: string;

	/**
	 * @since 16.4
	 */
	outputType: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAudioOutputClusterRenameOutputParams extends NSObject implements NSCopying {

	static alloc(): MTRAudioOutputClusterRenameOutputParams; // inherited from NSObject

	static new(): MTRAudioOutputClusterRenameOutputParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	index: number;

	/**
	 * @since 16.1
	 */
	name: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRAudioOutputClusterSelectOutputParams extends NSObject implements NSCopying {

	static alloc(): MTRAudioOutputClusterSelectOutputParams; // inherited from NSObject

	static new(): MTRAudioOutputClusterSelectOutputParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	index: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRAudioOutputFeature {

	NameUpdates = 1
}

/**
 * @since 16.1
 */
declare const enum MTRAudioOutputOutputType {

	HDMI = 0,

	Hdmi = 0,

	BT = 1,

	Bt = 1,

	Optical = 2,

	Headphone = 3,

	Internal = 4,

	Other = 5
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBarrierControlClusterBarrierControlGoToPercentParams extends NSObject implements NSCopying {

	static alloc(): MTRBarrierControlClusterBarrierControlGoToPercentParams; // inherited from NSObject

	static new(): MTRBarrierControlClusterBarrierControlGoToPercentParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	percentOpen: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBarrierControlClusterBarrierControlStopParams extends NSObject implements NSCopying {

	static alloc(): MTRBarrierControlClusterBarrierControlStopParams; // inherited from NSObject

	static new(): MTRBarrierControlClusterBarrierControlStopParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterAccessControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterAccessControl; // inherited from NSObject

	static new(): MTRBaseClusterAccessControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeACLWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAccessControlEntriesPerFabricWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAccessControlEntriesPerFabricWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAclWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeExtensionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeExtensionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSubjectsPerAccessControlEntryWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSubjectsPerAccessControlEntryWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTargetsPerAccessControlEntryWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTargetsPerAccessControlEntryWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeACLWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAccessControlEntriesPerFabricWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAccessControlEntriesPerFabricWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAclWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeExtensionWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeExtensionWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSubjectsPerAccessControlEntryWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSubjectsPerAccessControlEntryWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTargetsPerAccessControlEntryWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTargetsPerAccessControlEntryWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACLWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAccessControlEntriesPerFabricWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAccessControlEntriesPerFabricWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAclWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeExtensionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeExtensionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSubjectsPerAccessControlEntryWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSubjectsPerAccessControlEntryWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTargetsPerAccessControlEntryWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTargetsPerAccessControlEntryWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACLWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACLWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAclWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAclWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeExtensionWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeExtensionWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeExtensionWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeExtensionWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterAccountLogin extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterAccountLogin; // inherited from NSObject

	static new(): MTRBaseClusterAccountLogin; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	getSetupPINWithParamsCompletion(params: MTRAccountLoginClusterGetSetupPINParams, completion: (p1: MTRAccountLoginClusterGetSetupPINResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getSetupPINWithParamsCompletionHandler(params: MTRAccountLoginClusterGetSetupPINParams, completionHandler: (p1: MTRAccountLoginClusterGetSetupPINResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	loginWithParamsCompletion(params: MTRAccountLoginClusterLoginParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	loginWithParamsCompletionHandler(params: MTRAccountLoginClusterLoginParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	logoutWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	logoutWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	logoutWithParamsCompletion(params: MTRAccountLoginClusterLogoutParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	logoutWithParamsCompletionHandler(params: MTRAccountLoginClusterLogoutParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterActions extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterActions; // inherited from NSObject

	static new(): MTRBaseClusterActions; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActionListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActionListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEndpointListsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEndpointListsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSetupURLWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSetupURLWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	disableActionWithDurationWithParamsCompletion(params: MTRActionsClusterDisableActionWithDurationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	disableActionWithDurationWithParamsCompletionHandler(params: MTRActionsClusterDisableActionWithDurationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	disableActionWithParamsCompletion(params: MTRActionsClusterDisableActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	disableActionWithParamsCompletionHandler(params: MTRActionsClusterDisableActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enableActionWithDurationWithParamsCompletion(params: MTRActionsClusterEnableActionWithDurationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enableActionWithDurationWithParamsCompletionHandler(params: MTRActionsClusterEnableActionWithDurationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enableActionWithParamsCompletion(params: MTRActionsClusterEnableActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enableActionWithParamsCompletionHandler(params: MTRActionsClusterEnableActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	instantActionWithParamsCompletion(params: MTRActionsClusterInstantActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	instantActionWithParamsCompletionHandler(params: MTRActionsClusterInstantActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	instantActionWithTransitionWithParamsCompletion(params: MTRActionsClusterInstantActionWithTransitionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	instantActionWithTransitionWithParamsCompletionHandler(params: MTRActionsClusterInstantActionWithTransitionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseActionWithDurationWithParamsCompletion(params: MTRActionsClusterPauseActionWithDurationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseActionWithDurationWithParamsCompletionHandler(params: MTRActionsClusterPauseActionWithDurationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseActionWithParamsCompletion(params: MTRActionsClusterPauseActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseActionWithParamsCompletionHandler(params: MTRActionsClusterPauseActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActionListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActionListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEndpointListsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEndpointListsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSetupURLWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSetupURLWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resumeActionWithParamsCompletion(params: MTRActionsClusterResumeActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resumeActionWithParamsCompletionHandler(params: MTRActionsClusterResumeActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startActionWithDurationWithParamsCompletion(params: MTRActionsClusterStartActionWithDurationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startActionWithDurationWithParamsCompletionHandler(params: MTRActionsClusterStartActionWithDurationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startActionWithParamsCompletion(params: MTRActionsClusterStartActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startActionWithParamsCompletionHandler(params: MTRActionsClusterStartActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopActionWithParamsCompletion(params: MTRActionsClusterStopActionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopActionWithParamsCompletionHandler(params: MTRActionsClusterStopActionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActionListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActionListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEndpointListsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEndpointListsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSetupURLWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSetupURLWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterActivatedCarbonFilterMonitoring extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterActivatedCarbonFilterMonitoring; // inherited from NSObject

	static new(): MTRBaseClusterActivatedCarbonFilterMonitoring; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeChangeIndicationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeConditionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDegradationDirectionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeInPlaceIndicatorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLastChangedTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeReplacementProductListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeChangeIndicationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeConditionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDegradationDirectionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeInPlaceIndicatorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLastChangedTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeReplacementProductListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithParamsCompletion(params: MTRActivatedCarbonFilterMonitoringClusterResetConditionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeChangeIndicationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeConditionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDegradationDirectionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeInPlaceIndicatorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLastChangedTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeReplacementProductListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterAdministratorCommissioning extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterAdministratorCommissioning; // inherited from NSObject

	static new(): MTRBaseClusterAdministratorCommissioning; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAdminFabricIndexWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAdminFabricIndexWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAdminVendorIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAdminVendorIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWindowStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWindowStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	openBasicCommissioningWindowWithParamsCompletion(params: MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openBasicCommissioningWindowWithParamsCompletionHandler(params: MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	openCommissioningWindowWithParamsCompletion(params: MTRAdministratorCommissioningClusterOpenCommissioningWindowParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openCommissioningWindowWithParamsCompletionHandler(params: MTRAdministratorCommissioningClusterOpenCommissioningWindowParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAdminFabricIndexWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAdminFabricIndexWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAdminVendorIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAdminVendorIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWindowStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWindowStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	revokeCommissioningWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	revokeCommissioningWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	revokeCommissioningWithParamsCompletion(params: MTRAdministratorCommissioningClusterRevokeCommissioningParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	revokeCommissioningWithParamsCompletionHandler(params: MTRAdministratorCommissioningClusterRevokeCommissioningParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAdminFabricIndexWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAdminFabricIndexWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAdminVendorIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAdminVendorIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWindowStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWindowStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterAirQuality extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterAirQuality; // inherited from NSObject

	static new(): MTRBaseClusterAirQuality; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAirQualityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAirQualityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAirQualityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterApplicationBasic extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterApplicationBasic; // inherited from NSObject

	static new(): MTRBaseClusterApplicationBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAllowedVendorListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAllowedVendorListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApplicationNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeApplicationNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApplicationVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeApplicationVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApplicationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRApplicationBasicClusterApplicationBasicApplication, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeApplicationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRApplicationBasicClusterApplicationStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAllowedVendorListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAllowedVendorListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeApplicationNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApplicationNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeApplicationVersionWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApplicationVersionWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeApplicationWithCompletion(completion: (p1: MTRApplicationBasicClusterApplicationStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApplicationWithCompletionHandler(completionHandler: (p1: MTRApplicationBasicClusterApplicationBasicApplication, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductIDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductIDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorIDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAllowedVendorListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAllowedVendorListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApplicationNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeApplicationNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApplicationVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeApplicationVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApplicationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRApplicationBasicClusterApplicationBasicApplication, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeApplicationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRApplicationBasicClusterApplicationStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterApplicationLauncher extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterApplicationLauncher; // inherited from NSObject

	static new(): MTRBaseClusterApplicationLauncher; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCatalogListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCatalogListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentAppWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRApplicationLauncherClusterApplicationEP, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentAppWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRApplicationLauncherClusterApplicationEPStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	hideAppWithCompletion(completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	hideAppWithParamsCompletion(params: MTRApplicationLauncherClusterHideAppParams, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideAppWithParamsCompletionHandler(params: MTRApplicationLauncherClusterHideAppParams, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	launchAppWithCompletion(completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	launchAppWithParamsCompletion(params: MTRApplicationLauncherClusterLaunchAppParams, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchAppWithParamsCompletionHandler(params: MTRApplicationLauncherClusterLaunchAppParams, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCatalogListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCatalogListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentAppWithCompletion(completion: (p1: MTRApplicationLauncherClusterApplicationEPStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentAppWithCompletionHandler(completionHandler: (p1: MTRApplicationLauncherClusterApplicationEP, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	stopAppWithCompletion(completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopAppWithParamsCompletion(params: MTRApplicationLauncherClusterStopAppParams, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopAppWithParamsCompletionHandler(params: MTRApplicationLauncherClusterStopAppParams, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCatalogListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCatalogListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentAppWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRApplicationLauncherClusterApplicationEP, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentAppWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRApplicationLauncherClusterApplicationEPStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCurrentAppWithValueCompletion(value: MTRApplicationLauncherClusterApplicationEPStruct, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeCurrentAppWithValueCompletionHandler(value: MTRApplicationLauncherClusterApplicationEP, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCurrentAppWithValueParamsCompletion(value: MTRApplicationLauncherClusterApplicationEPStruct, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeCurrentAppWithValueParamsCompletionHandler(value: MTRApplicationLauncherClusterApplicationEP, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterAudioOutput extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterAudioOutput; // inherited from NSObject

	static new(): MTRBaseClusterAudioOutput; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentOutputWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentOutputWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOutputListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOutputListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentOutputWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentOutputWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOutputListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOutputListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	renameOutputWithParamsCompletion(params: MTRAudioOutputClusterRenameOutputParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	renameOutputWithParamsCompletionHandler(params: MTRAudioOutputClusterRenameOutputParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	selectOutputWithParamsCompletion(params: MTRAudioOutputClusterSelectOutputParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	selectOutputWithParamsCompletionHandler(params: MTRAudioOutputClusterSelectOutputParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentOutputWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentOutputWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOutputListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOutputListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterBallastConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBallastConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterBallastConfiguration; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBallastFactorAdjustmentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBallastFactorAdjustmentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBallastStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBallastStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeIntrinsicBalanceFactorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeIntrinsicBallastFactorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampAlarmModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampAlarmModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampBurnHoursTripPointWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampBurnHoursTripPointWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampBurnHoursWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampBurnHoursWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampManufacturerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampManufacturerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampQuantityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampQuantityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampRatedHoursWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampRatedHoursWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLampTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLampTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalMaxLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalMaxLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalMinLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalMinLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBallastFactorAdjustmentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBallastFactorAdjustmentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBallastStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBallastStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeIntrinsicBalanceFactorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeIntrinsicBallastFactorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampAlarmModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampAlarmModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampBurnHoursTripPointWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampBurnHoursTripPointWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampBurnHoursWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampBurnHoursWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampManufacturerWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampManufacturerWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampQuantityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampQuantityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampRatedHoursWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampRatedHoursWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLampTypeWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLampTypeWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalMaxLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalMaxLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalMinLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalMinLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBallastFactorAdjustmentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBallastFactorAdjustmentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBallastStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBallastStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeIntrinsicBalanceFactorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeIntrinsicBallastFactorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampAlarmModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampAlarmModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampBurnHoursTripPointWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampBurnHoursTripPointWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampBurnHoursWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampBurnHoursWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampManufacturerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampManufacturerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampQuantityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampQuantityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampRatedHoursWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampRatedHoursWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLampTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLampTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalMaxLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalMaxLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalMinLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalMinLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBallastFactorAdjustmentWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBallastFactorAdjustmentWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBallastFactorAdjustmentWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBallastFactorAdjustmentWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIntrinsicBalanceFactorWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIntrinsicBalanceFactorWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIntrinsicBallastFactorWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIntrinsicBallastFactorWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampAlarmModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampAlarmModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampAlarmModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampAlarmModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampBurnHoursTripPointWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampBurnHoursTripPointWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampBurnHoursTripPointWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampBurnHoursTripPointWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampBurnHoursWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampBurnHoursWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampBurnHoursWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampBurnHoursWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampManufacturerWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampManufacturerWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampManufacturerWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampManufacturerWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampRatedHoursWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampRatedHoursWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampRatedHoursWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampRatedHoursWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampTypeWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampTypeWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLampTypeWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLampTypeWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxLevelWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxLevelWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinLevelWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinLevelWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBaseClusterBarrierControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBarrierControl; // inherited from NSObject

	static new(): MTRBaseClusterBarrierControl; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierCapabilitiesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierCapabilitiesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierCloseEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierCloseEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierClosePeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierClosePeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierCommandCloseEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierCommandCloseEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierCommandOpenEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierCommandOpenEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierMovingStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierMovingStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierOpenEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierOpenEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierOpenPeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierOpenPeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierPositionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierPositionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBarrierSafetyStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeBarrierSafetyStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlGoToPercentWithParamsCompletion(params: MTRBarrierControlClusterBarrierControlGoToPercentParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlGoToPercentWithParamsCompletionHandler(params: MTRBarrierControlClusterBarrierControlGoToPercentParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlStopWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlStopWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlStopWithParamsCompletion(params: MTRBarrierControlClusterBarrierControlStopParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlStopWithParamsCompletionHandler(params: MTRBarrierControlClusterBarrierControlStopParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierCapabilitiesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierCapabilitiesWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierCloseEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierCloseEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierClosePeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierClosePeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierCommandCloseEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierCommandCloseEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierCommandOpenEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierCommandOpenEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierMovingStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierMovingStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierOpenEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierOpenEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierOpenPeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierOpenPeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierPositionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierPositionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeBarrierSafetyStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBarrierSafetyStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierCapabilitiesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierCapabilitiesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierCloseEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierCloseEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierClosePeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierClosePeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierCommandCloseEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierCommandCloseEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierCommandOpenEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierCommandOpenEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierMovingStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierMovingStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierOpenEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierOpenEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierOpenPeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierOpenPeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierPositionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierPositionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBarrierSafetyStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeBarrierSafetyStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCloseEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCloseEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCloseEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCloseEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierClosePeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierClosePeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierClosePeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierClosePeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandCloseEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCommandCloseEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandCloseEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCommandCloseEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandOpenEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCommandOpenEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandOpenEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierCommandOpenEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierOpenEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierOpenEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenPeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierOpenPeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenPeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBarrierOpenPeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBaseClusterBasic extends MTRBaseClusterBasicInformation {

	static alloc(): MTRBaseClusterBasic; // inherited from NSObject

	static new(): MTRBaseClusterBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCapabilityMinimaWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRBasicClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDataModelRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHardwareVersionStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHardwareVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocalConfigDisabledWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeManufacturingDateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNodeLabelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePartNumberWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductLabelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductURLWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReachableWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSerialNumberWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSoftwareVersionStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSoftwareVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUniqueIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	mfgSpecificPingWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	mfgSpecificPingWithParamsCompletionHandler(params: MTRBasicClusterMfgSpecificPingParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCapabilityMinimaWithCompletionHandler(completionHandler: (p1: MTRBasicClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDataModelRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHardwareVersionStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHardwareVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocalConfigDisabledWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocationWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeManufacturingDateWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNodeLabelWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePartNumberWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductIDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductLabelWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductURLWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReachableWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSerialNumberWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSoftwareVersionStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSoftwareVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUniqueIDWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorIDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCapabilityMinimaWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRBasicClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDataModelRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHardwareVersionStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHardwareVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocalConfigDisabledWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeManufacturingDateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNodeLabelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePartNumberWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductLabelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductURLWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReachableWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSerialNumberWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSoftwareVersionStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSoftwareVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUniqueIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocationWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocationWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNodeLabelWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNodeLabelWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterBasicInformation extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBasicInformation; // inherited from NSObject

	static new(): MTRBaseClusterBasicInformation; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCapabilityMinimaWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRBasicInformationClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDataModelRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHardwareVersionStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHardwareVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocalConfigDisabledWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeManufacturingDateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNodeLabelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePartNumberWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	static readAttributeProductAppearanceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductLabelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductURLWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeReachableWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSerialNumberWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSoftwareVersionStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSoftwareVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUniqueIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCapabilityMinimaWithCompletion(completion: (p1: MTRBasicInformationClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDataModelRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocalConfigDisabledWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocationWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeManufacturingDateWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNodeLabelWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePartNumberWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	readAttributeProductAppearanceWithCompletion(completion: (p1: MTRBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductIDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductLabelWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductURLWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeReachableWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSerialNumberWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUniqueIDWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCapabilityMinimaWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRBasicInformationClusterCapabilityMinimaStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDataModelRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHardwareVersionStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHardwareVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocalConfigDisabledWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeManufacturingDateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNodeLabelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePartNumberWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	subscribeAttributeProductAppearanceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductLabelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductURLWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeReachableWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSerialNumberWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSoftwareVersionStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSoftwareVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUniqueIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocationWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocationWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBaseClusterBinaryInputBasic extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBinaryInputBasic; // inherited from NSObject

	static new(): MTRBaseClusterBinaryInputBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveTextWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActiveTextWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApplicationTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeApplicationTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDescriptionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDescriptionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInactiveTextWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInactiveTextWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOutOfServiceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeOutOfServiceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePolarityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePolarityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePresentValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePresentValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReliabilityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReliabilityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStatusFlagsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeStatusFlagsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActiveTextWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveTextWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeApplicationTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApplicationTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDescriptionWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDescriptionWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInactiveTextWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInactiveTextWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeOutOfServiceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOutOfServiceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePolarityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePolarityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePresentValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePresentValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReliabilityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReliabilityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeStatusFlagsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStatusFlagsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveTextWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActiveTextWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApplicationTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeApplicationTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDescriptionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDescriptionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInactiveTextWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInactiveTextWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOutOfServiceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeOutOfServiceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePolarityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePolarityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePresentValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePresentValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReliabilityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReliabilityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStatusFlagsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeStatusFlagsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeActiveTextWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveTextWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeActiveTextWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveTextWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeDescriptionWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDescriptionWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeDescriptionWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDescriptionWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeInactiveTextWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInactiveTextWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeInactiveTextWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInactiveTextWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeOutOfServiceWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOutOfServiceWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeOutOfServiceWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOutOfServiceWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributePresentValueWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePresentValueWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributePresentValueWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePresentValueWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeReliabilityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeReliabilityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeReliabilityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeReliabilityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterBinding extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBinding; // inherited from NSObject

	static new(): MTRBaseClusterBinding; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBindingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBindingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBindingWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBindingWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBindingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBindingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBindingWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBindingWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBindingWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBindingWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterBooleanState extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBooleanState; // inherited from NSObject

	static new(): MTRBaseClusterBooleanState; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStateValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStateValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStateValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStateValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStateValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStateValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterBooleanStateConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBooleanStateConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterBooleanStateConfiguration; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAlarmsActiveWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAlarmsEnabledWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAlarmsSupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAlarmsSuppressedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCurrentSensitivityLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDefaultSensitivityLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeSensorFaultWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeSupportedSensitivityLevelsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	enableDisableAlarmWithParamsCompletion(params: MTRBooleanStateConfigurationClusterEnableDisableAlarmParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsActiveWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsEnabledWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsSupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsSuppressedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentSensitivityLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultSensitivityLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeSensorFaultWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeSupportedSensitivityLevelsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAlarmsActiveWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAlarmsEnabledWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAlarmsSupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAlarmsSuppressedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCurrentSensitivityLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDefaultSensitivityLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeSensorFaultWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeSupportedSensitivityLevelsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	suppressAlarmWithParamsCompletion(params: MTRBooleanStateConfigurationClusterSuppressAlarmParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeCurrentSensitivityLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeCurrentSensitivityLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRBaseClusterBridgedDeviceBasic extends MTRBaseClusterBridgedDeviceBasicInformation {

	static alloc(): MTRBaseClusterBridgedDeviceBasic; // inherited from NSObject

	static new(): MTRBaseClusterBridgedDeviceBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHardwareVersionStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHardwareVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeManufacturingDateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNodeLabelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePartNumberWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductLabelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeProductURLWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReachableWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSerialNumberWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSoftwareVersionStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSoftwareVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUniqueIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHardwareVersionStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHardwareVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeManufacturingDateWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNodeLabelWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePartNumberWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductLabelWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeProductURLWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReachableWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSerialNumberWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSoftwareVersionStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSoftwareVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUniqueIDWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorIDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHardwareVersionStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHardwareVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeManufacturingDateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNodeLabelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePartNumberWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductLabelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeProductURLWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReachableWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSerialNumberWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSoftwareVersionStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSoftwareVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUniqueIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNodeLabelWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNodeLabelWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterBridgedDeviceBasicInformation extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterBridgedDeviceBasicInformation; // inherited from NSObject

	static new(): MTRBaseClusterBridgedDeviceBasicInformation; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHardwareVersionStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHardwareVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeManufacturingDateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNodeLabelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePartNumberWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	static readAttributeProductAppearanceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductLabelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeProductURLWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeReachableWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSerialNumberWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSoftwareVersionStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSoftwareVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUniqueIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeManufacturingDateWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNodeLabelWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePartNumberWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	readAttributeProductAppearanceWithCompletion(completion: (p1: MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductLabelWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeProductURLWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeReachableWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSerialNumberWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUniqueIDWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHardwareVersionStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHardwareVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeManufacturingDateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNodeLabelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePartNumberWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	subscribeAttributeProductAppearanceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductLabelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeProductURLWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeReachableWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSerialNumberWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSoftwareVersionStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSoftwareVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUniqueIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterCarbonDioxideConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterCarbonDioxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterCarbonDioxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterCarbonMonoxideConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterCarbonMonoxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterCarbonMonoxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterChannel extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterChannel; // inherited from NSObject

	static new(): MTRBaseClusterChannel; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeChannelListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeChannelListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentChannelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRChannelClusterChannelInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentChannelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRChannelClusterChannelInfoStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLineupWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRChannelClusterLineupInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLineupWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRChannelClusterLineupInfoStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	changeChannelByNumberWithParamsCompletion(params: MTRChannelClusterChangeChannelByNumberParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeChannelByNumberWithParamsCompletionHandler(params: MTRChannelClusterChangeChannelByNumberParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	changeChannelWithParamsCompletion(params: MTRChannelClusterChangeChannelParams, completion: (p1: MTRChannelClusterChangeChannelResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeChannelWithParamsCompletionHandler(params: MTRChannelClusterChangeChannelParams, completionHandler: (p1: MTRChannelClusterChangeChannelResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeChannelListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeChannelListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentChannelWithCompletion(completion: (p1: MTRChannelClusterChannelInfoStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentChannelWithCompletionHandler(completionHandler: (p1: MTRChannelClusterChannelInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLineupWithCompletion(completion: (p1: MTRChannelClusterLineupInfoStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLineupWithCompletionHandler(completionHandler: (p1: MTRChannelClusterLineupInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	skipChannelWithParamsCompletion(params: MTRChannelClusterSkipChannelParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipChannelWithParamsCompletionHandler(params: MTRChannelClusterSkipChannelParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeChannelListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeChannelListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentChannelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRChannelClusterChannelInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentChannelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRChannelClusterChannelInfoStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLineupWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRChannelClusterLineupInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLineupWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRChannelClusterLineupInfoStruct, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterColorControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterColorControl; // inherited from NSObject

	static new(): MTRBaseClusterColorControl; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorCapabilitiesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorCapabilitiesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorLoopActiveWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorLoopActiveWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorLoopDirectionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorLoopDirectionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorLoopStartEnhancedHueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorLoopStartEnhancedHueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorLoopStoredEnhancedHueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorLoopStoredEnhancedHueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorLoopTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorLoopTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointBIntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointBIntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointBXWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointBXWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointBYWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointBYWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointGIntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointGIntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointGXWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointGXWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointGYWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointGYWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointRIntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointRIntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointRXWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointRXWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorPointRYWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorPointRYWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorTempPhysicalMaxMiredsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorTempPhysicalMaxMiredsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorTempPhysicalMinMiredsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorTempPhysicalMinMiredsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeColorTemperatureMiredsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeColorTemperatureMiredsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCompensationTextWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCompensationTextWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCoupleColorTempToLevelMinMiredsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCoupleColorTempToLevelMinMiredsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentHueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentHueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentSaturationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentSaturationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentXWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentXWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentYWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentYWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDriftCompensationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDriftCompensationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnhancedColorModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnhancedColorModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnhancedCurrentHueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnhancedCurrentHueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfPrimariesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfPrimariesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOptionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOptionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary1IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary1IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary1XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary1XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary1YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary1YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary2IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary2IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary2XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary2XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary2YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary2YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary3IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary3IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary3XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary3XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary3YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary3YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary4IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary4IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary4XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary4XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary4YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary4YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary5IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary5IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary5XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary5XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary5YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary5YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary6IntensityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary6IntensityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary6XWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary6XWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePrimary6YWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePrimary6YWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRemainingTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRemainingTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartUpColorTemperatureMiredsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartUpColorTemperatureMiredsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWhitePointXWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWhitePointXWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWhitePointYWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWhitePointYWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	colorLoopSetWithParamsCompletion(params: MTRColorControlClusterColorLoopSetParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	colorLoopSetWithParamsCompletionHandler(params: MTRColorControlClusterColorLoopSetParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveHueWithParamsCompletion(params: MTRColorControlClusterEnhancedMoveHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveHueWithParamsCompletionHandler(params: MTRColorControlClusterEnhancedMoveHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveToHueAndSaturationWithParamsCompletion(params: MTRColorControlClusterEnhancedMoveToHueAndSaturationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveToHueAndSaturationWithParamsCompletionHandler(params: MTRColorControlClusterEnhancedMoveToHueAndSaturationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveToHueWithParamsCompletion(params: MTRColorControlClusterEnhancedMoveToHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveToHueWithParamsCompletionHandler(params: MTRColorControlClusterEnhancedMoveToHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedStepHueWithParamsCompletion(params: MTRColorControlClusterEnhancedStepHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedStepHueWithParamsCompletionHandler(params: MTRColorControlClusterEnhancedStepHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	moveColorTemperatureWithParamsCompletion(params: MTRColorControlClusterMoveColorTemperatureParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveColorTemperatureWithParamsCompletionHandler(params: MTRColorControlClusterMoveColorTemperatureParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveColorWithParamsCompletion(params: MTRColorControlClusterMoveColorParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveColorWithParamsCompletionHandler(params: MTRColorControlClusterMoveColorParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveHueWithParamsCompletion(params: MTRColorControlClusterMoveHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveHueWithParamsCompletionHandler(params: MTRColorControlClusterMoveHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveSaturationWithParamsCompletion(params: MTRColorControlClusterMoveSaturationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveSaturationWithParamsCompletionHandler(params: MTRColorControlClusterMoveSaturationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToColorTemperatureWithParamsCompletion(params: MTRColorControlClusterMoveToColorTemperatureParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToColorTemperatureWithParamsCompletionHandler(params: MTRColorControlClusterMoveToColorTemperatureParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToColorWithParamsCompletion(params: MTRColorControlClusterMoveToColorParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToColorWithParamsCompletionHandler(params: MTRColorControlClusterMoveToColorParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToHueAndSaturationWithParamsCompletion(params: MTRColorControlClusterMoveToHueAndSaturationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToHueAndSaturationWithParamsCompletionHandler(params: MTRColorControlClusterMoveToHueAndSaturationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToHueWithParamsCompletion(params: MTRColorControlClusterMoveToHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToHueWithParamsCompletionHandler(params: MTRColorControlClusterMoveToHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToSaturationWithParamsCompletion(params: MTRColorControlClusterMoveToSaturationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToSaturationWithParamsCompletionHandler(params: MTRColorControlClusterMoveToSaturationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorCapabilitiesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorCapabilitiesWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorLoopActiveWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorLoopActiveWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorLoopDirectionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorLoopDirectionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorLoopStartEnhancedHueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorLoopStartEnhancedHueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorLoopStoredEnhancedHueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorLoopStoredEnhancedHueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorLoopTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorLoopTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointBIntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointBIntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointBXWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointBXWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointBYWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointBYWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointGIntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointGIntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointGXWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointGXWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointGYWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointGYWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointRIntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointRIntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointRXWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointRXWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorPointRYWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorPointRYWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorTempPhysicalMaxMiredsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorTempPhysicalMaxMiredsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorTempPhysicalMinMiredsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorTempPhysicalMinMiredsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeColorTemperatureMiredsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeColorTemperatureMiredsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCompensationTextWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCompensationTextWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCoupleColorTempToLevelMinMiredsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCoupleColorTempToLevelMinMiredsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentHueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentHueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentSaturationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentSaturationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentXWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentXWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentYWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentYWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDriftCompensationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDriftCompensationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnhancedColorModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnhancedColorModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnhancedCurrentHueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnhancedCurrentHueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfPrimariesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfPrimariesWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOptionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOptionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary1IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary1IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary1XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary1XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary1YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary1YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary2IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary2IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary2XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary2XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary2YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary2YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary3IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary3IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary3XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary3XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary3YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary3YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary4IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary4IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary4XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary4XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary4YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary4YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary5IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary5IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary5XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary5XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary5YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary5YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary6IntensityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary6IntensityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary6XWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary6XWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePrimary6YWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePrimary6YWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRemainingTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRemainingTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartUpColorTemperatureMiredsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartUpColorTemperatureMiredsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWhitePointXWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWhitePointXWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWhitePointYWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWhitePointYWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepColorTemperatureWithParamsCompletion(params: MTRColorControlClusterStepColorTemperatureParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepColorTemperatureWithParamsCompletionHandler(params: MTRColorControlClusterStepColorTemperatureParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepColorWithParamsCompletion(params: MTRColorControlClusterStepColorParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepColorWithParamsCompletionHandler(params: MTRColorControlClusterStepColorParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepHueWithParamsCompletion(params: MTRColorControlClusterStepHueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepHueWithParamsCompletionHandler(params: MTRColorControlClusterStepHueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepSaturationWithParamsCompletion(params: MTRColorControlClusterStepSaturationParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepSaturationWithParamsCompletionHandler(params: MTRColorControlClusterStepSaturationParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopMoveStepWithParamsCompletion(params: MTRColorControlClusterStopMoveStepParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMoveStepWithParamsCompletionHandler(params: MTRColorControlClusterStopMoveStepParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorCapabilitiesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorCapabilitiesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorLoopActiveWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorLoopActiveWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorLoopDirectionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorLoopDirectionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorLoopStartEnhancedHueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorLoopStartEnhancedHueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorLoopStoredEnhancedHueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorLoopStoredEnhancedHueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorLoopTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorLoopTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointBIntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointBIntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointBXWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointBXWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointBYWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointBYWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointGIntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointGIntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointGXWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointGXWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointGYWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointGYWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointRIntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointRIntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointRXWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointRXWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorPointRYWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorPointRYWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorTempPhysicalMaxMiredsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorTempPhysicalMaxMiredsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorTempPhysicalMinMiredsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorTempPhysicalMinMiredsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeColorTemperatureMiredsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeColorTemperatureMiredsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCompensationTextWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCompensationTextWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCoupleColorTempToLevelMinMiredsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCoupleColorTempToLevelMinMiredsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentHueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentHueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentSaturationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentSaturationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentXWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentXWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentYWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentYWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDriftCompensationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDriftCompensationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnhancedColorModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnhancedColorModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnhancedCurrentHueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnhancedCurrentHueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfPrimariesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfPrimariesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOptionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOptionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary1IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary1IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary1XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary1XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary1YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary1YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary2IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary2IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary2XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary2XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary2YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary2YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary3IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary3IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary3XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary3XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary3YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary3YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary4IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary4IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary4XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary4XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary4YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary4YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary5IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary5IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary5XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary5XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary5YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary5YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary6IntensityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary6IntensityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary6XWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary6XWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePrimary6YWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePrimary6YWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRemainingTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRemainingTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartUpColorTemperatureMiredsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartUpColorTemperatureMiredsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWhitePointXWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWhitePointXWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWhitePointYWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWhitePointYWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBIntensityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBIntensityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBIntensityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBIntensityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBXWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBXWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBXWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBXWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBYWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBYWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointBYWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointBYWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGIntensityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGIntensityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGIntensityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGIntensityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGXWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGXWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGXWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGXWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGYWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGYWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointGYWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointGYWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRIntensityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRIntensityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRIntensityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRIntensityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRXWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRXWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRXWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRXWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRYWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRYWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeColorPointRYWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeColorPointRYWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOptionsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOptionsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOptionsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOptionsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWhitePointXWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWhitePointXWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWhitePointXWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWhitePointXWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWhitePointYWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWhitePointYWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWhitePointYWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWhitePointYWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterContentLauncher extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterContentLauncher; // inherited from NSObject

	static new(): MTRBaseClusterContentLauncher; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptHeaderWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptHeaderWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedStreamingProtocolsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedStreamingProtocolsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	launchContentWithParamsCompletion(params: MTRContentLauncherClusterLaunchContentParams, completion: (p1: MTRContentLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchContentWithParamsCompletionHandler(params: MTRContentLauncherClusterLaunchContentParams, completionHandler: (p1: MTRContentLauncherClusterLaunchResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	launchURLWithParamsCompletion(params: MTRContentLauncherClusterLaunchURLParams, completion: (p1: MTRContentLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchURLWithParamsCompletionHandler(params: MTRContentLauncherClusterLaunchURLParams, completionHandler: (p1: MTRContentLauncherClusterLaunchResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptHeaderWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptHeaderWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedStreamingProtocolsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedStreamingProtocolsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptHeaderWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptHeaderWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedStreamingProtocolsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedStreamingProtocolsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSupportedStreamingProtocolsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSupportedStreamingProtocolsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSupportedStreamingProtocolsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSupportedStreamingProtocolsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterDescriptor extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterDescriptor; // inherited from NSObject

	static new(): MTRBaseClusterDescriptor; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClientListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClientListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDeviceListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDeviceTypeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePartsListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePartsListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeServerListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeServerListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClientListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClientListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDeviceListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDeviceTypeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePartsListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePartsListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeServerListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeServerListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClientListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClientListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDeviceListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDeviceTypeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePartsListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePartsListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeServerListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeServerListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterDiagnosticLogs extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterDiagnosticLogs; // inherited from NSObject

	static new(): MTRBaseClusterDiagnosticLogs; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	retrieveLogsRequestWithParamsCompletion(params: MTRDiagnosticLogsClusterRetrieveLogsRequestParams, completion: (p1: MTRDiagnosticLogsClusterRetrieveLogsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	retrieveLogsRequestWithParamsCompletionHandler(params: MTRDiagnosticLogsClusterRetrieveLogsRequestParams, completionHandler: (p1: MTRDiagnosticLogsClusterRetrieveLogsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterDoorLock extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterDoorLock; // inherited from NSObject

	static new(): MTRBaseClusterDoorLock; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActuatorEnabledWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActuatorEnabledWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAutoRelockTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAutoRelockTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCredentialRulesSupportWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCredentialRulesSupportWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDefaultConfigurationRegisterWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDefaultConfigurationRegisterWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDoorClosedEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDoorClosedEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDoorOpenEventsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDoorOpenEventsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDoorStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDoorStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnableInsideStatusLEDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnableInsideStatusLEDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnableLocalProgrammingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnableLocalProgrammingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnableOneTouchLockingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnableOneTouchLockingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnablePrivacyModeButtonWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnablePrivacyModeButtonWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeExpiringUserTimeoutWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeExpiringUserTimeoutWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLEDSettingsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLEDSettingsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLanguageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLanguageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocalProgrammingFeaturesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocalProgrammingFeaturesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLockStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLockStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLockTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLockTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxPINCodeLengthWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxPINCodeLengthWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxRFIDCodeLengthWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxRFIDCodeLengthWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinPINCodeLengthWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinPINCodeLengthWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinRFIDCodeLengthWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinRFIDCodeLengthWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfCredentialsSupportedPerUserWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfCredentialsSupportedPerUserWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfHolidaySchedulesSupportedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfHolidaySchedulesSupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfPINUsersSupportedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfPINUsersSupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfRFIDUsersSupportedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfRFIDUsersSupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfTotalUsersSupportedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfTotalUsersSupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfWeekDaySchedulesSupportedPerUserWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfWeekDaySchedulesSupportedPerUserWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfYearDaySchedulesSupportedPerUserWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfYearDaySchedulesSupportedPerUserWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOpenPeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOpenPeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOperatingModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOperatingModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRequirePINforRemoteOperationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRequirePINforRemoteOperationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSendPINOverTheAirWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSendPINOverTheAirWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSoundVolumeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSoundVolumeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedOperatingModesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedOperatingModesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUserCodeTemporaryDisableTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUserCodeTemporaryDisableTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWrongCodeEntryLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWrongCodeEntryLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	clearCredentialWithParamsCompletion(params: MTRDoorLockClusterClearCredentialParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearCredentialWithParamsCompletionHandler(params: MTRDoorLockClusterClearCredentialParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearHolidayScheduleWithParamsCompletion(params: MTRDoorLockClusterClearHolidayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearHolidayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterClearHolidayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearUserWithParamsCompletion(params: MTRDoorLockClusterClearUserParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearUserWithParamsCompletionHandler(params: MTRDoorLockClusterClearUserParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearWeekDayScheduleWithParamsCompletion(params: MTRDoorLockClusterClearWeekDayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeekDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterClearWeekDayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearYearDayScheduleWithParamsCompletion(params: MTRDoorLockClusterClearYearDayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearYearDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterClearYearDayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getCredentialStatusWithParamsCompletion(params: MTRDoorLockClusterGetCredentialStatusParams, completion: (p1: MTRDoorLockClusterGetCredentialStatusResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getCredentialStatusWithParamsCompletionHandler(params: MTRDoorLockClusterGetCredentialStatusParams, completionHandler: (p1: MTRDoorLockClusterGetCredentialStatusResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getHolidayScheduleWithParamsCompletion(params: MTRDoorLockClusterGetHolidayScheduleParams, completion: (p1: MTRDoorLockClusterGetHolidayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getHolidayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterGetHolidayScheduleParams, completionHandler: (p1: MTRDoorLockClusterGetHolidayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getUserWithParamsCompletion(params: MTRDoorLockClusterGetUserParams, completion: (p1: MTRDoorLockClusterGetUserResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getUserWithParamsCompletionHandler(params: MTRDoorLockClusterGetUserParams, completionHandler: (p1: MTRDoorLockClusterGetUserResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getWeekDayScheduleWithParamsCompletion(params: MTRDoorLockClusterGetWeekDayScheduleParams, completion: (p1: MTRDoorLockClusterGetWeekDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getWeekDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterGetWeekDayScheduleParams, completionHandler: (p1: MTRDoorLockClusterGetWeekDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getYearDayScheduleWithParamsCompletion(params: MTRDoorLockClusterGetYearDayScheduleParams, completion: (p1: MTRDoorLockClusterGetYearDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getYearDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterGetYearDayScheduleParams, completionHandler: (p1: MTRDoorLockClusterGetYearDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	lockDoorWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	lockDoorWithParamsCompletion(params: MTRDoorLockClusterLockDoorParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	lockDoorWithParamsCompletionHandler(params: MTRDoorLockClusterLockDoorParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActuatorEnabledWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActuatorEnabledWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAutoRelockTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAutoRelockTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCredentialRulesSupportWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCredentialRulesSupportWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDefaultConfigurationRegisterWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDefaultConfigurationRegisterWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDoorClosedEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDoorClosedEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDoorOpenEventsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDoorOpenEventsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDoorStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDoorStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnableInsideStatusLEDWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnableInsideStatusLEDWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnableLocalProgrammingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnableLocalProgrammingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnableOneTouchLockingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnableOneTouchLockingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnablePrivacyModeButtonWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnablePrivacyModeButtonWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeExpiringUserTimeoutWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeExpiringUserTimeoutWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLEDSettingsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLEDSettingsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLanguageWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLanguageWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocalProgrammingFeaturesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocalProgrammingFeaturesWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLockStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLockStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLockTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLockTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxPINCodeLengthWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxPINCodeLengthWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxRFIDCodeLengthWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxRFIDCodeLengthWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinPINCodeLengthWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinPINCodeLengthWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinRFIDCodeLengthWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinRFIDCodeLengthWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfCredentialsSupportedPerUserWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfCredentialsSupportedPerUserWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfHolidaySchedulesSupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfHolidaySchedulesSupportedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfPINUsersSupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfPINUsersSupportedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfRFIDUsersSupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfRFIDUsersSupportedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfTotalUsersSupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfTotalUsersSupportedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfWeekDaySchedulesSupportedPerUserWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfWeekDaySchedulesSupportedPerUserWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfYearDaySchedulesSupportedPerUserWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfYearDaySchedulesSupportedPerUserWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOpenPeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOpenPeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOperatingModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOperatingModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRequirePINforRemoteOperationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRequirePINforRemoteOperationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSendPINOverTheAirWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSendPINOverTheAirWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSoundVolumeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSoundVolumeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedOperatingModesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedOperatingModesWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUserCodeTemporaryDisableTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUserCodeTemporaryDisableTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWrongCodeEntryLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWrongCodeEntryLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setCredentialWithParamsCompletion(params: MTRDoorLockClusterSetCredentialParams, completion: (p1: MTRDoorLockClusterSetCredentialResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setCredentialWithParamsCompletionHandler(params: MTRDoorLockClusterSetCredentialParams, completionHandler: (p1: MTRDoorLockClusterSetCredentialResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setHolidayScheduleWithParamsCompletion(params: MTRDoorLockClusterSetHolidayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setHolidayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterSetHolidayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setUserWithParamsCompletion(params: MTRDoorLockClusterSetUserParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setUserWithParamsCompletionHandler(params: MTRDoorLockClusterSetUserParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setWeekDayScheduleWithParamsCompletion(params: MTRDoorLockClusterSetWeekDayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setWeekDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterSetWeekDayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setYearDayScheduleWithParamsCompletion(params: MTRDoorLockClusterSetYearDayScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setYearDayScheduleWithParamsCompletionHandler(params: MTRDoorLockClusterSetYearDayScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActuatorEnabledWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActuatorEnabledWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAutoRelockTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAutoRelockTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCredentialRulesSupportWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCredentialRulesSupportWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDefaultConfigurationRegisterWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDefaultConfigurationRegisterWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDoorClosedEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDoorClosedEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDoorOpenEventsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDoorOpenEventsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDoorStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDoorStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnableInsideStatusLEDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnableInsideStatusLEDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnableLocalProgrammingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnableLocalProgrammingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnableOneTouchLockingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnableOneTouchLockingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnablePrivacyModeButtonWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnablePrivacyModeButtonWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeExpiringUserTimeoutWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeExpiringUserTimeoutWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLEDSettingsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLEDSettingsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLanguageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLanguageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocalProgrammingFeaturesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocalProgrammingFeaturesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLockStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLockStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLockTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLockTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxPINCodeLengthWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxPINCodeLengthWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxRFIDCodeLengthWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxRFIDCodeLengthWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinPINCodeLengthWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinPINCodeLengthWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinRFIDCodeLengthWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinRFIDCodeLengthWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfCredentialsSupportedPerUserWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfCredentialsSupportedPerUserWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfHolidaySchedulesSupportedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfHolidaySchedulesSupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfPINUsersSupportedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfPINUsersSupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfRFIDUsersSupportedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfRFIDUsersSupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfTotalUsersSupportedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfTotalUsersSupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfWeekDaySchedulesSupportedPerUserWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfWeekDaySchedulesSupportedPerUserWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfYearDaySchedulesSupportedPerUserWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfYearDaySchedulesSupportedPerUserWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOpenPeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOpenPeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOperatingModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOperatingModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRequirePINforRemoteOperationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRequirePINforRemoteOperationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSendPINOverTheAirWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSendPINOverTheAirWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSoundVolumeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSoundVolumeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedOperatingModesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedOperatingModesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUserCodeTemporaryDisableTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUserCodeTemporaryDisableTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWrongCodeEntryLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWrongCodeEntryLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	unlockDoorWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	unlockDoorWithParamsCompletion(params: MTRDoorLockClusterUnlockDoorParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	unlockDoorWithParamsCompletionHandler(params: MTRDoorLockClusterUnlockDoorParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	unlockWithTimeoutWithParamsCompletion(params: MTRDoorLockClusterUnlockWithTimeoutParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	unlockWithTimeoutWithParamsCompletionHandler(params: MTRDoorLockClusterUnlockWithTimeoutParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeAutoRelockTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAutoRelockTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeAutoRelockTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAutoRelockTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDoorClosedEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDoorClosedEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDoorClosedEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDoorClosedEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDoorOpenEventsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDoorOpenEventsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDoorOpenEventsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDoorOpenEventsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableInsideStatusLEDWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableInsideStatusLEDWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableInsideStatusLEDWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableInsideStatusLEDWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableLocalProgrammingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableLocalProgrammingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableLocalProgrammingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableLocalProgrammingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableOneTouchLockingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableOneTouchLockingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnableOneTouchLockingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnableOneTouchLockingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnablePrivacyModeButtonWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnablePrivacyModeButtonWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnablePrivacyModeButtonWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnablePrivacyModeButtonWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeExpiringUserTimeoutWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeExpiringUserTimeoutWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeExpiringUserTimeoutWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeExpiringUserTimeoutWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLEDSettingsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLEDSettingsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLEDSettingsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLEDSettingsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLanguageWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLanguageWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLanguageWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLanguageWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalProgrammingFeaturesWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalProgrammingFeaturesWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalProgrammingFeaturesWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalProgrammingFeaturesWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOpenPeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOpenPeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOpenPeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOpenPeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOperatingModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOperatingModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOperatingModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOperatingModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRequirePINforRemoteOperationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRequirePINforRemoteOperationWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRequirePINforRemoteOperationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRequirePINforRemoteOperationWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSendPINOverTheAirWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSendPINOverTheAirWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSendPINOverTheAirWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSendPINOverTheAirWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSoundVolumeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSoundVolumeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSoundVolumeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSoundVolumeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWrongCodeEntryLimitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWrongCodeEntryLimitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWrongCodeEntryLimitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWrongCodeEntryLimitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterElectricalEnergyMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterElectricalEnergyMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterElectricalEnergyMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAccuracyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCumulativeEnergyExportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCumulativeEnergyImportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCumulativeEnergyResetWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeriodicEnergyExportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeriodicEnergyImportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAccuracyWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyExportedWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyImportedWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyResetWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeriodicEnergyExportedWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeriodicEnergyImportedWithCompletion(completion: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAccuracyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCumulativeEnergyExportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCumulativeEnergyImportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCumulativeEnergyResetWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeriodicEnergyExportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeriodicEnergyImportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBaseClusterElectricalMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterElectricalMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterElectricalMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcActivePowerOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcActivePowerOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcCurrentDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcCurrentDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcCurrentMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcCurrentMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcCurrentOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcCurrentOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcFrequencyDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcFrequencyDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcFrequencyMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcFrequencyMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcFrequencyMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcFrequencyMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcFrequencyMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcFrequencyMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcFrequencyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcOverloadAlarmsMaskWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcOverloadAlarmsMaskWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcPowerDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcPowerDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcPowerMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcPowerMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcReactivePowerOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcReactivePowerOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcVoltageDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcVoltageDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcVoltageMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcVoltageMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcVoltageOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcVoltageOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveCurrentPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActiveCurrentPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveCurrentPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActiveCurrentPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMaxPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMaxPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMaxPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMaxPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMinPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMinPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMinPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMinPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActivePowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeActivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApparentPowerPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeApparentPowerPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApparentPowerPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeApparentPowerPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeApparentPowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeApparentPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsOverVoltageCounterPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsOverVoltageCounterPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsOverVoltageCounterPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsOverVoltageCounterPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsOverVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsOverVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsUnderVoltageCounterPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsUnderVoltageCounterPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsUnderVoltageCounterPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsUnderVoltageCounterPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsUnderVoltageCounterWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsUnderVoltageCounterWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsUnderVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsUnderVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAverageRmsVoltageMeasurementPeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeCurrentOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcCurrentDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcCurrentDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcCurrentMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcCurrentMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcCurrentMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcCurrentMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcCurrentMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcCurrentMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcPowerDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcPowerDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcPowerMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcPowerMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcPowerMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcPowerMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcPowerMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcPowerMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcPowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcVoltageDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcVoltageDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcVoltageMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcVoltageMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcVoltageMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcVoltageMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcVoltageMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcVoltageMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDcVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeDcVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHarmonicCurrentMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeHarmonicCurrentMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstantaneousActiveCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInstantaneousActiveCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstantaneousLineCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInstantaneousLineCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstantaneousPowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInstantaneousPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstantaneousReactiveCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInstantaneousReactiveCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstantaneousVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeInstantaneousVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLineCurrentPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeLineCurrentPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLineCurrentPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeLineCurrentPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured11thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured11thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured1stHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured1stHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured3rdHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured3rdHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured5thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured5thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured7thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured7thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasured9thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasured9thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase11thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase11thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase1stHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase1stHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase3rdHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase3rdHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase5thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase5thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase7thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase7thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredPhase9thHarmonicCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasuredPhase9thHarmonicCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasurementTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeMeasurementTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNeutralCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeNeutralCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOverloadAlarmsMaskWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeOverloadAlarmsMaskWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhaseHarmonicCurrentMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePhaseHarmonicCurrentMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerDivisorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePowerDivisorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerFactorPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePowerFactorPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerFactorPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePowerFactorPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerFactorWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePowerFactorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerMultiplierWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributePowerMultiplierWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReactiveCurrentPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReactiveCurrentPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReactiveCurrentPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReactiveCurrentPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReactivePowerPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReactivePowerPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReactivePowerPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReactivePowerPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeReactivePowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeReactivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMaxPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMaxPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMaxPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMaxPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMinPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMinPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMinPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMinPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeOverVoltagePeriodPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeOverVoltagePeriodPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeOverVoltagePeriodPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeOverVoltagePeriodPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeOverVoltagePeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeOverVoltagePeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeOverVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeOverVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeUnderVoltagePeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsExtremeUnderVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsExtremeUnderVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMaxPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMaxPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMaxPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMaxPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMinPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMinPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMinPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMinPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltagePhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltagePhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltagePhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltagePhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSagPeriodPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSagPeriodPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSagPeriodPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSagPeriodPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSagPeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSagPeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSagWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSagWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSwellPeriodPhaseBWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSwellPeriodPhaseBWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSwellPeriodPhaseCWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSwellPeriodPhaseCWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSwellPeriodWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSwellPeriodWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageSwellWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageSwellWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRmsVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeRmsVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTotalActivePowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeTotalActivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTotalApparentPowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeTotalApparentPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTotalReactivePowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeTotalReactivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVoltageOverloadWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeVoltageOverloadWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getMeasurementProfileCommandWithParamsCompletion(params: MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getMeasurementProfileCommandWithParamsCompletionHandler(params: MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getProfileInfoCommandWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getProfileInfoCommandWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getProfileInfoCommandWithParamsCompletion(params: MTRElectricalMeasurementClusterGetProfileInfoCommandParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getProfileInfoCommandWithParamsCompletionHandler(params: MTRElectricalMeasurementClusterGetProfileInfoCommandParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcActivePowerOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcActivePowerOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcCurrentDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcCurrentMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcCurrentOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcFrequencyDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcFrequencyMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcFrequencyMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcFrequencyMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcFrequencyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcOverloadAlarmsMaskWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcOverloadAlarmsMaskWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcPowerDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcPowerDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcPowerMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcPowerMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcReactivePowerOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcReactivePowerOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcVoltageDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcVoltageMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcVoltageOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActiveCurrentPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveCurrentPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActiveCurrentPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveCurrentPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMaxPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMaxPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMinPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMinPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeActivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActivePowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApparentPowerPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApparentPowerPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeApparentPowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsOverVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsUnderVoltageCounterWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsUnderVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeCurrentOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcCurrentDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcCurrentMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcCurrentMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcCurrentMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcPowerDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcPowerDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcPowerMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcPowerMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcPowerMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcPowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcVoltageDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcVoltageMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcVoltageMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcVoltageMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDcVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeHarmonicCurrentMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHarmonicCurrentMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousActiveCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstantaneousActiveCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousLineCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstantaneousLineCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstantaneousPowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousReactiveCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstantaneousReactiveCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstantaneousVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeLineCurrentPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLineCurrentPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeLineCurrentPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLineCurrentPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured11thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured11thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured1stHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured1stHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured3rdHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured3rdHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured5thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured5thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured7thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured7thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasured9thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasured9thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase11thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase11thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase1stHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase1stHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase3rdHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase3rdHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase5thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase5thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase7thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase7thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase9thHarmonicCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredPhase9thHarmonicCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeMeasurementTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasurementTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeNeutralCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNeutralCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeOverloadAlarmsMaskWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOverloadAlarmsMaskWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePhaseHarmonicCurrentMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhaseHarmonicCurrentMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePowerDivisorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerDivisorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePowerFactorPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerFactorPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePowerFactorPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerFactorPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePowerFactorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerFactorWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributePowerMultiplierWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerMultiplierWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReactiveCurrentPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReactiveCurrentPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReactiveCurrentPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReactiveCurrentPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReactivePowerPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReactivePowerPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeReactivePowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMaxPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMaxPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMinPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMinPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeOverVoltagePeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeOverVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeUnderVoltagePeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsExtremeUnderVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMaxPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMaxPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMinPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMinPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltagePhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltagePhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltagePhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltagePhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSagPeriodPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSagPeriodPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSagPeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSagWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodPhaseBWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSwellPeriodPhaseBWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodPhaseCWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSwellPeriodPhaseCWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSwellPeriodWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageSwellWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRmsVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeTotalActivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTotalActivePowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeTotalApparentPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTotalApparentPowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeTotalReactivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTotalReactivePowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeVoltageOverloadWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVoltageOverloadWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcActivePowerOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcActivePowerOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcCurrentDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcCurrentDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcCurrentMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcCurrentMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcCurrentOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcCurrentOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcFrequencyDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcFrequencyDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcFrequencyMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcFrequencyMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcFrequencyMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcFrequencyMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcFrequencyMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcFrequencyMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcFrequencyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcOverloadAlarmsMaskWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcOverloadAlarmsMaskWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcPowerDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcPowerDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcPowerMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcPowerMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcReactivePowerOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcReactivePowerOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcVoltageDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcVoltageDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcVoltageMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcVoltageMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcVoltageOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcVoltageOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveCurrentPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActiveCurrentPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveCurrentPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActiveCurrentPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMaxPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMaxPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMaxPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMaxPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMinPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMinPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMinPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMinPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActivePowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeActivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApparentPowerPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeApparentPowerPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApparentPowerPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeApparentPowerPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeApparentPowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeApparentPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsOverVoltageCounterPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsOverVoltageCounterPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsOverVoltageCounterPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsOverVoltageCounterPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsOverVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsOverVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsUnderVoltageCounterWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsUnderVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsUnderVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAverageRmsVoltageMeasurementPeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeCurrentOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcCurrentDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcCurrentDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcCurrentMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcCurrentMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcCurrentMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcCurrentMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcCurrentMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcCurrentMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcPowerDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcPowerDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcPowerMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcPowerMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcPowerMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcPowerMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcPowerMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcPowerMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcPowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcVoltageDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcVoltageDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcVoltageMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcVoltageMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcVoltageMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcVoltageMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcVoltageMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcVoltageMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDcVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeDcVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHarmonicCurrentMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeHarmonicCurrentMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstantaneousActiveCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInstantaneousActiveCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstantaneousLineCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInstantaneousLineCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstantaneousPowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInstantaneousPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstantaneousReactiveCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInstantaneousReactiveCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstantaneousVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeInstantaneousVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLineCurrentPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeLineCurrentPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLineCurrentPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeLineCurrentPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured11thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured11thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured1stHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured1stHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured3rdHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured3rdHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured5thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured5thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured7thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured7thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasured9thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasured9thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase11thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase11thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase1stHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase1stHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase3rdHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase3rdHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase5thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase5thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase7thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase7thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredPhase9thHarmonicCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasuredPhase9thHarmonicCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasurementTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeMeasurementTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNeutralCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeNeutralCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOverloadAlarmsMaskWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeOverloadAlarmsMaskWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhaseHarmonicCurrentMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePhaseHarmonicCurrentMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerDivisorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePowerDivisorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerFactorPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePowerFactorPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerFactorPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePowerFactorPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerFactorWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePowerFactorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerMultiplierWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributePowerMultiplierWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReactiveCurrentPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReactiveCurrentPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReactiveCurrentPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReactiveCurrentPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReactivePowerPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReactivePowerPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReactivePowerPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReactivePowerPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeReactivePowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeReactivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMaxPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMaxPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMaxPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMaxPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMinPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMinPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMinPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMinPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeOverVoltagePeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeOverVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeOverVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeUnderVoltagePeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsExtremeUnderVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsExtremeUnderVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMaxPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMaxPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMaxPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMaxPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMinPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMinPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMinPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMinPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltagePhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltagePhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltagePhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltagePhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSagPeriodPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSagPeriodPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSagPeriodPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSagPeriodPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSagPeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSagPeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSagWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSagWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSwellPeriodPhaseBWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSwellPeriodPhaseBWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSwellPeriodPhaseCWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSwellPeriodPhaseCWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSwellPeriodWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSwellPeriodWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageSwellWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageSwellWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRmsVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeRmsVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTotalActivePowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeTotalActivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTotalApparentPowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeTotalApparentPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTotalReactivePowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeTotalReactivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVoltageOverloadWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeVoltageOverloadWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeOverloadAlarmsMaskWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOverloadAlarmsMaskWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeOverloadAlarmsMaskWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOverloadAlarmsMaskWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSagPeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsVoltageSagPeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSagPeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsVoltageSagPeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterElectricalPowerMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterElectricalPowerMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterElectricalPowerMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAccuracyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeActiveCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeActivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeApparentCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeApparentPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeHarmonicCurrentsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeHarmonicPhasesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeNeutralCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeNumberOfMeasurementTypesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePowerFactorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePowerModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeRMSCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeRMSPowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeRMSVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeRangesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeReactiveCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeReactivePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAccuracyWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeActiveCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeActivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeApparentCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeApparentPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeHarmonicCurrentsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeHarmonicPhasesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeNeutralCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeNumberOfMeasurementTypesWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePowerFactorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePowerModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeRMSCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeRMSPowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeRMSVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeRangesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeReactiveCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeReactivePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAccuracyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeActiveCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeActivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeApparentCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeApparentPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeHarmonicCurrentsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeHarmonicPhasesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeNeutralCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeNumberOfMeasurementTypesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePowerFactorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePowerModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeRMSCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeRMSPowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeRMSVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeRangesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeReactiveCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeReactivePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterEthernetNetworkDiagnostics extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterEthernetNetworkDiagnostics; // inherited from NSObject

	static new(): MTRBaseClusterEthernetNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCarrierDetectWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCarrierDetectWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCollisionCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCollisionCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFullDuplexWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFullDuplexWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOverrunCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOverrunCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePHYRateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePHYRateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketRxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketRxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketTxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketTxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTimeSinceResetWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTimeSinceResetWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxErrCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxErrCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCarrierDetectWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCarrierDetectWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCollisionCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCollisionCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFullDuplexWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFullDuplexWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOverrunCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOverrunCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePHYRateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePHYRateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketRxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketRxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketTxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketTxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTimeSinceResetWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTimeSinceResetWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxErrCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxErrCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsCompletion(params: MTREthernetNetworkDiagnosticsClusterResetCountsParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsCompletionHandler(params: MTREthernetNetworkDiagnosticsClusterResetCountsParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCarrierDetectWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCarrierDetectWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCollisionCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCollisionCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFullDuplexWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFullDuplexWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOverrunCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOverrunCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePHYRateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePHYRateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketRxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketRxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketTxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketTxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTimeSinceResetWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTimeSinceResetWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxErrCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxErrCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterFanControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterFanControl; // inherited from NSObject

	static new(): MTRBaseClusterFanControl; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAirflowDirectionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFanModeSequenceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFanModeSequenceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFanModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFanModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePercentCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePercentCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePercentSettingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePercentSettingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRockSettingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRockSettingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRockSupportWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRockSupportWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSpeedCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSpeedCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSpeedMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSpeedMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSpeedSettingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSpeedSettingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWindSettingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWindSettingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWindSupportWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWindSupportWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAirflowDirectionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFanModeSequenceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFanModeSequenceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFanModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFanModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePercentCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePercentCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePercentSettingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePercentSettingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRockSettingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRockSettingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRockSupportWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRockSupportWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSpeedCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSpeedCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSpeedMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSpeedMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSpeedSettingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSpeedSettingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWindSettingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWindSettingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWindSupportWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWindSupportWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	stepWithParamsCompletion(params: MTRFanControlClusterStepParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAirflowDirectionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFanModeSequenceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFanModeSequenceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFanModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFanModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePercentCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePercentCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePercentSettingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePercentSettingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRockSettingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRockSettingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRockSupportWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRockSupportWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSpeedCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSpeedCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSpeedMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSpeedMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSpeedSettingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSpeedSettingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWindSettingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWindSettingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWindSupportWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWindSupportWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeAirflowDirectionWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeAirflowDirectionWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFanModeSequenceWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFanModeSequenceWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFanModeSequenceWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFanModeSequenceWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFanModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFanModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFanModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFanModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePercentSettingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePercentSettingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePercentSettingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePercentSettingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRockSettingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRockSettingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRockSettingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRockSettingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSpeedSettingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSpeedSettingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSpeedSettingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSpeedSettingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWindSettingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWindSettingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWindSettingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWindSettingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterFixedLabel extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterFixedLabel; // inherited from NSObject

	static new(): MTRBaseClusterFixedLabel; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLabelListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLabelListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLabelListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLabelListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLabelListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLabelListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterFlowMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterFlowMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterFlowMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterFormaldehydeConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterFormaldehydeConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterFormaldehydeConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterGeneralCommissioning extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterGeneralCommissioning; // inherited from NSObject

	static new(): MTRBaseClusterGeneralCommissioning; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBasicCommissioningInfoWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBasicCommissioningInfoWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBreadcrumbWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBreadcrumbWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocationCapabilityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocationCapabilityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRegulatoryConfigWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRegulatoryConfigWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportsConcurrentConnectionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportsConcurrentConnectionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	armFailSafeWithParamsCompletion(params: MTRGeneralCommissioningClusterArmFailSafeParams, completion: (p1: MTRGeneralCommissioningClusterArmFailSafeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	armFailSafeWithParamsCompletionHandler(params: MTRGeneralCommissioningClusterArmFailSafeParams, completionHandler: (p1: MTRGeneralCommissioningClusterArmFailSafeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	commissioningCompleteWithCompletion(completion: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	commissioningCompleteWithCompletionHandler(completionHandler: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	commissioningCompleteWithParamsCompletion(params: MTRGeneralCommissioningClusterCommissioningCompleteParams, completion: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	commissioningCompleteWithParamsCompletionHandler(params: MTRGeneralCommissioningClusterCommissioningCompleteParams, completionHandler: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBasicCommissioningInfoWithCompletion(completion: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBasicCommissioningInfoWithCompletionHandler(completionHandler: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBreadcrumbWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBreadcrumbWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocationCapabilityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocationCapabilityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRegulatoryConfigWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRegulatoryConfigWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportsConcurrentConnectionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportsConcurrentConnectionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setRegulatoryConfigWithParamsCompletion(params: MTRGeneralCommissioningClusterSetRegulatoryConfigParams, completion: (p1: MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setRegulatoryConfigWithParamsCompletionHandler(params: MTRGeneralCommissioningClusterSetRegulatoryConfigParams, completionHandler: (p1: MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBasicCommissioningInfoWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBasicCommissioningInfoWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRGeneralCommissioningClusterBasicCommissioningInfo, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBreadcrumbWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBreadcrumbWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocationCapabilityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocationCapabilityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRegulatoryConfigWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRegulatoryConfigWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportsConcurrentConnectionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportsConcurrentConnectionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBreadcrumbWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBreadcrumbWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBreadcrumbWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBreadcrumbWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterGeneralDiagnostics extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterGeneralDiagnostics; // inherited from NSObject

	static new(): MTRBaseClusterGeneralDiagnostics; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveHardwareFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveHardwareFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveNetworkFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveNetworkFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveRadioFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveRadioFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBootReasonWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBootReasonsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNetworkInterfacesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNetworkInterfacesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRebootCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRebootCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTestEventTriggersEnabledWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTestEventTriggersEnabledWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTotalOperationalHoursWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTotalOperationalHoursWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUpTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUpTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveHardwareFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveHardwareFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveNetworkFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveNetworkFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveRadioFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveRadioFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBootReasonWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBootReasonsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNetworkInterfacesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNetworkInterfacesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRebootCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRebootCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTestEventTriggersEnabledWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTestEventTriggersEnabledWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTotalOperationalHoursWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTotalOperationalHoursWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUpTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUpTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveHardwareFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveHardwareFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveNetworkFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveNetworkFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveRadioFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveRadioFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBootReasonWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBootReasonsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNetworkInterfacesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNetworkInterfacesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRebootCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRebootCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTestEventTriggersEnabledWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTestEventTriggersEnabledWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTotalOperationalHoursWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTotalOperationalHoursWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUpTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUpTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEventTriggerWithParamsCompletion(params: MTRGeneralDiagnosticsClusterTestEventTriggerParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEventTriggerWithParamsCompletionHandler(params: MTRGeneralDiagnosticsClusterTestEventTriggerParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterGroupKeyManagement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterGroupKeyManagement; // inherited from NSObject

	static new(): MTRBaseClusterGroupKeyManagement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGroupKeyMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGroupKeyMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGroupTableWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGroupTableWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxGroupKeysPerFabricWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxGroupKeysPerFabricWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxGroupsPerFabricWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxGroupsPerFabricWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.0
	 */
	keySetReadAllIndicesWithCompletion(completion: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetReadAllIndicesWithParamsCompletion(params: MTRGroupKeyManagementClusterKeySetReadAllIndicesParams, completion: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetReadAllIndicesWithParamsCompletionHandler(params: MTRGroupKeyManagementClusterKeySetReadAllIndicesParams, completionHandler: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetReadWithParamsCompletion(params: MTRGroupKeyManagementClusterKeySetReadParams, completion: (p1: MTRGroupKeyManagementClusterKeySetReadResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetReadWithParamsCompletionHandler(params: MTRGroupKeyManagementClusterKeySetReadParams, completionHandler: (p1: MTRGroupKeyManagementClusterKeySetReadResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetRemoveWithParamsCompletion(params: MTRGroupKeyManagementClusterKeySetRemoveParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetRemoveWithParamsCompletionHandler(params: MTRGroupKeyManagementClusterKeySetRemoveParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetWriteWithParamsCompletion(params: MTRGroupKeyManagementClusterKeySetWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetWriteWithParamsCompletionHandler(params: MTRGroupKeyManagementClusterKeySetWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGroupKeyMapWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGroupKeyMapWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGroupTableWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGroupTableWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxGroupKeysPerFabricWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxGroupKeysPerFabricWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxGroupsPerFabricWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxGroupsPerFabricWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGroupKeyMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGroupKeyMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGroupTableWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGroupTableWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxGroupKeysPerFabricWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxGroupKeysPerFabricWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxGroupsPerFabricWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxGroupsPerFabricWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGroupKeyMapWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeGroupKeyMapWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGroupKeyMapWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeGroupKeyMapWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterGroups extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterGroups; // inherited from NSObject

	static new(): MTRBaseClusterGroups; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNameSupportWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNameSupportWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	addGroupIfIdentifyingWithParamsCompletion(params: MTRGroupsClusterAddGroupIfIdentifyingParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addGroupIfIdentifyingWithParamsCompletionHandler(params: MTRGroupsClusterAddGroupIfIdentifyingParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addGroupWithParamsCompletion(params: MTRGroupsClusterAddGroupParams, completion: (p1: MTRGroupsClusterAddGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addGroupWithParamsCompletionHandler(params: MTRGroupsClusterAddGroupParams, completionHandler: (p1: MTRGroupsClusterAddGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getGroupMembershipWithParamsCompletion(params: MTRGroupsClusterGetGroupMembershipParams, completion: (p1: MTRGroupsClusterGetGroupMembershipResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getGroupMembershipWithParamsCompletionHandler(params: MTRGroupsClusterGetGroupMembershipParams, completionHandler: (p1: MTRGroupsClusterGetGroupMembershipResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNameSupportWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNameSupportWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeAllGroupsWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeAllGroupsWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeAllGroupsWithParamsCompletion(params: MTRGroupsClusterRemoveAllGroupsParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeAllGroupsWithParamsCompletionHandler(params: MTRGroupsClusterRemoveAllGroupsParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeGroupWithParamsCompletion(params: MTRGroupsClusterRemoveGroupParams, completion: (p1: MTRGroupsClusterRemoveGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeGroupWithParamsCompletionHandler(params: MTRGroupsClusterRemoveGroupParams, completionHandler: (p1: MTRGroupsClusterRemoveGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNameSupportWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNameSupportWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	viewGroupWithParamsCompletion(params: MTRGroupsClusterViewGroupParams, completion: (p1: MTRGroupsClusterViewGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	viewGroupWithParamsCompletionHandler(params: MTRGroupsClusterViewGroupParams, completionHandler: (p1: MTRGroupsClusterViewGroupResponseParams, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterHEPAFilterMonitoring extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterHEPAFilterMonitoring; // inherited from NSObject

	static new(): MTRBaseClusterHEPAFilterMonitoring; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeChangeIndicationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeConditionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDegradationDirectionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeInPlaceIndicatorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLastChangedTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeReplacementProductListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeChangeIndicationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeConditionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDegradationDirectionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeInPlaceIndicatorWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLastChangedTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeReplacementProductListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithParamsCompletion(params: MTRHEPAFilterMonitoringClusterResetConditionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeChangeIndicationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeConditionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDegradationDirectionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeInPlaceIndicatorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLastChangedTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeReplacementProductListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterIdentify extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterIdentify; // inherited from NSObject

	static new(): MTRBaseClusterIdentify; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeIdentifyTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeIdentifyTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeIdentifyTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeIdentifyTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	identifyWithParamsCompletion(params: MTRIdentifyClusterIdentifyParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	identifyWithParamsCompletionHandler(params: MTRIdentifyClusterIdentifyParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeIdentifyTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeIdentifyTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeIdentifyTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeIdentifyTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeIdentifyTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeIdentifyTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeIdentifyTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeIdentifyTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	triggerEffectWithParamsCompletion(params: MTRIdentifyClusterTriggerEffectParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	triggerEffectWithParamsCompletionHandler(params: MTRIdentifyClusterTriggerEffectParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIdentifyTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIdentifyTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIdentifyTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIdentifyTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterIlluminanceMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterIlluminanceMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterIlluminanceMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLightSensorTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLightSensorTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLightSensorTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLightSensorTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLightSensorTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLightSensorTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterKeypadInput extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterKeypadInput; // inherited from NSObject

	static new(): MTRBaseClusterKeypadInput; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	sendKeyWithParamsCompletion(params: MTRKeypadInputClusterSendKeyParams, completion: (p1: MTRKeypadInputClusterSendKeyResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sendKeyWithParamsCompletionHandler(params: MTRKeypadInputClusterSendKeyParams, completionHandler: (p1: MTRKeypadInputClusterSendKeyResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterLevelControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterLevelControl; // inherited from NSObject

	static new(): MTRBaseClusterLevelControl; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentFrequencyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDefaultMoveRateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDefaultMoveRateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxFrequencyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinFrequencyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOffTransitionTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOffTransitionTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnOffTransitionTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnOffTransitionTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnTransitionTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnTransitionTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOptionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOptionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRemainingTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRemainingTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartUpCurrentLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartUpCurrentLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	moveToClosestFrequencyWithParamsCompletion(params: MTRLevelControlClusterMoveToClosestFrequencyParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToClosestFrequencyWithParamsCompletionHandler(params: MTRLevelControlClusterMoveToClosestFrequencyParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToLevelWithOnOffWithParamsCompletion(params: MTRLevelControlClusterMoveToLevelWithOnOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToLevelWithOnOffWithParamsCompletionHandler(params: MTRLevelControlClusterMoveToLevelWithOnOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToLevelWithParamsCompletion(params: MTRLevelControlClusterMoveToLevelParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToLevelWithParamsCompletionHandler(params: MTRLevelControlClusterMoveToLevelParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveWithOnOffWithParamsCompletion(params: MTRLevelControlClusterMoveWithOnOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveWithOnOffWithParamsCompletionHandler(params: MTRLevelControlClusterMoveWithOnOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveWithParamsCompletion(params: MTRLevelControlClusterMoveParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveWithParamsCompletionHandler(params: MTRLevelControlClusterMoveParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentFrequencyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDefaultMoveRateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDefaultMoveRateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxFrequencyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinFrequencyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOffTransitionTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOffTransitionTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnOffTransitionTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnOffTransitionTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnTransitionTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnTransitionTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOptionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOptionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRemainingTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRemainingTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartUpCurrentLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartUpCurrentLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepWithOnOffWithParamsCompletion(params: MTRLevelControlClusterStepWithOnOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepWithOnOffWithParamsCompletionHandler(params: MTRLevelControlClusterStepWithOnOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepWithParamsCompletion(params: MTRLevelControlClusterStepParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepWithParamsCompletionHandler(params: MTRLevelControlClusterStepParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithOnOffWithParamsCompletion(params: MTRLevelControlClusterStopWithOnOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopWithOnOffWithParamsCompletionHandler(params: MTRLevelControlClusterStopWithOnOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithParamsCompletion(params: MTRLevelControlClusterStopParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopWithParamsCompletionHandler(params: MTRLevelControlClusterStopParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentFrequencyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDefaultMoveRateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDefaultMoveRateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxFrequencyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinFrequencyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOffTransitionTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOffTransitionTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnOffTransitionTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnOffTransitionTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnTransitionTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnTransitionTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOptionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOptionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRemainingTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRemainingTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartUpCurrentLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartUpCurrentLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultMoveRateWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultMoveRateWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultMoveRateWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultMoveRateWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOffTransitionTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOffTransitionTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOffTransitionTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOffTransitionTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnLevelWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnLevelWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnOffTransitionTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnOffTransitionTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnOffTransitionTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnOffTransitionTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnTransitionTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnTransitionTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnTransitionTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnTransitionTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOptionsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOptionsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOptionsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOptionsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpCurrentLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpCurrentLevelWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpCurrentLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpCurrentLevelWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterLocalizationConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterLocalizationConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterLocalizationConfiguration; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveLocaleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveLocaleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedLocalesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedLocalesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveLocaleWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveLocaleWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedLocalesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedLocalesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveLocaleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveLocaleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedLocalesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedLocalesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeActiveLocaleWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveLocaleWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeActiveLocaleWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveLocaleWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterLowPower extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterLowPower; // inherited from NSObject

	static new(): MTRBaseClusterLowPower; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	sleepWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sleepWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	sleepWithParamsCompletion(params: MTRLowPowerClusterSleepParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sleepWithParamsCompletionHandler(params: MTRLowPowerClusterSleepParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterMediaInput extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterMediaInput; // inherited from NSObject

	static new(): MTRBaseClusterMediaInput; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentInputWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentInputWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInputListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInputListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	hideInputStatusWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideInputStatusWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	hideInputStatusWithParamsCompletion(params: MTRMediaInputClusterHideInputStatusParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideInputStatusWithParamsCompletionHandler(params: MTRMediaInputClusterHideInputStatusParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentInputWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentInputWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInputListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInputListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	renameInputWithParamsCompletion(params: MTRMediaInputClusterRenameInputParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	renameInputWithParamsCompletionHandler(params: MTRMediaInputClusterRenameInputParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	selectInputWithParamsCompletion(params: MTRMediaInputClusterSelectInputParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	selectInputWithParamsCompletionHandler(params: MTRMediaInputClusterSelectInputParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	showInputStatusWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	showInputStatusWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	showInputStatusWithParamsCompletion(params: MTRMediaInputClusterShowInputStatusParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	showInputStatusWithParamsCompletionHandler(params: MTRMediaInputClusterShowInputStatusParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentInputWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentInputWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInputListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInputListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterMediaPlayback extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterMediaPlayback; // inherited from NSObject

	static new(): MTRBaseClusterMediaPlayback; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDurationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePlaybackSpeedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePlaybackSpeedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSampledPositionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackPosition, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSampledPositionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRMediaPlaybackClusterPlaybackPositionStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSeekRangeEndWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSeekRangeEndWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSeekRangeStartWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSeekRangeStartWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	fastForwardWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fastForwardWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	fastForwardWithParamsCompletion(params: MTRMediaPlaybackClusterFastForwardParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fastForwardWithParamsCompletionHandler(params: MTRMediaPlaybackClusterFastForwardParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	nextWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nextWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	nextWithParamsCompletion(params: MTRMediaPlaybackClusterNextParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nextWithParamsCompletionHandler(params: MTRMediaPlaybackClusterNextParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseWithParamsCompletion(params: MTRMediaPlaybackClusterPauseParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseWithParamsCompletionHandler(params: MTRMediaPlaybackClusterPauseParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	playWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	playWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	playWithParamsCompletion(params: MTRMediaPlaybackClusterPlayParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	playWithParamsCompletionHandler(params: MTRMediaPlaybackClusterPlayParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	previousWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previousWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	previousWithParamsCompletion(params: MTRMediaPlaybackClusterPreviousParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previousWithParamsCompletionHandler(params: MTRMediaPlaybackClusterPreviousParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDurationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePlaybackSpeedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePlaybackSpeedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSampledPositionWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackPositionStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSampledPositionWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackPosition, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSeekRangeEndWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSeekRangeEndWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSeekRangeStartWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSeekRangeStartWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	rewindWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rewindWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	rewindWithParamsCompletion(params: MTRMediaPlaybackClusterRewindParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rewindWithParamsCompletionHandler(params: MTRMediaPlaybackClusterRewindParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	seekWithParamsCompletion(params: MTRMediaPlaybackClusterSeekParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	seekWithParamsCompletionHandler(params: MTRMediaPlaybackClusterSeekParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	skipBackwardWithParamsCompletion(params: MTRMediaPlaybackClusterSkipBackwardParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipBackwardWithParamsCompletionHandler(params: MTRMediaPlaybackClusterSkipBackwardParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	skipForwardWithParamsCompletion(params: MTRMediaPlaybackClusterSkipForwardParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipForwardWithParamsCompletionHandler(params: MTRMediaPlaybackClusterSkipForwardParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startOverWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startOverWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startOverWithParamsCompletion(params: MTRMediaPlaybackClusterStartOverParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startOverWithParamsCompletionHandler(params: MTRMediaPlaybackClusterStartOverParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopPlaybackWithCompletionHandler(completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopPlaybackWithParamsCompletionHandler(params: MTRMediaPlaybackClusterStopPlaybackParams, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithCompletion(completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithParamsCompletion(params: MTRMediaPlaybackClusterStopParams, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDurationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePlaybackSpeedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePlaybackSpeedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSampledPositionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRMediaPlaybackClusterPlaybackPosition, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSampledPositionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRMediaPlaybackClusterPlaybackPositionStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSeekRangeEndWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSeekRangeEndWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSeekRangeStartWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSeekRangeStartWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterModeSelect extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterModeSelect; // inherited from NSObject

	static new(): MTRBaseClusterModeSelect; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDescriptionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDescriptionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStandardNamespaceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStandardNamespaceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartUpModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartUpModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedModesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedModesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	changeToModeWithParamsCompletion(params: MTRModeSelectClusterChangeToModeParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeToModeWithParamsCompletionHandler(params: MTRModeSelectClusterChangeToModeParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDescriptionWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDescriptionWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStandardNamespaceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStandardNamespaceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartUpModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartUpModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedModesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedModesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDescriptionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDescriptionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStandardNamespaceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStandardNamespaceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartUpModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartUpModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedModesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedModesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterNetworkCommissioning extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterNetworkCommissioning; // inherited from NSObject

	static new(): MTRBaseClusterNetworkCommissioning; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeConnectMaxTimeSecondsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeConnectMaxTimeSecondsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInterfaceEnabledWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInterfaceEnabledWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLastConnectErrorValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLastConnectErrorValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLastNetworkIDWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLastNetworkIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLastNetworkingStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLastNetworkingStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxNetworksWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxNetworksWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNetworksWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNetworksWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeScanMaxTimeSecondsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeScanMaxTimeSecondsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	addOrUpdateThreadNetworkWithParamsCompletion(params: MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addOrUpdateThreadNetworkWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addOrUpdateWiFiNetworkWithParamsCompletion(params: MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addOrUpdateWiFiNetworkWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	connectNetworkWithParamsCompletion(params: MTRNetworkCommissioningClusterConnectNetworkParams, completion: (p1: MTRNetworkCommissioningClusterConnectNetworkResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	connectNetworkWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterConnectNetworkParams, completionHandler: (p1: MTRNetworkCommissioningClusterConnectNetworkResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeConnectMaxTimeSecondsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeConnectMaxTimeSecondsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInterfaceEnabledWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInterfaceEnabledWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLastConnectErrorValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLastConnectErrorValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLastNetworkIDWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLastNetworkIDWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLastNetworkingStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLastNetworkingStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxNetworksWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxNetworksWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNetworksWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNetworksWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeScanMaxTimeSecondsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeScanMaxTimeSecondsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeNetworkWithParamsCompletion(params: MTRNetworkCommissioningClusterRemoveNetworkParams, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeNetworkWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterRemoveNetworkParams, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	reorderNetworkWithParamsCompletion(params: MTRNetworkCommissioningClusterReorderNetworkParams, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	reorderNetworkWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterReorderNetworkParams, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	scanNetworksWithCompletion(completion: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	scanNetworksWithParamsCompletion(params: MTRNetworkCommissioningClusterScanNetworksParams, completion: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	scanNetworksWithParamsCompletionHandler(params: MTRNetworkCommissioningClusterScanNetworksParams, completionHandler: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeConnectMaxTimeSecondsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeConnectMaxTimeSecondsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInterfaceEnabledWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInterfaceEnabledWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLastConnectErrorValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLastConnectErrorValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLastNetworkIDWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLastNetworkIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLastNetworkingStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLastNetworkingStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxNetworksWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxNetworksWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNetworksWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNetworksWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeScanMaxTimeSecondsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeScanMaxTimeSecondsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInterfaceEnabledWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInterfaceEnabledWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInterfaceEnabledWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInterfaceEnabledWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterNitrogenDioxideConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterNitrogenDioxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterNitrogenDioxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterOTASoftwareUpdateProvider extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOTASoftwareUpdateProvider; // inherited from NSObject

	static new(): MTRBaseClusterOTASoftwareUpdateProvider; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	applyUpdateRequestWithParamsCompletion(params: MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams, completion: (p1: MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	notifyUpdateAppliedWithParamsCompletion(params: MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	queryImageWithParamsCompletion(params: MTROTASoftwareUpdateProviderClusterQueryImageParams, completion: (p1: MTROTASoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterOTASoftwareUpdateRequestor extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOTASoftwareUpdateRequestor; // inherited from NSObject

	static new(): MTRBaseClusterOTASoftwareUpdateRequestor; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDefaultOTAProvidersWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUpdatePossibleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUpdateStateProgressWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUpdateStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	announceOTAProviderWithParamsCompletion(params: MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDefaultOTAProvidersWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUpdatePossibleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUpdateStateProgressWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUpdateStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDefaultOTAProvidersWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUpdatePossibleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUpdateStateProgressWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUpdateStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultOTAProvidersWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultOTAProvidersWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterOccupancySensing extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOccupancySensing; // inherited from NSObject

	static new(): MTRBaseClusterOccupancySensing; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupancySensorTypeBitmapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupancySensorTypeBitmapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupancySensorTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupancySensorTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupancyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupancyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePIROccupiedToUnoccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePIRUnoccupiedToOccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePIRUnoccupiedToOccupiedThresholdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalContactOccupiedToUnoccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalContactOccupiedToUnoccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalContactUnoccupiedToOccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalContactUnoccupiedToOccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalContactUnoccupiedToOccupiedThresholdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalContactUnoccupiedToOccupiedThresholdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePirOccupiedToUnoccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePirUnoccupiedToOccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePirUnoccupiedToOccupiedThresholdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUltrasonicOccupiedToUnoccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUltrasonicOccupiedToUnoccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUltrasonicUnoccupiedToOccupiedDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUltrasonicUnoccupiedToOccupiedDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUltrasonicUnoccupiedToOccupiedThresholdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUltrasonicUnoccupiedToOccupiedThresholdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupancySensorTypeBitmapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupancySensorTypeBitmapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupancySensorTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupancySensorTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupancyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupancyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePIROccupiedToUnoccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePIRUnoccupiedToOccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePIRUnoccupiedToOccupiedThresholdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalContactOccupiedToUnoccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalContactOccupiedToUnoccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedThresholdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedThresholdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirOccupiedToUnoccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirUnoccupiedToOccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirUnoccupiedToOccupiedThresholdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUltrasonicOccupiedToUnoccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUltrasonicOccupiedToUnoccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedThresholdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedThresholdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupancySensorTypeBitmapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupancySensorTypeBitmapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupancySensorTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupancySensorTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupancyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupancyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePIROccupiedToUnoccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePIRUnoccupiedToOccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePIRUnoccupiedToOccupiedThresholdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalContactOccupiedToUnoccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalContactOccupiedToUnoccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalContactUnoccupiedToOccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalContactUnoccupiedToOccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePirOccupiedToUnoccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePirUnoccupiedToOccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePirUnoccupiedToOccupiedThresholdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUltrasonicOccupiedToUnoccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUltrasonicOccupiedToUnoccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUltrasonicUnoccupiedToOccupiedDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUltrasonicUnoccupiedToOccupiedDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIROccupiedToUnoccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIROccupiedToUnoccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedThresholdWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedThresholdWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirOccupiedToUnoccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirOccupiedToUnoccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedThresholdWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedThresholdWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterOnOff extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOnOff; // inherited from NSObject

	static new(): MTRBaseClusterOnOff; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGlobalSceneControlWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGlobalSceneControlWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOffWaitTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOffWaitTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnOffWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnOffWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOnTimeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOnTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartUpOnOffWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartUpOnOffWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	offWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	offWithEffectWithParamsCompletion(params: MTROnOffClusterOffWithEffectParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithEffectWithParamsCompletionHandler(params: MTROnOffClusterOffWithEffectParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	offWithParamsCompletion(params: MTROnOffClusterOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithParamsCompletionHandler(params: MTROnOffClusterOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithParamsCompletion(params: MTROnOffClusterOnParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithParamsCompletionHandler(params: MTROnOffClusterOnParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithRecallGlobalSceneWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithRecallGlobalSceneWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithRecallGlobalSceneWithParamsCompletion(params: MTROnOffClusterOnWithRecallGlobalSceneParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithRecallGlobalSceneWithParamsCompletionHandler(params: MTROnOffClusterOnWithRecallGlobalSceneParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithTimedOffWithParamsCompletion(params: MTROnOffClusterOnWithTimedOffParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithTimedOffWithParamsCompletionHandler(params: MTROnOffClusterOnWithTimedOffParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGlobalSceneControlWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGlobalSceneControlWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOffWaitTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOffWaitTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnOffWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnOffWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOnTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOnTimeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartUpOnOffWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartUpOnOffWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGlobalSceneControlWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGlobalSceneControlWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOffWaitTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOffWaitTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnOffWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnOffWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOnTimeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOnTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartUpOnOffWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartUpOnOffWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	toggleWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	toggleWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	toggleWithParamsCompletion(params: MTROnOffClusterToggleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	toggleWithParamsCompletionHandler(params: MTROnOffClusterToggleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOffWaitTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOffWaitTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOffWaitTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOffWaitTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnTimeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnTimeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOnTimeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOnTimeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpOnOffWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpOnOffWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStartUpOnOffWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStartUpOnOffWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRBaseClusterOnOffSwitchConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOnOffSwitchConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterOnOffSwitchConfiguration; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSwitchActionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeSwitchActionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSwitchTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	static readAttributeSwitchTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeSwitchActionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSwitchActionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	readAttributeSwitchTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSwitchTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSwitchActionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeSwitchActionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSwitchTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	subscribeAttributeSwitchTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeSwitchActionsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSwitchActionsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	writeAttributeSwitchActionsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSwitchActionsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterOperationalCredentials extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOperationalCredentials; // inherited from NSObject

	static new(): MTRBaseClusterOperationalCredentials; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCommissionedFabricsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCommissionedFabricsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentFabricIndexWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentFabricIndexWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFabricsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFabricsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNOCsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNOCsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedFabricsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedFabricsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTrustedRootCertificatesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTrustedRootCertificatesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	CSRRequestWithParamsCompletion(params: MTROperationalCredentialsClusterCSRRequestParams, completion: (p1: MTROperationalCredentialsClusterCSRResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	CSRRequestWithParamsCompletionHandler(params: MTROperationalCredentialsClusterCSRRequestParams, completionHandler: (p1: MTROperationalCredentialsClusterCSRResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addNOCWithParamsCompletion(params: MTROperationalCredentialsClusterAddNOCParams, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addNOCWithParamsCompletionHandler(params: MTROperationalCredentialsClusterAddNOCParams, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addTrustedRootCertificateWithParamsCompletion(params: MTROperationalCredentialsClusterAddTrustedRootCertificateParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addTrustedRootCertificateWithParamsCompletionHandler(params: MTROperationalCredentialsClusterAddTrustedRootCertificateParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	attestationRequestWithParamsCompletion(params: MTROperationalCredentialsClusterAttestationRequestParams, completion: (p1: MTROperationalCredentialsClusterAttestationResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	attestationRequestWithParamsCompletionHandler(params: MTROperationalCredentialsClusterAttestationRequestParams, completionHandler: (p1: MTROperationalCredentialsClusterAttestationResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	certificateChainRequestWithParamsCompletion(params: MTROperationalCredentialsClusterCertificateChainRequestParams, completion: (p1: MTROperationalCredentialsClusterCertificateChainResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	certificateChainRequestWithParamsCompletionHandler(params: MTROperationalCredentialsClusterCertificateChainRequestParams, completionHandler: (p1: MTROperationalCredentialsClusterCertificateChainResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCommissionedFabricsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCommissionedFabricsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentFabricIndexWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentFabricIndexWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFabricsWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFabricsWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNOCsWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNOCsWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedFabricsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedFabricsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTrustedRootCertificatesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTrustedRootCertificatesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeFabricWithParamsCompletion(params: MTROperationalCredentialsClusterRemoveFabricParams, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeFabricWithParamsCompletionHandler(params: MTROperationalCredentialsClusterRemoveFabricParams, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCommissionedFabricsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCommissionedFabricsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentFabricIndexWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentFabricIndexWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFabricsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFabricsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNOCsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNOCsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedFabricsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedFabricsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTrustedRootCertificatesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTrustedRootCertificatesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	updateFabricLabelWithParamsCompletion(params: MTROperationalCredentialsClusterUpdateFabricLabelParams, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	updateFabricLabelWithParamsCompletionHandler(params: MTROperationalCredentialsClusterUpdateFabricLabelParams, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	updateNOCWithParamsCompletion(params: MTROperationalCredentialsClusterUpdateNOCParams, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	updateNOCWithParamsCompletionHandler(params: MTROperationalCredentialsClusterUpdateNOCParams, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRBaseClusterOperationalState extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOperationalState; // inherited from NSObject

	static new(): MTRBaseClusterOperationalState; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCountdownTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCurrentPhaseWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalErrorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTROperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalStateListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributePhaseListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	pauseWithCompletion(completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	pauseWithParamsCompletion(params: MTROperationalStateClusterPauseParams, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCountdownTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentPhaseWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalErrorWithCompletion(completion: (p1: MTROperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributePhaseListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithCompletion(completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithParamsCompletion(params: MTROperationalStateClusterResumeParams, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	startWithCompletion(completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	startWithParamsCompletion(params: MTROperationalStateClusterStartParams, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	stopWithCompletion(completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	stopWithParamsCompletion(params: MTROperationalStateClusterStopParams, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCountdownTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCurrentPhaseWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalErrorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTROperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalStateListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributePhaseListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBaseClusterOtaSoftwareUpdateProvider extends MTRBaseClusterOTASoftwareUpdateProvider {

	static alloc(): MTRBaseClusterOtaSoftwareUpdateProvider; // inherited from NSObject

	static new(): MTRBaseClusterOtaSoftwareUpdateProvider; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	applyUpdateRequestWithParamsCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	notifyUpdateAppliedWithParamsCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	queryImageWithParamsCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterQueryImageParams, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBaseClusterOtaSoftwareUpdateRequestor extends MTRBaseClusterOTASoftwareUpdateRequestor {

	static alloc(): MTRBaseClusterOtaSoftwareUpdateRequestor; // inherited from NSObject

	static new(): MTRBaseClusterOtaSoftwareUpdateRequestor; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDefaultOtaProvidersWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUpdatePossibleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUpdateStateProgressWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUpdateStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	announceOtaProviderWithParamsCompletionHandler(params: MTROtaSoftwareUpdateRequestorClusterAnnounceOtaProviderParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDefaultOtaProvidersWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUpdatePossibleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUpdateStateProgressWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUpdateStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDefaultOtaProvidersWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUpdatePossibleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUpdateStateProgressWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUpdateStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultOtaProvidersWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultOtaProvidersWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterOzoneConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterOzoneConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterOzoneConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterPM10ConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPM10ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterPM10ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterPM1ConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPM1ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterPM1ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterPM25ConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPM25ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterPM25ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterPowerSource extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPowerSource; // inherited from NSObject

	static new(): MTRBaseClusterPowerSource; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveBatChargeFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveBatChargeFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveBatFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveBatFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveWiredFaultsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveWiredFaultsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatANSIDesignationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatANSIDesignationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatApprovedChemistryWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatApprovedChemistryWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatCapacityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatCapacityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatChargeLevelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatChargeLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatChargeStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatChargeStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatChargingCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatChargingCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatCommonDesignationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatCommonDesignationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatFunctionalWhileChargingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatFunctionalWhileChargingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatIECDesignationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatIECDesignationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatPercentRemainingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatPercentRemainingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatPresentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatPresentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatQuantityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatQuantityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatReplaceabilityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatReplaceabilityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatReplacementDescriptionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatReplacementDescriptionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatReplacementNeededWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatReplacementNeededWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatTimeRemainingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatTimeRemainingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatTimeToFullChargeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatTimeToFullChargeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBatVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBatVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDescriptionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDescriptionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeEndpointListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOrderWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOrderWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredAssessedCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredAssessedCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredAssessedInputFrequencyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredAssessedInputFrequencyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredAssessedInputVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredAssessedInputVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredCurrentTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredCurrentTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredMaximumCurrentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredMaximumCurrentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredNominalVoltageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredNominalVoltageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiredPresentWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiredPresentWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveBatChargeFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveBatChargeFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveBatFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveBatFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveWiredFaultsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveWiredFaultsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatANSIDesignationWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatANSIDesignationWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatApprovedChemistryWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatApprovedChemistryWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatCapacityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatCapacityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatChargeLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatChargeLevelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatChargeStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatChargeStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatChargingCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatChargingCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatCommonDesignationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatCommonDesignationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatFunctionalWhileChargingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatFunctionalWhileChargingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatIECDesignationWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatIECDesignationWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatPercentRemainingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatPercentRemainingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatPresentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatPresentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatQuantityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatQuantityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatReplaceabilityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatReplaceabilityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatReplacementDescriptionWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatReplacementDescriptionWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatReplacementNeededWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatReplacementNeededWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatTimeRemainingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatTimeRemainingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatTimeToFullChargeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatTimeToFullChargeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBatVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBatVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDescriptionWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDescriptionWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeEndpointListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOrderWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOrderWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredAssessedCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredAssessedCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredAssessedInputFrequencyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredAssessedInputFrequencyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredAssessedInputVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredAssessedInputVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredCurrentTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredCurrentTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredMaximumCurrentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredMaximumCurrentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredNominalVoltageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredNominalVoltageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiredPresentWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiredPresentWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveBatChargeFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveBatChargeFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveBatFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveBatFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveWiredFaultsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveWiredFaultsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatANSIDesignationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatANSIDesignationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatApprovedChemistryWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatApprovedChemistryWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatCapacityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatCapacityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatChargeLevelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatChargeLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatChargeStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatChargeStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatChargingCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatChargingCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatCommonDesignationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatCommonDesignationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatFunctionalWhileChargingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatFunctionalWhileChargingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatIECDesignationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatIECDesignationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatPercentRemainingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatPercentRemainingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatPresentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatPresentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatQuantityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatQuantityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatReplaceabilityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatReplaceabilityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatReplacementDescriptionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatReplacementDescriptionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatReplacementNeededWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatReplacementNeededWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatTimeRemainingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatTimeRemainingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatTimeToFullChargeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatTimeToFullChargeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBatVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBatVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDescriptionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDescriptionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeEndpointListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOrderWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOrderWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredAssessedCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredAssessedCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredAssessedInputFrequencyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredAssessedInputFrequencyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredAssessedInputVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredAssessedInputVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredCurrentTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredCurrentTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredMaximumCurrentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredMaximumCurrentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredNominalVoltageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredNominalVoltageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiredPresentWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiredPresentWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterPowerSourceConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPowerSourceConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterPowerSourceConfiguration; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSourcesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSourcesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSourcesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSourcesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSourcesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSourcesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterPressureMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPressureMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterPressureMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxScaledValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxScaledValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinScaledValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinScaledValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeScaleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeScaleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeScaledToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeScaledToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeScaledValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeScaledValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxScaledValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxScaledValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinScaledValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinScaledValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeScaleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeScaleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeScaledToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeScaledToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeScaledValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeScaledValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxScaledValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxScaledValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinScaledValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinScaledValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeScaleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeScaleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeScaledToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeScaledToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeScaledValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeScaledValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterPumpConfigurationAndControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterPumpConfigurationAndControl; // inherited from NSObject

	static new(): MTRBaseClusterPumpConfigurationAndControl; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCapacityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCapacityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeControlModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeControlModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEffectiveControlModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEffectiveControlModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEffectiveOperationModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEffectiveOperationModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLifetimeEnergyConsumedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLifetimeEnergyConsumedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLifetimeRunningHoursWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLifetimeRunningHoursWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxCompPressureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxCompPressureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxConstFlowWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxConstFlowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxConstPressureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxConstPressureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxConstSpeedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxConstSpeedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxConstTempWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxConstTempWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxFlowWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxFlowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxPressureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxPressureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxSpeedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxSpeedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinCompPressureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinCompPressureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinConstFlowWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinConstFlowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinConstPressureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinConstPressureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinConstSpeedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinConstSpeedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinConstTempWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinConstTempWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOperationModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOperationModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePowerWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePowerWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePumpStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePumpStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSpeedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSpeedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCapacityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCapacityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeControlModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeControlModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEffectiveControlModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEffectiveControlModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEffectiveOperationModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEffectiveOperationModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLifetimeEnergyConsumedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLifetimeEnergyConsumedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLifetimeRunningHoursWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLifetimeRunningHoursWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxCompPressureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxCompPressureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxConstFlowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxConstFlowWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxConstPressureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxConstPressureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxConstSpeedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxConstSpeedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxConstTempWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxConstTempWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxFlowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxFlowWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxPressureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxPressureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxSpeedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxSpeedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinCompPressureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinCompPressureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinConstFlowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinConstFlowWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinConstPressureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinConstPressureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinConstSpeedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinConstSpeedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinConstTempWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinConstTempWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOperationModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOperationModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePowerWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePowerWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePumpStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePumpStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSpeedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSpeedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCapacityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCapacityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeControlModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeControlModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEffectiveControlModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEffectiveControlModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEffectiveOperationModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEffectiveOperationModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLifetimeEnergyConsumedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLifetimeEnergyConsumedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLifetimeRunningHoursWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLifetimeRunningHoursWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxCompPressureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxCompPressureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxConstFlowWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxConstFlowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxConstPressureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxConstPressureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxConstSpeedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxConstSpeedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxConstTempWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxConstTempWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxFlowWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxFlowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxPressureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxPressureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxSpeedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxSpeedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinCompPressureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinCompPressureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinConstFlowWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinConstFlowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinConstPressureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinConstPressureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinConstSpeedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinConstSpeedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinConstTempWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinConstTempWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOperationModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOperationModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePowerWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePowerWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePumpStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePumpStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSpeedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSpeedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeControlModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeControlModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeControlModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeControlModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLifetimeEnergyConsumedWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLifetimeEnergyConsumedWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLifetimeEnergyConsumedWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLifetimeEnergyConsumedWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLifetimeRunningHoursWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLifetimeRunningHoursWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLifetimeRunningHoursWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLifetimeRunningHoursWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOperationModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOperationModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOperationModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOperationModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRBaseClusterRVCCleanMode extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterRVCCleanMode; // inherited from NSObject

	static new(): MTRBaseClusterRVCCleanMode; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCurrentModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeSupportedModesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	changeToModeWithParamsCompletion(params: MTRRVCCleanModeClusterChangeToModeParams, completion: (p1: MTRRVCCleanModeClusterChangeToModeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeSupportedModesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCurrentModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeSupportedModesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRBaseClusterRVCOperationalState extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterRVCOperationalState; // inherited from NSObject

	static new(): MTRBaseClusterRVCOperationalState; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCountdownTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCurrentPhaseWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalErrorWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRRVCOperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalStateListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeOperationalStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributePhaseListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	pauseWithCompletion(completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	pauseWithParamsCompletion(params: MTRRVCOperationalStateClusterPauseParams, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCountdownTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentPhaseWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalErrorWithCompletion(completion: (p1: MTRRVCOperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributePhaseListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithCompletion(completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithParamsCompletion(params: MTRRVCOperationalStateClusterResumeParams, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCountdownTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCurrentPhaseWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalErrorWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRRVCOperationalStateClusterErrorStateStruct, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalStateListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeOperationalStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributePhaseListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRBaseClusterRVCRunMode extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterRVCRunMode; // inherited from NSObject

	static new(): MTRBaseClusterRVCRunMode; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeCurrentModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	static readAttributeSupportedModesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	changeToModeWithParamsCompletion(params: MTRRVCRunModeClusterChangeToModeParams, completion: (p1: MTRRVCRunModeClusterChangeToModeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeSupportedModesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeCurrentModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	subscribeAttributeSupportedModesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterRadonConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterRadonConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterRadonConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterRelativeHumidityMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterRelativeHumidityMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterRelativeHumidityMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterSmokeCOAlarm extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterSmokeCOAlarm; // inherited from NSObject

	static new(): MTRBaseClusterSmokeCOAlarm; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeBatteryAlertWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCOStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeContaminationStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDeviceMutedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeEndOfServiceAlertWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeExpiryDateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeExpressedStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeHardwareFaultAlertWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeInterconnectCOAlarmWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeInterconnectSmokeAlarmWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeSmokeSensitivityLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeSmokeStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeTestInProgressWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeBatteryAlertWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCOStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeContaminationStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDeviceMutedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeEndOfServiceAlertWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeExpiryDateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeExpressedStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeHardwareFaultAlertWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeInterconnectCOAlarmWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeInterconnectSmokeAlarmWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeSmokeSensitivityLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeSmokeStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeTestInProgressWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	selfTestRequestWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	selfTestRequestWithParamsCompletion(params: MTRSmokeCOAlarmClusterSelfTestRequestParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeBatteryAlertWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCOStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeContaminationStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDeviceMutedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeEndOfServiceAlertWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeExpiryDateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeExpressedStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeHardwareFaultAlertWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeInterconnectCOAlarmWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeInterconnectSmokeAlarmWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeSmokeSensitivityLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeSmokeStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeTestInProgressWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeSmokeSensitivityLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeSmokeSensitivityLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterSoftwareDiagnostics extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterSoftwareDiagnostics; // inherited from NSObject

	static new(): MTRBaseClusterSoftwareDiagnostics; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentHeapFreeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentHeapFreeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentHeapHighWatermarkWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentHeapHighWatermarkWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentHeapUsedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentHeapUsedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeThreadMetricsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeThreadMetricsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentHeapFreeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentHeapFreeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentHeapHighWatermarkWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentHeapHighWatermarkWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentHeapUsedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentHeapUsedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeThreadMetricsWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeThreadMetricsWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetWatermarksWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetWatermarksWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetWatermarksWithParamsCompletion(params: MTRSoftwareDiagnosticsClusterResetWatermarksParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetWatermarksWithParamsCompletionHandler(params: MTRSoftwareDiagnosticsClusterResetWatermarksParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentHeapFreeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentHeapFreeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentHeapHighWatermarkWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentHeapHighWatermarkWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentHeapUsedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentHeapUsedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeThreadMetricsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeThreadMetricsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterSwitch extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterSwitch; // inherited from NSObject

	static new(): MTRBaseClusterSwitch; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMultiPressMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMultiPressMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfPositionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfPositionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMultiPressMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMultiPressMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfPositionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfPositionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMultiPressMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMultiPressMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfPositionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfPositionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterTargetNavigator extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterTargetNavigator; // inherited from NSObject

	static new(): MTRBaseClusterTargetNavigator; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentTargetWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentTargetWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTargetListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTargetListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	navigateTargetWithParamsCompletion(params: MTRTargetNavigatorClusterNavigateTargetParams, completion: (p1: MTRTargetNavigatorClusterNavigateTargetResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	navigateTargetWithParamsCompletionHandler(params: MTRTargetNavigatorClusterNavigateTargetParams, completionHandler: (p1: MTRTargetNavigatorClusterNavigateTargetResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentTargetWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentTargetWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTargetListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTargetListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentTargetWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentTargetWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTargetListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTargetListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterTemperatureMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterTemperatureMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterTemperatureMeasurement; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinMeasuredValueWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeToleranceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeToleranceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinMeasuredValueWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeToleranceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeToleranceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinMeasuredValueWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeToleranceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeToleranceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBaseClusterTestCluster extends MTRBaseClusterUnitTesting {

	static alloc(): MTRBaseClusterTestCluster; // inherited from NSObject

	static new(): MTRBaseClusterTestCluster; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBitmap16WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBitmap32WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBitmap64WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBitmap8WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBooleanWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCharStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterErrorBooleanWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnum16WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnum8WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEnumAttrWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEpochSWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEpochUsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFloatDoubleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFloatSingleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneralErrorBooleanWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt16sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt16uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt24sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt24uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt32sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt32uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt40sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt40uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt48sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt48uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt56sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt56uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt64sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt64uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt8sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListFabricScopedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListLongOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListNullablesAndOptionalsStructWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeListStructOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLongCharStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLongOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableBitmap16WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableBitmap32WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableBitmap64WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableBitmap8WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableBooleanWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableCharStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableEnum16WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableEnum8WithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableEnumAttrWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableFloatDoubleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableFloatSingleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt16sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt16uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt24sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt24uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt32sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt32uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt40sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt40uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt48sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt48uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt56sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt56uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt64sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt64uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt8sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableRangeRestrictedInt16sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableRangeRestrictedInt16uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableRangeRestrictedInt8sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableRangeRestrictedInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNullableStructWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOctetStringWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRangeRestrictedInt16sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRangeRestrictedInt16uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRangeRestrictedInt8sWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRangeRestrictedInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStructAttrWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTimedWriteBooleanWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnsupportedWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeVendorIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	static readAttributeWriteOnlyInt8uWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBitmap16WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBitmap32WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBitmap64WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBitmap8WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBooleanWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCharStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterErrorBooleanWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnum16WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnum8WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEnumAttrWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEpochSWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEpochUsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFloatDoubleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFloatSingleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneralErrorBooleanWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt16sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt16uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt24sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt24uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt32sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt32uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt40sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt40uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt48sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt48uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt56sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt56uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt64sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt64uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt8sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInt8uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListFabricScopedWithParamsCompletionHandler(params: MTRReadParams, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListInt8uWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListLongOctetStringWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListNullablesAndOptionalsStructWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListOctetStringWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeListStructOctetStringWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLongCharStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLongOctetStringWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableBitmap16WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableBitmap32WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableBitmap64WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableBitmap8WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableBooleanWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableCharStringWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableEnum16WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableEnum8WithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableEnumAttrWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableFloatDoubleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableFloatSingleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt16sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt16uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt24sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt24uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt32sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt32uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt40sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt40uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt48sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt48uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt56sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt56uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt64sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt64uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt8sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableInt8uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableOctetStringWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableRangeRestrictedInt16sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableRangeRestrictedInt16uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableRangeRestrictedInt8sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableRangeRestrictedInt8uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNullableStructWithCompletionHandler(completionHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOctetStringWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRangeRestrictedInt16sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRangeRestrictedInt16uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRangeRestrictedInt8sWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRangeRestrictedInt8uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStructAttrWithCompletionHandler(completionHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTimedWriteBooleanWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnsupportedWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeVendorIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	readAttributeWriteOnlyInt8uWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	simpleStructEchoRequestWithParamsCompletionHandler(params: MTRTestClusterClusterSimpleStructEchoRequestParams, completionHandler: (p1: MTRTestClusterClusterSimpleStructResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBitmap16WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBitmap32WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBitmap64WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBitmap8WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBooleanWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCharStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterErrorBooleanWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnum16WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnum8WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEnumAttrWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEpochSWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEpochUsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFloatDoubleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFloatSingleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneralErrorBooleanWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt16sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt16uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt24sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt24uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt32sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt32uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt40sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt40uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt48sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt48uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt56sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt56uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt64sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt64uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt8sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListFabricScopedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListLongOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListNullablesAndOptionalsStructWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeListStructOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLongCharStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLongOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableBitmap16WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableBitmap32WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableBitmap64WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableBitmap8WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableBooleanWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableCharStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableEnum16WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableEnum8WithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableEnumAttrWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableFloatDoubleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableFloatSingleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt16sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt16uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt24sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt24uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt32sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt32uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt40sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt40uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt48sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt48uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt56sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt56uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt64sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt64uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt8sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt16sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt16uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt8sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNullableStructWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOctetStringWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRangeRestrictedInt16sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRangeRestrictedInt16uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRangeRestrictedInt8sWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRangeRestrictedInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStructAttrWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRTestClusterClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTimedWriteBooleanWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnsupportedWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeVendorIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	subscribeAttributeWriteOnlyInt8uWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testAddArgumentsWithParamsCompletionHandler(params: MTRTestClusterClusterTestAddArgumentsParams, completionHandler: (p1: MTRTestClusterClusterTestAddArgumentsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testComplexNullableOptionalRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestComplexNullableOptionalRequestParams, completionHandler: (p1: MTRTestClusterClusterTestComplexNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEmitTestEventRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestEmitTestEventRequestParams, completionHandler: (p1: MTRTestClusterClusterTestEmitTestEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEmitTestFabricScopedEventRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestEmitTestFabricScopedEventRequestParams, completionHandler: (p1: MTRTestClusterClusterTestEmitTestFabricScopedEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEnumsRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestEnumsRequestParams, completionHandler: (p1: MTRTestClusterClusterTestEnumsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListInt8UArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestListInt8UArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListInt8UReverseRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestListInt8UReverseRequestParams, completionHandler: (p1: MTRTestClusterClusterTestListInt8UReverseResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListNestedStructListArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestListNestedStructListArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListStructArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestListStructArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNestedStructArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestNestedStructArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNestedStructListArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestNestedStructListArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNotHandledWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNotHandledWithParamsCompletionHandler(params: MTRTestClusterClusterTestNotHandledParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNullableOptionalRequestWithCompletionHandler(completionHandler: (p1: MTRTestClusterClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNullableOptionalRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestNullableOptionalRequestParams, completionHandler: (p1: MTRTestClusterClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestSimpleArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterTestSimpleArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleOptionalArgumentRequestWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleOptionalArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestSimpleOptionalArgumentRequestParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSpecificWithCompletionHandler(completionHandler: (p1: MTRTestClusterClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSpecificWithParamsCompletionHandler(params: MTRTestClusterClusterTestSpecificParams, completionHandler: (p1: MTRTestClusterClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testStructArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestStructArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testStructArrayArgumentRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTestStructArrayArgumentRequestParams, completionHandler: (p1: MTRTestClusterClusterTestStructArrayArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testUnknownCommandWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testUnknownCommandWithParamsCompletionHandler(params: MTRTestClusterClusterTestUnknownCommandParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testWithParamsCompletionHandler(params: MTRTestClusterClusterTestParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeRequestWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeRequestWithParamsCompletionHandler(params: MTRTestClusterClusterTimedInvokeRequestParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap16WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap16WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap32WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap32WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap64WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap64WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap8WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBitmap8WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBooleanWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeBooleanWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeCharStringWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeCharStringWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnum16WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnum16WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnum8WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnum8WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnumAttrWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEnumAttrWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEpochSWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEpochSWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEpochUsWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEpochUsWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFloatDoubleWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFloatDoubleWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFloatSingleWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeFloatSingleWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt16sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt16sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt16uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt16uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt24sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt24sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt24uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt24uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt32sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt32sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt32uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt32uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt40sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt40sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt40uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt40uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt48sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt48sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt48uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt48uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt56sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt56sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt56uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt56uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt64sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt64sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt64uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt64uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt8sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt8sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt8uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeInt8uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListFabricScopedWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListFabricScopedWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListInt8uWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListInt8uWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListLongOctetStringWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListLongOctetStringWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListOctetStringWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListOctetStringWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListStructOctetStringWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeListStructOctetStringWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLongCharStringWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLongCharStringWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLongOctetStringWithValueCompletionHandler(value: NSData, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLongOctetStringWithValueParamsCompletionHandler(value: NSData, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap16WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap16WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap32WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap32WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap64WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap64WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap8WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBitmap8WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBooleanWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableBooleanWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableCharStringWithValueCompletionHandler(value: string, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableCharStringWithValueParamsCompletionHandler(value: string, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnum16WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnum16WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnum8WithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnum8WithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnumAttrWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableEnumAttrWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableFloatSingleWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableFloatSingleWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt16sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt16sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt16uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt16uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt24sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt24sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt24uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt24uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt32sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt32sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt32uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt32uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt40sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt40sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt40uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt40uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt48sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt48sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt48uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt48uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt56sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt56sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt56uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt56uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt64sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt64sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt64uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt64uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt8sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt8sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt8uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableInt8uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableOctetStringWithValueCompletionHandler(value: NSData, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableOctetStringWithValueParamsCompletionHandler(value: NSData, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableStructWithValueCompletionHandler(value: MTRTestClusterClusterSimpleStruct, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeNullableStructWithValueParamsCompletionHandler(value: MTRTestClusterClusterSimpleStruct, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOctetStringWithValueCompletionHandler(value: NSData, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOctetStringWithValueParamsCompletionHandler(value: NSData, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStructAttrWithValueCompletionHandler(value: MTRTestClusterClusterSimpleStruct, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeStructAttrWithValueParamsCompletionHandler(value: MTRTestClusterClusterSimpleStruct, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnsupportedWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnsupportedWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeVendorIdWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeVendorIdWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterThermostat extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterThermostat; // inherited from NSObject

	static new(): MTRBaseClusterThermostat; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACCapacityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACCapacityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACCapacityformatWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACCapacityformatWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACCoilTemperatureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACCoilTemperatureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACCompressorTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACCompressorTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACErrorCodeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACErrorCodeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACLouverPositionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACLouverPositionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACRefrigerantTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACRefrigerantTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeACTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeACTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAbsMaxCoolSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAbsMaxCoolSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAbsMaxHeatSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAbsMaxHeatSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAbsMinCoolSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAbsMinCoolSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAbsMinHeatSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAbsMinHeatSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeControlSequenceOfOperationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeControlSequenceOfOperationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEmergencyHeatDeltaWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEmergencyHeatDeltaWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHVACSystemTypeConfigurationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHVACSystemTypeConfigurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocalTemperatureCalibrationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocalTemperatureCalibrationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLocalTemperatureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLocalTemperatureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxCoolSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxCoolSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMaxHeatSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMaxHeatSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinCoolSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinCoolSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinHeatSetpointLimitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinHeatSetpointLimitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMinSetpointDeadBandWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMinSetpointDeadBandWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfDailyTransitionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfDailyTransitionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfWeeklyTransitionsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfWeeklyTransitionsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupancyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupancyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupiedCoolingSetpointWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupiedCoolingSetpointWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupiedHeatingSetpointWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupiedHeatingSetpointWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupiedSetbackMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupiedSetbackMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupiedSetbackMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupiedSetbackMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOccupiedSetbackWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOccupiedSetbackWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOutdoorTemperatureWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOutdoorTemperatureWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePICoolingDemandWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePICoolingDemandWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePIHeatingDemandWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePIHeatingDemandWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRemoteSensingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRemoteSensingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSetpointChangeAmountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSetpointChangeAmountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSetpointChangeSourceTimestampWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSetpointChangeSourceTimestampWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSetpointChangeSourceWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSetpointChangeSourceWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStartOfWeekWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStartOfWeekWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSystemModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSystemModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTemperatureSetpointHoldDurationWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTemperatureSetpointHoldDurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTemperatureSetpointHoldWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTemperatureSetpointHoldWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeThermostatProgrammingOperationModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeThermostatProgrammingOperationModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeThermostatRunningModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeThermostatRunningModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeThermostatRunningStateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeThermostatRunningStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnoccupiedCoolingSetpointWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnoccupiedCoolingSetpointWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnoccupiedHeatingSetpointWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnoccupiedHeatingSetpointWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnoccupiedSetbackMaxWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnoccupiedSetbackMaxWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnoccupiedSetbackMinWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnoccupiedSetbackMinWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeUnoccupiedSetbackWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnoccupiedSetbackWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	clearWeeklyScheduleWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeeklyScheduleWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearWeeklyScheduleWithParamsCompletion(params: MTRThermostatClusterClearWeeklyScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeeklyScheduleWithParamsCompletionHandler(params: MTRThermostatClusterClearWeeklyScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getWeeklyScheduleWithParamsCompletion(params: MTRThermostatClusterGetWeeklyScheduleParams, completion: (p1: MTRThermostatClusterGetWeeklyScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getWeeklyScheduleWithParamsCompletionHandler(params: MTRThermostatClusterGetWeeklyScheduleParams, completionHandler: (p1: MTRThermostatClusterGetWeeklyScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeACCapacityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACCapacityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACCapacityformatWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACCapacityformatWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACCoilTemperatureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACCoilTemperatureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACCompressorTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACCompressorTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACErrorCodeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACErrorCodeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACLouverPositionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACLouverPositionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACRefrigerantTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACRefrigerantTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeACTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeACTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAbsMaxCoolSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAbsMaxCoolSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAbsMaxHeatSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAbsMaxHeatSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAbsMinCoolSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAbsMinCoolSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAbsMinHeatSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAbsMinHeatSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeControlSequenceOfOperationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeControlSequenceOfOperationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEmergencyHeatDeltaWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEmergencyHeatDeltaWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHVACSystemTypeConfigurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHVACSystemTypeConfigurationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocalTemperatureCalibrationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocalTemperatureCalibrationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLocalTemperatureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLocalTemperatureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxCoolSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxCoolSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMaxHeatSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMaxHeatSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinCoolSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinCoolSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinHeatSetpointLimitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinHeatSetpointLimitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMinSetpointDeadBandWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMinSetpointDeadBandWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfDailyTransitionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfDailyTransitionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfWeeklyTransitionsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfWeeklyTransitionsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupancyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupancyWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupiedCoolingSetpointWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupiedCoolingSetpointWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupiedHeatingSetpointWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupiedHeatingSetpointWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupiedSetbackMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupiedSetbackMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupiedSetbackMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupiedSetbackMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOccupiedSetbackWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOccupiedSetbackWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOutdoorTemperatureWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOutdoorTemperatureWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePICoolingDemandWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePICoolingDemandWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePIHeatingDemandWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePIHeatingDemandWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRemoteSensingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRemoteSensingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSetpointChangeAmountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSetpointChangeAmountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSetpointChangeSourceTimestampWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSetpointChangeSourceTimestampWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSetpointChangeSourceWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSetpointChangeSourceWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStartOfWeekWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStartOfWeekWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSystemModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSystemModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTemperatureSetpointHoldDurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTemperatureSetpointHoldDurationWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTemperatureSetpointHoldWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTemperatureSetpointHoldWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeThermostatProgrammingOperationModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeThermostatProgrammingOperationModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeThermostatRunningModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeThermostatRunningModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeThermostatRunningStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeThermostatRunningStateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnoccupiedCoolingSetpointWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnoccupiedCoolingSetpointWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnoccupiedHeatingSetpointWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnoccupiedHeatingSetpointWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnoccupiedSetbackMaxWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnoccupiedSetbackMaxWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnoccupiedSetbackMinWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnoccupiedSetbackMinWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnoccupiedSetbackWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeUnoccupiedSetbackWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setWeeklyScheduleWithParamsCompletion(params: MTRThermostatClusterSetWeeklyScheduleParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setWeeklyScheduleWithParamsCompletionHandler(params: MTRThermostatClusterSetWeeklyScheduleParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setpointRaiseLowerWithParamsCompletion(params: MTRThermostatClusterSetpointRaiseLowerParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setpointRaiseLowerWithParamsCompletionHandler(params: MTRThermostatClusterSetpointRaiseLowerParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACCapacityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACCapacityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACCapacityformatWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACCapacityformatWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACCoilTemperatureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACCoilTemperatureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACCompressorTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACCompressorTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACErrorCodeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACErrorCodeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACLouverPositionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACLouverPositionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACRefrigerantTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACRefrigerantTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeACTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeACTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAbsMaxCoolSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAbsMaxCoolSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAbsMaxHeatSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAbsMaxHeatSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAbsMinCoolSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAbsMinCoolSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAbsMinHeatSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAbsMinHeatSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeControlSequenceOfOperationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeControlSequenceOfOperationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEmergencyHeatDeltaWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEmergencyHeatDeltaWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHVACSystemTypeConfigurationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHVACSystemTypeConfigurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocalTemperatureCalibrationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocalTemperatureCalibrationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLocalTemperatureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLocalTemperatureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxCoolSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxCoolSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMaxHeatSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMaxHeatSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinCoolSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinCoolSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinHeatSetpointLimitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinHeatSetpointLimitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMinSetpointDeadBandWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMinSetpointDeadBandWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfDailyTransitionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfDailyTransitionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfWeeklyTransitionsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfWeeklyTransitionsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupancyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupancyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupiedCoolingSetpointWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupiedCoolingSetpointWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupiedHeatingSetpointWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupiedHeatingSetpointWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupiedSetbackMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupiedSetbackMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupiedSetbackMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupiedSetbackMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOccupiedSetbackWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOccupiedSetbackWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOutdoorTemperatureWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOutdoorTemperatureWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePICoolingDemandWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePICoolingDemandWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePIHeatingDemandWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePIHeatingDemandWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRemoteSensingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRemoteSensingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSetpointChangeAmountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSetpointChangeAmountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSetpointChangeSourceTimestampWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSetpointChangeSourceTimestampWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSetpointChangeSourceWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSetpointChangeSourceWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStartOfWeekWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStartOfWeekWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSystemModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSystemModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTemperatureSetpointHoldDurationWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTemperatureSetpointHoldDurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTemperatureSetpointHoldWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTemperatureSetpointHoldWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeThermostatProgrammingOperationModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeThermostatProgrammingOperationModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeThermostatRunningModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeThermostatRunningModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeThermostatRunningStateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeThermostatRunningStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnoccupiedCoolingSetpointWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnoccupiedCoolingSetpointWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnoccupiedHeatingSetpointWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnoccupiedHeatingSetpointWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnoccupiedSetbackMaxWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnoccupiedSetbackMaxWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnoccupiedSetbackMinWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnoccupiedSetbackMinWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeUnoccupiedSetbackWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnoccupiedSetbackWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCapacityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCapacityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCapacityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCapacityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCapacityformatWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCapacityformatWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCapacityformatWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCapacityformatWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCompressorTypeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCompressorTypeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACCompressorTypeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACCompressorTypeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACErrorCodeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACErrorCodeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACErrorCodeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACErrorCodeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACLouverPositionWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACLouverPositionWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACLouverPositionWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACLouverPositionWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACRefrigerantTypeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACRefrigerantTypeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACRefrigerantTypeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACRefrigerantTypeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACTypeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACTypeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACTypeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeACTypeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeControlSequenceOfOperationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeControlSequenceOfOperationWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeControlSequenceOfOperationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeControlSequenceOfOperationWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEmergencyHeatDeltaWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEmergencyHeatDeltaWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEmergencyHeatDeltaWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeEmergencyHeatDeltaWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalTemperatureCalibrationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalTemperatureCalibrationWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalTemperatureCalibrationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLocalTemperatureCalibrationWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxCoolSetpointLimitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxCoolSetpointLimitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxCoolSetpointLimitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxCoolSetpointLimitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxHeatSetpointLimitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxHeatSetpointLimitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMaxHeatSetpointLimitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMaxHeatSetpointLimitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinCoolSetpointLimitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinCoolSetpointLimitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinCoolSetpointLimitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinCoolSetpointLimitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinHeatSetpointLimitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinHeatSetpointLimitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinHeatSetpointLimitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinHeatSetpointLimitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinSetpointDeadBandWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinSetpointDeadBandWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeMinSetpointDeadBandWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeMinSetpointDeadBandWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedCoolingSetpointWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedCoolingSetpointWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedCoolingSetpointWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedCoolingSetpointWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedHeatingSetpointWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedHeatingSetpointWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedHeatingSetpointWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedHeatingSetpointWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedSetbackWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedSetbackWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOccupiedSetbackWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeOccupiedSetbackWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRemoteSensingWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRemoteSensingWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRemoteSensingWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeRemoteSensingWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSystemModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSystemModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeSystemModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeSystemModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureSetpointHoldWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureSetpointHoldWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureSetpointHoldWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureSetpointHoldWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedSetbackWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedSetbackWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnoccupiedSetbackWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeUnoccupiedSetbackWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterThermostatUserInterfaceConfiguration extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterThermostatUserInterfaceConfiguration; // inherited from NSObject

	static new(): MTRBaseClusterThermostatUserInterfaceConfiguration; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeKeypadLockoutWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeKeypadLockoutWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeScheduleProgrammingVisibilityWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeScheduleProgrammingVisibilityWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTemperatureDisplayModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTemperatureDisplayModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeKeypadLockoutWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeKeypadLockoutWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeScheduleProgrammingVisibilityWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeScheduleProgrammingVisibilityWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTemperatureDisplayModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTemperatureDisplayModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeKeypadLockoutWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeKeypadLockoutWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeScheduleProgrammingVisibilityWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeScheduleProgrammingVisibilityWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTemperatureDisplayModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTemperatureDisplayModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeKeypadLockoutWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeKeypadLockoutWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeKeypadLockoutWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeKeypadLockoutWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureDisplayModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureDisplayModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureDisplayModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureDisplayModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterThreadNetworkDiagnostics extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterThreadNetworkDiagnostics; // inherited from NSObject

	static new(): MTRBaseClusterThreadNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveNetworkFaultsListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveNetworkFaultsListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveTimestampWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveTimestampWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttachAttemptCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttachAttemptCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBetterPartitionAttachAttemptCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBetterPartitionAttachAttemptCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeChannelPage0MaskWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeChannelPage0MaskWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeChannelWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeChannelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeChildRoleCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeChildRoleCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDataVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDataVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDelayWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDelayWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeDetachedRoleCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeDetachedRoleCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeExtendedPanIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeExtendedPanIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLeaderRoleCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLeaderRoleCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLeaderRouterIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLeaderRouterIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMeshLocalPrefixWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMeshLocalPrefixWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNeighborTableListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNeighborTableWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNetworkNameWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNetworkNameWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOperationalDatasetComponentsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOperationalDatasetComponentsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOverrunCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOverrunCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePanIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePanIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeParentChangeCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeParentChangeCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePartitionIdChangeCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePartitionIdChangeCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePartitionIdWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePartitionIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePendingTimestampWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePendingTimestampWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRouteTableListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRouteTableWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRouterRoleCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRouterRoleCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRoutingRoleWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRoutingRoleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxAddressFilteredCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxAddressFilteredCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxBeaconCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxBeaconCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxBeaconRequestCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxBeaconRequestCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxBroadcastCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxBroadcastCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxDataCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxDataCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxDataPollCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxDataPollCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxDestAddrFilteredCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxDestAddrFilteredCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxDuplicatedCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxDuplicatedCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrFcsCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrFcsCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrInvalidSrcAddrCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrInvalidSrcAddrCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrNoFrameCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrNoFrameCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrOtherCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrOtherCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrSecCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrSecCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxErrUnknownNeighborCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxErrUnknownNeighborCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxOtherCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxOtherCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxTotalCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxTotalCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRxUnicastCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRxUnicastCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSecurityPolicyWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSecurityPolicyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeStableDataVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStableDataVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxAckRequestedCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxAckRequestedCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxAckedCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxAckedCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxBeaconCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxBeaconCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxBeaconRequestCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxBeaconRequestCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxBroadcastCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxBroadcastCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxDataCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxDataCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxDataPollCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxDataPollCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxDirectMaxRetryExpiryCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxDirectMaxRetryExpiryCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxErrAbortCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxErrAbortCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxErrBusyChannelCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxErrBusyChannelCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxErrCcaCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxErrCcaCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxIndirectMaxRetryExpiryCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxIndirectMaxRetryExpiryCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxNoAckRequestedCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxNoAckRequestedCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxOtherCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxOtherCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxRetryCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxRetryCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxTotalCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxTotalCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTxUnicastCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTxUnicastCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWeightingWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWeightingWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveNetworkFaultsListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveNetworkFaultsListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveTimestampWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveTimestampWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttachAttemptCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttachAttemptCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBetterPartitionAttachAttemptCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBetterPartitionAttachAttemptCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeChannelPage0MaskWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeChannelPage0MaskWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeChannelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeChannelWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeChildRoleCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeChildRoleCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDataVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDataVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDelayWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDelayWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeDetachedRoleCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDetachedRoleCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeExtendedPanIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeExtendedPanIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLeaderRoleCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLeaderRoleCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLeaderRouterIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLeaderRouterIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMeshLocalPrefixWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMeshLocalPrefixWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNeighborTableListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNeighborTableWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNetworkNameWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNetworkNameWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOperationalDatasetComponentsWithCompletion(completion: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOperationalDatasetComponentsWithCompletionHandler(completionHandler: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOverrunCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOverrunCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePanIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePanIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeParentChangeCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeParentChangeCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePartitionIdChangeCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePartitionIdChangeCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePartitionIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePartitionIdWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePendingTimestampWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePendingTimestampWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRouteTableListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRouteTableWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRouterRoleCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRouterRoleCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRoutingRoleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRoutingRoleWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxAddressFilteredCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxAddressFilteredCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxBeaconCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxBeaconCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxBeaconRequestCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxBeaconRequestCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxBroadcastCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxBroadcastCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxDataCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxDataCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxDataPollCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxDataPollCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxDestAddrFilteredCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxDestAddrFilteredCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxDuplicatedCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxDuplicatedCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrFcsCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrFcsCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrInvalidSrcAddrCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrInvalidSrcAddrCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrNoFrameCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrNoFrameCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrOtherCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrOtherCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrSecCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrSecCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxErrUnknownNeighborCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxErrUnknownNeighborCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxOtherCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxOtherCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxTotalCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxTotalCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRxUnicastCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRxUnicastCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSecurityPolicyWithCompletion(completion: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSecurityPolicyWithCompletionHandler(completionHandler: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStableDataVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeStableDataVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxAckRequestedCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxAckRequestedCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxAckedCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxAckedCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxBeaconCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxBeaconCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxBeaconRequestCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxBeaconRequestCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxBroadcastCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxBroadcastCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxDataCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxDataCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxDataPollCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxDataPollCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxDirectMaxRetryExpiryCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxDirectMaxRetryExpiryCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxErrAbortCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxErrAbortCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxErrBusyChannelCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxErrBusyChannelCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxErrCcaCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxErrCcaCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxIndirectMaxRetryExpiryCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxIndirectMaxRetryExpiryCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxNoAckRequestedCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxNoAckRequestedCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxOtherCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxOtherCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxRetryCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxRetryCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxTotalCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxTotalCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTxUnicastCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTxUnicastCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWeightingWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWeightingWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsCompletion(params: MTRThreadNetworkDiagnosticsClusterResetCountsParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsCompletionHandler(params: MTRThreadNetworkDiagnosticsClusterResetCountsParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveNetworkFaultsListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveNetworkFaultsListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveTimestampWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveTimestampWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttachAttemptCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttachAttemptCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBetterPartitionAttachAttemptCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBetterPartitionAttachAttemptCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeChannelPage0MaskWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeChannelPage0MaskWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeChannelWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeChannelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeChildRoleCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeChildRoleCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDataVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDataVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDelayWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDelayWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeDetachedRoleCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeDetachedRoleCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeExtendedPanIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeExtendedPanIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLeaderRoleCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLeaderRoleCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLeaderRouterIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLeaderRouterIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMeshLocalPrefixWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMeshLocalPrefixWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNeighborTableListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNeighborTableWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNetworkNameWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNetworkNameWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOperationalDatasetComponentsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOperationalDatasetComponentsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOverrunCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOverrunCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePanIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePanIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeParentChangeCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeParentChangeCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePartitionIdChangeCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePartitionIdChangeCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePartitionIdWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePartitionIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePendingTimestampWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePendingTimestampWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRouteTableListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRouteTableWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRouterRoleCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRouterRoleCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRoutingRoleWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRoutingRoleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxAddressFilteredCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxAddressFilteredCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxBeaconCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxBeaconCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxBeaconRequestCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxBeaconRequestCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxBroadcastCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxBroadcastCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxDataCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxDataCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxDataPollCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxDataPollCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxDestAddrFilteredCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxDestAddrFilteredCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxDuplicatedCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxDuplicatedCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrFcsCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrFcsCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrInvalidSrcAddrCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrInvalidSrcAddrCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrNoFrameCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrNoFrameCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrOtherCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrOtherCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrSecCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrSecCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxErrUnknownNeighborCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxErrUnknownNeighborCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxOtherCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxOtherCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxTotalCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxTotalCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRxUnicastCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRxUnicastCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSecurityPolicyWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSecurityPolicyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRThreadNetworkDiagnosticsClusterSecurityPolicy, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeStableDataVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStableDataVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxAckRequestedCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxAckRequestedCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxAckedCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxAckedCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxBeaconCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxBeaconCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxBeaconRequestCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxBeaconRequestCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxBroadcastCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxBroadcastCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxDataCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxDataCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxDataPollCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxDataPollCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxDirectMaxRetryExpiryCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxDirectMaxRetryExpiryCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxErrAbortCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxErrAbortCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxErrBusyChannelCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxErrBusyChannelCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxErrCcaCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxErrCcaCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxIndirectMaxRetryExpiryCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxIndirectMaxRetryExpiryCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxNoAckRequestedCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxNoAckRequestedCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxOtherCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxOtherCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxRetryCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxRetryCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxTotalCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxTotalCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTxUnicastCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTxUnicastCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWeightingWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWeightingWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterTimeFormatLocalization extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterTimeFormatLocalization; // inherited from NSObject

	static new(): MTRBaseClusterTimeFormatLocalization; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeActiveCalendarTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeActiveCalendarTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeHourFormatWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeHourFormatWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSupportedCalendarTypesWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSupportedCalendarTypesWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeActiveCalendarTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeActiveCalendarTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeHourFormatWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeHourFormatWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSupportedCalendarTypesWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSupportedCalendarTypesWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeActiveCalendarTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeActiveCalendarTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeHourFormatWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeHourFormatWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSupportedCalendarTypesWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSupportedCalendarTypesWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeActiveCalendarTypeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveCalendarTypeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeActiveCalendarTypeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeActiveCalendarTypeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeHourFormatWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeHourFormatWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeHourFormatWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeHourFormatWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterTotalVolatileOrganicCompoundsConcentrationMeasurement extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterTotalVolatileOrganicCompoundsConcentrationMeasurement; // inherited from NSObject

	static new(): MTRBaseClusterTotalVolatileOrganicCompoundsConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAverageMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMaxMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementMediumWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMeasurementUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeMinMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWindowWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributePeakMeasuredValueWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeUncertaintyWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAverageMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMaxMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementMediumWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMeasurementUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeMinMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWindowWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributePeakMeasuredValueWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeUncertaintyWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterUnitLocalization extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterUnitLocalization; // inherited from NSObject

	static new(): MTRBaseClusterUnitLocalization; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTemperatureUnitWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTemperatureUnitWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTemperatureUnitWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTemperatureUnitWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTemperatureUnitWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTemperatureUnitWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureUnitWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureUnitWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTemperatureUnitWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeTemperatureUnitWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterUnitTesting extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterUnitTesting; // inherited from NSObject

	static new(): MTRBaseClusterUnitTesting; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBitmap16WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBitmap32WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBitmap64WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBitmap8WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBooleanWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCharStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterErrorBooleanWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnum16WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnum8WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEnumAttrWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEpochSWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEpochUsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFloatDoubleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFloatSingleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneralErrorBooleanWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt16sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt16uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt24sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt24uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt32sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt32uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt40sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt40uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt48sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt48uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt56sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt56uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt64sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt64uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt8sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListFabricScopedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListLongOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListNullablesAndOptionalsStructWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeListStructOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLongCharStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLongOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableBitmap16WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableBitmap32WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableBitmap64WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableBitmap8WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableBooleanWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableCharStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableEnum16WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableEnum8WithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableEnumAttrWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableFloatDoubleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableFloatSingleWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt16sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt16uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt24sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt24uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt32sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt32uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt40sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt40uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt48sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt48uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt56sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt56uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt64sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt64uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt8sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableRangeRestrictedInt16sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableRangeRestrictedInt16uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableRangeRestrictedInt8sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableRangeRestrictedInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNullableStructWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOctetStringWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRangeRestrictedInt16sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRangeRestrictedInt16uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRangeRestrictedInt8sWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRangeRestrictedInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeStructAttrWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTimedWriteBooleanWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeUnsupportedWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeVendorIdWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWriteOnlyInt8uWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap16WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap32WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap64WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap8WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBooleanWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCharStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterErrorBooleanWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnum16WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnum8WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEnumAttrWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEpochSWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEpochUsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFloatDoubleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFloatSingleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneralErrorBooleanWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt16sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt16uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt24sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt24uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt32sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt32uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt40sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt40uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt48sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt48uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt56sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt56uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt64sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt64uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt8sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInt8uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListFabricScopedWithParamsCompletion(params: MTRReadParams, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListInt8uWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListLongOctetStringWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListNullablesAndOptionalsStructWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListOctetStringWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeListStructOctetStringWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLongCharStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLongOctetStringWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap16WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap32WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap64WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap8WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBooleanWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableCharStringWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnum16WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnum8WithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnumAttrWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableFloatDoubleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableFloatSingleWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt16sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt16uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt24sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt24uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt32sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt32uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt40sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt40uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt48sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt48uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt56sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt56uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt64sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt64uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt8sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt8uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableOctetStringWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt16sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt16uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt8sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt8uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNullableStructWithCompletion(completion: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOctetStringWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt16sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt16uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt8sWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt8uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeStructAttrWithCompletion(completion: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTimedWriteBooleanWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeUnsupportedWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIdWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWriteOnlyInt8uWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	simpleStructEchoRequestWithParamsCompletion(params: MTRUnitTestingClusterSimpleStructEchoRequestParams, completion: (p1: MTRUnitTestingClusterSimpleStructResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBitmap16WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBitmap32WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBitmap64WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBitmap8WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBooleanWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCharStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterErrorBooleanWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnum16WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnum8WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEnumAttrWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEpochSWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEpochUsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFloatDoubleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFloatSingleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneralErrorBooleanWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt16sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt16uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt24sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt24uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt32sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt32uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt40sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt40uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt48sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt48uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt56sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt56uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt64sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt64uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt8sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListFabricScopedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListLongOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListNullablesAndOptionalsStructWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeListStructOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLongCharStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLongOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableBitmap16WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableBitmap32WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableBitmap64WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableBitmap8WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableBooleanWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableCharStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableEnum16WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableEnum8WithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableEnumAttrWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableFloatDoubleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableFloatSingleWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt16sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt16uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt24sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt24uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt32sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt32uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt40sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt40uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt48sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt48uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt56sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt56uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt64sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt64uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt8sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt16sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt16uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt8sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableRangeRestrictedInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNullableStructWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOctetStringWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRangeRestrictedInt16sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRangeRestrictedInt16uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRangeRestrictedInt8sWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRangeRestrictedInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeStructAttrWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: MTRUnitTestingClusterSimpleStruct, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTimedWriteBooleanWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeUnsupportedWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeVendorIdWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWriteOnlyInt8uWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testAddArgumentsWithParamsCompletion(params: MTRUnitTestingClusterTestAddArgumentsParams, completion: (p1: MTRUnitTestingClusterTestAddArgumentsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testComplexNullableOptionalRequestWithParamsCompletion(params: MTRUnitTestingClusterTestComplexNullableOptionalRequestParams, completion: (p1: MTRUnitTestingClusterTestComplexNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEmitTestEventRequestWithParamsCompletion(params: MTRUnitTestingClusterTestEmitTestEventRequestParams, completion: (p1: MTRUnitTestingClusterTestEmitTestEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEmitTestFabricScopedEventRequestWithParamsCompletion(params: MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams, completion: (p1: MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEnumsRequestWithParamsCompletion(params: MTRUnitTestingClusterTestEnumsRequestParams, completion: (p1: MTRUnitTestingClusterTestEnumsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListInt8UArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestListInt8UArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListInt8UReverseRequestWithParamsCompletion(params: MTRUnitTestingClusterTestListInt8UReverseRequestParams, completion: (p1: MTRUnitTestingClusterTestListInt8UReverseResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListNestedStructListArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListStructArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestListStructArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNestedStructArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestNestedStructArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNestedStructListArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestNestedStructListArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNotHandledWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNotHandledWithParamsCompletion(params: MTRUnitTestingClusterTestNotHandledParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	testNullableOptionalRequestWithCompletion(completion: (p1: MTRUnitTestingClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNullableOptionalRequestWithParamsCompletion(params: MTRUnitTestingClusterTestNullableOptionalRequestParams, completion: (p1: MTRUnitTestingClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSimpleArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestSimpleArgumentRequestParams, completion: (p1: MTRUnitTestingClusterTestSimpleArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	testSimpleOptionalArgumentRequestWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSimpleOptionalArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSpecificWithCompletion(completion: (p1: MTRUnitTestingClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSpecificWithParamsCompletion(params: MTRUnitTestingClusterTestSpecificParams, completion: (p1: MTRUnitTestingClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testStructArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestStructArgumentRequestParams, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testStructArrayArgumentRequestWithParamsCompletion(params: MTRUnitTestingClusterTestStructArrayArgumentRequestParams, completion: (p1: MTRUnitTestingClusterTestStructArrayArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testUnknownCommandWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testUnknownCommandWithParamsCompletion(params: MTRUnitTestingClusterTestUnknownCommandParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testWithParamsCompletion(params: MTRUnitTestingClusterTestParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	timedInvokeRequestWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	timedInvokeRequestWithParamsCompletion(params: MTRUnitTestingClusterTimedInvokeRequestParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap16WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap16WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap32WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap32WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap64WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap64WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap8WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap8WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBooleanWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBooleanWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCharStringWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCharStringWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum16WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum16WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum8WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum8WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnumAttrWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnumAttrWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochSWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochSWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochUsWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochUsWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatDoubleWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatDoubleWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatSingleWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatSingleWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListFabricScopedWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListFabricScopedWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListInt8uWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListInt8uWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListLongOctetStringWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListLongOctetStringWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListOctetStringWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListOctetStringWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListStructOctetStringWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListStructOctetStringWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongCharStringWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongCharStringWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongOctetStringWithValueCompletion(value: NSData, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongOctetStringWithValueParamsCompletion(value: NSData, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap16WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap16WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap32WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap32WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap64WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap64WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap8WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap8WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBooleanWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBooleanWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableCharStringWithValueCompletion(value: string, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableCharStringWithValueParamsCompletion(value: string, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum16WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum16WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum8WithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum8WithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnumAttrWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnumAttrWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatSingleWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatSingleWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableOctetStringWithValueCompletion(value: NSData, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableOctetStringWithValueParamsCompletion(value: NSData, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableStructWithValueCompletion(value: MTRUnitTestingClusterSimpleStruct, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableStructWithValueParamsCompletion(value: MTRUnitTestingClusterSimpleStruct, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOctetStringWithValueCompletion(value: NSData, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOctetStringWithValueParamsCompletion(value: NSData, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStructAttrWithValueCompletion(value: MTRUnitTestingClusterSimpleStruct, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStructAttrWithValueParamsCompletion(value: MTRUnitTestingClusterSimpleStruct, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnsupportedWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnsupportedWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeVendorIdWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeVendorIdWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterUserLabel extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterUserLabel; // inherited from NSObject

	static new(): MTRBaseClusterUserLabel; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeLabelListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeLabelListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeLabelListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeLabelListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeLabelListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeLabelListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLabelListWithValueCompletion(value: NSArray<any> | any[], completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLabelListWithValueCompletionHandler(value: NSArray<any> | any[], completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLabelListWithValueParamsCompletion(value: NSArray<any> | any[], params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeLabelListWithValueParamsCompletionHandler(value: NSArray<any> | any[], params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRBaseClusterValveConfigurationAndControl extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterValveConfigurationAndControl; // inherited from NSObject

	static new(): MTRBaseClusterValveConfigurationAndControl; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeAutoCloseTimeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCurrentLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeCurrentStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDefaultOpenDurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeDefaultOpenLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeLevelStepWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeOpenDurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeRemainingDurationWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeTargetLevelWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeTargetStateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	static readAttributeValveFaultWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	closeWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	closeWithParamsCompletion(params: MTRValveConfigurationAndControlClusterCloseParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	openWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	openWithParamsCompletion(params: MTRValveConfigurationAndControlClusterOpenParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAutoCloseTimeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultOpenDurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultOpenLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeLevelStepWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeOpenDurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeRemainingDurationWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeTargetLevelWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeTargetStateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeValveFaultWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeAutoCloseTimeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCurrentLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeCurrentStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDefaultOpenDurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeDefaultOpenLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeLevelStepWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeOpenDurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeRemainingDurationWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeTargetLevelWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeTargetStateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	subscribeAttributeValveFaultWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenDurationWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenDurationWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenLevelWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenLevelWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRBaseClusterWakeOnLAN extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterWakeOnLAN; // inherited from NSObject

	static new(): MTRBaseClusterWakeOnLAN; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeMACAddressWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeMACAddressWithCompletion(completion: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeMACAddressWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: string, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBaseClusterWakeOnLan extends MTRBaseClusterWakeOnLAN {

	static alloc(): MTRBaseClusterWakeOnLan; // inherited from NSObject

	static new(): MTRBaseClusterWakeOnLan; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeMACAddressWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeMACAddressWithCompletionHandler(completionHandler: (p1: string, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeMACAddressWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: string, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterWiFiNetworkDiagnostics extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterWiFiNetworkDiagnostics; // inherited from NSObject

	static new(): MTRBaseClusterWiFiNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBSSIDWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBeaconLostCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBeaconLostCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBeaconRxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeBeaconRxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeBssidWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeChannelNumberWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeChannelNumberWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentMaxRateWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentMaxRateWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOverrunCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOverrunCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketMulticastRxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketMulticastRxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketMulticastTxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketMulticastTxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketUnicastRxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketUnicastRxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePacketUnicastTxCountWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePacketUnicastTxCountWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeRSSIWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeRssiWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSecurityTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSecurityTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeWiFiVersionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeWiFiVersionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBSSIDWithCompletion(completion: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBeaconLostCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBeaconLostCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeBeaconRxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBeaconRxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBssidWithCompletionHandler(completionHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeChannelNumberWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeChannelNumberWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentMaxRateWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentMaxRateWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOverrunCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOverrunCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketMulticastRxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketMulticastRxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketMulticastTxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketMulticastTxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketUnicastRxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketUnicastRxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePacketUnicastTxCountWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePacketUnicastTxCountWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeRSSIWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRssiWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSecurityTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSecurityTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeWiFiVersionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWiFiVersionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsCompletion(params: MTRWiFiNetworkDiagnosticsClusterResetCountsParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsCompletionHandler(params: MTRWiFiNetworkDiagnosticsClusterResetCountsParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBSSIDWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBeaconLostCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBeaconLostCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBeaconRxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeBeaconRxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeBssidWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSData, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeChannelNumberWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeChannelNumberWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentMaxRateWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentMaxRateWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOverrunCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOverrunCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketMulticastRxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketMulticastRxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketMulticastTxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketMulticastTxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketUnicastRxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketUnicastRxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePacketUnicastTxCountWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePacketUnicastTxCountWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeRSSIWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeRssiWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSecurityTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSecurityTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWiFiVersionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeWiFiVersionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseClusterWindowCovering extends MTRGenericBaseCluster {

	static alloc(): MTRBaseClusterWindowCovering; // inherited from NSObject

	static new(): MTRBaseClusterWindowCovering; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAcceptedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAcceptedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeAttributeListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeAttributeListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeClusterRevisionWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeClusterRevisionWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeConfigStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeConfigStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionLiftPercent100thsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionLiftPercent100thsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionLiftPercentageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionLiftPercentageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionLiftWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionLiftWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionTiltPercent100thsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionTiltPercent100thsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionTiltPercentageWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionTiltPercentageWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeCurrentPositionTiltWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeCurrentPositionTiltWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeEndProductTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeEndProductTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeFeatureMapWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeFeatureMapWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeGeneratedCommandListWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeGeneratedCommandListWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstalledClosedLimitLiftWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInstalledClosedLimitLiftWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstalledClosedLimitTiltWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInstalledClosedLimitTiltWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstalledOpenLimitLiftWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInstalledOpenLimitLiftWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeInstalledOpenLimitTiltWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeInstalledOpenLimitTiltWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeModeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeModeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfActuationsLiftWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfActuationsLiftWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeNumberOfActuationsTiltWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeNumberOfActuationsTiltWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeOperationalStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeOperationalStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalClosedLimitLiftWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalClosedLimitLiftWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributePhysicalClosedLimitTiltWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributePhysicalClosedLimitTiltWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeSafetyStatusWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeSafetyStatusWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTargetPositionLiftPercent100thsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTargetPositionLiftPercent100thsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTargetPositionTiltPercent100thsWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTargetPositionTiltPercent100thsWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static readAttributeTypeWithAttributeCacheEndpointQueueCompletionHandler(attributeCacheContainer: MTRAttributeCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	static readAttributeTypeWithClusterStateCacheEndpointQueueCompletion(clusterStateCacheContainer: MTRClusterStateCacheContainer, endpoint: number, queue: NSObject & OS_dispatch_queue, completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRBaseDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	downOrCloseWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	downOrCloseWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	downOrCloseWithParamsCompletion(params: MTRWindowCoveringClusterDownOrCloseParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	downOrCloseWithParamsCompletionHandler(params: MTRWindowCoveringClusterDownOrCloseParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToLiftPercentageWithParamsCompletion(params: MTRWindowCoveringClusterGoToLiftPercentageParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToLiftPercentageWithParamsCompletionHandler(params: MTRWindowCoveringClusterGoToLiftPercentageParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToLiftValueWithParamsCompletion(params: MTRWindowCoveringClusterGoToLiftValueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToLiftValueWithParamsCompletionHandler(params: MTRWindowCoveringClusterGoToLiftValueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToTiltPercentageWithParamsCompletion(params: MTRWindowCoveringClusterGoToTiltPercentageParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToTiltPercentageWithParamsCompletionHandler(params: MTRWindowCoveringClusterGoToTiltPercentageParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToTiltValueWithParamsCompletion(params: MTRWindowCoveringClusterGoToTiltValueParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToTiltValueWithParamsCompletionHandler(params: MTRWindowCoveringClusterGoToTiltValueParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRBaseDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRBaseDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAcceptedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAttributeListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeClusterRevisionWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeConfigStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeConfigStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionLiftPercent100thsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionLiftPercent100thsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionLiftPercentageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionLiftPercentageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionLiftWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionLiftWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionTiltPercent100thsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionTiltPercent100thsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionTiltPercentageWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionTiltPercentageWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeCurrentPositionTiltWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeCurrentPositionTiltWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeEndProductTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeEndProductTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeFeatureMapWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithCompletion(completion: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeGeneratedCommandListWithCompletionHandler(completionHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInstalledClosedLimitLiftWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstalledClosedLimitLiftWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInstalledClosedLimitTiltWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstalledClosedLimitTiltWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInstalledOpenLimitLiftWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstalledOpenLimitLiftWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeInstalledOpenLimitTiltWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeInstalledOpenLimitTiltWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeModeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeModeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfActuationsLiftWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfActuationsLiftWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeNumberOfActuationsTiltWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNumberOfActuationsTiltWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeOperationalStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeOperationalStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalClosedLimitLiftWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalClosedLimitLiftWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributePhysicalClosedLimitTiltWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePhysicalClosedLimitTiltWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeSafetyStatusWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeSafetyStatusWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTargetPositionLiftPercent100thsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTargetPositionLiftPercent100thsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTargetPositionTiltPercent100thsWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTargetPositionTiltPercent100thsWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeTypeWithCompletion(completion: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeTypeWithCompletionHandler(completionHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopMotionWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMotionWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopMotionWithParamsCompletion(params: MTRWindowCoveringClusterStopMotionParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMotionWithParamsCompletionHandler(params: MTRWindowCoveringClusterStopMotionParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAcceptedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAcceptedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeAttributeListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeAttributeListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeClusterRevisionWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeClusterRevisionWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeConfigStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeConfigStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionLiftPercent100thsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionLiftPercent100thsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionLiftPercentageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionLiftPercentageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionLiftWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionLiftWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionTiltPercent100thsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionTiltPercent100thsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionTiltPercentageWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionTiltPercentageWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeCurrentPositionTiltWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeCurrentPositionTiltWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeEndProductTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeEndProductTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeFeatureMapWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeFeatureMapWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeGeneratedCommandListWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeGeneratedCommandListWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: NSArray<any>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstalledClosedLimitLiftWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInstalledClosedLimitLiftWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstalledClosedLimitTiltWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInstalledClosedLimitTiltWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstalledOpenLimitLiftWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInstalledOpenLimitLiftWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeInstalledOpenLimitTiltWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeInstalledOpenLimitTiltWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeModeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeModeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfActuationsLiftWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfActuationsLiftWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeNumberOfActuationsTiltWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeNumberOfActuationsTiltWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeOperationalStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeOperationalStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalClosedLimitLiftWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalClosedLimitLiftWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributePhysicalClosedLimitTiltWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributePhysicalClosedLimitTiltWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeSafetyStatusWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeSafetyStatusWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTargetPositionLiftPercent100thsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTargetPositionLiftPercent100thsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTargetPositionTiltPercent100thsWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTargetPositionTiltPercent100thsWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeTypeWithMinIntervalMaxIntervalParamsSubscriptionEstablishedReportHandler(minInterval: number, maxInterval: number, params: MTRSubscribeParams, subscriptionEstablishedHandler: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeAttributeTypeWithParamsSubscriptionEstablishedReportHandler(params: MTRSubscribeParams, subscriptionEstablished: () => void, reportHandler: (p1: number, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	upOrOpenWithCompletion(completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	upOrOpenWithCompletionHandler(completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	upOrOpenWithParamsCompletion(params: MTRWindowCoveringClusterUpOrOpenParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	upOrOpenWithParamsCompletionHandler(params: MTRWindowCoveringClusterUpOrOpenParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeModeWithValueCompletion(value: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeModeWithValueCompletionHandler(value: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeModeWithValueParamsCompletion(value: number, params: MTRWriteParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeModeWithValueParamsCompletionHandler(value: number, params: MTRWriteParams, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRBaseDevice extends NSObject {

	static alloc(): MTRBaseDevice; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static deviceWithNodeIDController(nodeID: number, controller: MTRDeviceController): MTRBaseDevice;

	static new(): MTRBaseDevice; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	readonly sessionTransportType: MTRTransportType;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	deregisterReportHandlersWithClientQueueCompletion(queue: NSObject & OS_dispatch_queue, completion: () => void): void;

	/**
	 * @since 16.4
	 */
	deregisterReportHandlersWithQueueCompletion(queue: NSObject & OS_dispatch_queue, completion: () => void): void;

	/**
	 * @since 17.6
	 */
	downloadLogOfTypeTimeoutQueueCompletion(type: MTRDiagnosticLogType, timeout: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSURL, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	invokeCommandWithEndpointIDClusterIDCommandIDCommandFieldsTimedInvokeTimeoutQueueCompletion(endpointID: number, clusterID: number, commandID: number, commandFields: any, timeoutMs: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	invokeCommandWithEndpointIdClusterIdCommandIdCommandFieldsTimedInvokeTimeoutClientQueueCompletion(endpointId: number, clusterId: number, commandId: number, commandFields: any, timeoutMs: number, clientQueue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	openCommissioningWindowWithDiscriminatorDurationQueueCompletion(discriminator: number, duration: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRSetupPayload, p2: NSError) => void): void;

	/**
	 * @since 16.2
	 */
	openCommissioningWindowWithSetupPasscodeDiscriminatorDurationQueueCompletion(setupPasscode: number, discriminator: number, duration: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRSetupPayload, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	readAttributePathsEventPathsParamsQueueCompletion(attributePaths: NSArray<MTRAttributeRequestPath> | MTRAttributeRequestPath[], eventPaths: NSArray<MTREventRequestPath> | MTREventRequestPath[], params: MTRReadParams, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeWithEndpointIdClusterIdAttributeIdParamsClientQueueCompletion(endpointId: number, clusterId: number, attributeId: number, params: MTRReadParams, clientQueue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributesWithEndpointIDClusterIDAttributeIDParamsQueueCompletion(endpointID: number, clusterID: number, attributeID: number, params: MTRReadParams, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readEventsWithEndpointIDClusterIDEventIDParamsQueueCompletion(endpointID: number, clusterID: number, eventID: number, params: MTRReadParams, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeAttributeWithEndpointIdClusterIdAttributeIdMinIntervalMaxIntervalParamsClientQueueReportHandlerSubscriptionEstablished(endpointId: number, clusterId: number, attributeId: number, minInterval: number, maxInterval: number, params: MTRSubscribeParams, clientQueue: NSObject & OS_dispatch_queue, reportHandler: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void, subscriptionEstablishedHandler: () => void): void;

	/**
	 * @since 17.0
	 */
	subscribeToAttributePathsEventPathsParamsQueueReportHandlerSubscriptionEstablishedResubscriptionScheduled(attributePaths: NSArray<MTRAttributeRequestPath> | MTRAttributeRequestPath[], eventPaths: NSArray<MTREventRequestPath> | MTREventRequestPath[], params: MTRSubscribeParams, queue: NSObject & OS_dispatch_queue, reportHandler: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void, subscriptionEstablished: () => void, resubscriptionScheduled: (p1: NSError, p2: number) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeToAttributesWithEndpointIDClusterIDAttributeIDParamsQueueReportHandlerSubscriptionEstablished(endpointID: number, clusterID: number, attributeID: number, params: MTRSubscribeParams, queue: NSObject & OS_dispatch_queue, reportHandler: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void, subscriptionEstablished: () => void): void;

	/**
	 * @since 16.4
	 */
	subscribeToEventsWithEndpointIDClusterIDEventIDParamsQueueReportHandlerSubscriptionEstablished(endpointID: number, clusterID: number, eventID: number, params: MTRSubscribeParams, queue: NSObject & OS_dispatch_queue, reportHandler: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void, subscriptionEstablished: () => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	subscribeWithQueueMinIntervalMaxIntervalParamsCacheContainerAttributeReportHandlerEventReportHandlerErrorHandlerSubscriptionEstablishedResubscriptionScheduled(queue: NSObject & OS_dispatch_queue, minInterval: number, maxInterval: number, params: MTRSubscribeParams, attributeCacheContainer: MTRAttributeCacheContainer, attributeReportHandler: (p1: NSArray<any>) => void, eventReportHandler: (p1: NSArray<any>) => void, errorHandler: (p1: NSError) => void, subscriptionEstablishedHandler: () => void, resubscriptionScheduledHandler: (p1: NSError, p2: number) => void): void;

	/**
	 * @since 16.4
	 */
	subscribeWithQueueParamsClusterStateCacheContainerAttributeReportHandlerEventReportHandlerErrorHandlerSubscriptionEstablishedResubscriptionScheduled(queue: NSObject & OS_dispatch_queue, params: MTRSubscribeParams, clusterStateCacheContainer: MTRClusterStateCacheContainer, attributeReportHandler: (p1: NSArray<any>) => void, eventReportHandler: (p1: NSArray<any>) => void, errorHandler: (p1: NSError) => void, subscriptionEstablished: () => void, resubscriptionScheduled: (p1: NSError, p2: number) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWithEndpointIDClusterIDAttributeIDValueTimedWriteTimeoutQueueCompletion(endpointID: number, clusterID: number, attributeID: number, value: any, timeoutMs: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeWithEndpointIdClusterIdAttributeIdValueTimedWriteTimeoutClientQueueCompletion(endpointId: number, clusterId: number, attributeId: number, value: any, timeoutMs: number, clientQueue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterCapabilityMinimaStruct extends MTRBasicInformationClusterCapabilityMinimaStruct {

	static alloc(): MTRBasicClusterCapabilityMinimaStruct; // inherited from NSObject

	static new(): MTRBasicClusterCapabilityMinimaStruct; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterLeaveEvent extends MTRBasicInformationClusterLeaveEvent {

	static alloc(): MTRBasicClusterLeaveEvent; // inherited from NSObject

	static new(): MTRBasicClusterLeaveEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterMfgSpecificPingParams extends NSObject implements NSCopying {

	static alloc(): MTRBasicClusterMfgSpecificPingParams; // inherited from NSObject

	static new(): MTRBasicClusterMfgSpecificPingParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterReachableChangedEvent extends MTRBasicInformationClusterReachableChangedEvent {

	static alloc(): MTRBasicClusterReachableChangedEvent; // inherited from NSObject

	static new(): MTRBasicClusterReachableChangedEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterShutDownEvent extends MTRBasicInformationClusterShutDownEvent {

	static alloc(): MTRBasicClusterShutDownEvent; // inherited from NSObject

	static new(): MTRBasicClusterShutDownEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRBasicClusterStartUpEvent extends MTRBasicInformationClusterStartUpEvent {

	static alloc(): MTRBasicClusterStartUpEvent; // inherited from NSObject

	static new(): MTRBasicClusterStartUpEvent; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRBasicInformationClusterCapabilityMinimaStruct extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterCapabilityMinimaStruct; // inherited from NSObject

	static new(): MTRBasicInformationClusterCapabilityMinimaStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	caseSessionsPerFabric: number;

	/**
	 * @since 16.4
	 */
	subscriptionsPerFabric: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBasicInformationClusterLeaveEvent extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterLeaveEvent; // inherited from NSObject

	static new(): MTRBasicInformationClusterLeaveEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare class MTRBasicInformationClusterProductAppearanceStruct extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterProductAppearanceStruct; // inherited from NSObject

	static new(): MTRBasicInformationClusterProductAppearanceStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	finish: number;

	/**
	 * @since 17.0
	 */
	primaryColor: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBasicInformationClusterReachableChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterReachableChangedEvent; // inherited from NSObject

	static new(): MTRBasicInformationClusterReachableChangedEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	reachableNewValue: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBasicInformationClusterShutDownEvent extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterShutDownEvent; // inherited from NSObject

	static new(): MTRBasicInformationClusterShutDownEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBasicInformationClusterStartUpEvent extends NSObject implements NSCopying {

	static alloc(): MTRBasicInformationClusterStartUpEvent; // inherited from NSObject

	static new(): MTRBasicInformationClusterStartUpEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare const enum MTRBasicInformationColor {

	Black = 0,

	Navy = 1,

	Green = 2,

	Teal = 3,

	Maroon = 4,

	Purple = 5,

	Olive = 6,

	Gray = 7,

	Blue = 8,

	Lime = 9,

	Aqua = 10,

	Red = 11,

	Fuchsia = 12,

	Yellow = 13,

	White = 14,

	Nickel = 15,

	Chrome = 16,

	Brass = 17,

	Copper = 18,

	Silver = 19,

	Gold = 20
}

/**
 * @since 17.0
 */
declare const enum MTRBasicInformationProductFinish {

	Other = 0,

	Matte = 1,

	Satin = 2,

	Polished = 3,

	Rugged = 4,

	Fabric = 5
}

/**
 * @since 16.1
 */
declare class MTRBindingClusterTargetStruct extends NSObject implements NSCopying {

	static alloc(): MTRBindingClusterTargetStruct; // inherited from NSObject

	static new(): MTRBindingClusterTargetStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	cluster: number;

	/**
	 * @since 16.1
	 */
	endpoint: number;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	group: number;

	/**
	 * @since 16.1
	 */
	node: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRBooleanStateClusterStateChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRBooleanStateClusterStateChangeEvent; // inherited from NSObject

	static new(): MTRBooleanStateClusterStateChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	stateValue: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRBooleanStateConfigurationAlarmModeBitmap {

	Visual = 1,

	Audible = 2
}

/**
 * @since 17.6
 */
declare class MTRBooleanStateConfigurationClusterAlarmsStateChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRBooleanStateConfigurationClusterAlarmsStateChangedEvent; // inherited from NSObject

	static new(): MTRBooleanStateConfigurationClusterAlarmsStateChangedEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmsActive: number;

	/**
	 * @since 17.6
	 */
	alarmsSuppressed: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRBooleanStateConfigurationClusterEnableDisableAlarmParams extends NSObject implements NSCopying {

	static alloc(): MTRBooleanStateConfigurationClusterEnableDisableAlarmParams; // inherited from NSObject

	static new(): MTRBooleanStateConfigurationClusterEnableDisableAlarmParams; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmsToEnableDisable: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRBooleanStateConfigurationClusterSensorFaultEvent extends NSObject implements NSCopying {

	static alloc(): MTRBooleanStateConfigurationClusterSensorFaultEvent; // inherited from NSObject

	static new(): MTRBooleanStateConfigurationClusterSensorFaultEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	sensorFault: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRBooleanStateConfigurationClusterSuppressAlarmParams extends NSObject implements NSCopying {

	static alloc(): MTRBooleanStateConfigurationClusterSuppressAlarmParams; // inherited from NSObject

	static new(): MTRBooleanStateConfigurationClusterSuppressAlarmParams; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmsToSuppress: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRBooleanStateConfigurationFeature {

	Visual = 1,

	Audible = 2,

	AlarmSuppress = 4,

	SensitivityLevel = 8
}

/**
 * @since 17.6
 */
declare const enum MTRBooleanStateConfigurationSensorFaultBitmap {

	GeneralFault = 1
}

/**
 * @since 16.1
 */
declare var MTRBooleanValueType: string;

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRBridgedDeviceBasicClusterLeaveEvent extends MTRBridgedDeviceBasicInformationClusterLeaveEvent {

	static alloc(): MTRBridgedDeviceBasicClusterLeaveEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicClusterLeaveEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRBridgedDeviceBasicClusterReachableChangedEvent extends MTRBridgedDeviceBasicInformationClusterReachableChangedEvent {

	static alloc(): MTRBridgedDeviceBasicClusterReachableChangedEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicClusterReachableChangedEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRBridgedDeviceBasicClusterShutDownEvent extends MTRBridgedDeviceBasicInformationClusterShutDownEvent {

	static alloc(): MTRBridgedDeviceBasicClusterShutDownEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicClusterShutDownEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRBridgedDeviceBasicClusterStartUpEvent extends MTRBridgedDeviceBasicInformationClusterStartUpEvent {

	static alloc(): MTRBridgedDeviceBasicClusterStartUpEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicClusterStartUpEvent; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRBridgedDeviceBasicInformationClusterLeaveEvent extends NSObject implements NSCopying {

	static alloc(): MTRBridgedDeviceBasicInformationClusterLeaveEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicInformationClusterLeaveEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare class MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct extends NSObject implements NSCopying {

	static alloc(): MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicInformationClusterProductAppearanceStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	finish: number;

	/**
	 * @since 17.0
	 */
	primaryColor: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBridgedDeviceBasicInformationClusterReachableChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRBridgedDeviceBasicInformationClusterReachableChangedEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicInformationClusterReachableChangedEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	reachableNewValue: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBridgedDeviceBasicInformationClusterShutDownEvent extends NSObject implements NSCopying {

	static alloc(): MTRBridgedDeviceBasicInformationClusterShutDownEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicInformationClusterShutDownEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRBridgedDeviceBasicInformationClusterStartUpEvent extends NSObject implements NSCopying {

	static alloc(): MTRBridgedDeviceBasicInformationClusterStartUpEvent; // inherited from NSObject

	static new(): MTRBridgedDeviceBasicInformationClusterStartUpEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare const enum MTRBridgedDeviceBasicInformationColor {

	Black = 0,

	Navy = 1,

	Green = 2,

	Teal = 3,

	Maroon = 4,

	Purple = 5,

	Olive = 6,

	Gray = 7,

	Blue = 8,

	Lime = 9,

	Aqua = 10,

	Red = 11,

	Fuchsia = 12,

	Yellow = 13,

	White = 14,

	Nickel = 15,

	Chrome = 16,

	Brass = 17,

	Copper = 18,

	Silver = 19,

	Gold = 20
}

/**
 * @since 17.0
 */
declare const enum MTRBridgedDeviceBasicInformationProductFinish {

	Other = 0,

	Matte = 1,

	Satin = 2,

	Polished = 3,

	Rugged = 4,

	Fabric = 5
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonDioxideConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonDioxideConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonDioxideConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonDioxideConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonMonoxideConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonMonoxideConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonMonoxideConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRCarbonMonoxideConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.4
 */
declare class MTRCertificateInfo extends NSObject implements NSCopying {

	static alloc(): MTRCertificateInfo; // inherited from NSObject

	static new(): MTRCertificateInfo; // inherited from NSObject

	readonly issuer: MTRDistinguishedNameInfo;

	readonly notAfter: Date;

	readonly notBefore: Date;

	/**
	 * @since 18.2
	 */
	readonly publicKeyData: NSData;

	readonly subject: MTRDistinguishedNameInfo;

	constructor(o: { TLVBytes: NSData; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	initWithTLVBytes(bytes: NSData): this;
}

/**
 * @since 16.1
 */
declare class MTRCertificates extends NSObject {

	static alloc(): MTRCertificates; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static convertMatterCertificate(matterCertificate: NSData): NSData;

	static convertX509Certificate(x509Certificate: NSData): NSData;

	static createCertificateSigningRequestError(keypair: MTRKeypair): NSData;

	/**
	 * @since 16.4
	 */
	static createIntermediateCertificateRootCertificateIntermediatePublicKeyIssuerIDFabricIDError(rootKeypair: MTRKeypair, rootCertificate: NSData, intermediatePublicKey: any, issuerID: number, fabricID: number): NSData;

	/**
	 * @since 16.6
	 */
	static createIntermediateCertificateRootCertificateIntermediatePublicKeyIssuerIDFabricIDValidityPeriodError(rootKeypair: MTRKeypair, rootCertificate: NSData, intermediatePublicKey: any, issuerID: number, fabricID: number, validityPeriod: NSDateInterval): NSData;

	/**
	 * @since 16.4
	 */
	static createOperationalCertificateSigningCertificateOperationalPublicKeyFabricIDNodeIDCaseAuthenticatedTagsError(signingKeypair: MTRKeypair, signingCertificate: NSData, operationalPublicKey: any, fabricID: number, nodeID: number, caseAuthenticatedTags: NSSet<number>): NSData;

	/**
	 * @since 16.6
	 */
	static createOperationalCertificateSigningCertificateOperationalPublicKeyFabricIDNodeIDCaseAuthenticatedTagsValidityPeriodError(signingKeypair: MTRKeypair, signingCertificate: NSData, operationalPublicKey: any, fabricID: number, nodeID: number, caseAuthenticatedTags: NSSet<number>, validityPeriod: NSDateInterval): NSData;

	/**
	 * @since 16.4
	 */
	static createRootCertificateIssuerIDFabricIDError(keypair: MTRKeypair, issuerID: number, fabricID: number): NSData;

	/**
	 * @since 16.6
	 */
	static createRootCertificateIssuerIDFabricIDValidityPeriodError(keypair: MTRKeypair, issuerID: number, fabricID: number, validityPeriod: NSDateInterval): NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static generateCertificateSigningRequestError(keypair: MTRKeypair): NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static generateIntermediateCertificateRootCertificateIntermediatePublicKeyIssuerIdFabricIdError(rootKeypair: MTRKeypair, rootCertificate: NSData, intermediatePublicKey: any, issuerId: number, fabricId: number): NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static generateOperationalCertificateSigningCertificateOperationalPublicKeyFabricIdNodeIdCaseAuthenticatedTagsError(signingKeypair: MTRKeypair, signingCertificate: NSData, operationalPublicKey: any, fabricId: number, nodeId: number, caseAuthenticatedTags: NSArray<number> | number[]): NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static generateRootCertificateIssuerIdFabricIdError(keypair: MTRKeypair, issuerId: number, fabricId: number): NSData;

	static isCertificateEqualTo(certificate1: NSData, certificate2: NSData): boolean;

	static keypairMatchesCertificate(keypair: MTRKeypair, certificate: NSData): boolean;

	static new(): MTRCertificates; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static publicKeyFromCSRError(csr: NSData): NSData;
}

/**
 * @since 16.1
 */
declare class MTRChannelClusterChangeChannelByNumberParams extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterChangeChannelByNumberParams; // inherited from NSObject

	static new(): MTRChannelClusterChangeChannelByNumberParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	majorNumber: number;

	/**
	 * @since 16.1
	 */
	minorNumber: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRChannelClusterChangeChannelParams extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterChangeChannelParams; // inherited from NSObject

	static new(): MTRChannelClusterChangeChannelParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	match: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRChannelClusterChangeChannelResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterChangeChannelResponseParams; // inherited from NSObject

	static new(): MTRChannelClusterChangeChannelResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	data: string;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRChannelClusterChannelInfo extends MTRChannelClusterChannelInfoStruct {

	static alloc(): MTRChannelClusterChannelInfo; // inherited from NSObject

	static new(): MTRChannelClusterChannelInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRChannelClusterChannelInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterChannelInfoStruct; // inherited from NSObject

	static new(): MTRChannelClusterChannelInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	affiliateCallSign: string;

	/**
	 * @since 16.4
	 */
	callSign: string;

	/**
	 * @since 16.4
	 */
	majorNumber: number;

	/**
	 * @since 16.4
	 */
	minorNumber: number;

	/**
	 * @since 16.4
	 */
	name: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRChannelClusterLineupInfo extends MTRChannelClusterLineupInfoStruct {

	static alloc(): MTRChannelClusterLineupInfo; // inherited from NSObject

	static new(): MTRChannelClusterLineupInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRChannelClusterLineupInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterLineupInfoStruct; // inherited from NSObject

	static new(): MTRChannelClusterLineupInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	lineupInfoType: number;

	/**
	 * @since 16.4
	 */
	lineupName: string;

	/**
	 * @since 16.4
	 */
	operatorName: string;

	/**
	 * @since 16.4
	 */
	postalCode: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRChannelClusterSkipChannelParams extends NSObject implements NSCopying {

	static alloc(): MTRChannelClusterSkipChannelParams; // inherited from NSObject

	static new(): MTRChannelClusterSkipChannelParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	count: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRChannelFeature {

	ChannelList = 1,

	LineupInfo = 2,

	ElectronicGuide = 4,

	RecordProgram = 8
}

/**
 * @since 16.1
 */
declare const enum MTRChannelLineupInfoType {

	MSO = 0,

	Mso = 0
}

/**
 * @since 16.1
 */
declare const enum MTRChannelStatus {

	Success = 0,

	MultipleMatches = 1,

	NoMatches = 2
}

/**
 * @since 16.1
 */
declare class MTRCluster extends NSObject {

	static alloc(): MTRCluster; // inherited from NSObject

	static new(): MTRCluster; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	readonly endpointID: number;
}

/**
 * @since 16.1
 */
declare class MTRClusterAccessControl extends MTRGenericCluster {

	static alloc(): MTRClusterAccessControl; // inherited from NSObject

	static new(): MTRClusterAccessControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeACLWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAccessControlEntriesPerFabricWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeAclWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeExtensionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSubjectsPerAccessControlEntryWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTargetsPerAccessControlEntryWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	writeAttributeACLWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeACLWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAclWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeAclWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeExtensionWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeExtensionWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterAccountLogin extends MTRGenericCluster {

	static alloc(): MTRClusterAccountLogin; // inherited from NSObject

	static new(): MTRClusterAccountLogin; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	getSetupPINWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAccountLoginClusterGetSetupPINParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRAccountLoginClusterGetSetupPINResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getSetupPINWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAccountLoginClusterGetSetupPINParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRAccountLoginClusterGetSetupPINResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	loginWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAccountLoginClusterLoginParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	loginWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAccountLoginClusterLoginParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	logoutWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	logoutWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	logoutWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAccountLoginClusterLogoutParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	logoutWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAccountLoginClusterLogoutParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterActions extends MTRGenericCluster {

	static alloc(): MTRClusterActions; // inherited from NSObject

	static new(): MTRClusterActions; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	disableActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterDisableActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	disableActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterDisableActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	disableActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterDisableActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	disableActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterDisableActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enableActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterEnableActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enableActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterEnableActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enableActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterEnableActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enableActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterEnableActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	instantActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterInstantActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	instantActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterInstantActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	instantActionWithTransitionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterInstantActionWithTransitionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	instantActionWithTransitionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterInstantActionWithTransitionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterPauseActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterPauseActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterPauseActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterPauseActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActionListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEndpointListsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSetupURLWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	resumeActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterResumeActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resumeActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterResumeActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterStartActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startActionWithDurationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterStartActionWithDurationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterStartActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterStartActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopActionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActionsClusterStopActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopActionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRActionsClusterStopActionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterActivatedCarbonFilterMonitoring extends MTRGenericCluster {

	static alloc(): MTRClusterActivatedCarbonFilterMonitoring; // inherited from NSObject

	static new(): MTRClusterActivatedCarbonFilterMonitoring; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeChangeIndicationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeConditionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDegradationDirectionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeInPlaceIndicatorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLastChangedTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeReplacementProductListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	resetConditionWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRActivatedCarbonFilterMonitoringClusterResetConditionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterAdministratorCommissioning extends MTRGenericCluster {

	static alloc(): MTRClusterAdministratorCommissioning; // inherited from NSObject

	static new(): MTRClusterAdministratorCommissioning; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	openBasicCommissioningWindowWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openBasicCommissioningWindowWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAdministratorCommissioningClusterOpenBasicCommissioningWindowParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	openCommissioningWindowWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAdministratorCommissioningClusterOpenCommissioningWindowParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openCommissioningWindowWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAdministratorCommissioningClusterOpenCommissioningWindowParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAdminFabricIndexWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAdminVendorIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWindowStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	revokeCommissioningWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	revokeCommissioningWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	revokeCommissioningWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAdministratorCommissioningClusterRevokeCommissioningParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	revokeCommissioningWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAdministratorCommissioningClusterRevokeCommissioningParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterAirQuality extends MTRGenericCluster {

	static alloc(): MTRClusterAirQuality; // inherited from NSObject

	static new(): MTRClusterAirQuality; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAirQualityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterApplicationBasic extends MTRGenericCluster {

	static alloc(): MTRClusterApplicationBasic; // inherited from NSObject

	static new(): MTRClusterApplicationBasic; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAllowedVendorListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeApplicationNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeApplicationVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeApplicationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeProductIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeVendorIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeVendorNameWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterApplicationLauncher extends MTRGenericCluster {

	static alloc(): MTRClusterApplicationLauncher; // inherited from NSObject

	static new(): MTRClusterApplicationLauncher; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	hideAppWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	hideAppWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRApplicationLauncherClusterHideAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideAppWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRApplicationLauncherClusterHideAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	launchAppWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	launchAppWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRApplicationLauncherClusterLaunchAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchAppWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRApplicationLauncherClusterLaunchAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCatalogListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentAppWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	stopAppWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopAppWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRApplicationLauncherClusterStopAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopAppWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRApplicationLauncherClusterStopAppParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRApplicationLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeCurrentAppWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeCurrentAppWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterAudioOutput extends MTRGenericCluster {

	static alloc(): MTRClusterAudioOutput; // inherited from NSObject

	static new(): MTRClusterAudioOutput; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentOutputWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOutputListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	renameOutputWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAudioOutputClusterRenameOutputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	renameOutputWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAudioOutputClusterRenameOutputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	selectOutputWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRAudioOutputClusterSelectOutputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	selectOutputWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRAudioOutputClusterSelectOutputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterBallastConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterBallastConfiguration; // inherited from NSObject

	static new(): MTRClusterBallastConfiguration; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBallastFactorAdjustmentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBallastStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeIntrinsicBalanceFactorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeIntrinsicBallastFactorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampAlarmModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampBurnHoursTripPointWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampBurnHoursWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampManufacturerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampQuantityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampRatedHoursWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLampTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalMaxLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalMinLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeBallastFactorAdjustmentWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeBallastFactorAdjustmentWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIntrinsicBalanceFactorWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeIntrinsicBalanceFactorWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIntrinsicBallastFactorWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeIntrinsicBallastFactorWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampAlarmModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampAlarmModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampBurnHoursTripPointWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampBurnHoursTripPointWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampBurnHoursWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampBurnHoursWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampManufacturerWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampManufacturerWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampRatedHoursWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampRatedHoursWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampTypeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLampTypeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRClusterBarrierControl extends MTRGenericCluster {

	static alloc(): MTRClusterBarrierControl; // inherited from NSObject

	static new(): MTRClusterBarrierControl; // inherited from NSObject

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlGoToPercentWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRBarrierControlClusterBarrierControlGoToPercentParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlGoToPercentWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRBarrierControlClusterBarrierControlGoToPercentParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlStopWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlStopWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	barrierControlStopWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRBarrierControlClusterBarrierControlStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	barrierControlStopWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRBarrierControlClusterBarrierControlStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierCapabilitiesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierCloseEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierClosePeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierCommandCloseEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierCommandOpenEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierMovingStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierOpenEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierOpenPeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierPositionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeBarrierSafetyStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCloseEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCloseEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierClosePeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierClosePeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandCloseEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandCloseEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandOpenEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierCommandOpenEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenPeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeBarrierOpenPeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRClusterBasic extends MTRClusterBasicInformation {

	static alloc(): MTRClusterBasic; // inherited from NSObject

	static new(): MTRClusterBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	mfgSpecificPingWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	mfgSpecificPingWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRBasicClusterMfgSpecificPingParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRClusterBasicInformation extends MTRGenericCluster {

	static alloc(): MTRClusterBasicInformation; // inherited from NSObject

	static new(): MTRClusterBasicInformation; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeCapabilityMinimaWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeDataModelRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeLocalConfigDisabledWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeLocationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeManufacturingDateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNodeLabelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributePartNumberWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.0
	 */
	readAttributeProductAppearanceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductLabelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductURLWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeReachableWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSerialNumberWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUniqueIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeVendorNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocalConfigDisabledWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLocationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRClusterBinaryInputBasic extends MTRGenericCluster {

	static alloc(): MTRClusterBinaryInputBasic; // inherited from NSObject

	static new(): MTRClusterBinaryInputBasic; // inherited from NSObject

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActiveTextWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeApplicationTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDescriptionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInactiveTextWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeOutOfServiceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePolarityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePresentValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReliabilityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeStatusFlagsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeActiveTextWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeActiveTextWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeDescriptionWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeDescriptionWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeInactiveTextWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeInactiveTextWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeOutOfServiceWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeOutOfServiceWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributePresentValueWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributePresentValueWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeReliabilityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeReliabilityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterBinding extends MTRGenericCluster {

	static alloc(): MTRClusterBinding; // inherited from NSObject

	static new(): MTRClusterBinding; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBindingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeBindingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeBindingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterBooleanState extends MTRGenericCluster {

	static alloc(): MTRClusterBooleanState; // inherited from NSObject

	static new(): MTRClusterBooleanState; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStateValueWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterBooleanStateConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterBooleanStateConfiguration; // inherited from NSObject

	static new(): MTRClusterBooleanStateConfiguration; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	enableDisableAlarmWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRBooleanStateConfigurationClusterEnableDisableAlarmParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsActiveWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsEnabledWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsSupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAlarmsSuppressedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentSensitivityLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultSensitivityLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeSensorFaultWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeSupportedSensitivityLevelsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	suppressAlarmWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRBooleanStateConfigurationClusterSuppressAlarmParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeCurrentSensitivityLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeCurrentSensitivityLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRClusterBridgedDeviceBasic extends MTRClusterBridgedDeviceBasicInformation {

	static alloc(): MTRClusterBridgedDeviceBasic; // inherited from NSObject

	static new(): MTRClusterBridgedDeviceBasic; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;
}

/**
 * @since 16.4
 */
declare class MTRClusterBridgedDeviceBasicInformation extends MTRGenericCluster {

	static alloc(): MTRClusterBridgedDeviceBasicInformation; // inherited from NSObject

	static new(): MTRClusterBridgedDeviceBasicInformation; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeHardwareVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeManufacturingDateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNodeLabelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributePartNumberWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.0
	 */
	readAttributeProductAppearanceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductLabelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeProductURLWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeReachableWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSerialNumberWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeSoftwareVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUniqueIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeVendorNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNodeLabelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterCarbonDioxideConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterCarbonDioxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterCarbonDioxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterCarbonMonoxideConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterCarbonMonoxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterCarbonMonoxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterChannel extends MTRGenericCluster {

	static alloc(): MTRClusterChannel; // inherited from NSObject

	static new(): MTRClusterChannel; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	changeChannelByNumberWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRChannelClusterChangeChannelByNumberParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeChannelByNumberWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRChannelClusterChangeChannelByNumberParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	changeChannelWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRChannelClusterChangeChannelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRChannelClusterChangeChannelResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeChannelWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRChannelClusterChangeChannelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRChannelClusterChangeChannelResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeChannelListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentChannelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLineupWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	skipChannelWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRChannelClusterSkipChannelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipChannelWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRChannelClusterSkipChannelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterColorControl extends MTRGenericCluster {

	static alloc(): MTRClusterColorControl; // inherited from NSObject

	static new(): MTRClusterColorControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	colorLoopSetWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterColorLoopSetParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	colorLoopSetWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterColorLoopSetParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterEnhancedMoveHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterEnhancedMoveHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveToHueAndSaturationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterEnhancedMoveToHueAndSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveToHueAndSaturationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterEnhancedMoveToHueAndSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedMoveToHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterEnhancedMoveToHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedMoveToHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterEnhancedMoveToHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	enhancedStepHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterEnhancedStepHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	enhancedStepHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterEnhancedStepHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	moveColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveColorWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveColorWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveSaturationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveSaturationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveToColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveToColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToColorWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveToColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToColorWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveToColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToHueAndSaturationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveToHueAndSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToHueAndSaturationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveToHueAndSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveToHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveToHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToSaturationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterMoveToSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToSaturationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterMoveToSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorCapabilitiesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorLoopActiveWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorLoopDirectionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorLoopStartEnhancedHueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorLoopStoredEnhancedHueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorLoopTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointBIntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointBXWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointBYWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointGIntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointGXWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointGYWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointRIntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointRXWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorPointRYWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorTempPhysicalMaxMiredsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorTempPhysicalMinMiredsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeColorTemperatureMiredsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCompensationTextWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCoupleColorTempToLevelMinMiredsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentHueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentSaturationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentXWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentYWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDriftCompensationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnhancedColorModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnhancedCurrentHueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfPrimariesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOptionsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary1IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary1XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary1YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary2IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary2XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary2YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary3IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary3XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary3YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary4IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary4XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary4YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary5IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary5XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary5YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary6IntensityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary6XWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePrimary6YWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRemainingTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartUpColorTemperatureMiredsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWhitePointXWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWhitePointYWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	stepColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterStepColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepColorTemperatureWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterStepColorTemperatureParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepColorWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterStepColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepColorWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterStepColorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepHueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterStepHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepHueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterStepHueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepSaturationWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterStepSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepSaturationWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterStepSaturationParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopMoveStepWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRColorControlClusterStopMoveStepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMoveStepWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRColorControlClusterStopMoveStepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBIntensityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBIntensityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBXWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBXWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBYWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointBYWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGIntensityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGIntensityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGXWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGXWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGYWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointGYWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRIntensityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRIntensityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRXWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRXWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRYWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeColorPointRYWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOptionsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOptionsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpColorTemperatureMiredsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWhitePointXWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWhitePointXWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWhitePointYWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWhitePointYWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterContentLauncher extends MTRGenericCluster {

	static alloc(): MTRClusterContentLauncher; // inherited from NSObject

	static new(): MTRClusterContentLauncher; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	launchContentWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRContentLauncherClusterLaunchContentParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRContentLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchContentWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRContentLauncherClusterLaunchContentParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRContentLauncherClusterLaunchResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	launchURLWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRContentLauncherClusterLaunchURLParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRContentLauncherClusterLauncherResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	launchURLWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRContentLauncherClusterLaunchURLParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRContentLauncherClusterLaunchResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptHeaderWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedStreamingProtocolsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeSupportedStreamingProtocolsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSupportedStreamingProtocolsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterDescriptor extends MTRGenericCluster {

	static alloc(): MTRClusterDescriptor; // inherited from NSObject

	static new(): MTRClusterDescriptor; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClientListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDeviceListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeDeviceTypeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePartsListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeServerListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterDiagnosticLogs extends MTRGenericCluster {

	static alloc(): MTRClusterDiagnosticLogs; // inherited from NSObject

	static new(): MTRClusterDiagnosticLogs; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	retrieveLogsRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDiagnosticLogsClusterRetrieveLogsRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDiagnosticLogsClusterRetrieveLogsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	retrieveLogsRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDiagnosticLogsClusterRetrieveLogsRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDiagnosticLogsClusterRetrieveLogsResponseParams, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterDoorLock extends MTRGenericCluster {

	static alloc(): MTRClusterDoorLock; // inherited from NSObject

	static new(): MTRClusterDoorLock; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	clearCredentialWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterClearCredentialParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearCredentialWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterClearCredentialParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterClearHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterClearHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearUserWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterClearUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearUserWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterClearUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterClearWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterClearWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterClearYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterClearYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getCredentialStatusWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterGetCredentialStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterGetCredentialStatusResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getCredentialStatusWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterGetCredentialStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterGetCredentialStatusResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterGetHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterGetHolidayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterGetHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterGetHolidayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getUserWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterGetUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterGetUserResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getUserWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterGetUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterGetUserResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterGetWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterGetWeekDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterGetWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterGetWeekDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterGetYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterGetYearDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterGetYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterGetYearDayScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	lockDoorWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	lockDoorWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterLockDoorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	lockDoorWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterLockDoorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActuatorEnabledWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAutoRelockTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCredentialRulesSupportWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDefaultConfigurationRegisterWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDoorClosedEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDoorOpenEventsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDoorStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnableInsideStatusLEDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnableLocalProgrammingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnableOneTouchLockingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEnablePrivacyModeButtonWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeExpiringUserTimeoutWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLEDSettingsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLanguageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLocalProgrammingFeaturesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLockStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLockTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxPINCodeLengthWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxRFIDCodeLengthWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinPINCodeLengthWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinRFIDCodeLengthWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfCredentialsSupportedPerUserWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfHolidaySchedulesSupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfPINUsersSupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfRFIDUsersSupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfTotalUsersSupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfWeekDaySchedulesSupportedPerUserWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfYearDaySchedulesSupportedPerUserWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOpenPeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOperatingModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRequirePINforRemoteOperationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSendPINOverTheAirWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSoundVolumeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedOperatingModesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUserCodeTemporaryDisableTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWrongCodeEntryLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	setCredentialWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterSetCredentialParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRDoorLockClusterSetCredentialResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setCredentialWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterSetCredentialParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRDoorLockClusterSetCredentialResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterSetHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setHolidayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterSetHolidayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setUserWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterSetUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setUserWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterSetUserParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterSetWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setWeekDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterSetWeekDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterSetYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setYearDayScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterSetYearDayScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	unlockDoorWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	unlockDoorWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterUnlockDoorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	unlockDoorWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterUnlockDoorParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	unlockWithTimeoutWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRDoorLockClusterUnlockWithTimeoutParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	unlockWithTimeoutWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRDoorLockClusterUnlockWithTimeoutParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeAutoRelockTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeAutoRelockTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDoorClosedEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDoorClosedEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDoorOpenEventsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDoorOpenEventsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableInsideStatusLEDWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableInsideStatusLEDWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableLocalProgrammingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableLocalProgrammingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableOneTouchLockingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnableOneTouchLockingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnablePrivacyModeButtonWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEnablePrivacyModeButtonWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeExpiringUserTimeoutWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeExpiringUserTimeoutWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLEDSettingsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLEDSettingsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLanguageWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLanguageWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLocalProgrammingFeaturesWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLocalProgrammingFeaturesWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOpenPeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOpenPeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOperatingModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOperatingModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRequirePINforRemoteOperationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRequirePINforRemoteOperationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSendPINOverTheAirWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSendPINOverTheAirWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSoundVolumeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSoundVolumeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUserCodeTemporaryDisableTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWrongCodeEntryLimitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWrongCodeEntryLimitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterElectricalEnergyMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterElectricalEnergyMeasurement; // inherited from NSObject

	static new(): MTRClusterElectricalEnergyMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAccuracyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyExportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyImportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCumulativeEnergyResetWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeriodicEnergyExportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeriodicEnergyImportedWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRClusterElectricalMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterElectricalMeasurement; // inherited from NSObject

	static new(): MTRClusterElectricalMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getMeasurementProfileCommandWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getMeasurementProfileCommandWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getProfileInfoCommandWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getProfileInfoCommandWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	getProfileInfoCommandWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRElectricalMeasurementClusterGetProfileInfoCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getProfileInfoCommandWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRElectricalMeasurementClusterGetProfileInfoCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcActivePowerOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcCurrentOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcOverloadAlarmsMaskWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcPowerDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcPowerMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcReactivePowerOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcVoltageOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActiveCurrentPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActiveCurrentPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeActivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeApparentPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageCounterPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsOverVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageCounterWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsUnderVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAverageRmsVoltageMeasurementPeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeCurrentOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcPowerDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcPowerMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeDcVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeHarmonicCurrentMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousActiveCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousLineCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousReactiveCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeInstantaneousVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeLineCurrentPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeLineCurrentPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured11thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured1stHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured3rdHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured5thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured7thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasured9thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase11thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase1stHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase3rdHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase5thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase7thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasuredPhase9thHarmonicCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeMeasurementTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeNeutralCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeOverloadAlarmsMaskWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePhaseHarmonicCurrentMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePowerDivisorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePowerFactorPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePowerFactorPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePowerFactorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributePowerMultiplierWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReactiveCurrentPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReactiveCurrentPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeReactivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltagePeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeOverVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltagePeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsExtremeUnderVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltagePhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltagePhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagPeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSagWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodPhaseBWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodPhaseCWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellPeriodWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageSwellWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeRmsVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeTotalActivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeTotalApparentPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeTotalReactivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeVoltageOverloadWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAcOverloadAlarmsMaskWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsUnderVoltageCounterWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeAverageRmsVoltageMeasurementPeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeOverloadAlarmsMaskWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeOverloadAlarmsMaskWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeOverVoltagePeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsExtremeUnderVoltagePeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSagPeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSagPeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeRmsVoltageSwellPeriodWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterElectricalPowerMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterElectricalPowerMeasurement; // inherited from NSObject

	static new(): MTRClusterElectricalPowerMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAccuracyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeActiveCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeActivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeApparentCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeApparentPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeHarmonicCurrentsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeHarmonicPhasesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeNeutralCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeNumberOfMeasurementTypesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePowerFactorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePowerModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeRMSCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeRMSPowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeRMSVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeRangesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeReactiveCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeReactivePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterEthernetNetworkDiagnostics extends MTRGenericCluster {

	static alloc(): MTRClusterEthernetNetworkDiagnostics; // inherited from NSObject

	static new(): MTRClusterEthernetNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCarrierDetectWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCollisionCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFullDuplexWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOverrunCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePHYRateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketRxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketTxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTimeSinceResetWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxErrCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTREthernetNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTREthernetNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterFanControl extends MTRGenericCluster {

	static alloc(): MTRClusterFanControl; // inherited from NSObject

	static new(): MTRClusterFanControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAirflowDirectionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFanModeSequenceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFanModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePercentCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePercentSettingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRockSettingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRockSupportWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSpeedCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSpeedMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSpeedSettingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWindSettingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWindSupportWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	stepWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRFanControlClusterStepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeAirflowDirectionWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeAirflowDirectionWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeFanModeSequenceWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeFanModeSequenceWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeFanModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeFanModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributePercentSettingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributePercentSettingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRockSettingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRockSettingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSpeedSettingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSpeedSettingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWindSettingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeWindSettingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterFixedLabel extends MTRGenericCluster {

	static alloc(): MTRClusterFixedLabel; // inherited from NSObject

	static new(): MTRClusterFixedLabel; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLabelListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterFlowMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterFlowMeasurement; // inherited from NSObject

	static new(): MTRClusterFlowMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterFormaldehydeConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterFormaldehydeConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterFormaldehydeConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterGeneralCommissioning extends MTRGenericCluster {

	static alloc(): MTRClusterGeneralCommissioning; // inherited from NSObject

	static new(): MTRClusterGeneralCommissioning; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	armFailSafeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGeneralCommissioningClusterArmFailSafeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGeneralCommissioningClusterArmFailSafeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	armFailSafeWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGeneralCommissioningClusterArmFailSafeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGeneralCommissioningClusterArmFailSafeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	commissioningCompleteWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	commissioningCompleteWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	commissioningCompleteWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGeneralCommissioningClusterCommissioningCompleteParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	commissioningCompleteWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGeneralCommissioningClusterCommissioningCompleteParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGeneralCommissioningClusterCommissioningCompleteResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBasicCommissioningInfoWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBreadcrumbWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLocationCapabilityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRegulatoryConfigWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportsConcurrentConnectionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	setRegulatoryConfigWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGeneralCommissioningClusterSetRegulatoryConfigParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setRegulatoryConfigWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGeneralCommissioningClusterSetRegulatoryConfigParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeBreadcrumbWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeBreadcrumbWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterGeneralDiagnostics extends MTRGenericCluster {

	static alloc(): MTRClusterGeneralDiagnostics; // inherited from NSObject

	static new(): MTRClusterGeneralDiagnostics; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveHardwareFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveNetworkFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveRadioFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBootReasonWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBootReasonsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNetworkInterfacesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRebootCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTestEventTriggersEnabledWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTotalOperationalHoursWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUpTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	testEventTriggerWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGeneralDiagnosticsClusterTestEventTriggerParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEventTriggerWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGeneralDiagnosticsClusterTestEventTriggerParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterGroupKeyManagement extends MTRGenericCluster {

	static alloc(): MTRClusterGroupKeyManagement; // inherited from NSObject

	static new(): MTRClusterGroupKeyManagement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.0
	 */
	keySetReadAllIndicesWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetReadAllIndicesWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupKeyManagementClusterKeySetReadAllIndicesParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetReadAllIndicesWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupKeyManagementClusterKeySetReadAllIndicesParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetReadWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupKeyManagementClusterKeySetReadParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupKeyManagementClusterKeySetReadResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetReadWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupKeyManagementClusterKeySetReadParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupKeyManagementClusterKeySetReadResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetRemoveWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupKeyManagementClusterKeySetRemoveParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetRemoveWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupKeyManagementClusterKeySetRemoveParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	keySetWriteWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupKeyManagementClusterKeySetWriteParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keySetWriteWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupKeyManagementClusterKeySetWriteParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGroupKeyMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGroupTableWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxGroupKeysPerFabricWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxGroupsPerFabricWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeGroupKeyMapWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeGroupKeyMapWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterGroups extends MTRGenericCluster {

	static alloc(): MTRClusterGroups; // inherited from NSObject

	static new(): MTRClusterGroups; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	addGroupIfIdentifyingWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterAddGroupIfIdentifyingParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addGroupIfIdentifyingWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterAddGroupIfIdentifyingParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addGroupWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterAddGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupsClusterAddGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addGroupWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterAddGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupsClusterAddGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getGroupMembershipWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterGetGroupMembershipParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupsClusterGetGroupMembershipResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getGroupMembershipWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterGetGroupMembershipParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupsClusterGetGroupMembershipResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNameSupportWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	removeAllGroupsWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeAllGroupsWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeAllGroupsWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterRemoveAllGroupsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeAllGroupsWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterRemoveAllGroupsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	removeGroupWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterRemoveGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupsClusterRemoveGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeGroupWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterRemoveGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupsClusterRemoveGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	viewGroupWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRGroupsClusterViewGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRGroupsClusterViewGroupResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	viewGroupWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRGroupsClusterViewGroupParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRGroupsClusterViewGroupResponseParams, p2: NSError) => void): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterHEPAFilterMonitoring extends MTRGenericCluster {

	static alloc(): MTRClusterHEPAFilterMonitoring; // inherited from NSObject

	static new(): MTRClusterHEPAFilterMonitoring; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeChangeIndicationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeConditionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDegradationDirectionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeInPlaceIndicatorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLastChangedTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeReplacementProductListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	resetConditionWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	resetConditionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRHEPAFilterMonitoringClusterResetConditionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeLastChangedTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

declare const enum MTRClusterIDType {

	IdentifyID = 3,

	GroupsID = 4,

	OnOffID = 6,

	LevelControlID = 8,

	PulseWidthModulationID = 28,

	DescriptorID = 29,

	BindingID = 30,

	AccessControlID = 31,

	ActionsID = 37,

	BasicID = 40,

	OtaSoftwareUpdateProviderID = 41,

	OtaSoftwareUpdateRequestorID = 42,

	LocalizationConfigurationID = 43,

	TimeFormatLocalizationID = 44,

	UnitLocalizationID = 45,

	PowerSourceConfigurationID = 46,

	PowerSourceID = 47,

	GeneralCommissioningID = 48,

	NetworkCommissioningID = 49,

	DiagnosticLogsID = 50,

	GeneralDiagnosticsID = 51,

	SoftwareDiagnosticsID = 52,

	ThreadNetworkDiagnosticsID = 53,

	WiFiNetworkDiagnosticsID = 54,

	EthernetNetworkDiagnosticsID = 55,

	TimeSynchronizationID = 56,

	BridgedDeviceBasicID = 57,

	SwitchID = 59,

	AdministratorCommissioningID = 60,

	OperationalCredentialsID = 62,

	GroupKeyManagementID = 63,

	FixedLabelID = 64,

	UserLabelID = 65,

	BooleanStateID = 69,

	ModeSelectID = 80,

	DoorLockID = 257,

	WindowCoveringID = 258,

	PumpConfigurationAndControlID = 512,

	ThermostatID = 513,

	FanControlID = 514,

	ThermostatUserInterfaceConfigurationID = 516,

	ColorControlID = 768,

	BallastConfigurationID = 769,

	IlluminanceMeasurementID = 1024,

	TemperatureMeasurementID = 1026,

	PressureMeasurementID = 1027,

	FlowMeasurementID = 1028,

	RelativeHumidityMeasurementID = 1029,

	OccupancySensingID = 1030,

	WakeOnLanID = 1283,

	ChannelID = 1284,

	TargetNavigatorID = 1285,

	MediaPlaybackID = 1286,

	MediaInputID = 1287,

	LowPowerID = 1288,

	KeypadInputID = 1289,

	ContentLauncherID = 1290,

	AudioOutputID = 1291,

	ApplicationLauncherID = 1292,

	ApplicationBasicID = 1293,

	AccountLoginID = 1294,

	TestClusterID = 4294048773,

	IDTypeAppleDeviceInformationID = 323615744,

	IDTypeAppleLockClusterID = 323615747,

	IDTypeIdentifyID = 3,

	IDTypeGroupsID = 4,

	IDTypeOnOffID = 6,

	IDTypeLevelControlID = 8,

	IDTypePulseWidthModulationID = 28,

	IDTypeDescriptorID = 29,

	IDTypeBindingID = 30,

	IDTypeAccessControlID = 31,

	IDTypeActionsID = 37,

	IDTypeBasicInformationID = 40,

	IDTypeOTASoftwareUpdateProviderID = 41,

	IDTypeOTASoftwareUpdateRequestorID = 42,

	IDTypeLocalizationConfigurationID = 43,

	IDTypeTimeFormatLocalizationID = 44,

	IDTypeUnitLocalizationID = 45,

	IDTypePowerSourceConfigurationID = 46,

	IDTypePowerSourceID = 47,

	IDTypeGeneralCommissioningID = 48,

	IDTypeNetworkCommissioningID = 49,

	IDTypeDiagnosticLogsID = 50,

	IDTypeGeneralDiagnosticsID = 51,

	IDTypeSoftwareDiagnosticsID = 52,

	IDTypeThreadNetworkDiagnosticsID = 53,

	IDTypeWiFiNetworkDiagnosticsID = 54,

	IDTypeEthernetNetworkDiagnosticsID = 55,

	IDTypeTimeSynchronizationID = 56,

	IDTypeBridgedDeviceBasicInformationID = 57,

	IDTypeSwitchID = 59,

	IDTypeAdministratorCommissioningID = 60,

	IDTypeOperationalCredentialsID = 62,

	IDTypeGroupKeyManagementID = 63,

	IDTypeFixedLabelID = 64,

	IDTypeUserLabelID = 65,

	IDTypeBooleanStateID = 69,

	IDTypeICDManagementID = 70,

	IDTypeTimerID = 71,

	IDTypeOvenCavityOperationalStateID = 72,

	IDTypeOvenModeID = 73,

	IDTypeLaundryDryerControlsID = 74,

	IDTypeModeSelectID = 80,

	IDTypeLaundryWasherModeID = 81,

	IDTypeRefrigeratorAndTemperatureControlledCabinetModeID = 82,

	IDTypeLaundryWasherControlsID = 83,

	IDTypeRVCRunModeID = 84,

	IDTypeRVCCleanModeID = 85,

	IDTypeTemperatureControlID = 86,

	IDTypeRefrigeratorAlarmID = 87,

	IDTypeDishwasherModeID = 89,

	IDTypeAirQualityID = 91,

	IDTypeSmokeCOAlarmID = 92,

	IDTypeDishwasherAlarmID = 93,

	IDTypeMicrowaveOvenModeID = 94,

	IDTypeMicrowaveOvenControlID = 95,

	IDTypeOperationalStateID = 96,

	IDTypeRVCOperationalStateID = 97,

	IDTypeScenesManagementID = 98,

	IDTypeHEPAFilterMonitoringID = 113,

	IDTypeActivatedCarbonFilterMonitoringID = 114,

	IDTypeBooleanStateConfigurationID = 128,

	IDTypeValveConfigurationAndControlID = 129,

	IDTypeElectricalPowerMeasurementID = 144,

	IDTypeElectricalEnergyMeasurementID = 145,

	IDTypeWaterHeaterManagementID = 148,

	IDTypeDemandResponseLoadControlID = 150,

	IDTypeMessagesID = 151,

	IDTypeDeviceEnergyManagementID = 152,

	IDTypeEnergyEVSEID = 153,

	IDTypeEnergyPreferenceID = 155,

	IDTypePowerTopologyID = 156,

	IDTypeEnergyEVSEModeID = 157,

	IDTypeWaterHeaterModeID = 158,

	IDTypeDeviceEnergyManagementModeID = 159,

	IDTypeDoorLockID = 257,

	IDTypeWindowCoveringID = 258,

	IDTypeServiceAreaID = 336,

	IDTypePumpConfigurationAndControlID = 512,

	IDTypeThermostatID = 513,

	IDTypeFanControlID = 514,

	IDTypeThermostatUserInterfaceConfigurationID = 516,

	IDTypeColorControlID = 768,

	IDTypeBallastConfigurationID = 769,

	IDTypeIlluminanceMeasurementID = 1024,

	IDTypeTemperatureMeasurementID = 1026,

	IDTypePressureMeasurementID = 1027,

	IDTypeFlowMeasurementID = 1028,

	IDTypeRelativeHumidityMeasurementID = 1029,

	IDTypeOccupancySensingID = 1030,

	IDTypeCarbonMonoxideConcentrationMeasurementID = 1036,

	IDTypeCarbonDioxideConcentrationMeasurementID = 1037,

	IDTypeNitrogenDioxideConcentrationMeasurementID = 1043,

	IDTypeOzoneConcentrationMeasurementID = 1045,

	IDTypePM25ConcentrationMeasurementID = 1066,

	IDTypeFormaldehydeConcentrationMeasurementID = 1067,

	IDTypePM1ConcentrationMeasurementID = 1068,

	IDTypePM10ConcentrationMeasurementID = 1069,

	IDTypeTotalVolatileOrganicCompoundsConcentrationMeasurementID = 1070,

	IDTypeRadonConcentrationMeasurementID = 1071,

	IDTypeWiFiNetworkManagementID = 1105,

	IDTypeThreadBorderRouterManagementID = 1106,

	IDTypeThreadNetworkDirectoryID = 1107,

	IDTypeWakeOnLANID = 1283,

	IDTypeChannelID = 1284,

	IDTypeTargetNavigatorID = 1285,

	IDTypeMediaPlaybackID = 1286,

	IDTypeMediaInputID = 1287,

	IDTypeLowPowerID = 1288,

	IDTypeKeypadInputID = 1289,

	IDTypeContentLauncherID = 1290,

	IDTypeAudioOutputID = 1291,

	IDTypeApplicationLauncherID = 1292,

	IDTypeApplicationBasicID = 1293,

	IDTypeAccountLoginID = 1294,

	IDTypeContentControlID = 1295,

	IDTypeContentAppObserverID = 1296,

	IDTypeZoneManagementID = 1360,

	IDTypeCameraAVStreamManagementID = 1361,

	IDTypeWebRTCTransportProviderID = 1363,

	IDTypeWebRTCTransportRequestorID = 1364,

	IDTypeChimeID = 1366,

	IDTypeEcosystemInformationID = 1872,

	IDTypeCommissionerControlID = 1873,

	IDTypeUnitTestingID = 4294048773,

	IDTypeSampleMEIID = 4294048800,

	BarrierControlID = 259,

	IDTypeBarrierControlID = 259,

	BinaryInputBasicID = 15,

	IDTypeBinaryInputBasicID = 15,

	ElectricalMeasurementID = 2820,

	IDTypeElectricalMeasurementID = 2820,

	OnOffSwitchConfigurationID = 7,

	IDTypeOnOffSwitchConfigurationID = 7
}

/**
 * @since 16.1
 */
declare class MTRClusterIdentify extends MTRGenericCluster {

	static alloc(): MTRClusterIdentify; // inherited from NSObject

	static new(): MTRClusterIdentify; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	identifyWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRIdentifyClusterIdentifyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	identifyWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRIdentifyClusterIdentifyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeIdentifyTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeIdentifyTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	triggerEffectWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRIdentifyClusterTriggerEffectParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	triggerEffectWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRIdentifyClusterTriggerEffectParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeIdentifyTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeIdentifyTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterIlluminanceMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterIlluminanceMeasurement; // inherited from NSObject

	static new(): MTRClusterIlluminanceMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLightSensorTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterKeypadInput extends MTRGenericCluster {

	static alloc(): MTRClusterKeypadInput; // inherited from NSObject

	static new(): MTRClusterKeypadInput; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	sendKeyWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRKeypadInputClusterSendKeyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRKeypadInputClusterSendKeyResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sendKeyWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRKeypadInputClusterSendKeyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRKeypadInputClusterSendKeyResponseParams, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterLevelControl extends MTRGenericCluster {

	static alloc(): MTRClusterLevelControl; // inherited from NSObject

	static new(): MTRClusterLevelControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	moveToClosestFrequencyWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterMoveToClosestFrequencyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToClosestFrequencyWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterMoveToClosestFrequencyParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToLevelWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterMoveToLevelWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToLevelWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterMoveToLevelWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveToLevelWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterMoveToLevelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveToLevelWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterMoveToLevelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterMoveWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterMoveWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	moveWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterMoveParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	moveWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterMoveParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDefaultMoveRateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOffTransitionTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnOffTransitionTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnTransitionTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOptionsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRemainingTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartUpCurrentLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	stepWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterStepWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterStepWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stepWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterStepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stepWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterStepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterStopWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopWithOnOffWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterStopWithOnOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLevelControlClusterStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLevelControlClusterStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDefaultMoveRateWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeDefaultMoveRateWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOffTransitionTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOffTransitionTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnOffTransitionTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnOffTransitionTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnTransitionTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnTransitionTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOptionsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOptionsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpCurrentLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpCurrentLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterLocalizationConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterLocalizationConfiguration; // inherited from NSObject

	static new(): MTRClusterLocalizationConfiguration; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveLocaleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedLocalesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeActiveLocaleWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeActiveLocaleWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterLowPower extends MTRGenericCluster {

	static alloc(): MTRClusterLowPower; // inherited from NSObject

	static new(): MTRClusterLowPower; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	sleepWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sleepWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	sleepWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRLowPowerClusterSleepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	sleepWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRLowPowerClusterSleepParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterMediaInput extends MTRGenericCluster {

	static alloc(): MTRClusterMediaInput; // inherited from NSObject

	static new(): MTRClusterMediaInput; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	hideInputStatusWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideInputStatusWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	hideInputStatusWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaInputClusterHideInputStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	hideInputStatusWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaInputClusterHideInputStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentInputWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInputListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	renameInputWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaInputClusterRenameInputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	renameInputWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaInputClusterRenameInputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	selectInputWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaInputClusterSelectInputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	selectInputWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaInputClusterSelectInputParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	showInputStatusWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	showInputStatusWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	showInputStatusWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaInputClusterShowInputStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	showInputStatusWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaInputClusterShowInputStatusParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterMediaPlayback extends MTRGenericCluster {

	static alloc(): MTRClusterMediaPlayback; // inherited from NSObject

	static new(): MTRClusterMediaPlayback; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	fastForwardWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fastForwardWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	fastForwardWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterFastForwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fastForwardWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterFastForwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	nextWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nextWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	nextWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterNextParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nextWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterNextParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	pauseWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterPauseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pauseWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterPauseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	playWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	playWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	playWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterPlayParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	playWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterPlayParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	previousWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previousWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	previousWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterPreviousParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previousWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterPreviousParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePlaybackSpeedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSampledPositionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSeekRangeEndWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSeekRangeStartWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	rewindWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rewindWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	rewindWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterRewindParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rewindWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterRewindParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	seekWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterSeekParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	seekWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterSeekParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	skipBackwardWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterSkipBackwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipBackwardWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterSkipBackwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	skipForwardWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterSkipForwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	skipForwardWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterSkipForwardParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startOverWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startOverWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	startOverWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterStartOverParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startOverWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterStartOverParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopPlaybackWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopPlaybackWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRMediaPlaybackClusterStopPlaybackParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRMediaPlaybackClusterStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRMediaPlaybackClusterPlaybackResponseParams, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterModeSelect extends MTRGenericCluster {

	static alloc(): MTRClusterModeSelect; // inherited from NSObject

	static new(): MTRClusterModeSelect; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	changeToModeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRModeSelectClusterChangeToModeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	changeToModeWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRModeSelectClusterChangeToModeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDescriptionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStandardNamespaceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartUpModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedModesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeOnModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare function MTRClusterNameForID(clusterID: MTRClusterIDType): string;

/**
 * @since 16.1
 */
declare class MTRClusterNetworkCommissioning extends MTRGenericCluster {

	static alloc(): MTRClusterNetworkCommissioning; // inherited from NSObject

	static new(): MTRClusterNetworkCommissioning; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	addOrUpdateThreadNetworkWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addOrUpdateThreadNetworkWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addOrUpdateWiFiNetworkWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addOrUpdateWiFiNetworkWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	connectNetworkWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterConnectNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterConnectNetworkResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	connectNetworkWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterConnectNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterConnectNetworkResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeConnectMaxTimeSecondsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInterfaceEnabledWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLastConnectErrorValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLastNetworkIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLastNetworkingStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxNetworksWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNetworksWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeScanMaxTimeSecondsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	removeNetworkWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterRemoveNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeNetworkWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterRemoveNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	reorderNetworkWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterReorderNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	reorderNetworkWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterReorderNetworkParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterNetworkConfigResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	scanNetworksWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	scanNetworksWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRNetworkCommissioningClusterScanNetworksParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	scanNetworksWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRNetworkCommissioningClusterScanNetworksParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRNetworkCommissioningClusterScanNetworksResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeInterfaceEnabledWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeInterfaceEnabledWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterNitrogenDioxideConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterNitrogenDioxideConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterNitrogenDioxideConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.4
 */
declare class MTRClusterOTASoftwareUpdateProvider extends MTRGenericCluster {

	static alloc(): MTRClusterOTASoftwareUpdateProvider; // inherited from NSObject

	static new(): MTRClusterOTASoftwareUpdateProvider; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	applyUpdateRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	notifyUpdateAppliedWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	queryImageWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROTASoftwareUpdateProviderClusterQueryImageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROTASoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.4
 */
declare class MTRClusterOTASoftwareUpdateRequestor extends MTRGenericCluster {

	static alloc(): MTRClusterOTASoftwareUpdateRequestor; // inherited from NSObject

	static new(): MTRClusterOTASoftwareUpdateRequestor; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	announceOTAProviderWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeDefaultOTAProvidersWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUpdatePossibleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUpdateStateProgressWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUpdateStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultOTAProvidersWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeDefaultOTAProvidersWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterOccupancySensing extends MTRGenericCluster {

	static alloc(): MTRClusterOccupancySensing; // inherited from NSObject

	static new(): MTRClusterOccupancySensing; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupancySensorTypeBitmapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupancySensorTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupancyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributePIROccupiedToUnoccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributePIRUnoccupiedToOccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributePIRUnoccupiedToOccupiedThresholdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalContactOccupiedToUnoccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalContactUnoccupiedToOccupiedThresholdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirOccupiedToUnoccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirUnoccupiedToOccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributePirUnoccupiedToOccupiedThresholdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUltrasonicOccupiedToUnoccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUltrasonicUnoccupiedToOccupiedThresholdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	writeAttributePIROccupiedToUnoccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIROccupiedToUnoccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedThresholdWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributePIRUnoccupiedToOccupiedThresholdWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactOccupiedToUnoccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributePhysicalContactUnoccupiedToOccupiedThresholdWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirOccupiedToUnoccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirOccupiedToUnoccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedThresholdWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributePirUnoccupiedToOccupiedThresholdWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicOccupiedToUnoccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedDelayWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUltrasonicUnoccupiedToOccupiedThresholdWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterOnOff extends MTRGenericCluster {

	static alloc(): MTRClusterOnOff; // inherited from NSObject

	static new(): MTRClusterOnOff; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	offWithEffectWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterOffWithEffectParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithEffectWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterOffWithEffectParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	offWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	offWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	offWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterOnParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterOnParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithRecallGlobalSceneWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithRecallGlobalSceneWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithRecallGlobalSceneWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterOnWithRecallGlobalSceneParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithRecallGlobalSceneWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterOnWithRecallGlobalSceneParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	onWithTimedOffWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterOnWithTimedOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	onWithTimedOffWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterOnWithTimedOffParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGlobalSceneControlWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOffWaitTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnOffWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOnTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartUpOnOffWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	toggleWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	toggleWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	toggleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROnOffClusterToggleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	toggleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROnOffClusterToggleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOffWaitTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOffWaitTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnTimeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOnTimeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpOnOffWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeStartUpOnOffWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRClusterOnOffSwitchConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterOnOffSwitchConfiguration; // inherited from NSObject

	static new(): MTRClusterOnOffSwitchConfiguration; // inherited from NSObject

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 * @deprecated 18.2
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeSwitchActionsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	readAttributeSwitchTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeSwitchActionsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	writeAttributeSwitchActionsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterOperationalCredentials extends MTRGenericCluster {

	static alloc(): MTRClusterOperationalCredentials; // inherited from NSObject

	static new(): MTRClusterOperationalCredentials; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	CSRRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterCSRRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterCSRResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	CSRRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterCSRRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterCSRResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addNOCWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterAddNOCParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addNOCWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterAddNOCParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	addTrustedRootCertificateWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterAddTrustedRootCertificateParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	addTrustedRootCertificateWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterAddTrustedRootCertificateParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	attestationRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterAttestationRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterAttestationResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	attestationRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterAttestationRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterAttestationResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	certificateChainRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterCertificateChainRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterCertificateChainResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	certificateChainRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterCertificateChainRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterCertificateChainResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCommissionedFabricsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentFabricIndexWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFabricsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNOCsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedFabricsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTrustedRootCertificatesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	removeFabricWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterRemoveFabricParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	removeFabricWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterRemoveFabricParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	updateFabricLabelWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterUpdateFabricLabelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	updateFabricLabelWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterUpdateFabricLabelParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	updateNOCWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalCredentialsClusterUpdateNOCParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	updateNOCWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROperationalCredentialsClusterUpdateNOCParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROperationalCredentialsClusterNOCResponseParams, p2: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRClusterOperationalState extends MTRGenericCluster {

	static alloc(): MTRClusterOperationalState; // inherited from NSObject

	static new(): MTRClusterOperationalState; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	pauseWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	pauseWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalStateClusterPauseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCountdownTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentPhaseWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalErrorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributePhaseListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	resumeWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalStateClusterResumeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	startWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	startWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalStateClusterStartParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	stopWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	stopWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTROperationalStateClusterStopParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTROperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRClusterOtaSoftwareUpdateProvider extends MTRClusterOTASoftwareUpdateProvider {

	static alloc(): MTRClusterOtaSoftwareUpdateProvider; // inherited from NSObject

	static new(): MTRClusterOtaSoftwareUpdateProvider; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	applyUpdateRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	notifyUpdateAppliedWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	queryImageWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROtaSoftwareUpdateProviderClusterQueryImageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRClusterOtaSoftwareUpdateRequestor extends MTRClusterOTASoftwareUpdateRequestor {

	static alloc(): MTRClusterOtaSoftwareUpdateRequestor; // inherited from NSObject

	static new(): MTRClusterOtaSoftwareUpdateRequestor; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	announceOtaProviderWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTROtaSoftwareUpdateRequestorClusterAnnounceOtaProviderParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeDefaultOtaProvidersWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultOtaProvidersWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	writeAttributeDefaultOtaProvidersWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterOzoneConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterOzoneConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterOzoneConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterPM10ConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterPM10ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterPM10ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterPM1ConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterPM1ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterPM1ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterPM25ConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterPM25ConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterPM25ConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.4
 */
declare class MTRClusterPath extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTRClusterPath; // inherited from NSObject

	static clusterPathWithEndpointIDClusterID(endpointID: number, clusterID: number): MTRClusterPath;

	static new(): MTRClusterPath; // inherited from NSObject

	readonly cluster: number;

	readonly endpoint: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 16.1
 */
declare class MTRClusterPowerSource extends MTRGenericCluster {

	static alloc(): MTRClusterPowerSource; // inherited from NSObject

	static new(): MTRClusterPowerSource; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveBatChargeFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveBatFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveWiredFaultsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatANSIDesignationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatApprovedChemistryWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatCapacityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatChargeLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatChargeStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatChargingCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatCommonDesignationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatFunctionalWhileChargingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatIECDesignationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatPercentRemainingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatPresentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatQuantityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatReplaceabilityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatReplacementDescriptionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatReplacementNeededWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatTimeRemainingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatTimeToFullChargeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBatVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDescriptionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeEndpointListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOrderWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredAssessedCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredAssessedInputFrequencyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredAssessedInputVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredCurrentTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredMaximumCurrentWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredNominalVoltageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiredPresentWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterPowerSourceConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterPowerSourceConfiguration; // inherited from NSObject

	static new(): MTRClusterPowerSourceConfiguration; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSourcesWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterPressureMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterPressureMeasurement; // inherited from NSObject

	static new(): MTRClusterPressureMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxScaledValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinScaledValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeScaleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeScaledToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeScaledValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterPumpConfigurationAndControl extends MTRGenericCluster {

	static alloc(): MTRClusterPumpConfigurationAndControl; // inherited from NSObject

	static new(): MTRClusterPumpConfigurationAndControl; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCapacityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeControlModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEffectiveControlModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEffectiveOperationModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLifetimeEnergyConsumedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLifetimeRunningHoursWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxCompPressureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxConstFlowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxConstPressureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxConstSpeedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxConstTempWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxFlowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxPressureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxSpeedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinCompPressureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinConstFlowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinConstPressureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinConstSpeedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinConstTempWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOperationModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePowerWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePumpStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSpeedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeControlModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeControlModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLifetimeEnergyConsumedWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLifetimeEnergyConsumedWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLifetimeRunningHoursWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLifetimeRunningHoursWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOperationModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOperationModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.4
 */
declare class MTRClusterRVCCleanMode extends MTRGenericCluster {

	static alloc(): MTRClusterRVCCleanMode; // inherited from NSObject

	static new(): MTRClusterRVCCleanMode; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	changeToModeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRRVCCleanModeClusterChangeToModeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCCleanModeClusterChangeToModeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeSupportedModesWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.4
 */
declare class MTRClusterRVCOperationalState extends MTRGenericCluster {

	static alloc(): MTRClusterRVCOperationalState; // inherited from NSObject

	static new(): MTRClusterRVCOperationalState; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	pauseWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	pauseWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRRVCOperationalStateClusterPauseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCountdownTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentPhaseWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalErrorWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeOperationalStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributePhaseListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	resumeWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	resumeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRRVCOperationalStateClusterResumeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCOperationalStateClusterOperationalCommandResponseParams, p2: NSError) => void): void;
}

/**
 * @since 17.4
 */
declare class MTRClusterRVCRunMode extends MTRGenericCluster {

	static alloc(): MTRClusterRVCRunMode; // inherited from NSObject

	static new(): MTRClusterRVCRunMode; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.4
	 */
	changeToModeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRRVCRunModeClusterChangeToModeParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRRVCRunModeClusterChangeToModeResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeCurrentModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.4
	 */
	readAttributeSupportedModesWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterRadonConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterRadonConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterRadonConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterRelativeHumidityMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterRelativeHumidityMeasurement; // inherited from NSObject

	static new(): MTRClusterRelativeHumidityMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 17.6
 */
declare class MTRClusterSmokeCOAlarm extends MTRGenericCluster {

	static alloc(): MTRClusterSmokeCOAlarm; // inherited from NSObject

	static new(): MTRClusterSmokeCOAlarm; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeBatteryAlertWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCOStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeContaminationStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDeviceMutedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeEndOfServiceAlertWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeExpiryDateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeExpressedStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeHardwareFaultAlertWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeInterconnectCOAlarmWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeInterconnectSmokeAlarmWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeSmokeSensitivityLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeSmokeStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeTestInProgressWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	selfTestRequestWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	selfTestRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRSmokeCOAlarmClusterSelfTestRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	writeAttributeSmokeSensitivityLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeSmokeSensitivityLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterSoftwareDiagnostics extends MTRGenericCluster {

	static alloc(): MTRClusterSoftwareDiagnostics; // inherited from NSObject

	static new(): MTRClusterSoftwareDiagnostics; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentHeapFreeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentHeapHighWatermarkWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentHeapUsedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeThreadMetricsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	resetWatermarksWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetWatermarksWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetWatermarksWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRSoftwareDiagnosticsClusterResetWatermarksParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetWatermarksWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRSoftwareDiagnosticsClusterResetWatermarksParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.4
 */
declare class MTRClusterStateCacheContainer extends NSObject {

	static alloc(): MTRClusterStateCacheContainer; // inherited from NSObject

	static new(): MTRClusterStateCacheContainer; // inherited from NSObject

	readAttributesWithEndpointIDClusterIDAttributeIDQueueCompletion(endpointID: number, clusterID: number, attributeID: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterSwitch extends MTRGenericCluster {

	static alloc(): MTRClusterSwitch; // inherited from NSObject

	static new(): MTRClusterSwitch; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMultiPressMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfPositionsWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterTargetNavigator extends MTRGenericCluster {

	static alloc(): MTRClusterTargetNavigator; // inherited from NSObject

	static new(): MTRClusterTargetNavigator; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	navigateTargetWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRTargetNavigatorClusterNavigateTargetParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRTargetNavigatorClusterNavigateTargetResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	navigateTargetWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTargetNavigatorClusterNavigateTargetParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTargetNavigatorClusterNavigateTargetResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentTargetWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTargetListWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterTemperatureMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterTemperatureMeasurement; // inherited from NSObject

	static new(): MTRClusterTemperatureMeasurement; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeToleranceWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRClusterTestCluster extends MTRClusterUnitTesting {

	static alloc(): MTRClusterTestCluster; // inherited from NSObject

	static new(): MTRClusterTestCluster; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	simpleStructEchoRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterSimpleStructEchoRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterSimpleStructResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testAddArgumentsWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestAddArgumentsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestAddArgumentsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testComplexNullableOptionalRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestComplexNullableOptionalRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestComplexNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEmitTestEventRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestEmitTestEventRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestEmitTestEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEmitTestFabricScopedEventRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestEmitTestFabricScopedEventRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestEmitTestFabricScopedEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testEnumsRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestEnumsRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestEnumsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListInt8UArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestListInt8UArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListInt8UReverseRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestListInt8UReverseRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestListInt8UReverseResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListNestedStructListArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestListNestedStructListArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testListStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestListStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNestedStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestNestedStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNestedStructListArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestNestedStructListArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNotHandledWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNotHandledWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestNotHandledParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNullableOptionalRequestWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testNullableOptionalRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestNullableOptionalRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestSimpleArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestSimpleArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleOptionalArgumentRequestWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSimpleOptionalArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestSimpleOptionalArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSpecificWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testSpecificWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestSpecificParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testStructArrayArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestStructArrayArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRTestClusterClusterTestStructArrayArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testUnknownCommandWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testUnknownCommandWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestUnknownCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	testWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeRequestWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeRequestWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRTestClusterClusterTimedInvokeRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterThermostat extends MTRGenericCluster {

	static alloc(): MTRClusterThermostat; // inherited from NSObject

	static new(): MTRClusterThermostat; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	clearWeeklyScheduleWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeeklyScheduleWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	clearWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRThermostatClusterClearWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	clearWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRThermostatClusterClearWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	getWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRThermostatClusterGetWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRThermostatClusterGetWeeklyScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRThermostatClusterGetWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: MTRThermostatClusterGetWeeklyScheduleResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeACCapacityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACCapacityformatWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACCoilTemperatureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACCompressorTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACErrorCodeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACLouverPositionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACRefrigerantTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeACTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAbsMaxCoolSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAbsMaxHeatSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAbsMinCoolSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAbsMinHeatSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeControlSequenceOfOperationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEmergencyHeatDeltaWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeHVACSystemTypeConfigurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLocalTemperatureCalibrationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLocalTemperatureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxCoolSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMaxHeatSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinCoolSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinHeatSetpointLimitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMinSetpointDeadBandWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfDailyTransitionsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfWeeklyTransitionsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupancyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupiedCoolingSetpointWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupiedHeatingSetpointWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupiedSetbackMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupiedSetbackMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOccupiedSetbackWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOutdoorTemperatureWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePICoolingDemandWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePIHeatingDemandWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRemoteSensingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSetpointChangeAmountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSetpointChangeSourceTimestampWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSetpointChangeSourceWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStartOfWeekWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSystemModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTemperatureSetpointHoldDurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTemperatureSetpointHoldWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeThermostatProgrammingOperationModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeThermostatRunningModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeThermostatRunningStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUnoccupiedCoolingSetpointWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUnoccupiedHeatingSetpointWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUnoccupiedSetbackMaxWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUnoccupiedSetbackMinWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeUnoccupiedSetbackWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	setWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRThermostatClusterSetWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setWeeklyScheduleWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRThermostatClusterSetWeeklyScheduleParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	setpointRaiseLowerWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRThermostatClusterSetpointRaiseLowerParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setpointRaiseLowerWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRThermostatClusterSetpointRaiseLowerParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCapacityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCapacityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCapacityformatWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCapacityformatWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCompressorTypeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACCompressorTypeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACErrorCodeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACErrorCodeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACLouverPositionWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACLouverPositionWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACRefrigerantTypeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACRefrigerantTypeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACTypeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeACTypeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeControlSequenceOfOperationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeControlSequenceOfOperationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEmergencyHeatDeltaWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeEmergencyHeatDeltaWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeHVACSystemTypeConfigurationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLocalTemperatureCalibrationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLocalTemperatureCalibrationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxCoolSetpointLimitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxCoolSetpointLimitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxHeatSetpointLimitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMaxHeatSetpointLimitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinCoolSetpointLimitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinCoolSetpointLimitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinHeatSetpointLimitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinHeatSetpointLimitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinSetpointDeadBandWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeMinSetpointDeadBandWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedCoolingSetpointWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedCoolingSetpointWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedHeatingSetpointWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedHeatingSetpointWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedSetbackWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeOccupiedSetbackWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRemoteSensingWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeRemoteSensingWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSystemModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeSystemModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureSetpointHoldDurationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureSetpointHoldWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureSetpointHoldWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeThermostatProgrammingOperationModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedCoolingSetpointWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedHeatingSetpointWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedSetbackWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeUnoccupiedSetbackWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterThermostatUserInterfaceConfiguration extends MTRGenericCluster {

	static alloc(): MTRClusterThermostatUserInterfaceConfiguration; // inherited from NSObject

	static new(): MTRClusterThermostatUserInterfaceConfiguration; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeKeypadLockoutWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeScheduleProgrammingVisibilityWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTemperatureDisplayModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeKeypadLockoutWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeKeypadLockoutWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeScheduleProgrammingVisibilityWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureDisplayModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureDisplayModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterThreadNetworkDiagnostics extends MTRGenericCluster {

	static alloc(): MTRClusterThreadNetworkDiagnostics; // inherited from NSObject

	static new(): MTRClusterThreadNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveNetworkFaultsListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveTimestampWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttachAttemptCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBetterPartitionAttachAttemptCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeChannelPage0MaskWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeChannelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeChildRoleCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDataVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDelayWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeDetachedRoleCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeExtendedPanIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLeaderRoleCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLeaderRouterIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeMeshLocalPrefixWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeNeighborTableListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNeighborTableWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNetworkNameWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOperationalDatasetComponentsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOverrunCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePanIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeParentChangeCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePartitionIdChangeCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePartitionIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePendingTimestampWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRouteTableListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRouteTableWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRouterRoleCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRoutingRoleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxAddressFilteredCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxBeaconCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxBeaconRequestCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxBroadcastCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxDataCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxDataPollCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxDestAddrFilteredCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxDuplicatedCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrFcsCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrInvalidSrcAddrCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrNoFrameCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrOtherCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrSecCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxErrUnknownNeighborCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxOtherCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxTotalCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeRxUnicastCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSecurityPolicyWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeStableDataVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxAckRequestedCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxAckedCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxBeaconCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxBeaconRequestCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxBroadcastCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxDataCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxDataPollCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxDirectMaxRetryExpiryCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxErrAbortCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxErrBusyChannelCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxErrCcaCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxIndirectMaxRetryExpiryCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxNoAckRequestedCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxOtherCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxRetryCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxTotalCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTxUnicastCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWeightingWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRThreadNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRThreadNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterTimeFormatLocalization extends MTRGenericCluster {

	static alloc(): MTRClusterTimeFormatLocalization; // inherited from NSObject

	static new(): MTRClusterTimeFormatLocalization; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeActiveCalendarTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeHourFormatWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSupportedCalendarTypesWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeActiveCalendarTypeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeActiveCalendarTypeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.1
	 */
	writeAttributeHourFormatWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeHourFormatWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterTotalVolatileOrganicCompoundsConcentrationMeasurement extends MTRGenericCluster {

	static alloc(): MTRClusterTotalVolatileOrganicCompoundsConcentrationMeasurement; // inherited from NSObject

	static new(): MTRClusterTotalVolatileOrganicCompoundsConcentrationMeasurement; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAverageMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMaxMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementMediumWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMeasurementUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeMinMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWindowWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributePeakMeasuredValueWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeUncertaintyWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 */
declare class MTRClusterUnitLocalization extends MTRGenericCluster {

	static alloc(): MTRClusterUnitLocalization; // inherited from NSObject

	static new(): MTRClusterUnitLocalization; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTemperatureUnitWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureUnitWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeTemperatureUnitWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.4
 */
declare class MTRClusterUnitTesting extends MTRGenericCluster {

	static alloc(): MTRClusterUnitTesting; // inherited from NSObject

	static new(): MTRClusterUnitTesting; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap16WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap32WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap64WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBitmap8WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBooleanWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeCharStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterErrorBooleanWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeEnum16WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeEnum8WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeEnumAttrWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeEpochSWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeEpochUsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFloatDoubleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFloatSingleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneralErrorBooleanWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt16sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt16uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt24sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt24uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt32sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt32uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt40sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt40uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt48sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt48uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt56sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt56uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt64sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt64uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt8sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListFabricScopedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListLongOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListNullablesAndOptionalsStructWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeListStructOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeLongCharStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeLongOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap16WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap32WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap64WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBitmap8WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableBooleanWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableCharStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnum16WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnum8WithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableEnumAttrWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableFloatDoubleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableFloatSingleWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt16sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt16uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt24sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt24uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt32sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt32uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt40sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt40uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt48sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt48uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt56sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt56uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt64sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt64uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt8sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt16sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt16uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt8sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableRangeRestrictedInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeNullableStructWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeOctetStringWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt16sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt16uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt8sWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRangeRestrictedInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeStructAttrWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeTimedWriteBooleanWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeUnsupportedWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeVendorIdWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeWriteOnlyInt8uWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	simpleStructEchoRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterSimpleStructEchoRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterSimpleStructResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testAddArgumentsWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestAddArgumentsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestAddArgumentsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testComplexNullableOptionalRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestComplexNullableOptionalRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestComplexNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEmitTestEventRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestEmitTestEventRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestEmitTestEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEmitTestFabricScopedEventRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testEnumsRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestEnumsRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestEnumsResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListInt8UArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestListInt8UArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListInt8UReverseRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestListInt8UReverseRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestListInt8UReverseResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListNestedStructListArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testListStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestListStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNestedStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestNestedStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNestedStructListArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestNestedStructListArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNotHandledWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNotHandledWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestNotHandledParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	testNullableOptionalRequestWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testNullableOptionalRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestNullableOptionalRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestNullableOptionalResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSimpleArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestSimpleArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestSimpleArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	testSimpleOptionalArgumentRequestWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSimpleOptionalArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSpecificWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testSpecificWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestSpecificParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestSpecificResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testStructArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestStructArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterBooleanResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testStructArrayArgumentRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestStructArrayArgumentRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: MTRUnitTestingClusterTestStructArrayArgumentResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testUnknownCommandWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testUnknownCommandWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestUnknownCommandParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	testWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	timedInvokeRequestWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	timedInvokeRequestWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRUnitTestingClusterTimedInvokeRequestParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap16WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap16WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap32WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap32WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap64WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap64WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap8WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBitmap8WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBooleanWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeBooleanWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCharStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeCharStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeClusterErrorBooleanWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum16WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum16WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum8WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnum8WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnumAttrWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEnumAttrWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochSWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochSWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochUsWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeEpochUsWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatDoubleWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatDoubleWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatSingleWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeFloatSingleWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeGeneralErrorBooleanWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt16uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt24uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt32uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt40uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt48uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt56uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt64uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListFabricScopedWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListFabricScopedWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListLongOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListLongOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListNullablesAndOptionalsStructWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListStructOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeListStructOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongCharStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongCharStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeLongOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap16WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap16WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap32WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap32WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap64WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap64WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap8WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBitmap8WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBooleanWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableBooleanWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableCharStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableCharStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum16WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum16WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum8WithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnum8WithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnumAttrWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableEnumAttrWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatDoubleWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatSingleWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableFloatSingleWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt16uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt24uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt32uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt40uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt48uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt56uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt64uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt16uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableRangeRestrictedInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableStructWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeNullableStructWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOctetStringWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeOctetStringWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt16uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8sWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeRangeRestrictedInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStructAttrWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeStructAttrWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeTimedWriteBooleanWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnsupportedWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeUnsupportedWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeVendorIdWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeVendorIdWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.4
	 */
	writeAttributeWriteOnlyInt8uWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterUserLabel extends MTRGenericCluster {

	static alloc(): MTRClusterUserLabel; // inherited from NSObject

	static new(): MTRClusterUserLabel; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeLabelListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	writeAttributeLabelListWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeLabelListWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 17.6
 */
declare class MTRClusterValveConfigurationAndControl extends MTRGenericCluster {

	static alloc(): MTRClusterValveConfigurationAndControl; // inherited from NSObject

	static new(): MTRClusterValveConfigurationAndControl; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 17.6
	 */
	closeWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	closeWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRValveConfigurationAndControlClusterCloseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 17.6
	 */
	openWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	openWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRValveConfigurationAndControlClusterOpenParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 17.6
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeAutoCloseTimeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeCurrentStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultOpenDurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeDefaultOpenLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeLevelStepWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeOpenDurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeRemainingDurationWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeTargetLevelWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeTargetStateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	readAttributeValveFaultWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenDurationWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenDurationWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenLevelWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 17.6
	 */
	writeAttributeDefaultOpenLevelWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.4
 */
declare class MTRClusterWakeOnLAN extends MTRGenericCluster {

	static alloc(): MTRClusterWakeOnLAN; // inherited from NSObject

	static new(): MTRClusterWakeOnLAN; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.4
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeMACAddressWithParams(params: MTRReadParams): NSDictionary<string, any>;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRClusterWakeOnLan extends MTRClusterWakeOnLAN {

	static alloc(): MTRClusterWakeOnLan; // inherited from NSObject

	static new(): MTRClusterWakeOnLan; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;
}

/**
 * @since 16.1
 */
declare class MTRClusterWiFiNetworkDiagnostics extends MTRGenericCluster {

	static alloc(): MTRClusterWiFiNetworkDiagnostics; // inherited from NSObject

	static new(): MTRClusterWiFiNetworkDiagnostics; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeBSSIDWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBeaconLostCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeBeaconRxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeBssidWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeChannelNumberWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentMaxRateWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOverrunCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketMulticastRxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketMulticastTxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketUnicastRxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePacketUnicastTxCountWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	readAttributeRSSIWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readAttributeRssiWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSecurityTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeWiFiVersionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWiFiNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	resetCountsWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWiFiNetworkDiagnosticsClusterResetCountsParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;
}

/**
 * @since 16.1
 */
declare class MTRClusterWindowCovering extends MTRGenericCluster {

	static alloc(): MTRClusterWindowCovering; // inherited from NSObject

	static new(): MTRClusterWindowCovering; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	constructor(o: { device: MTRDevice; endpointID: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { device: MTRDevice; endpoint: number; queue: NSObject & OS_dispatch_queue; });

	/**
	 * @since 16.4
	 */
	downOrCloseWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	downOrCloseWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	downOrCloseWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterDownOrCloseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	downOrCloseWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterDownOrCloseParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToLiftPercentageWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterGoToLiftPercentageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToLiftPercentageWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterGoToLiftPercentageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToLiftValueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterGoToLiftValueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToLiftValueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterGoToLiftValueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToTiltPercentageWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterGoToTiltPercentageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToTiltPercentageWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterGoToTiltPercentageParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	goToTiltValueWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterGoToTiltValueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	goToTiltValueWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterGoToTiltValueParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	initWithDeviceEndpointIDQueue(device: MTRDevice, endpointID: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithDeviceEndpointQueue(device: MTRDevice, endpoint: number, queue: NSObject & OS_dispatch_queue): this;

	/**
	 * @since 16.1
	 */
	readAttributeAcceptedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeAttributeListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeClusterRevisionWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeConfigStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionLiftPercent100thsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionLiftPercentageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionLiftWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionTiltPercent100thsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionTiltPercentageWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeCurrentPositionTiltWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeEndProductTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeFeatureMapWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeGeneratedCommandListWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInstalledClosedLimitLiftWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInstalledClosedLimitTiltWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInstalledOpenLimitLiftWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeInstalledOpenLimitTiltWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeModeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfActuationsLiftWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeNumberOfActuationsTiltWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeOperationalStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalClosedLimitLiftWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributePhysicalClosedLimitTiltWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeSafetyStatusWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTargetPositionLiftPercent100thsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTargetPositionTiltPercent100thsWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.1
	 */
	readAttributeTypeWithParams(params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 16.4
	 */
	stopMotionWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMotionWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	stopMotionWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterStopMotionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopMotionWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterStopMotionParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	upOrOpenWithExpectedValuesExpectedValueIntervalCompletion(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	upOrOpenWithExpectedValuesExpectedValueIntervalCompletionHandler(expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	upOrOpenWithParamsExpectedValuesExpectedValueIntervalCompletion(params: MTRWindowCoveringClusterUpOrOpenParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	upOrOpenWithParamsExpectedValuesExpectedValueIntervalCompletionHandler(params: MTRWindowCoveringClusterUpOrOpenParams, expectedDataValueDictionaries: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueIntervalMs: number, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 */
	writeAttributeModeWithValueExpectedValueInterval(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number): void;

	/**
	 * @since 16.1
	 */
	writeAttributeModeWithValueExpectedValueIntervalParams(dataValueDictionary: NSDictionary<string, any>, expectedValueIntervalMs: number, params: MTRWriteParams): void;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterColorLoopSetParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterColorLoopSetParams; // inherited from NSObject

	static new(): MTRColorControlClusterColorLoopSetParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	action: number;

	/**
	 * @since 16.1
	 */
	direction: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	startHue: number;

	/**
	 * @since 16.1
	 */
	time: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	updateFlags: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterEnhancedMoveHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterEnhancedMoveHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterEnhancedMoveHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterEnhancedMoveToHueAndSaturationParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterEnhancedMoveToHueAndSaturationParams; // inherited from NSObject

	static new(): MTRColorControlClusterEnhancedMoveToHueAndSaturationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	enhancedHue: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	saturation: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterEnhancedMoveToHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterEnhancedMoveToHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterEnhancedMoveToHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	direction: number;

	/**
	 * @since 16.1
	 */
	enhancedHue: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterEnhancedStepHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterEnhancedStepHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterEnhancedStepHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveColorParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveColorParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveColorParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rateX: number;

	/**
	 * @since 16.1
	 */
	rateY: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveColorTemperatureParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveColorTemperatureParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveColorTemperatureParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	colorTemperatureMaximumMireds: number;

	/**
	 * @since 16.1
	 */
	colorTemperatureMinimumMireds: number;

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveSaturationParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveSaturationParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveSaturationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveToColorParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveToColorParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveToColorParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	colorX: number;

	/**
	 * @since 16.1
	 */
	colorY: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveToColorTemperatureParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveToColorTemperatureParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveToColorTemperatureParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	colorTemperature: number;

	/**
	 * @since 16.4
	 */
	colorTemperatureMireds: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveToHueAndSaturationParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveToHueAndSaturationParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveToHueAndSaturationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	hue: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	saturation: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveToHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveToHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveToHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	direction: number;

	/**
	 * @since 16.1
	 */
	hue: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterMoveToSaturationParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterMoveToSaturationParams; // inherited from NSObject

	static new(): MTRColorControlClusterMoveToSaturationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	saturation: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterStepColorParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterStepColorParams; // inherited from NSObject

	static new(): MTRColorControlClusterStepColorParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepX: number;

	/**
	 * @since 16.1
	 */
	stepY: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterStepColorTemperatureParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterStepColorTemperatureParams; // inherited from NSObject

	static new(): MTRColorControlClusterStepColorTemperatureParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	colorTemperatureMaximumMireds: number;

	/**
	 * @since 16.1
	 */
	colorTemperatureMinimumMireds: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterStepHueParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterStepHueParams; // inherited from NSObject

	static new(): MTRColorControlClusterStepHueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterStepSaturationParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterStepSaturationParams; // inherited from NSObject

	static new(): MTRColorControlClusterStepSaturationParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRColorControlClusterStopMoveStepParams extends NSObject implements NSCopying {

	static alloc(): MTRColorControlClusterStopMoveStepParams; // inherited from NSObject

	static new(): MTRColorControlClusterStopMoveStepParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlColorCapabilities {

	HueSaturationSupported = 1,

	EnhancedHueSupported = 2,

	ColorLoopSupported = 4,

	XYAttributesSupported = 8,

	ColorTemperatureSupported = 16
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlColorCapabilitiesBitmap {

	HueSaturation = 1,

	EnhancedHue = 2,

	ColorLoop = 4,

	XY = 8,

	ColorTemperature = 16
}

/**
 * @since 16.1
 */
declare const enum MTRColorControlColorLoopAction {

	Deactivate = 0,

	ActivateFromColorLoopStartEnhancedHue = 1,

	ActivateFromEnhancedCurrentHue = 2
}

/**
 * @since 16.1
 */
declare const enum MTRColorControlColorLoopDirection {

	Decrement = 0,

	DecrementHue = 0,

	Increment = 1,

	IncrementHue = 1
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlColorLoopUpdateFlags {

	UpdateAction = 1,

	UpdateDirection = 2,

	UpdateTime = 4,

	UpdateStartHue = 8
}

/**
 * @since 16.1
 */
declare const enum MTRColorControlColorMode {

	CurrentHueAndCurrentSaturation = 0,

	CurrentXAndCurrentY = 1,

	ColorTemperatureMireds = 2,

	ColorTemperature = 2
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlDirection {

	Shortest = 0,

	Longest = 1,

	Up = 2,

	Down = 3
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlDriftCompensation {

	None = 0,

	OtherOrUnknown = 1,

	TemperatureMonitoring = 2,

	OpticalLuminanceMonitoringAndFeedback = 3,

	OpticalColorMonitoringAndFeedback = 4
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlEnhancedColorMode {

	CurrentHueAndCurrentSaturation = 0,

	CurrentXAndCurrentY = 1,

	ColorTemperatureMireds = 2,

	EnhancedCurrentHueAndCurrentSaturation = 3
}

/**
 * @since 16.1
 */
declare const enum MTRColorControlFeature {

	HueAndSaturation = 1,

	EnhancedHue = 2,

	ColorLoop = 4,

	XY = 8,

	ColorTemperature = 16
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlHueDirection {

	ShortestDistance = 0,

	LongestDistance = 1,

	Up = 2,

	Down = 3
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlHueMoveMode {

	Stop = 0,

	Up = 1,

	Down = 3
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlHueStepMode {

	Up = 1,

	Down = 3
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlMoveMode {

	Stop = 0,

	Up = 1,

	Down = 3
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlOptionsBitmap {

	ExecuteIfOff = 1
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlSaturationMoveMode {

	Stop = 0,

	Up = 1,

	Down = 3
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare const enum MTRColorControlSaturationStepMode {

	Up = 1,

	Down = 3
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlStepMode {

	Up = 1,

	Down = 3
}

/**
 * @since 18.2
 */
declare const enum MTRColorControlUpdateFlagsBitmap {

	UpdateAction = 1,

	UpdateDirection = 2,

	UpdateTime = 4,

	UpdateStartHue = 8
}

declare const enum MTRCommandIDType {

	ClusterIdentifyCommandIdentifyID = 0,

	ClusterIdentifyCommandTriggerEffectID = 64,

	CommandIDTypeClusterIdentifyCommandIdentifyID = 0,

	CommandIDTypeClusterIdentifyCommandTriggerEffectID = 64,

	ClusterGroupsCommandAddGroupID = 0,

	ClusterGroupsCommandAddGroupResponseID = 0,

	ClusterGroupsCommandViewGroupID = 1,

	ClusterGroupsCommandViewGroupResponseID = 1,

	ClusterGroupsCommandGetGroupMembershipID = 2,

	ClusterGroupsCommandGetGroupMembershipResponseID = 2,

	ClusterGroupsCommandRemoveGroupID = 3,

	ClusterGroupsCommandRemoveGroupResponseID = 3,

	ClusterGroupsCommandRemoveAllGroupsID = 4,

	ClusterGroupsCommandAddGroupIfIdentifyingID = 5,

	CommandIDTypeClusterGroupsCommandAddGroupID = 0,

	CommandIDTypeClusterGroupsCommandAddGroupResponseID = 0,

	CommandIDTypeClusterGroupsCommandViewGroupID = 1,

	CommandIDTypeClusterGroupsCommandViewGroupResponseID = 1,

	CommandIDTypeClusterGroupsCommandGetGroupMembershipID = 2,

	CommandIDTypeClusterGroupsCommandGetGroupMembershipResponseID = 2,

	CommandIDTypeClusterGroupsCommandRemoveGroupID = 3,

	CommandIDTypeClusterGroupsCommandRemoveGroupResponseID = 3,

	CommandIDTypeClusterGroupsCommandRemoveAllGroupsID = 4,

	CommandIDTypeClusterGroupsCommandAddGroupIfIdentifyingID = 5,

	ClusterOnOffCommandOffID = 0,

	ClusterOnOffCommandOnID = 1,

	ClusterOnOffCommandToggleID = 2,

	ClusterOnOffCommandOffWithEffectID = 64,

	ClusterOnOffCommandOnWithRecallGlobalSceneID = 65,

	ClusterOnOffCommandOnWithTimedOffID = 66,

	CommandIDTypeClusterOnOffCommandOffID = 0,

	CommandIDTypeClusterOnOffCommandOnID = 1,

	CommandIDTypeClusterOnOffCommandToggleID = 2,

	CommandIDTypeClusterOnOffCommandOffWithEffectID = 64,

	CommandIDTypeClusterOnOffCommandOnWithRecallGlobalSceneID = 65,

	CommandIDTypeClusterOnOffCommandOnWithTimedOffID = 66,

	ClusterLevelControlCommandMoveToLevelID = 0,

	ClusterLevelControlCommandMoveID = 1,

	ClusterLevelControlCommandStepID = 2,

	ClusterLevelControlCommandStopID = 3,

	ClusterLevelControlCommandMoveToLevelWithOnOffID = 4,

	ClusterLevelControlCommandMoveWithOnOffID = 5,

	ClusterLevelControlCommandStepWithOnOffID = 6,

	ClusterLevelControlCommandStopWithOnOffID = 7,

	ClusterLevelControlCommandMoveToClosestFrequencyID = 8,

	CommandIDTypeClusterLevelControlCommandMoveToLevelID = 0,

	CommandIDTypeClusterLevelControlCommandMoveID = 1,

	CommandIDTypeClusterLevelControlCommandStepID = 2,

	CommandIDTypeClusterLevelControlCommandStopID = 3,

	CommandIDTypeClusterLevelControlCommandMoveToLevelWithOnOffID = 4,

	CommandIDTypeClusterLevelControlCommandMoveWithOnOffID = 5,

	CommandIDTypeClusterLevelControlCommandStepWithOnOffID = 6,

	CommandIDTypeClusterLevelControlCommandStopWithOnOffID = 7,

	CommandIDTypeClusterLevelControlCommandMoveToClosestFrequencyID = 8,

	CommandIDTypeClusterAccessControlCommandReviewFabricRestrictionsID = 0,

	CommandIDTypeClusterAccessControlCommandReviewFabricRestrictionsResponseID = 1,

	ClusterActionsCommandInstantActionID = 0,

	ClusterActionsCommandInstantActionWithTransitionID = 1,

	ClusterActionsCommandStartActionID = 2,

	ClusterActionsCommandStartActionWithDurationID = 3,

	ClusterActionsCommandStopActionID = 4,

	ClusterActionsCommandPauseActionID = 5,

	ClusterActionsCommandPauseActionWithDurationID = 6,

	ClusterActionsCommandResumeActionID = 7,

	ClusterActionsCommandEnableActionID = 8,

	ClusterActionsCommandEnableActionWithDurationID = 9,

	ClusterActionsCommandDisableActionID = 10,

	ClusterActionsCommandDisableActionWithDurationID = 11,

	CommandIDTypeClusterActionsCommandInstantActionID = 0,

	CommandIDTypeClusterActionsCommandInstantActionWithTransitionID = 1,

	CommandIDTypeClusterActionsCommandStartActionID = 2,

	CommandIDTypeClusterActionsCommandStartActionWithDurationID = 3,

	CommandIDTypeClusterActionsCommandStopActionID = 4,

	CommandIDTypeClusterActionsCommandPauseActionID = 5,

	CommandIDTypeClusterActionsCommandPauseActionWithDurationID = 6,

	CommandIDTypeClusterActionsCommandResumeActionID = 7,

	CommandIDTypeClusterActionsCommandEnableActionID = 8,

	CommandIDTypeClusterActionsCommandEnableActionWithDurationID = 9,

	CommandIDTypeClusterActionsCommandDisableActionID = 10,

	CommandIDTypeClusterActionsCommandDisableActionWithDurationID = 11,

	ClusterBasicCommandMfgSpecificPingID = 268566528,

	ClusterOtaSoftwareUpdateProviderCommandQueryImageID = 0,

	ClusterOtaSoftwareUpdateProviderCommandQueryImageResponseID = 1,

	ClusterOtaSoftwareUpdateProviderCommandApplyUpdateRequestID = 2,

	ClusterOtaSoftwareUpdateProviderCommandApplyUpdateResponseID = 3,

	ClusterOtaSoftwareUpdateProviderCommandNotifyUpdateAppliedID = 4,

	CommandIDTypeClusterOTASoftwareUpdateProviderCommandQueryImageID = 0,

	CommandIDTypeClusterOTASoftwareUpdateProviderCommandQueryImageResponseID = 1,

	CommandIDTypeClusterOTASoftwareUpdateProviderCommandApplyUpdateRequestID = 2,

	CommandIDTypeClusterOTASoftwareUpdateProviderCommandApplyUpdateResponseID = 3,

	CommandIDTypeClusterOTASoftwareUpdateProviderCommandNotifyUpdateAppliedID = 4,

	ClusterOtaSoftwareUpdateRequestorCommandAnnounceOtaProviderID = 0,

	CommandIDTypeClusterOTASoftwareUpdateRequestorCommandAnnounceOTAProviderID = 0,

	ClusterGeneralCommissioningCommandArmFailSafeID = 0,

	ClusterGeneralCommissioningCommandArmFailSafeResponseID = 1,

	ClusterGeneralCommissioningCommandSetRegulatoryConfigID = 2,

	ClusterGeneralCommissioningCommandSetRegulatoryConfigResponseID = 3,

	ClusterGeneralCommissioningCommandCommissioningCompleteID = 4,

	ClusterGeneralCommissioningCommandCommissioningCompleteResponseID = 5,

	CommandIDTypeClusterGeneralCommissioningCommandArmFailSafeID = 0,

	CommandIDTypeClusterGeneralCommissioningCommandArmFailSafeResponseID = 1,

	CommandIDTypeClusterGeneralCommissioningCommandSetRegulatoryConfigID = 2,

	CommandIDTypeClusterGeneralCommissioningCommandSetRegulatoryConfigResponseID = 3,

	CommandIDTypeClusterGeneralCommissioningCommandCommissioningCompleteID = 4,

	CommandIDTypeClusterGeneralCommissioningCommandCommissioningCompleteResponseID = 5,

	CommandIDTypeClusterGeneralCommissioningCommandSetTCAcknowledgementsID = 6,

	CommandIDTypeClusterGeneralCommissioningCommandSetTCAcknowledgementsResponseID = 7,

	ClusterNetworkCommissioningCommandScanNetworksID = 0,

	ClusterNetworkCommissioningCommandScanNetworksResponseID = 1,

	ClusterNetworkCommissioningCommandAddOrUpdateWiFiNetworkID = 2,

	ClusterNetworkCommissioningCommandAddOrUpdateThreadNetworkID = 3,

	ClusterNetworkCommissioningCommandRemoveNetworkID = 4,

	ClusterNetworkCommissioningCommandNetworkConfigResponseID = 5,

	ClusterNetworkCommissioningCommandConnectNetworkID = 6,

	ClusterNetworkCommissioningCommandConnectNetworkResponseID = 7,

	ClusterNetworkCommissioningCommandReorderNetworkID = 8,

	CommandIDTypeClusterNetworkCommissioningCommandScanNetworksID = 0,

	CommandIDTypeClusterNetworkCommissioningCommandScanNetworksResponseID = 1,

	CommandIDTypeClusterNetworkCommissioningCommandAddOrUpdateWiFiNetworkID = 2,

	CommandIDTypeClusterNetworkCommissioningCommandAddOrUpdateThreadNetworkID = 3,

	CommandIDTypeClusterNetworkCommissioningCommandRemoveNetworkID = 4,

	CommandIDTypeClusterNetworkCommissioningCommandNetworkConfigResponseID = 5,

	CommandIDTypeClusterNetworkCommissioningCommandConnectNetworkID = 6,

	CommandIDTypeClusterNetworkCommissioningCommandConnectNetworkResponseID = 7,

	CommandIDTypeClusterNetworkCommissioningCommandReorderNetworkID = 8,

	CommandIDTypeClusterNetworkCommissioningCommandQueryIdentityID = 9,

	CommandIDTypeClusterNetworkCommissioningCommandQueryIdentityResponseID = 10,

	ClusterDiagnosticLogsCommandRetrieveLogsRequestID = 0,

	ClusterDiagnosticLogsCommandRetrieveLogsResponseID = 1,

	CommandIDTypeClusterDiagnosticLogsCommandRetrieveLogsRequestID = 0,

	CommandIDTypeClusterDiagnosticLogsCommandRetrieveLogsResponseID = 1,

	ClusterGeneralDiagnosticsCommandTestEventTriggerID = 0,

	CommandIDTypeClusterGeneralDiagnosticsCommandTestEventTriggerID = 0,

	CommandIDTypeClusterGeneralDiagnosticsCommandTimeSnapshotID = 1,

	CommandIDTypeClusterGeneralDiagnosticsCommandTimeSnapshotResponseID = 2,

	CommandIDTypeClusterGeneralDiagnosticsCommandPayloadTestRequestID = 3,

	CommandIDTypeClusterGeneralDiagnosticsCommandPayloadTestResponseID = 4,

	ClusterSoftwareDiagnosticsCommandResetWatermarksID = 0,

	CommandIDTypeClusterSoftwareDiagnosticsCommandResetWatermarksID = 0,

	ClusterThreadNetworkDiagnosticsCommandResetCountsID = 0,

	CommandIDTypeClusterThreadNetworkDiagnosticsCommandResetCountsID = 0,

	ClusterWiFiNetworkDiagnosticsCommandResetCountsID = 0,

	CommandIDTypeClusterWiFiNetworkDiagnosticsCommandResetCountsID = 0,

	ClusterEthernetNetworkDiagnosticsCommandResetCountsID = 0,

	CommandIDTypeClusterEthernetNetworkDiagnosticsCommandResetCountsID = 0,

	ClusterTimeSynchronizationCommandSetUtcTimeID = 0,

	CommandIDTypeClusterTimeSynchronizationCommandSetUTCTimeID = 0,

	CommandIDTypeClusterTimeSynchronizationCommandSetUtcTimeID = 0,

	CommandIDTypeClusterTimeSynchronizationCommandSetTrustedTimeSourceID = 1,

	CommandIDTypeClusterTimeSynchronizationCommandSetTimeZoneID = 2,

	CommandIDTypeClusterTimeSynchronizationCommandSetTimeZoneResponseID = 3,

	CommandIDTypeClusterTimeSynchronizationCommandSetDSTOffsetID = 4,

	CommandIDTypeClusterTimeSynchronizationCommandSetDefaultNTPID = 5,

	CommandIDTypeClusterBridgedDeviceBasicInformationCommandKeepActiveID = 128,

	ClusterAdministratorCommissioningCommandOpenCommissioningWindowID = 0,

	ClusterAdministratorCommissioningCommandOpenBasicCommissioningWindowID = 1,

	ClusterAdministratorCommissioningCommandRevokeCommissioningID = 2,

	CommandIDTypeClusterAdministratorCommissioningCommandOpenCommissioningWindowID = 0,

	CommandIDTypeClusterAdministratorCommissioningCommandOpenBasicCommissioningWindowID = 1,

	CommandIDTypeClusterAdministratorCommissioningCommandRevokeCommissioningID = 2,

	ClusterOperationalCredentialsCommandAttestationRequestID = 0,

	ClusterOperationalCredentialsCommandAttestationResponseID = 1,

	ClusterOperationalCredentialsCommandCertificateChainRequestID = 2,

	ClusterOperationalCredentialsCommandCertificateChainResponseID = 3,

	ClusterOperationalCredentialsCommandCSRRequestID = 4,

	ClusterOperationalCredentialsCommandCSRResponseID = 5,

	ClusterOperationalCredentialsCommandAddNOCID = 6,

	ClusterOperationalCredentialsCommandUpdateNOCID = 7,

	ClusterOperationalCredentialsCommandNOCResponseID = 8,

	ClusterOperationalCredentialsCommandUpdateFabricLabelID = 9,

	ClusterOperationalCredentialsCommandRemoveFabricID = 10,

	ClusterOperationalCredentialsCommandAddTrustedRootCertificateID = 11,

	CommandIDTypeClusterOperationalCredentialsCommandAttestationRequestID = 0,

	CommandIDTypeClusterOperationalCredentialsCommandAttestationResponseID = 1,

	CommandIDTypeClusterOperationalCredentialsCommandCertificateChainRequestID = 2,

	CommandIDTypeClusterOperationalCredentialsCommandCertificateChainResponseID = 3,

	CommandIDTypeClusterOperationalCredentialsCommandCSRRequestID = 4,

	CommandIDTypeClusterOperationalCredentialsCommandCSRResponseID = 5,

	CommandIDTypeClusterOperationalCredentialsCommandAddNOCID = 6,

	CommandIDTypeClusterOperationalCredentialsCommandUpdateNOCID = 7,

	CommandIDTypeClusterOperationalCredentialsCommandNOCResponseID = 8,

	CommandIDTypeClusterOperationalCredentialsCommandUpdateFabricLabelID = 9,

	CommandIDTypeClusterOperationalCredentialsCommandRemoveFabricID = 10,

	CommandIDTypeClusterOperationalCredentialsCommandAddTrustedRootCertificateID = 11,

	ClusterGroupKeyManagementCommandKeySetWriteID = 0,

	ClusterGroupKeyManagementCommandKeySetReadID = 1,

	ClusterGroupKeyManagementCommandKeySetReadResponseID = 2,

	ClusterGroupKeyManagementCommandKeySetRemoveID = 3,

	ClusterGroupKeyManagementCommandKeySetReadAllIndicesID = 4,

	ClusterGroupKeyManagementCommandKeySetReadAllIndicesResponseID = 5,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetWriteID = 0,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetReadID = 1,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetReadResponseID = 2,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetRemoveID = 3,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetReadAllIndicesID = 4,

	CommandIDTypeClusterGroupKeyManagementCommandKeySetReadAllIndicesResponseID = 5,

	CommandIDTypeClusterICDManagementCommandRegisterClientID = 0,

	CommandIDTypeClusterICDManagementCommandRegisterClientResponseID = 1,

	CommandIDTypeClusterICDManagementCommandUnregisterClientID = 2,

	CommandIDTypeClusterICDManagementCommandStayActiveRequestID = 3,

	CommandIDTypeClusterICDManagementCommandStayActiveResponseID = 4,

	CommandIDTypeClusterTimerCommandSetTimerID = 0,

	CommandIDTypeClusterTimerCommandResetTimerID = 1,

	CommandIDTypeClusterTimerCommandAddTimeID = 2,

	CommandIDTypeClusterTimerCommandReduceTimeID = 3,

	CommandIDTypeClusterOvenCavityOperationalStateCommandPauseID = 0,

	CommandIDTypeClusterOvenCavityOperationalStateCommandStopID = 1,

	CommandIDTypeClusterOvenCavityOperationalStateCommandStartID = 2,

	CommandIDTypeClusterOvenCavityOperationalStateCommandResumeID = 3,

	CommandIDTypeClusterOvenCavityOperationalStateCommandOperationalCommandResponseID = 4,

	CommandIDTypeClusterOvenModeCommandChangeToModeID = 0,

	CommandIDTypeClusterOvenModeCommandChangeToModeResponseID = 1,

	ClusterModeSelectCommandChangeToModeID = 0,

	CommandIDTypeClusterModeSelectCommandChangeToModeID = 0,

	CommandIDTypeClusterLaundryWasherModeCommandChangeToModeID = 0,

	CommandIDTypeClusterLaundryWasherModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeCommandChangeToModeID = 0,

	CommandIDTypeClusterRefrigeratorAndTemperatureControlledCabinetModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterRVCRunModeCommandChangeToModeID = 0,

	CommandIDTypeClusterRVCRunModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterRVCCleanModeCommandChangeToModeID = 0,

	CommandIDTypeClusterRVCCleanModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterTemperatureControlCommandSetTemperatureID = 0,

	CommandIDTypeClusterDishwasherModeCommandChangeToModeID = 0,

	CommandIDTypeClusterDishwasherModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterSmokeCOAlarmCommandSelfTestRequestID = 0,

	CommandIDTypeClusterDishwasherAlarmCommandResetID = 0,

	CommandIDTypeClusterDishwasherAlarmCommandModifyEnabledAlarmsID = 1,

	CommandIDTypeClusterMicrowaveOvenControlCommandSetCookingParametersID = 0,

	CommandIDTypeClusterMicrowaveOvenControlCommandAddMoreTimeID = 1,

	CommandIDTypeClusterOperationalStateCommandPauseID = 0,

	CommandIDTypeClusterOperationalStateCommandStopID = 1,

	CommandIDTypeClusterOperationalStateCommandStartID = 2,

	CommandIDTypeClusterOperationalStateCommandResumeID = 3,

	CommandIDTypeClusterOperationalStateCommandOperationalCommandResponseID = 4,

	CommandIDTypeClusterRVCOperationalStateCommandPauseID = 0,

	CommandIDTypeClusterRVCOperationalStateCommandResumeID = 3,

	CommandIDTypeClusterRVCOperationalStateCommandOperationalCommandResponseID = 4,

	CommandIDTypeClusterRVCOperationalStateCommandGoHomeID = 128,

	CommandIDTypeClusterScenesManagementCommandAddSceneID = 0,

	CommandIDTypeClusterScenesManagementCommandAddSceneResponseID = 0,

	CommandIDTypeClusterScenesManagementCommandViewSceneID = 1,

	CommandIDTypeClusterScenesManagementCommandViewSceneResponseID = 1,

	CommandIDTypeClusterScenesManagementCommandRemoveSceneID = 2,

	CommandIDTypeClusterScenesManagementCommandRemoveSceneResponseID = 2,

	CommandIDTypeClusterScenesManagementCommandRemoveAllScenesID = 3,

	CommandIDTypeClusterScenesManagementCommandRemoveAllScenesResponseID = 3,

	CommandIDTypeClusterScenesManagementCommandStoreSceneID = 4,

	CommandIDTypeClusterScenesManagementCommandStoreSceneResponseID = 4,

	CommandIDTypeClusterScenesManagementCommandRecallSceneID = 5,

	CommandIDTypeClusterScenesManagementCommandGetSceneMembershipID = 6,

	CommandIDTypeClusterScenesManagementCommandGetSceneMembershipResponseID = 6,

	CommandIDTypeClusterScenesManagementCommandCopySceneID = 64,

	CommandIDTypeClusterScenesManagementCommandCopySceneResponseID = 64,

	CommandIDTypeClusterHEPAFilterMonitoringCommandResetConditionID = 0,

	CommandIDTypeClusterActivatedCarbonFilterMonitoringCommandResetConditionID = 0,

	CommandIDTypeClusterBooleanStateConfigurationCommandSuppressAlarmID = 0,

	CommandIDTypeClusterBooleanStateConfigurationCommandEnableDisableAlarmID = 1,

	CommandIDTypeClusterValveConfigurationAndControlCommandOpenID = 0,

	CommandIDTypeClusterValveConfigurationAndControlCommandCloseID = 1,

	CommandIDTypeClusterWaterHeaterManagementCommandBoostID = 0,

	CommandIDTypeClusterWaterHeaterManagementCommandCancelBoostID = 1,

	CommandIDTypeClusterDemandResponseLoadControlCommandRegisterLoadControlProgramRequestID = 0,

	CommandIDTypeClusterDemandResponseLoadControlCommandUnregisterLoadControlProgramRequestID = 1,

	CommandIDTypeClusterDemandResponseLoadControlCommandAddLoadControlEventRequestID = 2,

	CommandIDTypeClusterDemandResponseLoadControlCommandRemoveLoadControlEventRequestID = 3,

	CommandIDTypeClusterDemandResponseLoadControlCommandClearLoadControlEventsRequestID = 4,

	CommandIDTypeClusterMessagesCommandPresentMessagesRequestID = 0,

	CommandIDTypeClusterMessagesCommandCancelMessagesRequestID = 1,

	CommandIDTypeClusterDeviceEnergyManagementCommandPowerAdjustRequestID = 0,

	CommandIDTypeClusterDeviceEnergyManagementCommandCancelPowerAdjustRequestID = 1,

	CommandIDTypeClusterDeviceEnergyManagementCommandStartTimeAdjustRequestID = 2,

	CommandIDTypeClusterDeviceEnergyManagementCommandPauseRequestID = 3,

	CommandIDTypeClusterDeviceEnergyManagementCommandResumeRequestID = 4,

	CommandIDTypeClusterDeviceEnergyManagementCommandModifyForecastRequestID = 5,

	CommandIDTypeClusterDeviceEnergyManagementCommandRequestConstraintBasedForecastID = 6,

	CommandIDTypeClusterDeviceEnergyManagementCommandCancelRequestID = 7,

	CommandIDTypeClusterEnergyEVSECommandGetTargetsResponseID = 0,

	CommandIDTypeClusterEnergyEVSECommandDisableID = 1,

	CommandIDTypeClusterEnergyEVSECommandEnableChargingID = 2,

	CommandIDTypeClusterEnergyEVSECommandEnableDischargingID = 3,

	CommandIDTypeClusterEnergyEVSECommandStartDiagnosticsID = 4,

	CommandIDTypeClusterEnergyEVSECommandSetTargetsID = 5,

	CommandIDTypeClusterEnergyEVSECommandGetTargetsID = 6,

	CommandIDTypeClusterEnergyEVSECommandClearTargetsID = 7,

	CommandIDTypeClusterEnergyEVSEModeCommandChangeToModeID = 0,

	CommandIDTypeClusterEnergyEVSEModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterWaterHeaterModeCommandChangeToModeID = 0,

	CommandIDTypeClusterWaterHeaterModeCommandChangeToModeResponseID = 1,

	CommandIDTypeClusterDeviceEnergyManagementModeCommandChangeToModeID = 0,

	CommandIDTypeClusterDeviceEnergyManagementModeCommandChangeToModeResponseID = 1,

	ClusterDoorLockCommandLockDoorID = 0,

	ClusterDoorLockCommandUnlockDoorID = 1,

	ClusterDoorLockCommandUnlockWithTimeoutID = 3,

	ClusterDoorLockCommandSetWeekDayScheduleID = 11,

	ClusterDoorLockCommandGetWeekDayScheduleID = 12,

	ClusterDoorLockCommandGetWeekDayScheduleResponseID = 12,

	ClusterDoorLockCommandClearWeekDayScheduleID = 13,

	ClusterDoorLockCommandSetYearDayScheduleID = 14,

	ClusterDoorLockCommandGetYearDayScheduleID = 15,

	ClusterDoorLockCommandGetYearDayScheduleResponseID = 15,

	ClusterDoorLockCommandClearYearDayScheduleID = 16,

	ClusterDoorLockCommandSetHolidayScheduleID = 17,

	ClusterDoorLockCommandGetHolidayScheduleID = 18,

	ClusterDoorLockCommandGetHolidayScheduleResponseID = 18,

	ClusterDoorLockCommandClearHolidayScheduleID = 19,

	ClusterDoorLockCommandSetUserID = 26,

	ClusterDoorLockCommandGetUserID = 27,

	ClusterDoorLockCommandGetUserResponseID = 28,

	ClusterDoorLockCommandClearUserID = 29,

	ClusterDoorLockCommandSetCredentialID = 34,

	ClusterDoorLockCommandSetCredentialResponseID = 35,

	ClusterDoorLockCommandGetCredentialStatusID = 36,

	ClusterDoorLockCommandGetCredentialStatusResponseID = 37,

	ClusterDoorLockCommandClearCredentialID = 38,

	CommandIDTypeClusterDoorLockCommandLockDoorID = 0,

	CommandIDTypeClusterDoorLockCommandUnlockDoorID = 1,

	CommandIDTypeClusterDoorLockCommandUnlockWithTimeoutID = 3,

	CommandIDTypeClusterDoorLockCommandSetWeekDayScheduleID = 11,

	CommandIDTypeClusterDoorLockCommandGetWeekDayScheduleID = 12,

	CommandIDTypeClusterDoorLockCommandGetWeekDayScheduleResponseID = 12,

	CommandIDTypeClusterDoorLockCommandClearWeekDayScheduleID = 13,

	CommandIDTypeClusterDoorLockCommandSetYearDayScheduleID = 14,

	CommandIDTypeClusterDoorLockCommandGetYearDayScheduleID = 15,

	CommandIDTypeClusterDoorLockCommandGetYearDayScheduleResponseID = 15,

	CommandIDTypeClusterDoorLockCommandClearYearDayScheduleID = 16,

	CommandIDTypeClusterDoorLockCommandSetHolidayScheduleID = 17,

	CommandIDTypeClusterDoorLockCommandGetHolidayScheduleID = 18,

	CommandIDTypeClusterDoorLockCommandGetHolidayScheduleResponseID = 18,

	CommandIDTypeClusterDoorLockCommandClearHolidayScheduleID = 19,

	CommandIDTypeClusterDoorLockCommandSetUserID = 26,

	CommandIDTypeClusterDoorLockCommandGetUserID = 27,

	CommandIDTypeClusterDoorLockCommandGetUserResponseID = 28,

	CommandIDTypeClusterDoorLockCommandClearUserID = 29,

	CommandIDTypeClusterDoorLockCommandSetCredentialID = 34,

	CommandIDTypeClusterDoorLockCommandSetCredentialResponseID = 35,

	CommandIDTypeClusterDoorLockCommandGetCredentialStatusID = 36,

	CommandIDTypeClusterDoorLockCommandGetCredentialStatusResponseID = 37,

	CommandIDTypeClusterDoorLockCommandClearCredentialID = 38,

	CommandIDTypeClusterDoorLockCommandUnboltDoorID = 39,

	CommandIDTypeClusterDoorLockCommandSetAliroReaderConfigID = 40,

	CommandIDTypeClusterDoorLockCommandClearAliroReaderConfigID = 41,

	CommandIDTypeClusterDoorLockCommandAppleSetAliroCredentialID = 323551232,

	CommandIDTypeClusterDoorLockCommandAppleGetAliroCredentialStatusID = 323551233,

	CommandIDTypeClusterDoorLockCommandAppleClearAliroCredentialID = 323551234,

	CommandIDTypeClusterDoorLockCommandAppleSetAliroReaderConfigID = 323551235,

	CommandIDTypeClusterDoorLockCommandAppleClearAliroReaderConfigID = 323551236,

	ClusterWindowCoveringCommandUpOrOpenID = 0,

	ClusterWindowCoveringCommandDownOrCloseID = 1,

	ClusterWindowCoveringCommandStopMotionID = 2,

	ClusterWindowCoveringCommandGoToLiftValueID = 4,

	ClusterWindowCoveringCommandGoToLiftPercentageID = 5,

	ClusterWindowCoveringCommandGoToTiltValueID = 7,

	ClusterWindowCoveringCommandGoToTiltPercentageID = 8,

	CommandIDTypeClusterWindowCoveringCommandUpOrOpenID = 0,

	CommandIDTypeClusterWindowCoveringCommandDownOrCloseID = 1,

	CommandIDTypeClusterWindowCoveringCommandStopMotionID = 2,

	CommandIDTypeClusterWindowCoveringCommandGoToLiftValueID = 4,

	CommandIDTypeClusterWindowCoveringCommandGoToLiftPercentageID = 5,

	CommandIDTypeClusterWindowCoveringCommandGoToTiltValueID = 7,

	CommandIDTypeClusterWindowCoveringCommandGoToTiltPercentageID = 8,

	CommandIDTypeClusterServiceAreaCommandSelectAreasID = 0,

	CommandIDTypeClusterServiceAreaCommandSelectAreasResponseID = 1,

	CommandIDTypeClusterServiceAreaCommandSkipAreaID = 2,

	CommandIDTypeClusterServiceAreaCommandSkipAreaResponseID = 3,

	ClusterThermostatCommandSetpointRaiseLowerID = 0,

	ClusterThermostatCommandGetWeeklyScheduleResponseID = 0,

	ClusterThermostatCommandSetWeeklyScheduleID = 1,

	ClusterThermostatCommandGetWeeklyScheduleID = 2,

	ClusterThermostatCommandClearWeeklyScheduleID = 3,

	CommandIDTypeClusterThermostatCommandSetpointRaiseLowerID = 0,

	CommandIDTypeClusterThermostatCommandGetWeeklyScheduleResponseID = 0,

	CommandIDTypeClusterThermostatCommandSetWeeklyScheduleID = 1,

	CommandIDTypeClusterThermostatCommandGetWeeklyScheduleID = 2,

	CommandIDTypeClusterThermostatCommandClearWeeklyScheduleID = 3,

	CommandIDTypeClusterThermostatCommandSetActiveScheduleRequestID = 5,

	CommandIDTypeClusterThermostatCommandSetActivePresetRequestID = 6,

	CommandIDTypeClusterThermostatCommandAtomicResponseID = 253,

	CommandIDTypeClusterThermostatCommandAtomicRequestID = 254,

	CommandIDTypeClusterFanControlCommandStepID = 0,

	ClusterColorControlCommandMoveToHueID = 0,

	ClusterColorControlCommandMoveHueID = 1,

	ClusterColorControlCommandStepHueID = 2,

	ClusterColorControlCommandMoveToSaturationID = 3,

	ClusterColorControlCommandMoveSaturationID = 4,

	ClusterColorControlCommandStepSaturationID = 5,

	ClusterColorControlCommandMoveToHueAndSaturationID = 6,

	ClusterColorControlCommandMoveToColorID = 7,

	ClusterColorControlCommandMoveColorID = 8,

	ClusterColorControlCommandStepColorID = 9,

	ClusterColorControlCommandMoveToColorTemperatureID = 10,

	ClusterColorControlCommandEnhancedMoveToHueID = 64,

	ClusterColorControlCommandEnhancedMoveHueID = 65,

	ClusterColorControlCommandEnhancedStepHueID = 66,

	ClusterColorControlCommandEnhancedMoveToHueAndSaturationID = 67,

	ClusterColorControlCommandColorLoopSetID = 68,

	ClusterColorControlCommandStopMoveStepID = 71,

	ClusterColorControlCommandMoveColorTemperatureID = 75,

	ClusterColorControlCommandStepColorTemperatureID = 76,

	CommandIDTypeClusterColorControlCommandMoveToHueID = 0,

	CommandIDTypeClusterColorControlCommandMoveHueID = 1,

	CommandIDTypeClusterColorControlCommandStepHueID = 2,

	CommandIDTypeClusterColorControlCommandMoveToSaturationID = 3,

	CommandIDTypeClusterColorControlCommandMoveSaturationID = 4,

	CommandIDTypeClusterColorControlCommandStepSaturationID = 5,

	CommandIDTypeClusterColorControlCommandMoveToHueAndSaturationID = 6,

	CommandIDTypeClusterColorControlCommandMoveToColorID = 7,

	CommandIDTypeClusterColorControlCommandMoveColorID = 8,

	CommandIDTypeClusterColorControlCommandStepColorID = 9,

	CommandIDTypeClusterColorControlCommandMoveToColorTemperatureID = 10,

	CommandIDTypeClusterColorControlCommandEnhancedMoveToHueID = 64,

	CommandIDTypeClusterColorControlCommandEnhancedMoveHueID = 65,

	CommandIDTypeClusterColorControlCommandEnhancedStepHueID = 66,

	CommandIDTypeClusterColorControlCommandEnhancedMoveToHueAndSaturationID = 67,

	CommandIDTypeClusterColorControlCommandColorLoopSetID = 68,

	CommandIDTypeClusterColorControlCommandStopMoveStepID = 71,

	CommandIDTypeClusterColorControlCommandMoveColorTemperatureID = 75,

	CommandIDTypeClusterColorControlCommandStepColorTemperatureID = 76,

	CommandIDTypeClusterWiFiNetworkManagementCommandNetworkPassphraseRequestID = 0,

	CommandIDTypeClusterWiFiNetworkManagementCommandNetworkPassphraseResponseID = 1,

	CommandIDTypeClusterThreadBorderRouterManagementCommandGetActiveDatasetRequestID = 0,

	CommandIDTypeClusterThreadBorderRouterManagementCommandGetPendingDatasetRequestID = 1,

	CommandIDTypeClusterThreadBorderRouterManagementCommandDatasetResponseID = 2,

	CommandIDTypeClusterThreadBorderRouterManagementCommandSetActiveDatasetRequestID = 3,

	CommandIDTypeClusterThreadBorderRouterManagementCommandSetPendingDatasetRequestID = 4,

	CommandIDTypeClusterThreadNetworkDirectoryCommandAddNetworkID = 0,

	CommandIDTypeClusterThreadNetworkDirectoryCommandRemoveNetworkID = 1,

	CommandIDTypeClusterThreadNetworkDirectoryCommandGetOperationalDatasetID = 2,

	CommandIDTypeClusterThreadNetworkDirectoryCommandOperationalDatasetResponseID = 3,

	ClusterChannelCommandChangeChannelID = 0,

	ClusterChannelCommandChangeChannelResponseID = 1,

	ClusterChannelCommandChangeChannelByNumberID = 2,

	ClusterChannelCommandSkipChannelID = 3,

	CommandIDTypeClusterChannelCommandChangeChannelID = 0,

	CommandIDTypeClusterChannelCommandChangeChannelResponseID = 1,

	CommandIDTypeClusterChannelCommandChangeChannelByNumberID = 2,

	CommandIDTypeClusterChannelCommandSkipChannelID = 3,

	CommandIDTypeClusterChannelCommandGetProgramGuideID = 4,

	CommandIDTypeClusterChannelCommandProgramGuideResponseID = 5,

	CommandIDTypeClusterChannelCommandRecordProgramID = 6,

	CommandIDTypeClusterChannelCommandCancelRecordProgramID = 7,

	ClusterTargetNavigatorCommandNavigateTargetID = 0,

	ClusterTargetNavigatorCommandNavigateTargetResponseID = 1,

	CommandIDTypeClusterTargetNavigatorCommandNavigateTargetID = 0,

	CommandIDTypeClusterTargetNavigatorCommandNavigateTargetResponseID = 1,

	ClusterMediaPlaybackCommandPlayID = 0,

	ClusterMediaPlaybackCommandPauseID = 1,

	ClusterMediaPlaybackCommandStopPlaybackID = 2,

	ClusterMediaPlaybackCommandStartOverID = 3,

	ClusterMediaPlaybackCommandPreviousID = 4,

	ClusterMediaPlaybackCommandNextID = 5,

	ClusterMediaPlaybackCommandRewindID = 6,

	ClusterMediaPlaybackCommandFastForwardID = 7,

	ClusterMediaPlaybackCommandSkipForwardID = 8,

	ClusterMediaPlaybackCommandSkipBackwardID = 9,

	ClusterMediaPlaybackCommandPlaybackResponseID = 10,

	ClusterMediaPlaybackCommandSeekID = 11,

	CommandIDTypeClusterMediaPlaybackCommandPlayID = 0,

	CommandIDTypeClusterMediaPlaybackCommandPauseID = 1,

	CommandIDTypeClusterMediaPlaybackCommandStopID = 2,

	CommandIDTypeClusterMediaPlaybackCommandStartOverID = 3,

	CommandIDTypeClusterMediaPlaybackCommandPreviousID = 4,

	CommandIDTypeClusterMediaPlaybackCommandNextID = 5,

	CommandIDTypeClusterMediaPlaybackCommandRewindID = 6,

	CommandIDTypeClusterMediaPlaybackCommandFastForwardID = 7,

	CommandIDTypeClusterMediaPlaybackCommandSkipForwardID = 8,

	CommandIDTypeClusterMediaPlaybackCommandSkipBackwardID = 9,

	CommandIDTypeClusterMediaPlaybackCommandPlaybackResponseID = 10,

	CommandIDTypeClusterMediaPlaybackCommandSeekID = 11,

	CommandIDTypeClusterMediaPlaybackCommandActivateAudioTrackID = 12,

	CommandIDTypeClusterMediaPlaybackCommandActivateTextTrackID = 13,

	CommandIDTypeClusterMediaPlaybackCommandDeactivateTextTrackID = 14,

	ClusterMediaInputCommandSelectInputID = 0,

	ClusterMediaInputCommandShowInputStatusID = 1,

	ClusterMediaInputCommandHideInputStatusID = 2,

	ClusterMediaInputCommandRenameInputID = 3,

	CommandIDTypeClusterMediaInputCommandSelectInputID = 0,

	CommandIDTypeClusterMediaInputCommandShowInputStatusID = 1,

	CommandIDTypeClusterMediaInputCommandHideInputStatusID = 2,

	CommandIDTypeClusterMediaInputCommandRenameInputID = 3,

	ClusterLowPowerCommandSleepID = 0,

	CommandIDTypeClusterLowPowerCommandSleepID = 0,

	ClusterKeypadInputCommandSendKeyID = 0,

	ClusterKeypadInputCommandSendKeyResponseID = 1,

	CommandIDTypeClusterKeypadInputCommandSendKeyID = 0,

	CommandIDTypeClusterKeypadInputCommandSendKeyResponseID = 1,

	ClusterContentLauncherCommandLaunchContentID = 0,

	ClusterContentLauncherCommandLaunchURLID = 1,

	ClusterContentLauncherCommandLaunchResponseID = 2,

	CommandIDTypeClusterContentLauncherCommandLaunchContentID = 0,

	CommandIDTypeClusterContentLauncherCommandLaunchURLID = 1,

	CommandIDTypeClusterContentLauncherCommandLauncherResponseID = 2,

	ClusterAudioOutputCommandSelectOutputID = 0,

	ClusterAudioOutputCommandRenameOutputID = 1,

	CommandIDTypeClusterAudioOutputCommandSelectOutputID = 0,

	CommandIDTypeClusterAudioOutputCommandRenameOutputID = 1,

	ClusterApplicationLauncherCommandLaunchAppID = 0,

	ClusterApplicationLauncherCommandStopAppID = 1,

	ClusterApplicationLauncherCommandHideAppID = 2,

	ClusterApplicationLauncherCommandLauncherResponseID = 3,

	CommandIDTypeClusterApplicationLauncherCommandLaunchAppID = 0,

	CommandIDTypeClusterApplicationLauncherCommandStopAppID = 1,

	CommandIDTypeClusterApplicationLauncherCommandHideAppID = 2,

	CommandIDTypeClusterApplicationLauncherCommandLauncherResponseID = 3,

	ClusterAccountLoginCommandGetSetupPINID = 0,

	ClusterAccountLoginCommandGetSetupPINResponseID = 1,

	ClusterAccountLoginCommandLoginID = 2,

	ClusterAccountLoginCommandLogoutID = 3,

	CommandIDTypeClusterAccountLoginCommandGetSetupPINID = 0,

	CommandIDTypeClusterAccountLoginCommandGetSetupPINResponseID = 1,

	CommandIDTypeClusterAccountLoginCommandLoginID = 2,

	CommandIDTypeClusterAccountLoginCommandLogoutID = 3,

	CommandIDTypeClusterContentControlCommandUpdatePINID = 0,

	CommandIDTypeClusterContentControlCommandResetPINID = 1,

	CommandIDTypeClusterContentControlCommandResetPINResponseID = 2,

	CommandIDTypeClusterContentControlCommandEnableID = 3,

	CommandIDTypeClusterContentControlCommandDisableID = 4,

	CommandIDTypeClusterContentControlCommandAddBonusTimeID = 5,

	CommandIDTypeClusterContentControlCommandSetScreenDailyTimeID = 6,

	CommandIDTypeClusterContentControlCommandBlockUnratedContentID = 7,

	CommandIDTypeClusterContentControlCommandUnblockUnratedContentID = 8,

	CommandIDTypeClusterContentControlCommandSetOnDemandRatingThresholdID = 9,

	CommandIDTypeClusterContentControlCommandSetScheduledContentRatingThresholdID = 10,

	CommandIDTypeClusterContentAppObserverCommandContentAppMessageID = 0,

	CommandIDTypeClusterContentAppObserverCommandContentAppMessageResponseID = 1,

	CommandIDTypeClusterZoneManagementCommandCreateTwoDCartesianZoneID = 0,

	CommandIDTypeClusterZoneManagementCommandCreateTwoDCartesianZoneResponseID = 1,

	CommandIDTypeClusterZoneManagementCommandUpdateTwoDCartesianZoneID = 2,

	CommandIDTypeClusterZoneManagementCommandGetTwoDCartesianZoneID = 3,

	CommandIDTypeClusterZoneManagementCommandGetTwoDCartesianZoneResponseID = 4,

	CommandIDTypeClusterZoneManagementCommandRemoveZoneID = 5,

	CommandIDTypeClusterCameraAVStreamManagementCommandAudioStreamAllocateID = 0,

	CommandIDTypeClusterCameraAVStreamManagementCommandAudioStreamAllocateResponseID = 1,

	CommandIDTypeClusterCameraAVStreamManagementCommandAudioStreamDeallocateID = 2,

	CommandIDTypeClusterCameraAVStreamManagementCommandVideoStreamAllocateID = 3,

	CommandIDTypeClusterCameraAVStreamManagementCommandVideoStreamAllocateResponseID = 4,

	CommandIDTypeClusterCameraAVStreamManagementCommandVideoStreamModifyID = 5,

	CommandIDTypeClusterCameraAVStreamManagementCommandVideoStreamDeallocateID = 6,

	CommandIDTypeClusterCameraAVStreamManagementCommandSnapshotStreamAllocateID = 7,

	CommandIDTypeClusterCameraAVStreamManagementCommandSnapshotStreamAllocateResponseID = 8,

	CommandIDTypeClusterCameraAVStreamManagementCommandSnapshotStreamDeallocateID = 9,

	CommandIDTypeClusterCameraAVStreamManagementCommandSetStreamPrioritiesID = 10,

	CommandIDTypeClusterCameraAVStreamManagementCommandCaptureSnapshotID = 11,

	CommandIDTypeClusterCameraAVStreamManagementCommandCaptureSnapshotResponseID = 12,

	CommandIDTypeClusterCameraAVStreamManagementCommandSetViewportID = 13,

	CommandIDTypeClusterCameraAVStreamManagementCommandSetImageRotationID = 14,

	CommandIDTypeClusterCameraAVStreamManagementCommandSetImageFlipHorizontalID = 15,

	CommandIDTypeClusterCameraAVStreamManagementCommandSetImageFlipVerticalID = 16,

	CommandIDTypeClusterWebRTCTransportProviderCommandSolicitOfferID = 1,

	CommandIDTypeClusterWebRTCTransportProviderCommandSolicitOfferResponseID = 2,

	CommandIDTypeClusterWebRTCTransportProviderCommandProvideOfferID = 3,

	CommandIDTypeClusterWebRTCTransportProviderCommandProvideOfferResponseID = 4,

	CommandIDTypeClusterWebRTCTransportProviderCommandProvideAnswerID = 5,

	CommandIDTypeClusterWebRTCTransportProviderCommandProvideICECandidateID = 6,

	CommandIDTypeClusterWebRTCTransportProviderCommandEndSessionID = 7,

	CommandIDTypeClusterWebRTCTransportRequestorCommandOfferID = 1,

	CommandIDTypeClusterWebRTCTransportRequestorCommandAnswerID = 2,

	CommandIDTypeClusterWebRTCTransportRequestorCommandICECandidateID = 3,

	CommandIDTypeClusterWebRTCTransportRequestorCommandEndID = 4,

	CommandIDTypeClusterChimeCommandPlayChimeSoundID = 0,

	CommandIDTypeClusterCommissionerControlCommandRequestCommissioningApprovalID = 0,

	CommandIDTypeClusterCommissionerControlCommandCommissionNodeID = 1,

	CommandIDTypeClusterCommissionerControlCommandReverseOpenCommissioningWindowID = 2,

	ClusterTestClusterCommandTestID = 0,

	ClusterTestClusterCommandTestSpecificResponseID = 0,

	ClusterTestClusterCommandTestNotHandledID = 1,

	ClusterTestClusterCommandTestAddArgumentsResponseID = 1,

	ClusterTestClusterCommandTestSpecificID = 2,

	ClusterTestClusterCommandTestSimpleArgumentResponseID = 2,

	ClusterTestClusterCommandTestUnknownCommandID = 3,

	ClusterTestClusterCommandTestStructArrayArgumentResponseID = 3,

	ClusterTestClusterCommandTestAddArgumentsID = 4,

	ClusterTestClusterCommandTestListInt8UReverseResponseID = 4,

	ClusterTestClusterCommandTestSimpleArgumentRequestID = 5,

	ClusterTestClusterCommandTestEnumsResponseID = 5,

	ClusterTestClusterCommandTestStructArrayArgumentRequestID = 6,

	ClusterTestClusterCommandTestNullableOptionalResponseID = 6,

	ClusterTestClusterCommandTestStructArgumentRequestID = 7,

	ClusterTestClusterCommandTestComplexNullableOptionalResponseID = 7,

	ClusterTestClusterCommandTestNestedStructArgumentRequestID = 8,

	ClusterTestClusterCommandBooleanResponseID = 8,

	ClusterTestClusterCommandTestListStructArgumentRequestID = 9,

	ClusterTestClusterCommandSimpleStructResponseID = 9,

	ClusterTestClusterCommandTestListInt8UArgumentRequestID = 10,

	ClusterTestClusterCommandTestEmitTestEventResponseID = 10,

	ClusterTestClusterCommandTestNestedStructListArgumentRequestID = 11,

	ClusterTestClusterCommandTestEmitTestFabricScopedEventResponseID = 11,

	ClusterTestClusterCommandTestListNestedStructListArgumentRequestID = 12,

	ClusterTestClusterCommandTestListInt8UReverseRequestID = 13,

	ClusterTestClusterCommandTestEnumsRequestID = 14,

	ClusterTestClusterCommandTestNullableOptionalRequestID = 15,

	ClusterTestClusterCommandTestComplexNullableOptionalRequestID = 16,

	ClusterTestClusterCommandSimpleStructEchoRequestID = 17,

	ClusterTestClusterCommandTimedInvokeRequestID = 18,

	ClusterTestClusterCommandTestSimpleOptionalArgumentRequestID = 19,

	ClusterTestClusterCommandTestEmitTestEventRequestID = 20,

	ClusterTestClusterCommandTestEmitTestFabricScopedEventRequestID = 21,

	CommandIDTypeClusterUnitTestingCommandTestID = 0,

	CommandIDTypeClusterUnitTestingCommandTestSpecificResponseID = 0,

	CommandIDTypeClusterUnitTestingCommandTestNotHandledID = 1,

	CommandIDTypeClusterUnitTestingCommandTestAddArgumentsResponseID = 1,

	CommandIDTypeClusterUnitTestingCommandTestSpecificID = 2,

	CommandIDTypeClusterUnitTestingCommandTestSimpleArgumentResponseID = 2,

	CommandIDTypeClusterUnitTestingCommandTestUnknownCommandID = 3,

	CommandIDTypeClusterUnitTestingCommandTestStructArrayArgumentResponseID = 3,

	CommandIDTypeClusterUnitTestingCommandTestAddArgumentsID = 4,

	CommandIDTypeClusterUnitTestingCommandTestListInt8UReverseResponseID = 4,

	CommandIDTypeClusterUnitTestingCommandTestSimpleArgumentRequestID = 5,

	CommandIDTypeClusterUnitTestingCommandTestEnumsResponseID = 5,

	CommandIDTypeClusterUnitTestingCommandTestStructArrayArgumentRequestID = 6,

	CommandIDTypeClusterUnitTestingCommandTestNullableOptionalResponseID = 6,

	CommandIDTypeClusterUnitTestingCommandTestStructArgumentRequestID = 7,

	CommandIDTypeClusterUnitTestingCommandTestComplexNullableOptionalResponseID = 7,

	CommandIDTypeClusterUnitTestingCommandTestNestedStructArgumentRequestID = 8,

	CommandIDTypeClusterUnitTestingCommandBooleanResponseID = 8,

	CommandIDTypeClusterUnitTestingCommandTestListStructArgumentRequestID = 9,

	CommandIDTypeClusterUnitTestingCommandSimpleStructResponseID = 9,

	CommandIDTypeClusterUnitTestingCommandTestListInt8UArgumentRequestID = 10,

	CommandIDTypeClusterUnitTestingCommandTestEmitTestEventResponseID = 10,

	CommandIDTypeClusterUnitTestingCommandTestNestedStructListArgumentRequestID = 11,

	CommandIDTypeClusterUnitTestingCommandTestEmitTestFabricScopedEventResponseID = 11,

	CommandIDTypeClusterUnitTestingCommandTestListNestedStructListArgumentRequestID = 12,

	CommandIDTypeClusterUnitTestingCommandTestBatchHelperResponseID = 12,

	CommandIDTypeClusterUnitTestingCommandTestListInt8UReverseRequestID = 13,

	CommandIDTypeClusterUnitTestingCommandStringEchoResponseID = 13,

	CommandIDTypeClusterUnitTestingCommandTestEnumsRequestID = 14,

	CommandIDTypeClusterUnitTestingCommandGlobalEchoResponseID = 14,

	CommandIDTypeClusterUnitTestingCommandTestNullableOptionalRequestID = 15,

	CommandIDTypeClusterUnitTestingCommandTestComplexNullableOptionalRequestID = 16,

	CommandIDTypeClusterUnitTestingCommandSimpleStructEchoRequestID = 17,

	CommandIDTypeClusterUnitTestingCommandTimedInvokeRequestID = 18,

	CommandIDTypeClusterUnitTestingCommandTestSimpleOptionalArgumentRequestID = 19,

	CommandIDTypeClusterUnitTestingCommandTestEmitTestEventRequestID = 20,

	CommandIDTypeClusterUnitTestingCommandTestEmitTestFabricScopedEventRequestID = 21,

	CommandIDTypeClusterUnitTestingCommandTestBatchHelperRequestID = 22,

	CommandIDTypeClusterUnitTestingCommandTestSecondBatchHelperRequestID = 23,

	CommandIDTypeClusterUnitTestingCommandStringEchoRequestID = 24,

	CommandIDTypeClusterUnitTestingCommandGlobalEchoRequestID = 25,

	CommandIDTypeClusterUnitTestingCommandTestDifferentVendorMeiRequestID = 4294049962,

	CommandIDTypeClusterUnitTestingCommandTestDifferentVendorMeiResponseID = 4294049979,

	CommandIDTypeClusterSampleMEICommandPingID = 0,

	CommandIDTypeClusterSampleMEICommandAddArgumentsResponseID = 1,

	CommandIDTypeClusterSampleMEICommandAddArgumentsID = 2,

	ClusterBarrierControlCommandBarrierControlGoToPercentID = 0,

	ClusterBarrierControlCommandBarrierControlStopID = 1,

	CommandIDTypeClusterBarrierControlCommandBarrierControlGoToPercentID = 0,

	CommandIDTypeClusterBarrierControlCommandBarrierControlStopID = 1,

	ClusterElectricalMeasurementCommandGetProfileInfoResponseCommandID = 0,

	ClusterElectricalMeasurementCommandGetProfileInfoCommandID = 0,

	ClusterElectricalMeasurementCommandGetMeasurementProfileResponseCommandID = 1,

	ClusterElectricalMeasurementCommandGetMeasurementProfileCommandID = 1,

	CommandIDTypeClusterElectricalMeasurementCommandGetProfileInfoResponseCommandID = 0,

	CommandIDTypeClusterElectricalMeasurementCommandGetProfileInfoCommandID = 0,

	CommandIDTypeClusterElectricalMeasurementCommandGetMeasurementProfileResponseCommandID = 1,

	CommandIDTypeClusterElectricalMeasurementCommandGetMeasurementProfileCommandID = 1
}

/**
 * @since 16.1
 */
declare class MTRCommandPath extends MTRClusterPath {

	static alloc(): MTRCommandPath; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static commandPathWithEndpointIDClusterIDCommandID(endpointID: number, clusterID: number, commandID: number): MTRCommandPath;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static commandPathWithEndpointIdClusterIdCommandId(endpointId: number, clusterId: number, commandId: number): MTRCommandPath;

	static new(): MTRCommandPath; // inherited from NSObject

	readonly command: number;
}

/**
 * @since 16.1
 */
declare var MTRCommandPathKey: string;

/**
 * @since 17.0
 */
interface MTRCommissionableBrowserDelegate extends NSObjectProtocol {

	controllerDidFindCommissionableDevice(controller: MTRDeviceController, device: MTRCommissionableBrowserResult): void;

	controllerDidRemoveCommissionableDevice(controller: MTRDeviceController, device: MTRCommissionableBrowserResult): void;
}
declare var MTRCommissionableBrowserDelegate: {

	prototype: MTRCommissionableBrowserDelegate;
};

/**
 * @since 17.0
 */
declare class MTRCommissionableBrowserResult extends NSObject {

	static alloc(): MTRCommissionableBrowserResult; // inherited from NSObject

	static new(): MTRCommissionableBrowserResult; // inherited from NSObject

	readonly commissioningMode: boolean;

	readonly discriminator: number;

	readonly instanceName: string;

	readonly productID: number;

	readonly vendorID: number;
}

/**
 * @since 16.1
 */
declare const enum MTRCommissioningFlow {

	Standard = 0,

	UserActionRequired = 1,

	Custom = 2,

	Invalid = 3
}

/**
 * @since 16.1
 */
declare class MTRCommissioningParameters extends NSObject {

	static alloc(): MTRCommissioningParameters; // inherited from NSObject

	static new(): MTRCommissioningParameters; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	CSRNonce: NSData;

	attestationNonce: NSData;

	/**
	 * @since 17.0
	 */
	countryCode: string;

	/**
	 * @since 16.4
	 */
	csrNonce: NSData;

	deviceAttestationDelegate: MTRDeviceAttestationDelegate;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	failSafeExpiryTimeoutSecs: number;

	/**
	 * @since 16.4
	 */
	failSafeTimeout: number;

	/**
	 * @since 17.0
	 */
	skipCommissioningComplete: boolean;

	threadOperationalDataset: NSData;

	wifiCredentials: NSData;

	wifiSSID: NSData;
}

/**
 * @since 16.4
 */
declare const enum MTRCommissioningStatus {

	Unknown = 0,

	Success = 1,

	Failed = 2,

	DiscoveringMoreDevices = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterAdditionalInfo extends MTRContentLauncherClusterAdditionalInfoStruct {

	static alloc(): MTRContentLauncherClusterAdditionalInfo; // inherited from NSObject

	static new(): MTRContentLauncherClusterAdditionalInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterAdditionalInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterAdditionalInfoStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterAdditionalInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	name: string;

	/**
	 * @since 16.4
	 */
	value: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterBrandingInformation extends MTRContentLauncherClusterBrandingInformationStruct {

	static alloc(): MTRContentLauncherClusterBrandingInformation; // inherited from NSObject

	static new(): MTRContentLauncherClusterBrandingInformation; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterBrandingInformationStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterBrandingInformationStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterBrandingInformationStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	background: MTRContentLauncherClusterStyleInformationStruct;

	/**
	 * @since 16.4
	 */
	logo: MTRContentLauncherClusterStyleInformationStruct;

	/**
	 * @since 16.4
	 */
	progressBar: MTRContentLauncherClusterStyleInformationStruct;

	/**
	 * @since 16.4
	 */
	providerName: string;

	/**
	 * @since 16.4
	 */
	splash: MTRContentLauncherClusterStyleInformationStruct;

	/**
	 * @since 16.4
	 */
	waterMark: MTRContentLauncherClusterStyleInformationStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterContentSearch extends MTRContentLauncherClusterContentSearchStruct {

	static alloc(): MTRContentLauncherClusterContentSearch; // inherited from NSObject

	static new(): MTRContentLauncherClusterContentSearch; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterContentSearchStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterContentSearchStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterContentSearchStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	parameterList: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterDimension extends MTRContentLauncherClusterDimensionStruct {

	static alloc(): MTRContentLauncherClusterDimension; // inherited from NSObject

	static new(): MTRContentLauncherClusterDimension; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterDimensionStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterDimensionStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterDimensionStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	height: number;

	/**
	 * @since 16.4
	 */
	metric: number;

	/**
	 * @since 16.4
	 */
	width: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRContentLauncherClusterLaunchContentParams extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterLaunchContentParams; // inherited from NSObject

	static new(): MTRContentLauncherClusterLaunchContentParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	autoPlay: number;

	/**
	 * @since 16.1
	 */
	data: string;

	/**
	 * @since 16.1
	 */
	search: MTRContentLauncherClusterContentSearchStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterLaunchResponseParams extends MTRContentLauncherClusterLauncherResponseParams {

	static alloc(): MTRContentLauncherClusterLaunchResponseParams; // inherited from NSObject

	static new(): MTRContentLauncherClusterLaunchResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare class MTRContentLauncherClusterLaunchURLParams extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterLaunchURLParams; // inherited from NSObject

	static new(): MTRContentLauncherClusterLaunchURLParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	brandingInformation: MTRContentLauncherClusterBrandingInformationStruct;

	/**
	 * @since 16.1
	 */
	contentURL: string;

	/**
	 * @since 16.1
	 */
	displayString: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterLauncherResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterLauncherResponseParams; // inherited from NSObject

	static new(): MTRContentLauncherClusterLauncherResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	data: string;

	/**
	 * @since 16.4
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterParameter extends MTRContentLauncherClusterParameterStruct {

	static alloc(): MTRContentLauncherClusterParameter; // inherited from NSObject

	static new(): MTRContentLauncherClusterParameter; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterParameterStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterParameterStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterParameterStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	externalIDList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	type: number;

	/**
	 * @since 16.4
	 */
	value: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRContentLauncherClusterStyleInformation extends MTRContentLauncherClusterStyleInformationStruct {

	static alloc(): MTRContentLauncherClusterStyleInformation; // inherited from NSObject

	static new(): MTRContentLauncherClusterStyleInformation; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRContentLauncherClusterStyleInformationStruct extends NSObject implements NSCopying {

	static alloc(): MTRContentLauncherClusterStyleInformationStruct; // inherited from NSObject

	static new(): MTRContentLauncherClusterStyleInformationStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	color: string;

	/**
	 * @since 16.4
	 */
	imageURL: string;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	imageUrl: string;

	/**
	 * @since 16.4
	 */
	size: MTRContentLauncherClusterDimensionStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRContentLauncherContentLaunchStatus {

	Success = 0,

	UrlNotAvailable = 1,

	AuthFailed = 2
}

/**
 * @since 16.1
 */
declare const enum MTRContentLauncherFeature {

	ContentSearch = 1,

	URLPlayback = 2,

	AdvancedSeek = 4,

	TextTracks = 8,

	AudioTracks = 16
}

/**
 * @since 16.1
 */
declare const enum MTRContentLauncherMetricType {

	Pixels = 0,

	PIXELS = 0,

	Percentage = 1,

	PERCENTAGE = 1
}

/**
 * @since 16.1
 */
declare const enum MTRContentLauncherParameter {

	Actor = 0,

	Channel = 1,

	Character = 2,

	Director = 3,

	Event = 4,

	Franchise = 5,

	Genre = 6,

	League = 7,

	Popularity = 8,

	Provider = 9,

	Sport = 10,

	SportsTeam = 11,

	Type = 12,

	Video = 13,

	Season = 14,

	Episode = 15,

	Any = 16
}

/**
 * @since 17.4
 */
declare const enum MTRContentLauncherStatus {

	Success = 0,

	URLNotAvailable = 1,

	AuthFailed = 2,

	TextTrackNotAvailable = 3,

	AudioTrackNotAvailable = 4
}

/**
 * @since 17.4
 */
declare const enum MTRContentLauncherSupportedProtocolsBitmap {

	DASH = 1,

	HLS = 2
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRContentLauncherSupportedStreamingProtocol {

	DASH = 1,

	HLS = 2
}

/**
 * @since 16.1
 */
declare var MTRContextTagKey: string;

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRControllerFactory extends NSObject {

	static alloc(): MTRControllerFactory; // inherited from NSObject

	static new(): MTRControllerFactory; // inherited from NSObject

	static sharedInstance(): MTRControllerFactory;

	readonly isRunning: boolean;

	shutdown(): void;

	startControllerOnExistingFabric(startupParams: MTRDeviceControllerStartupParams): MTRDeviceController;

	startControllerOnNewFabric(startupParams: MTRDeviceControllerStartupParams): MTRDeviceController;

	startup(startupParams: MTRControllerFactoryParams): boolean;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRControllerFactoryParams extends MTRDeviceControllerFactoryParams {

	static alloc(): MTRControllerFactoryParams; // inherited from NSObject

	static new(): MTRControllerFactoryParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	cdCerts: NSArray<NSData>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	paaCerts: NSArray<NSData>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	startServer: boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readonly storageDelegate: MTRPersistentStorageDelegate;
}

/**
 * @since 16.1
 */
declare var MTRDataKey: string;

/**
 * @since 17.6
 */
declare var MTRDataVersionKey: string;

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRDescriptorClusterDeviceType extends MTRDescriptorClusterDeviceTypeStruct {

	static alloc(): MTRDescriptorClusterDeviceType; // inherited from NSObject

	static new(): MTRDescriptorClusterDeviceType; // inherited from NSObject
}

/**
 * @since 16.2
 */
declare class MTRDescriptorClusterDeviceTypeStruct extends NSObject implements NSCopying {

	static alloc(): MTRDescriptorClusterDeviceTypeStruct; // inherited from NSObject

	static new(): MTRDescriptorClusterDeviceTypeStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	deviceType: number;

	/**
	 * @since 16.2
	 */
	revision: number;

	/**
	 * @since 16.2
	 * @deprecated 16.4
	 */
	type: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDevice extends NSObject {

	static alloc(): MTRDevice; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static deviceWithNodeIDController(nodeID: number, controller: MTRDeviceController): MTRDevice;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static deviceWithNodeIDDeviceController(nodeID: number, deviceController: MTRDeviceController): MTRDevice;

	static new(): MTRDevice; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	readonly deviceCachePrimed: boolean;

	/**
	 * @since 17.4
	 */
	readonly deviceController: MTRDeviceController;

	/**
	 * @since 16.5
	 */
	readonly estimatedStartTime: Date;

	/**
	 * @since 17.6
	 */
	readonly estimatedSubscriptionLatency: number;

	/**
	 * @since 17.4
	 */
	readonly nodeID: number;

	readonly state: MTRDeviceState;

	/**
	 * @since 18.0
	 */
	addDelegateQueue(delegate: MTRDeviceDelegate, queue: NSObject & OS_dispatch_queue): void;

	/**
	 * @since 18.0
	 */
	addDelegateQueueInterestedPathsForAttributesInterestedPathsForEvents(delegate: MTRDeviceDelegate, queue: NSObject & OS_dispatch_queue, interestedPathsForAttributes: NSArray<any> | any[], interestedPathsForEvents: NSArray<any> | any[]): void;

	/**
	 * @since 17.6
	 */
	downloadLogOfTypeTimeoutQueueCompletion(type: MTRDiagnosticLogType, timeout: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSURL, p2: NSError) => void): void;

	/**
	 * @since 17.4
	 */
	invokeCommandWithEndpointIDClusterIDCommandIDCommandFieldsExpectedValuesExpectedValueIntervalQueueCompletion(endpointID: number, clusterID: number, commandID: number, commandFields: NSDictionary<string, any>, expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueInterval: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	invokeCommandWithEndpointIDClusterIDCommandIDCommandFieldsExpectedValuesExpectedValueIntervalTimedInvokeTimeoutClientQueueCompletion(endpointID: number, clusterID: number, commandID: number, commandFields: any, expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueInterval: number, timeout: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	invokeCommandWithEndpointIDClusterIDCommandIDCommandFieldsExpectedValuesExpectedValueIntervalTimedInvokeTimeoutQueueCompletion(endpointID: number, clusterID: number, commandID: number, commandFields: any, expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueInterval: number, timeout: number, queue: NSObject & OS_dispatch_queue, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	/**
	 * @since 17.0
	 */
	openCommissioningWindowWithDiscriminatorDurationQueueCompletion(discriminator: number, duration: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRSetupPayload, p2: NSError) => void): void;

	/**
	 * @since 16.2
	 */
	openCommissioningWindowWithSetupPasscodeDiscriminatorDurationQueueCompletion(setupPasscode: number, discriminator: number, duration: number, queue: NSObject & OS_dispatch_queue, completion: (p1: MTRSetupPayload, p2: NSError) => void): void;

	/**
	 * @since 18.2
	 */
	readAttributePaths(attributePaths: NSArray<MTRAttributeRequestPath> | MTRAttributeRequestPath[]): NSArray<NSDictionary<string, any>>;

	readAttributeWithEndpointIDClusterIDAttributeIDParams(endpointID: number, clusterID: number, attributeID: number, params: MTRReadParams): NSDictionary<string, any>;

	/**
	 * @since 18.0
	 */
	removeDelegate(delegate: MTRDeviceDelegate): void;

	/**
	 * @since 16.1
	 * @deprecated 18.0
	 */
	setDelegateQueue(delegate: MTRDeviceDelegate, queue: NSObject & OS_dispatch_queue): void;

	writeAttributeWithEndpointIDClusterIDAttributeIDValueExpectedValueIntervalTimedWriteTimeout(endpointID: number, clusterID: number, attributeID: number, value: any, expectedValueInterval: number, timeout: number): void;
}

interface MTRDeviceAttestationDelegate extends NSObjectProtocol {

	/**
	 * @since 16.4
	 */
	deviceAttestationCompletedForControllerOpaqueDeviceHandleAttestationDeviceInfoError?(controller: MTRDeviceController, opaqueDeviceHandle: interop.Pointer | interop.Reference<any>, attestationDeviceInfo: MTRDeviceAttestationDeviceInfo, error: NSError): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	deviceAttestationCompletedForDeviceAttestationDeviceInfoError?(controller: MTRDeviceController, device: interop.Pointer | interop.Reference<any>, attestationDeviceInfo: MTRDeviceAttestationDeviceInfo, error: NSError): void;

	/**
	 * @since 16.4
	 */
	deviceAttestationFailedForControllerOpaqueDeviceHandleError?(controller: MTRDeviceController, opaqueDeviceHandle: interop.Pointer | interop.Reference<any>, error: NSError): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	deviceAttestationFailedForDeviceError?(controller: MTRDeviceController, device: interop.Pointer | interop.Reference<any>, error: NSError): void;
}
declare var MTRDeviceAttestationDelegate: {

	prototype: MTRDeviceAttestationDelegate;
};

/**
 * @since 16.1
 */
declare class MTRDeviceAttestationDeviceInfo extends NSObject {

	static alloc(): MTRDeviceAttestationDeviceInfo; // inherited from NSObject

	static new(): MTRDeviceAttestationDeviceInfo; // inherited from NSObject

	/**
	 * @since 16.6
	 */
	readonly basicInformationProductID: number;

	/**
	 * @since 16.6
	 */
	readonly basicInformationVendorID: number;

	readonly certificateDeclaration: NSData;

	readonly dacCertificate: NSData;

	readonly dacPAICertificate: NSData;

	/**
	 * @since 16.4
	 */
	readonly productID: number;

	/**
	 * @since 16.4
	 */
	readonly vendorID: number;
}

/**
 * @since 16.4
 */
declare class MTRDeviceAttestationInfo extends NSObject {

	static alloc(): MTRDeviceAttestationInfo; // inherited from NSObject

	static new(): MTRDeviceAttestationInfo; // inherited from NSObject

	readonly certificationDeclaration: NSData;

	readonly challenge: NSData;

	readonly deviceAttestationCertificate: NSData;

	readonly elementsSignature: NSData;

	readonly elementsTLV: NSData;

	readonly firmwareInfo: NSData;

	readonly nonce: NSData;

	readonly productAttestationIntermediateCertificate: NSData;

	constructor(o: { deviceAttestationChallenge: NSData; nonce: NSData; elementsTLV: NSData; elementsSignature: NSData; deviceAttestationCertificate: NSData; productAttestationIntermediateCertificate: NSData; certificationDeclaration: NSData; firmwareInfo: NSData; });

	initWithDeviceAttestationChallengeNonceElementsTLVElementsSignatureDeviceAttestationCertificateProductAttestationIntermediateCertificateCertificationDeclarationFirmwareInfo(challenge: NSData, nonce: NSData, elementsTLV: NSData, elementsSignature: NSData, deviceAttestationCertificate: NSData, processAttestationIntermediateCertificate: NSData, certificationDeclaration: NSData, firmwareInfo: NSData): this;
}

/**
 * @since 16.1
 */
declare class MTRDeviceController extends NSObject {

	static alloc(): MTRDeviceController; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static computePASEVerifierForSetupPasscodeIterationsSaltError(setupPasscode: number, iterations: number, salt: NSData): NSData;

	static decodeXPCReadParams(params: NSDictionary<string, any>): MTRReadParams;

	static decodeXPCResponseValues(values: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): NSArray<NSDictionary<string, any>>;

	static decodeXPCSubscribeParams(params: NSDictionary<string, any>): MTRSubscribeParams;

	static encodeXPCReadParams(params: MTRReadParams): NSDictionary<string, any>;

	static encodeXPCResponseValues(values: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): NSArray<NSDictionary<string, any>>;

	static encodeXPCSubscribeParams(params: MTRSubscribeParams): NSDictionary<string, any>;

	static new(): MTRDeviceController; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static sharedControllerWithIDXpcConnectBlock(controllerID: any, xpcConnectBlock: () => NSXPCConnection): MTRDeviceController;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static sharedControllerWithIdXpcConnectBlock(controllerID: any, xpcConnectBlock: () => NSXPCConnection): MTRDeviceController;

	/**
	 * @since 16.5
	 */
	static xpcInterfaceForClientProtocol(): NSXPCInterface;

	/**
	 * @since 16.5
	 */
	static xpcInterfaceForServerProtocol(): NSXPCInterface;

	/**
	 * @since 16.4
	 */
	readonly controllerNodeID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readonly controllerNodeId: number;

	readonly running: boolean;

	/**
	 * @since 18.2
	 */
	readonly suspended: boolean;

	/**
	 * @since 17.6
	 */
	readonly uniqueIdentifier: NSUUID;

	/**
	 * @since 17.6
	 */
	constructor(o: { parameters: MTRDeviceControllerAbstractParameters; });

	/**
	 * @since 18.2
	 */
	addDeviceControllerDelegateQueue(delegate: MTRDeviceControllerDelegate, queue: NSObject & OS_dispatch_queue): void;

	/**
	 * @since 17.6
	 */
	addServerEndpoint(endpoint: MTRServerEndpoint): boolean;

	/**
	 * @since 16.4
	 */
	attestationChallengeForDeviceID(deviceID: number): NSData;

	/**
	 * @since 16.4
	 */
	cancelCommissioningForNodeIDError(nodeID: number): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	commissionDeviceCommissioningParamsError(deviceId: number, commissioningParams: MTRCommissioningParameters): boolean;

	/**
	 * @since 16.4
	 */
	commissionNodeWithIDCommissioningParamsError(nodeID: number, commissioningParams: MTRCommissioningParameters): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	computePaseVerifierIterationsSalt(setupPincode: number, iterations: number, salt: NSData): NSData;

	continueCommissioningDeviceIgnoreAttestationFailureError(opaqueDeviceHandle: interop.Pointer | interop.Reference<any>, ignoreAttestationFailure: boolean): boolean;

	/**
	 * @since 16.4
	 */
	deviceBeingCommissionedWithNodeIDError(nodeID: number): MTRBaseDevice;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fetchAttestationChallengeForDeviceId(deviceId: number): NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getBaseDeviceQueueCompletionHandler(deviceID: number, queue: NSObject & OS_dispatch_queue, completionHandler: (p1: MTRBaseDevice, p2: NSError) => void): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getDeviceBeingCommissionedError(deviceId: number): MTRBaseDevice;

	/**
	 * @since 17.6
	 */
	initWithParametersError(parameters: MTRDeviceControllerAbstractParameters): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openPairingWindowDurationError(deviceID: number, duration: number): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	openPairingWindowWithPINDurationDiscriminatorSetupPINError(deviceID: number, duration: number, discriminator: number, setupPIN: number): string;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pairDeviceAddressPortSetupPINCodeError(deviceID: number, address: string, port: number, setupPINCode: number): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pairDeviceDiscriminatorSetupPINCodeError(deviceID: number, discriminator: number, setupPINCode: number): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	pairDeviceOnboardingPayloadError(deviceID: number, onboardingPayload: string): boolean;

	/**
	 * @since 16.4
	 * @deprecated 17.6
	 */
	preWarmCommissioningSession(): void;

	/**
	 * @since 18.2
	 */
	removeDeviceControllerDelegate(delegate: MTRDeviceControllerDelegate): void;

	/**
	 * @since 17.6
	 */
	removeServerEndpoint(endpoint: MTRServerEndpoint): void;

	/**
	 * @since 17.6
	 */
	removeServerEndpointQueueCompletion(endpoint: MTRServerEndpoint, queue: NSObject & OS_dispatch_queue, completion: () => void): void;

	/**
	 * @since 18.2
	 */
	resume(): void;

	/**
	 * @since 16.4
	 */
	setDeviceControllerDelegateQueue(delegate: MTRDeviceControllerDelegate, queue: NSObject & OS_dispatch_queue): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setNocChainIssuerQueue(nocChainIssuer: MTRNOCChainIssuer, queue: NSObject & OS_dispatch_queue): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setPairingDelegateQueue(delegate: MTRDevicePairingDelegate, queue: NSObject & OS_dispatch_queue): void;

	/**
	 * @since 17.0
	 */
	setupCommissioningSessionWithDiscoveredDevicePayloadNewNodeIDError(discoveredDevice: MTRCommissionableBrowserResult, payload: MTRSetupPayload, newNodeID: number): boolean;

	/**
	 * @since 16.2
	 */
	setupCommissioningSessionWithPayloadNewNodeIDError(payload: MTRSetupPayload, newNodeID: number): boolean;

	shutdown(): void;

	/**
	 * @since 17.0
	 */
	startBrowseForCommissionablesQueue(delegate: MTRCommissionableBrowserDelegate, queue: NSObject & OS_dispatch_queue): boolean;

	/**
	 * @since 17.0
	 */
	stopBrowseForCommissionables(): boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	stopDevicePairingError(deviceID: number): boolean;

	/**
	 * @since 18.2
	 */
	suspend(): void;
}

/**
 * @since 17.6
 */
declare class MTRDeviceControllerAbstractParameters extends NSObject {

	static alloc(): MTRDeviceControllerAbstractParameters; // inherited from NSObject

	static new(): MTRDeviceControllerAbstractParameters; // inherited from NSObject

	startSuspended: boolean;
}

interface MTRDeviceControllerClientProtocol extends NSObjectProtocol {

	handleReportWithControllerNodeIdValuesError(controller: any, nodeId: number, values: any, error: NSError): void;
}
declare var MTRDeviceControllerClientProtocol: {

	prototype: MTRDeviceControllerClientProtocol;
};

/**
 * @since 16.4
 */
interface MTRDeviceControllerDelegate extends NSObjectProtocol {

	/**
	 * @since 16.4
	 * @deprecated 17.0
	 */
	controllerCommissioningComplete?(controller: MTRDeviceController, error: NSError): void;

	/**
	 * @since 17.0
	 */
	controllerCommissioningCompleteNodeID?(controller: MTRDeviceController, error: NSError, nodeID: number): void;

	/**
	 * @since 17.6
	 */
	controllerCommissioningCompleteNodeIDMetrics?(controller: MTRDeviceController, error: NSError, nodeID: number, metrics: MTRMetrics): void;

	controllerCommissioningSessionEstablishmentDone?(controller: MTRDeviceController, error: NSError): void;

	/**
	 * @since 17.0
	 */
	controllerReadCommissioningInfo?(controller: MTRDeviceController, info: MTRProductIdentity): void;

	controllerStatusUpdate?(controller: MTRDeviceController, status: MTRCommissioningStatus): void;

	/**
	 * @since 18.2
	 */
	controllerSuspendedChangedTo?(controller: MTRDeviceController, suspended: boolean): void;
}
declare var MTRDeviceControllerDelegate: {

	prototype: MTRDeviceControllerDelegate;
};

/**
 * @since 17.6
 */
declare class MTRDeviceControllerExternalCertificateParameters extends MTRDeviceControllerParameters {

	static alloc(): MTRDeviceControllerExternalCertificateParameters; // inherited from NSObject

	static new(): MTRDeviceControllerExternalCertificateParameters; // inherited from NSObject

	/**
	 * @since 18.2
	 */
	readonly rootCertificate: NSData;

	constructor(o: { storageDelegate: MTRDeviceControllerStorageDelegate; storageDelegateQueue: NSObject & OS_dispatch_queue; uniqueIdentifier: NSUUID; ipk: NSData; vendorID: number; operationalKeypair: MTRKeypair; operationalCertificate: NSData; intermediateCertificate: NSData; rootCertificate: NSData; });

	initWithStorageDelegateStorageDelegateQueueUniqueIdentifierIpkVendorIDOperationalKeypairOperationalCertificateIntermediateCertificateRootCertificate(storageDelegate: MTRDeviceControllerStorageDelegate, storageDelegateQueue: NSObject & OS_dispatch_queue, uniqueIdentifier: NSUUID, ipk: NSData, vendorID: number, operationalKeypair: MTRKeypair, operationalCertificate: NSData, intermediateCertificate: NSData, rootCertificate: NSData): this;
}

/**
 * @since 16.4
 */
declare class MTRDeviceControllerFactory extends NSObject {

	static alloc(): MTRDeviceControllerFactory; // inherited from NSObject

	static new(): MTRDeviceControllerFactory; // inherited from NSObject

	static sharedInstance(): MTRDeviceControllerFactory;

	readonly knownFabrics: NSArray<MTRFabricInfo>;

	readonly running: boolean;

	createControllerOnExistingFabricError(startupParams: MTRDeviceControllerStartupParams): MTRDeviceController;

	createControllerOnNewFabricError(startupParams: MTRDeviceControllerStartupParams): MTRDeviceController;

	/**
	 * @since 17.6
	 */
	preWarmCommissioningSession(): void;

	startControllerFactoryError(startupParams: MTRDeviceControllerFactoryParams): boolean;

	stopControllerFactory(): void;
}

/**
 * @since 16.4
 */
declare class MTRDeviceControllerFactoryParams extends NSObject {

	static alloc(): MTRDeviceControllerFactoryParams; // inherited from NSObject

	static new(): MTRDeviceControllerFactoryParams; // inherited from NSObject

	certificationDeclarationCertificates: NSArray<NSData>;

	otaProviderDelegate: MTROTAProviderDelegate;

	port: number;

	productAttestationAuthorityCertificates: NSArray<NSData>;

	shouldStartServer: boolean;

	readonly storage: MTRStorage;

	constructor(o: { storage: MTRStorage; });

	initWithStorage(storage: MTRStorage): this;
}

/**
 * @since 17.6
 */
declare class MTRDeviceControllerParameters extends MTRDeviceControllerAbstractParameters {

	static alloc(): MTRDeviceControllerParameters; // inherited from NSObject

	static new(): MTRDeviceControllerParameters; // inherited from NSObject

	certificationDeclarationCertificates: NSArray<NSData>;

	/**
	 * @since 17.6
	 */
	concurrentSubscriptionEstablishmentsAllowedOnThread: number;

	productAttestationAuthorityCertificates: NSArray<NSData>;

	shouldAdvertiseOperational: boolean;

	storageBehaviorConfiguration: MTRDeviceStorageBehaviorConfiguration;

	setOTAProviderDelegateQueue(otaProviderDelegate: MTROTAProviderDelegate, queue: NSObject & OS_dispatch_queue): void;

	setOperationalCertificateIssuerQueue(operationalCertificateIssuer: MTROperationalCertificateIssuer, queue: NSObject & OS_dispatch_queue): void;
}

/**
 * @since 18.2
 */
declare var MTRDeviceControllerRegistrationControllerContextKey: string;

/**
 * @since 18.2
 */
declare var MTRDeviceControllerRegistrationNodeIDKey: string;

/**
 * @since 18.2
 */
declare var MTRDeviceControllerRegistrationNodeIDsKey: string;

interface MTRDeviceControllerServerProtocol extends NSObjectProtocol {

	/**
	 * @since 17.6
	 */
	downloadLogWithControllerNodeIdTypeTimeoutCompletion?(controller: any, nodeId: number, type: MTRDiagnosticLogType, timeout: number, completion: (p1: string, p2: NSError) => void): void;

	getAnyDeviceControllerWithCompletion(completion: (p1: any, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	getDeviceControllerWithFabricIdCompletion?(fabricId: number, completion: (p1: any, p2: NSError) => void): void;

	invokeCommandWithControllerNodeIdEndpointIdClusterIdCommandIdFieldsTimedInvokeTimeoutCompletion(controller: any, nodeId: number, endpointId: number, clusterId: number, commandId: number, fields: any, timeoutMs: number, completion: (p1: any, p2: NSError) => void): void;

	readAttributeCacheWithControllerNodeIdEndpointIdClusterIdAttributeIdCompletion(controller: any, nodeId: number, endpointId: number, clusterId: number, attributeId: number, completion: (p1: any, p2: NSError) => void): void;

	readAttributeWithControllerNodeIdEndpointIdClusterIdAttributeIdParamsCompletion(controller: any, nodeId: number, endpointId: number, clusterId: number, attributeId: number, params: NSDictionary<string, any>, completion: (p1: any, p2: NSError) => void): void;

	stopReportsWithControllerNodeIdCompletion(controller: any, nodeId: number, completion: () => void): void;

	subscribeAttributeWithControllerNodeIdEndpointIdClusterIdAttributeIdMinIntervalMaxIntervalParamsEstablishedHandler(controller: any, nodeId: number, endpointId: number, clusterId: number, attributeId: number, minInterval: number, maxInterval: number, params: NSDictionary<string, any>, establishedHandler: () => void): void;

	subscribeWithControllerNodeIdMinIntervalMaxIntervalParamsShouldCacheCompletion(controller: any, nodeId: number, minInterval: number, maxInterval: number, params: NSDictionary<string, any>, shouldCache: boolean, completion: (p1: NSError) => void): void;

	writeAttributeWithControllerNodeIdEndpointIdClusterIdAttributeIdValueTimedWriteTimeoutCompletion(controller: any, nodeId: number, endpointId: number, clusterId: number, attributeId: number, value: any, timeoutMs: number, completion: (p1: any, p2: NSError) => void): void;
}
declare var MTRDeviceControllerServerProtocol: {

	prototype: MTRDeviceControllerServerProtocol;
};

/**
 * @since 16.1
 */
declare class MTRDeviceControllerStartupParams extends NSObject {

	static alloc(): MTRDeviceControllerStartupParams; // inherited from NSObject

	static new(): MTRDeviceControllerStartupParams; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	caseAuthenticatedTags: NSSet<number>;

	/**
	 * @since 16.4
	 */
	readonly fabricID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	readonly fabricId: number;

	intermediateCertificate: NSData;

	readonly ipk: NSData;

	readonly nocSigner: MTRKeypair;

	/**
	 * @since 16.4
	 */
	nodeID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nodeId: number;

	readonly operationalCertificate: NSData;

	/**
	 * @since 16.4
	 */
	operationalCertificateIssuer: MTROperationalCertificateIssuer;

	/**
	 * @since 16.4
	 */
	operationalCertificateIssuerQueue: NSObject & OS_dispatch_queue;

	operationalKeypair: MTRKeypair;

	rootCertificate: NSData;

	/**
	 * @since 16.4
	 */
	vendorID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	vendorId: number;

	/**
	 * @since 16.4
	 */
	constructor(o: { IPK: NSData; fabricID: number; nocSigner: MTRKeypair; });

	/**
	 * @since 16.4
	 */
	constructor(o: { IPK: NSData; operationalKeypair: MTRKeypair; operationalCertificate: NSData; intermediateCertificate: NSData; rootCertificate: NSData; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { operationalKeypair: MTRKeypair; operationalCertificate: NSData; intermediateCertificate: NSData; rootCertificate: NSData; ipk: NSData; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { signingKeypair: MTRKeypair; fabricId: number; ipk: NSData; });

	/**
	 * @since 16.4
	 */
	initWithIPKFabricIDNocSigner(ipk: NSData, fabricID: number, nocSigner: MTRKeypair): this;

	/**
	 * @since 16.4
	 */
	initWithIPKOperationalKeypairOperationalCertificateIntermediateCertificateRootCertificate(ipk: NSData, operationalKeypair: MTRKeypair, operationalCertificate: NSData, intermediateCertificate: NSData, rootCertificate: NSData): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithOperationalKeypairOperationalCertificateIntermediateCertificateRootCertificateIpk(operationalKeypair: MTRKeypair, operationalCertificate: NSData, intermediateCertificate: NSData, rootCertificate: NSData, ipk: NSData): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithSigningKeypairFabricIdIpk(nocSigner: MTRKeypair, fabricId: number, ipk: NSData): this;
}

/**
 * @since 17.6
 */
declare function MTRDeviceControllerStorageClasses(): NSSet<typeof NSObject>;

/**
 * @since 17.6
 */
interface MTRDeviceControllerStorageDelegate extends NSObjectProtocol {

	controllerRemoveValueForKeySecurityLevelSharingType(controller: MTRDeviceController, key: string, securityLevel: MTRStorageSecurityLevel, sharingType: MTRStorageSharingType): boolean;

	controllerStoreValueForKeySecurityLevelSharingType(controller: MTRDeviceController, value: NSSecureCoding, key: string, securityLevel: MTRStorageSecurityLevel, sharingType: MTRStorageSharingType): boolean;

	controllerStoreValuesSecurityLevelSharingType?(controller: MTRDeviceController, values: NSDictionary<string, NSSecureCoding>, securityLevel: MTRStorageSecurityLevel, sharingType: MTRStorageSharingType): boolean;

	controllerValueForKeySecurityLevelSharingType(controller: MTRDeviceController, key: string, securityLevel: MTRStorageSecurityLevel, sharingType: MTRStorageSharingType): NSSecureCoding;

	valuesForControllerSecurityLevelSharingType?(controller: MTRDeviceController, securityLevel: MTRStorageSecurityLevel, sharingType: MTRStorageSharingType): NSDictionary<string, NSSecureCoding>;
}
declare var MTRDeviceControllerStorageDelegate: {

	prototype: MTRDeviceControllerStorageDelegate;
};

interface MTRDeviceDelegate extends NSObjectProtocol {

	/**
	 * @since 16.4
	 */
	deviceBecameActive?(device: MTRDevice): void;

	/**
	 * @since 17.6
	 */
	deviceCachePrimed?(device: MTRDevice): void;

	/**
	 * @since 17.6
	 */
	deviceConfigurationChanged?(device: MTRDevice): void;

	deviceReceivedAttributeReport(device: MTRDevice, attributeReport: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): void;

	deviceReceivedEventReport(device: MTRDevice, eventReport: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): void;

	deviceStateChanged(device: MTRDevice, state: MTRDeviceState): void;
}
declare var MTRDeviceDelegate: {

	prototype: MTRDeviceDelegate;
};

/**
 * @since 16.1
 * @deprecated 16.4
 */
interface MTRDevicePairingDelegate extends NSObjectProtocol {

	onCommissioningComplete?(error: NSError): void;

	onPairingComplete?(error: NSError): void;

	onPairingDeleted?(error: NSError): void;

	onStatusUpdate?(status: MTRPairingStatus): void;
}
declare var MTRDevicePairingDelegate: {

	prototype: MTRDevicePairingDelegate;
};

declare const enum MTRDeviceState {

	Unknown = 0,

	Reachable = 1,

	Unreachable = 2
}

/**
 * @since 17.6
 */
declare class MTRDeviceStorageBehaviorConfiguration extends NSObject implements NSCopying {

	static alloc(): MTRDeviceStorageBehaviorConfiguration; // inherited from NSObject

	static configurationWithDefaultStorageBehavior(): MTRDeviceStorageBehaviorConfiguration;

	static configurationWithReportToPersistenceDelayTimeReportToPersistenceDelayTimeMaxRecentReportTimesMaxCountTimeBetweenReportsTooShortThresholdTimeBetweenReportsTooShortMinThresholdReportToPersistenceDelayMaxMultiplierDeviceReportingExcessivelyIntervalThreshold(reportToPersistenceDelayTime: number, reportToPersistenceDelayTimeMax: number, recentReportTimesMaxCount: number, timeBetweenReportsTooShortThreshold: number, timeBetweenReportsTooShortMinThreshold: number, reportToPersistenceDelayMaxMultiplier: number, deviceReportingExcessivelyIntervalThreshold: number): MTRDeviceStorageBehaviorConfiguration;

	static configurationWithStorageBehaviorOptimizationDisabled(): MTRDeviceStorageBehaviorConfiguration;

	static new(): MTRDeviceStorageBehaviorConfiguration; // inherited from NSObject

	deviceReportingExcessivelyIntervalThreshold: number;

	disableStorageBehaviorOptimization: boolean;

	recentReportTimesMaxCount: number;

	reportToPersistenceDelayMaxMultiplier: number;

	reportToPersistenceDelayTime: number;

	reportToPersistenceDelayTimeMax: number;

	timeBetweenReportsTooShortMinThreshold: number;

	timeBetweenReportsTooShortThreshold: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 18.2
 */
declare class MTRDeviceType extends NSObject {

	static alloc(): MTRDeviceType; // inherited from NSObject

	static deviceTypeForID(deviceTypeID: number): MTRDeviceType;

	static new(): MTRDeviceType; // inherited from NSObject

	readonly id: number;

	readonly isUtility: boolean;

	readonly name: string;
}

/**
 * @since 18.2
 */
declare const enum MTRDeviceTypeIDType {

	DoorLockID = 10,

	DoorLockControllerID = 11,

	AggregatorID = 14,

	GenericSwitchID = 15,

	PowerSourceID = 17,

	OTARequestorID = 18,

	BridgedNodeID = 19,

	OTAProviderID = 20,

	ContactSensorID = 21,

	RootNodeID = 22,

	SecondaryNetworkInterfaceID = 25,

	SpeakerID = 34,

	CastingVideoPlayerID = 35,

	ContentAppID = 36,

	ModeSelectID = 39,

	BasicVideoPlayerID = 40,

	CastingVideoClientID = 41,

	VideoRemoteControlID = 42,

	FanID = 43,

	AirQualitySensorID = 44,

	AirPurifierID = 45,

	WaterFreezeDetectorID = 65,

	WaterValveID = 66,

	WaterLeakDetectorID = 67,

	RainSensorID = 68,

	RefrigeratorID = 112,

	TemperatureControlledCabinetID = 113,

	RoomAirConditionerID = 114,

	LaundryWasherID = 115,

	RoboticVacuumCleanerID = 116,

	DishwasherID = 117,

	SmokeCOAlarmID = 118,

	CookSurfaceID = 119,

	CooktopID = 120,

	MicrowaveOvenID = 121,

	ExtractorHoodID = 122,

	OvenID = 123,

	LaundryDryerID = 124,

	NetworkInfrastructureManagerID = 144,

	ThreadBorderRouterID = 145,

	OnOffLightID = 256,

	DimmableLightID = 257,

	OnOffLightSwitchID = 259,

	DimmerSwitchID = 260,

	ColorDimmerSwitchID = 261,

	LightSensorID = 262,

	OccupancySensorID = 263,

	OnOffPlugInUnitID = 266,

	DimmablePlugInUnitID = 267,

	ColorTemperatureLightID = 268,

	ExtendedColorLightID = 269,

	WindowCoveringID = 514,

	WindowCoveringControllerID = 515,

	HeatingCoolingUnitID = 768,

	ThermostatID = 769,

	TemperatureSensorID = 770,

	PumpID = 771,

	PumpControllerID = 772,

	PressureSensorID = 773,

	FlowSensorID = 774,

	HumiditySensorID = 775,

	EVSEID = 1292,

	DeviceEnergyManagementID = 1293,

	ElectricalSensorID = 1296,

	ControlBridgeID = 2112,

	OnOffSensorID = 2128
}

/**
 * @since 17.6
 */
declare class MTRDeviceTypeRevision extends NSObject implements NSCopying {

	static alloc(): MTRDeviceTypeRevision; // inherited from NSObject

	static new(): MTRDeviceTypeRevision; // inherited from NSObject

	readonly deviceTypeID: number;

	readonly deviceTypeRevision: number;

	constructor(o: { deviceTypeID: number; revision: number; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	initWithDeviceTypeIDRevision(deviceTypeID: number, revision: number): this;
}

/**
 * @since 17.6
 */
declare const enum MTRDiagnosticLogType {

	EndUserSupport = 0,

	NetworkDiagnostics = 1,

	Crash = 2
}

/**
 * @since 16.1
 */
declare class MTRDiagnosticLogsClusterRetrieveLogsRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRDiagnosticLogsClusterRetrieveLogsRequestParams; // inherited from NSObject

	static new(): MTRDiagnosticLogsClusterRetrieveLogsRequestParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	intent: number;

	/**
	 * @since 16.1
	 */
	requestedProtocol: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.5
	 */
	transferFileDesignator: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDiagnosticLogsClusterRetrieveLogsResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDiagnosticLogsClusterRetrieveLogsResponseParams; // inherited from NSObject

	static new(): MTRDiagnosticLogsClusterRetrieveLogsResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	content: NSData;

	/**
	 * @since 16.4
	 */
	logContent: NSData;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 */
	timeSinceBoot: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timeStamp: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	utcTimeStamp: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.5
 */
declare const enum MTRDiagnosticLogsIntent {

	EndUserSupport = 0,

	NetworkDiag = 1,

	CrashLogs = 2
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRDiagnosticLogsLogsIntent {

	EndUserSupport = 0,

	NetworkDiag = 1,

	CrashLogs = 2
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRDiagnosticLogsLogsStatus {

	Success = 0,

	Exhausted = 1,

	NoLogs = 2,

	Busy = 3,

	Denied = 4
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRDiagnosticLogsLogsTransferProtocol {

	ResponsePayload = 0,

	BDX = 1
}

/**
 * @since 16.5
 */
declare const enum MTRDiagnosticLogsStatus {

	Success = 0,

	Exhausted = 1,

	NoLogs = 2,

	Busy = 3,

	Denied = 4
}

/**
 * @since 16.5
 */
declare const enum MTRDiagnosticLogsTransferProtocol {

	ResponsePayload = 0,

	BDX = 1
}

declare const enum MTRDiscoveryCapabilities {

	Unknown = 0,

	None = 0,

	SoftAP = 1,

	BLE = 2,

	OnNetwork = 4,

	AllMask = 7
}

/**
 * @since 16.4
 */
declare class MTRDistinguishedNameInfo extends NSObject implements NSCopying {

	static alloc(): MTRDistinguishedNameInfo; // inherited from NSObject

	static new(): MTRDistinguishedNameInfo; // inherited from NSObject

	readonly caseAuthenticatedTags: NSSet<number>;

	readonly fabricID: number;

	readonly intermediateCACertificateID: number;

	readonly nodeID: number;

	readonly rootCACertificateID: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockAlarmCode {

	LockJammed = 0,

	LockFactoryReset = 1,

	LockRadioPowerCycled = 3,

	WrongCodeEntryLimit = 4,

	FrontEsceutcheonRemoved = 5,

	DoorForcedOpen = 6,

	DoorAjar = 7,

	ForcedUser = 8
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterClearCredentialParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterClearCredentialParams; // inherited from NSObject

	static new(): MTRDoorLockClusterClearCredentialParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credential: MTRDoorLockClusterCredentialStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterClearHolidayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterClearHolidayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterClearHolidayScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	holidayIndex: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterClearUserParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterClearUserParams; // inherited from NSObject

	static new(): MTRDoorLockClusterClearUserParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterClearWeekDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterClearWeekDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterClearWeekDayScheduleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	weekDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterClearYearDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterClearYearDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterClearYearDayScheduleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	yearDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRDoorLockClusterCredentialStruct extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterCredentialStruct; // inherited from NSObject

	static new(): MTRDoorLockClusterCredentialStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	credentialIndex: number;

	/**
	 * @since 16.4
	 */
	credentialType: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRDoorLockClusterDlCredential extends MTRDoorLockClusterCredentialStruct {

	static alloc(): MTRDoorLockClusterDlCredential; // inherited from NSObject

	static new(): MTRDoorLockClusterDlCredential; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterDoorLockAlarmEvent extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterDoorLockAlarmEvent; // inherited from NSObject

	static new(): MTRDoorLockClusterDoorLockAlarmEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	alarmCode: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterDoorStateChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterDoorStateChangeEvent; // inherited from NSObject

	static new(): MTRDoorLockClusterDoorStateChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	doorState: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetCredentialStatusParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetCredentialStatusParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetCredentialStatusParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credential: MTRDoorLockClusterCredentialStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetCredentialStatusResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetCredentialStatusResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetCredentialStatusResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	creatorFabricIndex: number;

	/**
	 * @since 16.1
	 */
	credentialExists: number;

	/**
	 * @since 16.1
	 */
	lastModifiedFabricIndex: number;

	/**
	 * @since 16.1
	 */
	nextCredentialIndex: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetHolidayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetHolidayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetHolidayScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	holidayIndex: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetHolidayScheduleResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetHolidayScheduleResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetHolidayScheduleResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	holidayIndex: number;

	/**
	 * @since 16.1
	 */
	localEndTime: number;

	/**
	 * @since 16.1
	 */
	localStartTime: number;

	/**
	 * @since 16.1
	 */
	operatingMode: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetUserParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetUserParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetUserParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetUserResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetUserResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetUserResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	creatorFabricIndex: number;

	/**
	 * @since 16.1
	 */
	credentialRule: number;

	/**
	 * @since 16.1
	 */
	credentials: NSArray<any>;

	/**
	 * @since 16.1
	 */
	lastModifiedFabricIndex: number;

	/**
	 * @since 16.1
	 */
	nextUserIndex: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	userName: string;

	/**
	 * @since 16.1
	 */
	userStatus: number;

	/**
	 * @since 16.1
	 */
	userType: number;

	/**
	 * @since 16.4
	 */
	userUniqueID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	userUniqueId: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetWeekDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetWeekDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetWeekDayScheduleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	weekDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetWeekDayScheduleResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetWeekDayScheduleResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetWeekDayScheduleResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	daysMask: number;

	/**
	 * @since 16.1
	 */
	endHour: number;

	/**
	 * @since 16.1
	 */
	endMinute: number;

	/**
	 * @since 16.1
	 */
	startHour: number;

	/**
	 * @since 16.1
	 */
	startMinute: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	weekDayIndex: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetYearDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetYearDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetYearDayScheduleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	yearDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterGetYearDayScheduleResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterGetYearDayScheduleResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterGetYearDayScheduleResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	localEndTime: number;

	/**
	 * @since 16.1
	 */
	localStartTime: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	yearDayIndex: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterLockDoorParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterLockDoorParams; // inherited from NSObject

	static new(): MTRDoorLockClusterLockDoorParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	pinCode: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterLockOperationErrorEvent extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterLockOperationErrorEvent; // inherited from NSObject

	static new(): MTRDoorLockClusterLockOperationErrorEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credentials: NSArray<any>;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	lockOperationType: number;

	/**
	 * @since 16.1
	 */
	operationError: number;

	/**
	 * @since 16.1
	 */
	operationSource: number;

	/**
	 * @since 16.1
	 */
	sourceNode: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterLockOperationEvent extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterLockOperationEvent; // inherited from NSObject

	static new(): MTRDoorLockClusterLockOperationEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credentials: NSArray<any>;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	lockOperationType: number;

	/**
	 * @since 16.1
	 */
	operationSource: number;

	/**
	 * @since 16.1
	 */
	sourceNode: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterLockUserChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterLockUserChangeEvent; // inherited from NSObject

	static new(): MTRDoorLockClusterLockUserChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	dataIndex: number;

	/**
	 * @since 16.1
	 */
	dataOperationType: number;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	lockDataType: number;

	/**
	 * @since 16.1
	 */
	operationSource: number;

	/**
	 * @since 16.1
	 */
	sourceNode: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetCredentialParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetCredentialParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetCredentialParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credential: MTRDoorLockClusterCredentialStruct;

	/**
	 * @since 16.1
	 */
	credentialData: NSData;

	/**
	 * @since 16.1
	 */
	operationType: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	userStatus: number;

	/**
	 * @since 16.1
	 */
	userType: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetCredentialResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetCredentialResponseParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetCredentialResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	nextCredentialIndex: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetHolidayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetHolidayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetHolidayScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	holidayIndex: number;

	/**
	 * @since 16.1
	 */
	localEndTime: number;

	/**
	 * @since 16.1
	 */
	localStartTime: number;

	/**
	 * @since 16.1
	 */
	operatingMode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetUserParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetUserParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetUserParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	credentialRule: number;

	/**
	 * @since 16.1
	 */
	operationType: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	userName: string;

	/**
	 * @since 16.1
	 */
	userStatus: number;

	/**
	 * @since 16.1
	 */
	userType: number;

	/**
	 * @since 16.4
	 */
	userUniqueID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	userUniqueId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetWeekDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetWeekDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetWeekDayScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	daysMask: number;

	/**
	 * @since 16.1
	 */
	endHour: number;

	/**
	 * @since 16.1
	 */
	endMinute: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	startHour: number;

	/**
	 * @since 16.1
	 */
	startMinute: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	weekDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterSetYearDayScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterSetYearDayScheduleParams; // inherited from NSObject

	static new(): MTRDoorLockClusterSetYearDayScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	localEndTime: number;

	/**
	 * @since 16.1
	 */
	localStartTime: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	userIndex: number;

	/**
	 * @since 16.1
	 */
	yearDayIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterUnlockDoorParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterUnlockDoorParams; // inherited from NSObject

	static new(): MTRDoorLockClusterUnlockDoorParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	pinCode: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRDoorLockClusterUnlockWithTimeoutParams extends NSObject implements NSCopying {

	static alloc(): MTRDoorLockClusterUnlockWithTimeoutParams; // inherited from NSObject

	static new(): MTRDoorLockClusterUnlockWithTimeoutParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	pinCode: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	timeout: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockCredentialRule {

	Single = 0,

	Dual = 1,

	Tri = 2
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockCredentialType {

	ProgrammingPIN = 0,

	PIN = 1,

	RFID = 2,

	Fingerprint = 3,

	FingerVein = 4,

	Face = 5,

	AliroCredentialIssuerKey = 6,

	AliroEvictableEndpointKey = 7,

	AliroNonEvictableEndpointKey = 8
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockDataOperationType {

	Add = 0,

	Clear = 1,

	Modify = 2
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDayOfWeek {

	Sunday = 1,

	Monday = 2,

	Tuesday = 4,

	Wednesday = 8,

	Thursday = 16,

	Friday = 32,

	Saturday = 64
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockDaysMaskMap {

	Sunday = 1,

	Monday = 2,

	Tuesday = 4,

	Wednesday = 8,

	Thursday = 16,

	Friday = 32,

	Saturday = 64
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlAlarmCode {

	LockJammed = 0,

	LockFactoryReset = 1,

	LockRadioPowerCycled = 3,

	WrongCodeEntryLimit = 4,

	FrontEsceutcheonRemoved = 5,

	DoorForcedOpen = 6,

	DoorAjar = 7,

	ForcedUser = 8
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlCredentialRule {

	Single = 0,

	Tri = 2
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlCredentialRuleMask {

	Single = 1,

	Dual = 2,

	Tri = 4
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlCredentialRulesSupport {

	Single = 1,

	Dual = 2,

	Tri = 4
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlCredentialType {

	ProgrammingPIN = 0,

	PIN = 1,

	RFID = 2,

	Fingerprint = 3,

	FingerVein = 4,

	Face = 5
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlDataOperationType {

	Add = 0,

	Clear = 1,

	Modify = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlDaysMaskMap {

	Sunday = 1,

	Monday = 2,

	Tuesday = 4,

	Wednesday = 8,

	Thursday = 16,

	Friday = 32,

	Saturday = 64
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlDefaultConfigurationRegister {

	EnableLocalProgrammingEnabled = 1,

	KeypadInterfaceDefaultAccessEnabled = 2,

	RemoteInterfaceDefaultAccessIsEnabled = 4,

	SoundEnabled = 32,

	AutoRelockTimeSet = 64,

	LEDSettingsSet = 128
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlDoorState {

	DoorOpen = 0,

	DoorClosed = 1,

	DoorJammed = 2,

	DoorForcedOpen = 3,

	DoorUnspecifiedError = 4,

	DoorAjar = 5
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlKeypadOperationEventMask {

	Unknown = 1,

	Lock = 2,

	Unlock = 4,

	LockInvalidPIN = 8,

	LockInvalidSchedule = 16,

	UnlockInvalidCode = 32,

	UnlockInvalidSchedule = 64,

	NonAccessUserOpEvent = 128
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlKeypadProgrammingEventMask {

	Unknown = 1,

	ProgrammingPINChanged = 2,

	PINAdded = 4,

	PINCleared = 8,

	PINChanged = 16
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlLocalProgrammingFeatures {

	AddUsersCredentialsSchedulesLocally = 1,

	ModifyUsersCredentialsSchedulesLocally = 2,

	ClearUsersCredentialsSchedulesLocally = 4,

	AdjustLockSettingsLocally = 8
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlLockDataType {

	Unspecified = 0,

	ProgrammingCode = 1,

	UserIndex = 2,

	WeekDaySchedule = 3,

	YearDaySchedule = 4,

	HolidaySchedule = 5,

	PIN = 6,

	RFID = 7,

	Fingerprint = 8
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlLockOperationType {

	Lock = 0,

	Unlock = 1,

	NonAccessUserEvent = 2,

	ForcedUserEvent = 3
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlLockState {

	NotFullyLocked = 0,

	Locked = 1,

	Unlocked = 2,

	Unlatched = 3
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlLockType {

	DeadBolt = 0,

	Magnetic = 1,

	Other = 2,

	Mortise = 3,

	Rim = 4,

	LatchBolt = 5,

	CylindricalLock = 6,

	TubularLock = 7,

	InterconnectedLock = 8,

	DeadLatch = 9,

	DoorFurniture = 10,

	Eurocylinder = 11
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlManualOperationEventMask {

	Unknown = 1,

	ThumbturnLock = 2,

	ThumbturnUnlock = 4,

	OneTouchLock = 8,

	KeyLock = 16,

	KeyUnlock = 32,

	AutoLock = 64,

	ScheduleLock = 128,

	ScheduleUnlock = 256,

	ManualLock = 512,

	ManualUnlock = 1024
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlOperatingMode {

	Normal = 0,

	Vacation = 1,

	Privacy = 2,

	NoRemoteLockUnlock = 3,

	Passage = 4
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlOperationError {

	Unspecified = 0,

	InvalidCredential = 1,

	DisabledUserDenied = 2,

	Restricted = 3,

	InsufficientBattery = 4
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlOperationSource {

	Unspecified = 0,

	Manual = 1,

	ProprietaryRemote = 2,

	Keypad = 3,

	Auto = 4,

	Button = 5,

	Schedule = 6,

	Remote = 7,

	RFID = 8,

	Biometric = 9
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlRFIDOperationEventMask {

	Unknown = 1,

	Lock = 2,

	Unlock = 4,

	LockInvalidRFID = 8,

	LockInvalidSchedule = 16,

	UnlockInvalidRFID = 32,

	UnlockInvalidSchedule = 64
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlRFIDProgrammingEventMask {

	Unknown = 1,

	RFIDCodeAdded = 32,

	RFIDCodeCleared = 64
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlRemoteOperationEventMask {

	Unknown = 1,

	Lock = 2,

	Unlock = 4,

	LockInvalidCode = 8,

	LockInvalidSchedule = 16,

	UnlockInvalidCode = 32,

	UnlockInvalidSchedule = 64
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlRemoteProgrammingEventMask {

	Unknown = 1,

	ProgrammingPINChanged = 2,

	PINAdded = 4,

	PINCleared = 8,

	PINChanged = 16,

	RFIDCodeAdded = 32,

	RFIDCodeCleared = 64
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlStatus {

	Success = 0,

	Failure = 1,

	Duplicate = 2,

	Occupied = 3,

	InvalidField = 133,

	ResourceExhausted = 137,

	NotFound = 139
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockDlSupportedOperatingModes {

	Normal = 1,

	Vacation = 2,

	Privacy = 4,

	NoRemoteLockUnlock = 8,

	Passage = 16
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlUserStatus {

	Available = 0,

	OccupiedEnabled = 1,

	OccupiedDisabled = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockDlUserType {

	UnrestrictedUser = 0,

	YearDayScheduleUser = 1,

	WeekDayScheduleUser = 2,

	ProgrammingUser = 3,

	NonAccessUser = 4,

	ForcedUser = 5,

	DisposableUser = 6,

	ExpiringUser = 7,

	ScheduleRestrictedUser = 8,

	RemoteOnlyUser = 9
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockDoorState {

	DoorOpen = 0,

	DoorClosed = 1,

	DoorJammed = 2,

	DoorForcedOpen = 3,

	DoorUnspecifiedError = 4,

	DoorAjar = 5
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockFeature {

	PINCredential = 1,

	PINCredentials = 1,

	RFIDCredential = 2,

	RFIDCredentials = 2,

	FingerCredentials = 4,

	Logging = 8,

	WeekDayAccessSchedules = 16,

	WeekDaySchedules = 16,

	DoorPositionSensor = 32,

	FaceCredentials = 64,

	CredentialsOverTheAirAccess = 128,

	CredentialsOTA = 128,

	User = 256,

	UsersManagement = 256,

	Notification = 512,

	Notifications = 512,

	YearDayAccessSchedules = 1024,

	YearDaySchedules = 1024,

	HolidaySchedules = 2048,

	Unbolt = 4096,

	AliroProvisioning = 8192,

	AliroBLEUWB = 16384
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockLockDataType {

	Unspecified = 0,

	ProgrammingCode = 1,

	UserIndex = 2,

	WeekDaySchedule = 3,

	YearDaySchedule = 4,

	HolidaySchedule = 5,

	PIN = 6,

	RFID = 7,

	Fingerprint = 8,

	FingerVein = 9,

	Face = 10,

	AliroCredentialIssuerKey = 11,

	AliroEvictableEndpointKey = 12,

	AliroNonEvictableEndpointKey = 13
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockLockOperationType {

	Lock = 0,

	Unlock = 1,

	NonAccessUserEvent = 2,

	ForcedUserEvent = 3,

	Unlatch = 4
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockOperatingMode {

	Normal = 0,

	Vacation = 1,

	Privacy = 2,

	NoRemoteLockUnlock = 3,

	Passage = 4
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockOperationError {

	Unspecified = 0,

	InvalidCredential = 1,

	DisabledUserDenied = 2,

	Restricted = 3,

	InsufficientBattery = 4
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockOperationEventCode {

	UnknownOrMfgSpecific = 0,

	Lock = 1,

	Unlock = 2,

	LockInvalidPinOrId = 3,

	LockInvalidSchedule = 4,

	UnlockInvalidPinOrId = 5,

	UnlockInvalidSchedule = 6,

	OneTouchLock = 7,

	KeyLock = 8,

	KeyUnlock = 9,

	AutoLock = 10,

	ScheduleLock = 11,

	ScheduleUnlock = 12,

	ManualLock = 13,

	ManualUnlock = 14
}

/**
 * @since 16.4
 */
declare const enum MTRDoorLockOperationSource {

	Unspecified = 0,

	Manual = 1,

	ProprietaryRemote = 2,

	Keypad = 3,

	Auto = 4,

	Button = 5,

	Schedule = 6,

	Remote = 7,

	RFID = 8,

	Biometric = 9,

	Aliro = 10
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockProgrammingEventCode {

	UnknownOrMfgSpecific = 0,

	MasterCodeChanged = 1,

	PinAdded = 2,

	PinDeleted = 3,

	PinChanged = 4,

	IdAdded = 5,

	IdDeleted = 6
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRDoorLockSetPinOrIdStatus {

	Success = 0,

	GeneralFailure = 1,

	MemoryFull = 2,

	DuplicateCodeError = 3
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockUserStatus {

	Available = 0,

	OccupiedEnabled = 1,

	OccupiedDisabled = 3,

	NotSupported = 255
}

/**
 * @since 16.1
 */
declare const enum MTRDoorLockUserType {

	UnrestrictedUser = 0,

	Unrestricted = 0,

	YearDayScheduleUser = 1,

	WeekDayScheduleUser = 2,

	ProgrammingUser = 3,

	MasterUser = 3,

	NonAccessUser = 4,

	ForcedUser = 5,

	DisposableUser = 6,

	ExpiringUser = 7,

	ScheduleRestrictedUser = 8,

	RemoteOnlyUser = 9,

	NotSupported = 255
}

/**
 * @since 16.1
 */
declare var MTRDoubleValueType: string;

/**
 * @since 17.6
 */
declare class MTRElectricalEnergyMeasurementClusterCumulativeEnergyMeasuredEvent extends NSObject implements NSCopying {

	static alloc(): MTRElectricalEnergyMeasurementClusterCumulativeEnergyMeasuredEvent; // inherited from NSObject

	static new(): MTRElectricalEnergyMeasurementClusterCumulativeEnergyMeasuredEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	energyExported: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct;

	/**
	 * @since 17.6
	 */
	energyImported: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct; // inherited from NSObject

	static new(): MTRElectricalEnergyMeasurementClusterCumulativeEnergyResetStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	exportedResetSystime: number;

	/**
	 * @since 17.6
	 */
	exportedResetTimestamp: number;

	/**
	 * @since 17.6
	 */
	importedResetSystime: number;

	/**
	 * @since 17.6
	 */
	importedResetTimestamp: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct; // inherited from NSObject

	static new(): MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	endSystime: number;

	/**
	 * @since 17.6
	 */
	endTimestamp: number;

	/**
	 * @since 17.6
	 */
	energy: number;

	/**
	 * @since 17.6
	 */
	startSystime: number;

	/**
	 * @since 17.6
	 */
	startTimestamp: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct; // inherited from NSObject

	static new(): MTRElectricalEnergyMeasurementClusterMeasurementAccuracyStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	accuracyRanges: NSArray<any>;

	/**
	 * @since 17.6
	 */
	maxMeasuredValue: number;

	/**
	 * @since 17.6
	 */
	measured: number;

	/**
	 * @since 17.6
	 */
	measurementType: number;

	/**
	 * @since 17.6
	 */
	minMeasuredValue: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalEnergyMeasurementClusterPeriodicEnergyMeasuredEvent extends NSObject implements NSCopying {

	static alloc(): MTRElectricalEnergyMeasurementClusterPeriodicEnergyMeasuredEvent; // inherited from NSObject

	static new(): MTRElectricalEnergyMeasurementClusterPeriodicEnergyMeasuredEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	energyExported: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct;

	/**
	 * @since 17.6
	 */
	energyImported: MTRElectricalEnergyMeasurementClusterEnergyMeasurementStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRElectricalEnergyMeasurementFeature {

	ImportedEnergy = 1,

	ExportedEnergy = 2,

	CumulativeEnergy = 4,

	PeriodicEnergy = 8
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams extends NSObject implements NSCopying {

	static alloc(): MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams; // inherited from NSObject

	static new(): MTRElectricalMeasurementClusterGetMeasurementProfileCommandParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	attributeId: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	numberOfIntervals: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	startTime: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRElectricalMeasurementClusterGetMeasurementProfileResponseCommandParams extends NSObject implements NSCopying {

	static alloc(): MTRElectricalMeasurementClusterGetMeasurementProfileResponseCommandParams; // inherited from NSObject

	static new(): MTRElectricalMeasurementClusterGetMeasurementProfileResponseCommandParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	attributeId: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	intervals: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	numberOfIntervalsDelivered: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	profileIntervalPeriod: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	startTime: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 * @deprecated 18.2
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 * @deprecated 18.2
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRElectricalMeasurementClusterGetProfileInfoCommandParams extends NSObject implements NSCopying {

	static alloc(): MTRElectricalMeasurementClusterGetProfileInfoCommandParams; // inherited from NSObject

	static new(): MTRElectricalMeasurementClusterGetProfileInfoCommandParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 18.2
 */
declare class MTRElectricalMeasurementClusterGetProfileInfoResponseCommandParams extends NSObject implements NSCopying {

	static alloc(): MTRElectricalMeasurementClusterGetProfileInfoResponseCommandParams; // inherited from NSObject

	static new(): MTRElectricalMeasurementClusterGetProfileInfoResponseCommandParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	listOfAttributes: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	maxNumberOfIntervals: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	profileCount: number;

	/**
	 * @since 16.1
	 * @deprecated 18.2
	 */
	profileIntervalPeriod: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 * @deprecated 18.2
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 * @deprecated 18.2
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.6
 */
declare class MTRElectricalPowerMeasurementClusterHarmonicMeasurementStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalPowerMeasurementClusterHarmonicMeasurementStruct; // inherited from NSObject

	static new(): MTRElectricalPowerMeasurementClusterHarmonicMeasurementStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	measurement: number;

	/**
	 * @since 17.6
	 */
	order: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalPowerMeasurementClusterMeasurementAccuracyRangeStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalPowerMeasurementClusterMeasurementAccuracyRangeStruct; // inherited from NSObject

	static new(): MTRElectricalPowerMeasurementClusterMeasurementAccuracyRangeStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	fixedMax: number;

	/**
	 * @since 17.6
	 */
	fixedMin: number;

	/**
	 * @since 17.6
	 */
	fixedTypical: number;

	/**
	 * @since 17.6
	 */
	percentMax: number;

	/**
	 * @since 17.6
	 */
	percentMin: number;

	/**
	 * @since 17.6
	 */
	percentTypical: number;

	/**
	 * @since 17.6
	 */
	rangeMax: number;

	/**
	 * @since 17.6
	 */
	rangeMin: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalPowerMeasurementClusterMeasurementAccuracyStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalPowerMeasurementClusterMeasurementAccuracyStruct; // inherited from NSObject

	static new(): MTRElectricalPowerMeasurementClusterMeasurementAccuracyStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	accuracyRanges: NSArray<any>;

	/**
	 * @since 17.6
	 */
	maxMeasuredValue: number;

	/**
	 * @since 17.6
	 */
	measured: number;

	/**
	 * @since 17.6
	 */
	measurementType: number;

	/**
	 * @since 17.6
	 */
	minMeasuredValue: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalPowerMeasurementClusterMeasurementPeriodRangesEvent extends NSObject implements NSCopying {

	static alloc(): MTRElectricalPowerMeasurementClusterMeasurementPeriodRangesEvent; // inherited from NSObject

	static new(): MTRElectricalPowerMeasurementClusterMeasurementPeriodRangesEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	ranges: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRElectricalPowerMeasurementClusterMeasurementRangeStruct extends NSObject implements NSCopying {

	static alloc(): MTRElectricalPowerMeasurementClusterMeasurementRangeStruct; // inherited from NSObject

	static new(): MTRElectricalPowerMeasurementClusterMeasurementRangeStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	endSystime: number;

	/**
	 * @since 17.6
	 */
	endTimestamp: number;

	/**
	 * @since 17.6
	 */
	max: number;

	/**
	 * @since 17.6
	 */
	maxSystime: number;

	/**
	 * @since 17.6
	 */
	maxTimestamp: number;

	/**
	 * @since 17.6
	 */
	measurementType: number;

	/**
	 * @since 17.6
	 */
	min: number;

	/**
	 * @since 17.6
	 */
	minSystime: number;

	/**
	 * @since 17.6
	 */
	minTimestamp: number;

	/**
	 * @since 17.6
	 */
	startSystime: number;

	/**
	 * @since 17.6
	 */
	startTimestamp: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRElectricalPowerMeasurementFeature {

	DirectCurrent = 1,

	AlternatingCurrent = 2,

	PolyphasePower = 4,

	Harmonics = 8,

	PowerQuality = 16
}

/**
 * @since 17.6
 */
declare const enum MTRElectricalPowerMeasurementMeasurementType {

	Unspecified = 0,

	Voltage = 1,

	ActiveCurrent = 2,

	ReactiveCurrent = 3,

	ApparentCurrent = 4,

	ActivePower = 5,

	ReactivePower = 6,

	ApparentPower = 7,

	RMSVoltage = 8,

	RMSCurrent = 9,

	RMSPower = 10,

	Frequency = 11,

	PowerFactor = 12,

	NeutralCurrent = 13,

	ElectricalEnergy = 14
}

/**
 * @since 17.6
 */
declare const enum MTRElectricalPowerMeasurementPowerMode {

	Unknown = 0,

	DC = 1,

	AC = 2
}

declare const enum MTRErrorCode {

	GeneralError = 1,

	InvalidStringLength = 2,

	InvalidIntegerValue = 3,

	InvalidArgument = 4,

	InvalidMessageLength = 5,

	InvalidState = 6,

	WrongAddressType = 7,

	IntegrityCheckFailed = 8,

	Timeout = 9,

	BufferTooSmall = 10,

	FabricExists = 11,

	UnknownSchema = 12,

	SchemaMismatch = 13,

	TLVDecodeFailed = 14,

	DNSSDUnauthorized = 15,

	Cancelled = 16
}

/**
 * @since 16.1
 */
declare var MTRErrorDomain: string;

/**
 * @since 16.1
 */
declare var MTRErrorKey: string;

/**
 * @since 16.1
 */
declare class MTREthernetNetworkDiagnosticsClusterResetCountsParams extends NSObject implements NSCopying {

	static alloc(): MTREthernetNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	static new(): MTREthernetNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTREthernetNetworkDiagnosticsFeature {

	PacketCounts = 1,

	ErrorCounts = 2
}

/**
 * @since 16.4
 */
declare const enum MTREthernetNetworkDiagnosticsPHYRate {

	Rate10M = 0,

	Rate100M = 1,

	Rate1G = 2,

	Rate25G = 3,

	Rate5G = 4,

	Rate10G = 5,

	Rate40G = 6,

	Rate100G = 7,

	Rate200G = 8,

	Rate400G = 9
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTREthernetNetworkDiagnosticsPHYRateType {

	Type10M = 0,

	Type100M = 1,

	Type1000M = 2,

	Type25G = 3,

	Type5G = 4,

	Type10G = 5,

	Type40G = 6,

	Type100G = 7,

	Type200G = 8,

	Type400G = 9
}

declare const enum MTREventIDType {

	ClusterAccessControlEventAccessControlEntryChangedID = 0,

	ClusterAccessControlEventAccessControlExtensionChangedID = 1,

	EventIDTypeClusterAccessControlEventAccessControlEntryChangedID = 0,

	EventIDTypeClusterAccessControlEventAccessControlExtensionChangedID = 1,

	EventIDTypeClusterAccessControlEventFabricRestrictionReviewUpdateID = 2,

	ClusterActionsEventStateChangedID = 0,

	ClusterActionsEventActionFailedID = 1,

	EventIDTypeClusterActionsEventStateChangedID = 0,

	EventIDTypeClusterActionsEventActionFailedID = 1,

	ClusterBasicEventStartUpID = 0,

	ClusterBasicEventShutDownID = 1,

	ClusterBasicEventLeaveID = 2,

	ClusterBasicEventReachableChangedID = 3,

	EventIDTypeClusterBasicInformationEventStartUpID = 0,

	EventIDTypeClusterBasicInformationEventShutDownID = 1,

	EventIDTypeClusterBasicInformationEventLeaveID = 2,

	EventIDTypeClusterBasicInformationEventReachableChangedID = 3,

	ClusterOtaSoftwareUpdateRequestorEventStateTransitionID = 0,

	ClusterOtaSoftwareUpdateRequestorEventVersionAppliedID = 1,

	ClusterOtaSoftwareUpdateRequestorEventDownloadErrorID = 2,

	EventIDTypeClusterOTASoftwareUpdateRequestorEventStateTransitionID = 0,

	EventIDTypeClusterOTASoftwareUpdateRequestorEventVersionAppliedID = 1,

	EventIDTypeClusterOTASoftwareUpdateRequestorEventDownloadErrorID = 2,

	EventIDTypeClusterPowerSourceEventWiredFaultChangeID = 0,

	EventIDTypeClusterPowerSourceEventBatFaultChangeID = 1,

	EventIDTypeClusterPowerSourceEventBatChargeFaultChangeID = 2,

	ClusterGeneralDiagnosticsEventHardwareFaultChangeID = 0,

	ClusterGeneralDiagnosticsEventRadioFaultChangeID = 1,

	ClusterGeneralDiagnosticsEventNetworkFaultChangeID = 2,

	ClusterGeneralDiagnosticsEventBootReasonID = 3,

	EventIDTypeClusterGeneralDiagnosticsEventHardwareFaultChangeID = 0,

	EventIDTypeClusterGeneralDiagnosticsEventRadioFaultChangeID = 1,

	EventIDTypeClusterGeneralDiagnosticsEventNetworkFaultChangeID = 2,

	EventIDTypeClusterGeneralDiagnosticsEventBootReasonID = 3,

	ClusterSoftwareDiagnosticsEventSoftwareFaultID = 0,

	EventIDTypeClusterSoftwareDiagnosticsEventSoftwareFaultID = 0,

	ClusterThreadNetworkDiagnosticsEventConnectionStatusID = 0,

	ClusterThreadNetworkDiagnosticsEventNetworkFaultChangeID = 1,

	EventIDTypeClusterThreadNetworkDiagnosticsEventConnectionStatusID = 0,

	EventIDTypeClusterThreadNetworkDiagnosticsEventNetworkFaultChangeID = 1,

	ClusterWiFiNetworkDiagnosticsEventDisconnectionID = 0,

	ClusterWiFiNetworkDiagnosticsEventAssociationFailureID = 1,

	ClusterWiFiNetworkDiagnosticsEventConnectionStatusID = 2,

	EventIDTypeClusterWiFiNetworkDiagnosticsEventDisconnectionID = 0,

	EventIDTypeClusterWiFiNetworkDiagnosticsEventAssociationFailureID = 1,

	EventIDTypeClusterWiFiNetworkDiagnosticsEventConnectionStatusID = 2,

	EventIDTypeClusterTimeSynchronizationEventDSTTableEmptyID = 0,

	EventIDTypeClusterTimeSynchronizationEventDSTStatusID = 1,

	EventIDTypeClusterTimeSynchronizationEventTimeZoneStatusID = 2,

	EventIDTypeClusterTimeSynchronizationEventTimeFailureID = 3,

	EventIDTypeClusterTimeSynchronizationEventMissingTrustedTimeSourceID = 4,

	ClusterBridgedDeviceBasicEventStartUpID = 0,

	ClusterBridgedDeviceBasicEventShutDownID = 1,

	ClusterBridgedDeviceBasicEventLeaveID = 2,

	ClusterBridgedDeviceBasicEventReachableChangedID = 3,

	EventIDTypeClusterBridgedDeviceBasicInformationEventStartUpID = 0,

	EventIDTypeClusterBridgedDeviceBasicInformationEventShutDownID = 1,

	EventIDTypeClusterBridgedDeviceBasicInformationEventLeaveID = 2,

	EventIDTypeClusterBridgedDeviceBasicInformationEventReachableChangedID = 3,

	EventIDTypeClusterBridgedDeviceBasicInformationEventActiveChangedID = 128,

	ClusterSwitchEventSwitchLatchedID = 0,

	ClusterSwitchEventInitialPressID = 1,

	ClusterSwitchEventLongPressID = 2,

	ClusterSwitchEventShortReleaseID = 3,

	ClusterSwitchEventLongReleaseID = 4,

	ClusterSwitchEventMultiPressOngoingID = 5,

	ClusterSwitchEventMultiPressCompleteID = 6,

	EventIDTypeClusterSwitchEventSwitchLatchedID = 0,

	EventIDTypeClusterSwitchEventInitialPressID = 1,

	EventIDTypeClusterSwitchEventLongPressID = 2,

	EventIDTypeClusterSwitchEventShortReleaseID = 3,

	EventIDTypeClusterSwitchEventLongReleaseID = 4,

	EventIDTypeClusterSwitchEventMultiPressOngoingID = 5,

	EventIDTypeClusterSwitchEventMultiPressCompleteID = 6,

	ClusterBooleanStateEventStateChangeID = 0,

	EventIDTypeClusterBooleanStateEventStateChangeID = 0,

	EventIDTypeClusterOvenCavityOperationalStateEventOperationalErrorID = 0,

	EventIDTypeClusterOvenCavityOperationalStateEventOperationCompletionID = 1,

	EventIDTypeClusterRefrigeratorAlarmEventNotifyID = 0,

	EventIDTypeClusterSmokeCOAlarmEventSmokeAlarmID = 0,

	EventIDTypeClusterSmokeCOAlarmEventCOAlarmID = 1,

	EventIDTypeClusterSmokeCOAlarmEventLowBatteryID = 2,

	EventIDTypeClusterSmokeCOAlarmEventHardwareFaultID = 3,

	EventIDTypeClusterSmokeCOAlarmEventEndOfServiceID = 4,

	EventIDTypeClusterSmokeCOAlarmEventSelfTestCompleteID = 5,

	EventIDTypeClusterSmokeCOAlarmEventAlarmMutedID = 6,

	EventIDTypeClusterSmokeCOAlarmEventMuteEndedID = 7,

	EventIDTypeClusterSmokeCOAlarmEventInterconnectSmokeAlarmID = 8,

	EventIDTypeClusterSmokeCOAlarmEventInterconnectCOAlarmID = 9,

	EventIDTypeClusterSmokeCOAlarmEventAllClearID = 10,

	EventIDTypeClusterDishwasherAlarmEventNotifyID = 0,

	EventIDTypeClusterOperationalStateEventOperationalErrorID = 0,

	EventIDTypeClusterOperationalStateEventOperationCompletionID = 1,

	EventIDTypeClusterRVCOperationalStateEventOperationalErrorID = 0,

	EventIDTypeClusterRVCOperationalStateEventOperationCompletionID = 1,

	EventIDTypeClusterBooleanStateConfigurationEventAlarmsStateChangedID = 0,

	EventIDTypeClusterBooleanStateConfigurationEventSensorFaultID = 1,

	EventIDTypeClusterValveConfigurationAndControlEventValveStateChangedID = 0,

	EventIDTypeClusterValveConfigurationAndControlEventValveFaultID = 1,

	EventIDTypeClusterElectricalPowerMeasurementEventMeasurementPeriodRangesID = 0,

	EventIDTypeClusterElectricalEnergyMeasurementEventCumulativeEnergyMeasuredID = 0,

	EventIDTypeClusterElectricalEnergyMeasurementEventPeriodicEnergyMeasuredID = 1,

	EventIDTypeClusterWaterHeaterManagementEventBoostStartedID = 0,

	EventIDTypeClusterWaterHeaterManagementEventBoostEndedID = 1,

	EventIDTypeClusterDemandResponseLoadControlEventLoadControlEventStatusChangeID = 0,

	EventIDTypeClusterMessagesEventMessageQueuedID = 0,

	EventIDTypeClusterMessagesEventMessagePresentedID = 1,

	EventIDTypeClusterMessagesEventMessageCompleteID = 2,

	EventIDTypeClusterDeviceEnergyManagementEventPowerAdjustStartID = 0,

	EventIDTypeClusterDeviceEnergyManagementEventPowerAdjustEndID = 1,

	EventIDTypeClusterDeviceEnergyManagementEventPausedID = 2,

	EventIDTypeClusterDeviceEnergyManagementEventResumedID = 3,

	EventIDTypeClusterEnergyEVSEEventEVConnectedID = 0,

	EventIDTypeClusterEnergyEVSEEventEVNotDetectedID = 1,

	EventIDTypeClusterEnergyEVSEEventEnergyTransferStartedID = 2,

	EventIDTypeClusterEnergyEVSEEventEnergyTransferStoppedID = 3,

	EventIDTypeClusterEnergyEVSEEventFaultID = 4,

	EventIDTypeClusterEnergyEVSEEventRFIDID = 5,

	ClusterDoorLockEventDoorLockAlarmID = 0,

	ClusterDoorLockEventDoorStateChangeID = 1,

	ClusterDoorLockEventLockOperationID = 2,

	ClusterDoorLockEventLockOperationErrorID = 3,

	ClusterDoorLockEventLockUserChangeID = 4,

	EventIDTypeClusterDoorLockEventDoorLockAlarmID = 0,

	EventIDTypeClusterDoorLockEventDoorStateChangeID = 1,

	EventIDTypeClusterDoorLockEventLockOperationID = 2,

	EventIDTypeClusterDoorLockEventLockOperationErrorID = 3,

	EventIDTypeClusterDoorLockEventLockUserChangeID = 4,

	EventIDTypeClusterDoorLockEventAppleAliroLockOperationID = 323551232,

	EventIDTypeClusterDoorLockEventAppleAliroLockOperationErrorID = 323551233,

	EventIDTypeClusterDoorLockEventAppleAliroLockUserChangeID = 323551234,

	ClusterPumpConfigurationAndControlEventSupplyVoltageLowID = 0,

	ClusterPumpConfigurationAndControlEventSupplyVoltageHighID = 1,

	ClusterPumpConfigurationAndControlEventPowerMissingPhaseID = 2,

	ClusterPumpConfigurationAndControlEventSystemPressureLowID = 3,

	ClusterPumpConfigurationAndControlEventSystemPressureHighID = 4,

	ClusterPumpConfigurationAndControlEventDryRunningID = 5,

	ClusterPumpConfigurationAndControlEventMotorTemperatureHighID = 6,

	ClusterPumpConfigurationAndControlEventPumpMotorFatalFailureID = 7,

	ClusterPumpConfigurationAndControlEventElectronicTemperatureHighID = 8,

	ClusterPumpConfigurationAndControlEventPumpBlockedID = 9,

	ClusterPumpConfigurationAndControlEventSensorFailureID = 10,

	ClusterPumpConfigurationAndControlEventElectronicNonFatalFailureID = 11,

	ClusterPumpConfigurationAndControlEventElectronicFatalFailureID = 12,

	ClusterPumpConfigurationAndControlEventGeneralFaultID = 13,

	ClusterPumpConfigurationAndControlEventLeakageID = 14,

	ClusterPumpConfigurationAndControlEventAirDetectionID = 15,

	ClusterPumpConfigurationAndControlEventTurbineOperationID = 16,

	EventIDTypeClusterPumpConfigurationAndControlEventSupplyVoltageLowID = 0,

	EventIDTypeClusterPumpConfigurationAndControlEventSupplyVoltageHighID = 1,

	EventIDTypeClusterPumpConfigurationAndControlEventPowerMissingPhaseID = 2,

	EventIDTypeClusterPumpConfigurationAndControlEventSystemPressureLowID = 3,

	EventIDTypeClusterPumpConfigurationAndControlEventSystemPressureHighID = 4,

	EventIDTypeClusterPumpConfigurationAndControlEventDryRunningID = 5,

	EventIDTypeClusterPumpConfigurationAndControlEventMotorTemperatureHighID = 6,

	EventIDTypeClusterPumpConfigurationAndControlEventPumpMotorFatalFailureID = 7,

	EventIDTypeClusterPumpConfigurationAndControlEventElectronicTemperatureHighID = 8,

	EventIDTypeClusterPumpConfigurationAndControlEventPumpBlockedID = 9,

	EventIDTypeClusterPumpConfigurationAndControlEventSensorFailureID = 10,

	EventIDTypeClusterPumpConfigurationAndControlEventElectronicNonFatalFailureID = 11,

	EventIDTypeClusterPumpConfigurationAndControlEventElectronicFatalFailureID = 12,

	EventIDTypeClusterPumpConfigurationAndControlEventGeneralFaultID = 13,

	EventIDTypeClusterPumpConfigurationAndControlEventLeakageID = 14,

	EventIDTypeClusterPumpConfigurationAndControlEventAirDetectionID = 15,

	EventIDTypeClusterPumpConfigurationAndControlEventTurbineOperationID = 16,

	EventIDTypeClusterOccupancySensingEventOccupancyChangedID = 0,

	EventIDTypeClusterTargetNavigatorEventTargetUpdatedID = 0,

	EventIDTypeClusterMediaPlaybackEventStateChangedID = 0,

	EventIDTypeClusterAccountLoginEventLoggedOutID = 0,

	EventIDTypeClusterContentControlEventRemainingScreenTimeExpiredID = 0,

	EventIDTypeClusterZoneManagementEventZoneTriggeredID = 0,

	EventIDTypeClusterZoneManagementEventZoneStoppedID = 1,

	EventIDTypeClusterCameraAVStreamManagementEventVideoStreamChangedID = 0,

	EventIDTypeClusterCameraAVStreamManagementEventAudioStreamChangedID = 1,

	EventIDTypeClusterCameraAVStreamManagementEventSnapshotStreamChangedID = 2,

	EventIDTypeClusterCommissionerControlEventCommissioningRequestResultID = 0,

	ClusterTestClusterEventTestEventID = 1,

	ClusterTestClusterEventTestFabricScopedEventID = 2,

	EventIDTypeClusterUnitTestingEventTestEventID = 1,

	EventIDTypeClusterUnitTestingEventTestFabricScopedEventID = 2,

	EventIDTypeClusterUnitTestingEventTestDifferentVendorMeiEventID = 4294050030,

	EventIDTypeClusterSampleMEIEventPingCountEventID = 0
}

/**
 * @since 17.3
 */
declare var MTREventIsHistoricalKey: string;

/**
 * @since 18.2
 */
declare function MTREventNameForID(clusterID: MTRClusterIDType, eventID: MTREventIDType): string;

/**
 * @since 16.5
 */
declare var MTREventNumberKey: string;

/**
 * @since 16.1
 */
declare class MTREventPath extends MTRClusterPath {

	static alloc(): MTREventPath; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	static eventPathWithEndpointIDClusterIDEventID(endpointID: number, clusterID: number, eventID: number): MTREventPath;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	static eventPathWithEndpointIdClusterIdEventId(endpointId: number, clusterId: number, eventId: number): MTREventPath;

	static new(): MTREventPath; // inherited from NSObject

	readonly event: number;
}

/**
 * @since 16.1
 */
declare var MTREventPathKey: string;

/**
 * @since 16.5
 */
declare const enum MTREventPriority {

	Debug = 0,

	Info = 1,

	Critical = 2
}

/**
 * @since 16.5
 */
declare var MTREventPriorityKey: string;

/**
 * @since 16.1
 */
declare class MTREventReport extends NSObject {

	static alloc(): MTREventReport; // inherited from NSObject

	static new(): MTREventReport; // inherited from NSObject

	readonly error: NSError;

	readonly eventNumber: number;

	/**
	 * @since 16.5
	 */
	readonly eventTimeType: MTREventTimeType;

	readonly path: MTREventPath;

	readonly priority: number;

	/**
	 * @since 16.5
	 */
	readonly systemUpTime: number;

	/**
	 * @since 16.1
	 * @deprecated 16.5
	 */
	readonly timestamp: number;

	/**
	 * @since 16.5
	 */
	readonly timestampDate: Date;

	readonly value: any;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.0
 */
declare class MTREventRequestPath extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTREventRequestPath; // inherited from NSObject

	static new(): MTREventRequestPath; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	static requestPathWithEndpointIDClusterIDEventID(endpointID: number, clusterID: number, eventID: number): MTREventRequestPath;

	/**
	 * @since 17.0
	 */
	readonly cluster: number;

	/**
	 * @since 17.0
	 */
	readonly endpoint: number;

	/**
	 * @since 17.0
	 */
	readonly event: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 16.5
 */
declare var MTREventSystemUpTimeKey: string;

/**
 * @since 16.5
 */
declare const enum MTREventTimeType {

	SystemUpTime = 0,

	TimestampDate = 1
}

/**
 * @since 16.5
 */
declare var MTREventTimeTypeKey: string;

/**
 * @since 16.5
 */
declare var MTREventTimestampDateKey: string;

/**
 * @since 16.5
 */
declare class MTRFabricInfo extends NSObject {

	static alloc(): MTRFabricInfo; // inherited from NSObject

	static new(): MTRFabricInfo; // inherited from NSObject

	readonly fabricID: number;

	readonly fabricIndex: number;

	readonly intermediateCertificate: NSData;

	readonly intermediateCertificateTLV: NSData;

	readonly label: string;

	readonly nodeID: number;

	readonly operationalCertificate: NSData;

	readonly operationalCertificateTLV: NSData;

	readonly rootCertificate: NSData;

	readonly rootCertificateTLV: NSData;

	readonly rootPublicKey: NSData;

	readonly vendorID: number;
}

/**
 * @since 17.6
 */
declare const enum MTRFanControlAirflowDirection {

	Forward = 0,

	Reverse = 1
}

/**
 * @since 17.6
 */
declare class MTRFanControlClusterStepParams extends NSObject implements NSCopying {

	static alloc(): MTRFanControlClusterStepParams; // inherited from NSObject

	static new(): MTRFanControlClusterStepParams; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	direction: number;

	/**
	 * @since 17.6
	 */
	lowestOff: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.6
	 */
	wrap: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.0
 */
declare const enum MTRFanControlFanMode {

	Off = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	On = 4,

	Auto = 5,

	Smart = 6
}

/**
 * @since 17.0
 */
declare const enum MTRFanControlFanModeSequence {

	OffLowMedHigh = 0,

	OffLowHigh = 1,

	OffLowMedHighAuto = 2,

	OffLowHighAuto = 3,

	OffHighAuto = 4,

	OffOnAuto = 4,

	OffHigh = 5,

	OffOn = 5
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRFanControlFanModeSequenceType {

	OffLowMedHigh = 0,

	OffLowHigh = 1,

	OffLowMedHighAuto = 2,

	OffLowHighAuto = 3,

	OffOnAuto = 4,

	OffOn = 5
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRFanControlFanModeType {

	Off = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	On = 4,

	Auto = 5,

	Smart = 6
}

/**
 * @since 16.1
 */
declare const enum MTRFanControlFeature {

	MultiSpeed = 1,

	Auto = 2,

	Rocking = 4,

	Wind = 8,

	Step = 16,

	AirflowDirection = 32
}

/**
 * @since 17.0
 */
declare const enum MTRFanControlRockBitmap {

	RockLeftRight = 1,

	RockUpDown = 2,

	RockRound = 4
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRFanControlRockSupportMask {

	RockLeftRight = 1,

	RockUpDown = 2,

	RockRound = 4
}

/**
 * @since 17.6
 */
declare const enum MTRFanControlStepDirection {

	Increase = 0,

	Decrease = 1
}

/**
 * @since 17.0
 */
declare const enum MTRFanControlWindBitmap {

	SleepWind = 1,

	NaturalWind = 2
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRFanControlWindSettingMask {

	SleepWind = 1,

	NaturalWind = 2
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRFanControlWindSupportMask {

	SleepWind = 1,

	NaturalWind = 2
}

/**
 * @since 16.1
 */
declare class MTRFixedLabelClusterLabelStruct extends NSObject implements NSCopying {

	static alloc(): MTRFixedLabelClusterLabelStruct; // inherited from NSObject

	static new(): MTRFixedLabelClusterLabelStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	label: string;

	/**
	 * @since 16.1
	 */
	value: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare var MTRFloatValueType: string;

/**
 * @since 17.6
 */
declare const enum MTRFormaldehydeConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRFormaldehydeConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRFormaldehydeConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRFormaldehydeConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterArmFailSafeParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterArmFailSafeParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterArmFailSafeParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	expiryLengthSeconds: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterArmFailSafeResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterArmFailSafeResponseParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterArmFailSafeResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	errorCode: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterBasicCommissioningInfo extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterBasicCommissioningInfo; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterBasicCommissioningInfo; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	failSafeExpiryLengthSeconds: number;

	/**
	 * @since 16.1
	 */
	maxCumulativeFailsafeSeconds: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterCommissioningCompleteParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterCommissioningCompleteParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterCommissioningCompleteParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterCommissioningCompleteResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterCommissioningCompleteResponseParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterCommissioningCompleteResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	errorCode: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterSetRegulatoryConfigParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterSetRegulatoryConfigParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterSetRegulatoryConfigParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	countryCode: string;

	/**
	 * @since 16.1
	 */
	newRegulatoryConfig: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams; // inherited from NSObject

	static new(): MTRGeneralCommissioningClusterSetRegulatoryConfigResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	errorCode: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare const enum MTRGeneralCommissioningCommissioningError {

	OK = 0,

	Ok = 0,

	ValueOutsideRange = 1,

	InvalidAuthentication = 2,

	NoFailSafe = 3,

	BusyWithOtherAdmin = 4,

	RequiredTCNotAccepted = 5,

	TCAcknowledgementsNotReceived = 6,

	TCMinVersionNotMet = 7
}

/**
 * @since 16.1
 */
declare const enum MTRGeneralCommissioningRegulatoryLocationType {

	Indoor = 0,

	Outdoor = 1,

	IndoorOutdoor = 2
}

/**
 * @since 16.4
 */
declare const enum MTRGeneralDiagnosticsBootReason {

	Unspecified = 0,

	PowerOnReboot = 1,

	BrownOutReset = 2,

	SoftwareWatchdogReset = 3,

	HardwareWatchdogReset = 4,

	SoftwareUpdateCompleted = 5,

	SoftwareReset = 6
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRGeneralDiagnosticsBootReasonType {

	Unspecified = 0,

	PowerOnReboot = 1,

	BrownOutReset = 2,

	SoftwareWatchdogReset = 3,

	HardwareWatchdogReset = 4,

	SoftwareUpdateCompleted = 5,

	SoftwareReset = 6
}

/**
 * @since 16.1
 */
declare class MTRGeneralDiagnosticsClusterBootReasonEvent extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterBootReasonEvent; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterBootReasonEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	bootReason: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralDiagnosticsClusterHardwareFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterHardwareFaultChangeEvent; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterHardwareFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralDiagnosticsClusterNetworkFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterNetworkFaultChangeEvent; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterNetworkFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRGeneralDiagnosticsClusterNetworkInterface extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterNetworkInterface; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterNetworkInterface; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	hardwareAddress: NSData;

	/**
	 * @since 16.4
	 */
	iPv4Addresses: NSArray<any>;

	/**
	 * @since 16.4
	 */
	iPv6Addresses: NSArray<any>;

	/**
	 * @since 16.4
	 */
	isOperational: number;

	/**
	 * @since 16.4
	 */
	name: string;

	/**
	 * @since 16.4
	 */
	offPremiseServicesReachableIPv4: number;

	/**
	 * @since 16.4
	 */
	offPremiseServicesReachableIPv6: number;

	/**
	 * @since 16.4
	 */
	type: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRGeneralDiagnosticsClusterNetworkInterfaceType extends MTRGeneralDiagnosticsClusterNetworkInterface {

	static alloc(): MTRGeneralDiagnosticsClusterNetworkInterfaceType; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterNetworkInterfaceType; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare class MTRGeneralDiagnosticsClusterRadioFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterRadioFaultChangeEvent; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterRadioFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGeneralDiagnosticsClusterTestEventTriggerParams extends NSObject implements NSCopying {

	static alloc(): MTRGeneralDiagnosticsClusterTestEventTriggerParams; // inherited from NSObject

	static new(): MTRGeneralDiagnosticsClusterTestEventTriggerParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	enableKey: NSData;

	/**
	 * @since 16.1
	 */
	eventTrigger: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTRGeneralDiagnosticsHardwareFault {

	Unspecified = 0,

	Radio = 1,

	Sensor = 2,

	ResettableOverTemp = 3,

	NonResettableOverTemp = 4,

	PowerSource = 5,

	VisualDisplayFault = 6,

	AudioOutputFault = 7,

	UserInterfaceFault = 8,

	NonVolatileMemoryError = 9,

	TamperDetected = 10
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRGeneralDiagnosticsHardwareFaultType {

	Unspecified = 0,

	Radio = 1,

	Sensor = 2,

	ResettableOverTemp = 3,

	NonResettableOverTemp = 4,

	PowerSource = 5,

	VisualDisplayFault = 6,

	AudioOutputFault = 7,

	UserInterfaceFault = 8,

	NonVolatileMemoryError = 9,

	TamperDetected = 10
}

/**
 * @since 16.1
 */
declare const enum MTRGeneralDiagnosticsInterfaceType {

	Unspecified = 0,

	WiFi = 1,

	Ethernet = 2,

	Cellular = 3,

	Thread = 4
}

/**
 * @since 16.4
 */
declare const enum MTRGeneralDiagnosticsNetworkFault {

	Unspecified = 0,

	HardwareFailure = 1,

	NetworkJammed = 2,

	ConnectionFailed = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRGeneralDiagnosticsNetworkFaultType {

	Unspecified = 0,

	HardwareFailure = 1,

	NetworkJammed = 2,

	ConnectionFailed = 3
}

/**
 * @since 16.4
 */
declare const enum MTRGeneralDiagnosticsRadioFault {

	Unspecified = 0,

	WiFiFault = 1,

	CellularFault = 2,

	ThreadFault = 3,

	NFCFault = 4,

	BLEFault = 5,

	EthernetFault = 6
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRGeneralDiagnosticsRadioFaultType {

	Unspecified = 0,

	WiFiFault = 1,

	CellularFault = 2,

	ThreadFault = 3,

	NFCFault = 4,

	BLEFault = 5,

	EthernetFault = 6
}

/**
 * @since 17.4
 */
declare class MTRGenericBaseCluster extends MTRCluster {

	static alloc(): MTRGenericBaseCluster; // inherited from NSObject

	static new(): MTRGenericBaseCluster; // inherited from NSObject
}

/**
 * @since 17.4
 */
declare class MTRGenericCluster extends MTRCluster {

	static alloc(): MTRGenericCluster; // inherited from NSObject

	static new(): MTRGenericCluster; // inherited from NSObject

	readonly device: MTRDevice;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterGroupInfoMapStruct extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterGroupInfoMapStruct; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterGroupInfoMapStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	endpoints: NSArray<any>;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	groupName: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterGroupKeyMapStruct extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterGroupKeyMapStruct; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterGroupKeyMapStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	groupKeySetID: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterGroupKeySetStruct extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterGroupKeySetStruct; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterGroupKeySetStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	epochKey0: NSData;

	/**
	 * @since 16.1
	 */
	epochKey1: NSData;

	/**
	 * @since 16.1
	 */
	epochKey2: NSData;

	/**
	 * @since 16.1
	 */
	epochStartTime0: number;

	/**
	 * @since 16.1
	 */
	epochStartTime1: number;

	/**
	 * @since 16.1
	 */
	epochStartTime2: number;

	/**
	 * @since 16.1
	 */
	groupKeySecurityPolicy: number;

	/**
	 * @since 16.1
	 */
	groupKeySetID: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetReadAllIndicesParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetReadAllIndicesParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetReadAllIndicesParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 17.0
	 */
	groupKeySetIDs: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetReadAllIndicesResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupKeySetIDs: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetReadParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetReadParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetReadParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupKeySetID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetReadResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetReadResponseParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetReadResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupKeySet: MTRGroupKeyManagementClusterGroupKeySetStruct;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetRemoveParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetRemoveParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetRemoveParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupKeySetID: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupKeyManagementClusterKeySetWriteParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupKeyManagementClusterKeySetWriteParams; // inherited from NSObject

	static new(): MTRGroupKeyManagementClusterKeySetWriteParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupKeySet: MTRGroupKeyManagementClusterGroupKeySetStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRGroupKeyManagementGroupKeySecurityPolicy {

	TrustFirst = 0,

	CacheAndSync = 1
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterAddGroupIfIdentifyingParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterAddGroupIfIdentifyingParams; // inherited from NSObject

	static new(): MTRGroupsClusterAddGroupIfIdentifyingParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	groupName: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterAddGroupParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterAddGroupParams; // inherited from NSObject

	static new(): MTRGroupsClusterAddGroupParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	groupName: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterAddGroupResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterAddGroupResponseParams; // inherited from NSObject

	static new(): MTRGroupsClusterAddGroupResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterGetGroupMembershipParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterGetGroupMembershipParams; // inherited from NSObject

	static new(): MTRGroupsClusterGetGroupMembershipParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	groupList: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterGetGroupMembershipResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterGetGroupMembershipResponseParams; // inherited from NSObject

	static new(): MTRGroupsClusterGetGroupMembershipResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	capacity: number;

	/**
	 * @since 16.1
	 */
	groupList: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterRemoveAllGroupsParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterRemoveAllGroupsParams; // inherited from NSObject

	static new(): MTRGroupsClusterRemoveAllGroupsParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterRemoveGroupParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterRemoveGroupParams; // inherited from NSObject

	static new(): MTRGroupsClusterRemoveGroupParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterRemoveGroupResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterRemoveGroupResponseParams; // inherited from NSObject

	static new(): MTRGroupsClusterRemoveGroupResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterViewGroupParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterViewGroupParams; // inherited from NSObject

	static new(): MTRGroupsClusterViewGroupParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRGroupsClusterViewGroupResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRGroupsClusterViewGroupResponseParams; // inherited from NSObject

	static new(): MTRGroupsClusterViewGroupResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	groupID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	groupId: number;

	/**
	 * @since 16.1
	 */
	groupName: string;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.0
 */
declare const enum MTRGroupsFeature {

	GroupNames = 1
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRGroupsGroupClusterFeature {

	GroupNames = 1
}

/**
 * @since 17.0
 */
declare const enum MTRGroupsNameSupportBitmap {

	GroupNames = 128
}

/**
 * @since 17.6
 */
declare const enum MTRHEPAFilterMonitoringChangeIndication {

	OK = 0,

	Warning = 1,

	Critical = 2
}

/**
 * @since 17.6
 */
declare class MTRHEPAFilterMonitoringClusterReplacementProductStruct extends NSObject implements NSCopying {

	static alloc(): MTRHEPAFilterMonitoringClusterReplacementProductStruct; // inherited from NSObject

	static new(): MTRHEPAFilterMonitoringClusterReplacementProductStruct; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	productIdentifierType: number;

	/**
	 * @since 17.6
	 */
	productIdentifierValue: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRHEPAFilterMonitoringClusterResetConditionParams extends NSObject implements NSCopying {

	static alloc(): MTRHEPAFilterMonitoringClusterResetConditionParams; // inherited from NSObject

	static new(): MTRHEPAFilterMonitoringClusterResetConditionParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRHEPAFilterMonitoringDegradationDirection {

	Up = 0,

	Down = 1
}

/**
 * @since 17.6
 */
declare const enum MTRHEPAFilterMonitoringFeature {

	Condition = 1,

	Warning = 2,

	ReplacementProductList = 4
}

/**
 * @since 17.6
 */
declare const enum MTRHEPAFilterMonitoringProductIdentifierType {

	UPC = 0,

	GTIN8 = 1,

	EAN = 2,

	GTIN14 = 3,

	OEM = 4
}

/**
 * @since 16.1
 */
declare class MTRIdentifyClusterIdentifyParams extends NSObject implements NSCopying {

	static alloc(): MTRIdentifyClusterIdentifyParams; // inherited from NSObject

	static new(): MTRIdentifyClusterIdentifyParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	identifyTime: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRIdentifyClusterTriggerEffectParams extends NSObject implements NSCopying {

	static alloc(): MTRIdentifyClusterTriggerEffectParams; // inherited from NSObject

	static new(): MTRIdentifyClusterTriggerEffectParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	effectIdentifier: number;

	/**
	 * @since 16.1
	 */
	effectVariant: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRIdentifyEffectIdentifier {

	Blink = 0,

	Breathe = 1,

	Okay = 2,

	ChannelChange = 11,

	FinishEffect = 254,

	StopEffect = 255
}

/**
 * @since 16.1
 */
declare const enum MTRIdentifyEffectVariant {

	Default = 0
}

/**
 * @since 16.1
 */
declare const enum MTRIdentifyType {

	None = 0,

	LightOutput = 1,

	VisibleLight = 1,

	VisibleIndicator = 2,

	VisibleLED = 2,

	AudibleBeep = 3,

	Display = 4,

	Actuator = 5
}

/**
 * @since 16.1
 */
declare const enum MTRIlluminanceMeasurementLightSensorType {

	Photodiode = 0,

	CMOS = 1
}

declare const enum MTRInteractionErrorCode {

	Failure = 1,

	InvalidSubscription = 125,

	UnsupportedAccess = 126,

	UnsupportedEndpoint = 127,

	InvalidAction = 128,

	UnsupportedCommand = 129,

	InvalidCommand = 133,

	UnsupportedAttribute = 134,

	ConstraintError = 135,

	UnsupportedWrite = 136,

	ResourceExhausted = 137,

	NotFound = 139,

	UnreportableAttribute = 140,

	InvalidDataType = 141,

	UnsupportedRead = 143,

	DataVersionMismatch = 146,

	Timeout = 148,

	Busy = 156,

	UnsupportedCluster = 195,

	NoUpstreamSubscription = 197,

	NeedsTimedInteraction = 198,

	UnsupportedEvent = 199,

	PathsExhausted = 200,

	TimedRequestMismatch = 201,

	FailsafeRequired = 202,

	InvalidInState = 203,

	NoCommandResponse = 204
}

/**
 * @since 16.1
 */
declare var MTRInteractionErrorDomain: string;

/**
 * @since 17.4
 */
declare const enum MTRKeypadInputCECKeyCode {

	Select = 0,

	Up = 1,

	Down = 2,

	Left = 3,

	Right = 4,

	RightUp = 5,

	RightDown = 6,

	LeftUp = 7,

	LeftDown = 8,

	RootMenu = 9,

	SetupMenu = 10,

	ContentsMenu = 11,

	FavoriteMenu = 12,

	Exit = 13,

	MediaTopMenu = 16,

	MediaContextSensitiveMenu = 17,

	NumberEntryMode = 29,

	Number11 = 30,

	Number12 = 31,

	Number0OrNumber10 = 32,

	Numbers1 = 33,

	Numbers2 = 34,

	Numbers3 = 35,

	Numbers4 = 36,

	Numbers5 = 37,

	Numbers6 = 38,

	Numbers7 = 39,

	Numbers8 = 40,

	Numbers9 = 41,

	Dot = 42,

	Enter = 43,

	Clear = 44,

	NextFavorite = 47,

	ChannelUp = 48,

	ChannelDown = 49,

	PreviousChannel = 50,

	SoundSelect = 51,

	InputSelect = 52,

	DisplayInformation = 53,

	Help = 54,

	PageUp = 55,

	PageDown = 56,

	Power = 64,

	VolumeUp = 65,

	VolumeDown = 66,

	Mute = 67,

	Play = 68,

	Stop = 69,

	Pause = 70,

	Record = 71,

	Rewind = 72,

	FastForward = 73,

	Eject = 74,

	Forward = 75,

	Backward = 76,

	StopRecord = 77,

	PauseRecord = 78,

	Reserved = 79,

	Angle = 80,

	SubPicture = 81,

	VideoOnDemand = 82,

	ElectronicProgramGuide = 83,

	TimerProgramming = 84,

	InitialConfiguration = 85,

	SelectBroadcastType = 86,

	SelectSoundPresentation = 87,

	PlayFunction = 96,

	PausePlayFunction = 97,

	RecordFunction = 98,

	PauseRecordFunction = 99,

	StopFunction = 100,

	MuteFunction = 101,

	RestoreVolumeFunction = 102,

	TuneFunction = 103,

	SelectMediaFunction = 104,

	SelectAvInputFunction = 105,

	SelectAudioInputFunction = 106,

	PowerToggleFunction = 107,

	PowerOffFunction = 108,

	PowerOnFunction = 109,

	F1Blue = 113,

	F2Red = 114,

	F3Green = 115,

	F4Yellow = 116,

	F5 = 117,

	Data = 118
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRKeypadInputCecKeyCode {

	Select = 0,

	Up = 1,

	Down = 2,

	Left = 3,

	Right = 4,

	RightUp = 5,

	RightDown = 6,

	LeftUp = 7,

	LeftDown = 8,

	RootMenu = 9,

	SetupMenu = 10,

	ContentsMenu = 11,

	FavoriteMenu = 12,

	Exit = 13,

	MediaTopMenu = 16,

	MediaContextSensitiveMenu = 17,

	NumberEntryMode = 29,

	Number11 = 30,

	Number12 = 31,

	Number0OrNumber10 = 32,

	Numbers1 = 33,

	Numbers2 = 34,

	Numbers3 = 35,

	Numbers4 = 36,

	Numbers5 = 37,

	Numbers6 = 38,

	Numbers7 = 39,

	Numbers8 = 40,

	Numbers9 = 41,

	Dot = 42,

	Enter = 43,

	Clear = 44,

	NextFavorite = 47,

	ChannelUp = 48,

	ChannelDown = 49,

	PreviousChannel = 50,

	SoundSelect = 51,

	InputSelect = 52,

	DisplayInformation = 53,

	Help = 54,

	PageUp = 55,

	PageDown = 56,

	Power = 64,

	VolumeUp = 65,

	VolumeDown = 66,

	Mute = 67,

	Play = 68,

	Stop = 69,

	Pause = 70,

	Record = 71,

	Rewind = 72,

	FastForward = 73,

	Eject = 74,

	Forward = 75,

	Backward = 76,

	StopRecord = 77,

	PauseRecord = 78,

	Reserved = 79,

	Angle = 80,

	SubPicture = 81,

	VideoOnDemand = 82,

	ElectronicProgramGuide = 83,

	TimerProgramming = 84,

	InitialConfiguration = 85,

	SelectBroadcastType = 86,

	SelectSoundPresentation = 87,

	PlayFunction = 96,

	PausePlayFunction = 97,

	RecordFunction = 98,

	PauseRecordFunction = 99,

	StopFunction = 100,

	MuteFunction = 101,

	RestoreVolumeFunction = 102,

	TuneFunction = 103,

	SelectMediaFunction = 104,

	SelectAvInputFunction = 105,

	SelectAudioInputFunction = 106,

	PowerToggleFunction = 107,

	PowerOffFunction = 108,

	PowerOnFunction = 109,

	F1Blue = 113,

	F2Red = 114,

	F3Green = 115,

	F4Yellow = 116,

	F5 = 117,

	Data = 118
}

/**
 * @since 16.1
 */
declare class MTRKeypadInputClusterSendKeyParams extends NSObject implements NSCopying {

	static alloc(): MTRKeypadInputClusterSendKeyParams; // inherited from NSObject

	static new(): MTRKeypadInputClusterSendKeyParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	keyCode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRKeypadInputClusterSendKeyResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRKeypadInputClusterSendKeyResponseParams; // inherited from NSObject

	static new(): MTRKeypadInputClusterSendKeyResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare const enum MTRKeypadInputFeature {

	NavigationKeyCodes = 1,

	LocationKeys = 2,

	NumberKeys = 4
}

/**
 * @since 16.1
 */
declare const enum MTRKeypadInputStatus {

	Success = 0,

	UnsupportedKey = 1,

	InvalidKeyInCurrentState = 2
}

interface MTRKeypair extends NSObjectProtocol {

	publicKey(): any;

	signMessageECDSA_DER?(message: NSData): NSData;

	signMessageECDSA_RAW?(message: NSData): NSData;
}
declare var MTRKeypair: {

	prototype: MTRKeypair;
};

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterMoveParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterMoveParams; // inherited from NSObject

	static new(): MTRLevelControlClusterMoveParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterMoveToClosestFrequencyParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterMoveToClosestFrequencyParams; // inherited from NSObject

	static new(): MTRLevelControlClusterMoveToClosestFrequencyParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	frequency: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterMoveToLevelParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterMoveToLevelParams; // inherited from NSObject

	static new(): MTRLevelControlClusterMoveToLevelParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	level: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterMoveToLevelWithOnOffParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterMoveToLevelWithOnOffParams; // inherited from NSObject

	static new(): MTRLevelControlClusterMoveToLevelWithOnOffParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	level: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterMoveWithOnOffParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterMoveWithOnOffParams; // inherited from NSObject

	static new(): MTRLevelControlClusterMoveWithOnOffParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	moveMode: number;

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	/**
	 * @since 16.1
	 */
	rate: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterStepParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterStepParams; // inherited from NSObject

	static new(): MTRLevelControlClusterStepParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterStepWithOnOffParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterStepWithOnOffParams; // inherited from NSObject

	static new(): MTRLevelControlClusterStepWithOnOffParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	stepMode: number;

	/**
	 * @since 16.1
	 */
	stepSize: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterStopParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterStopParams; // inherited from NSObject

	static new(): MTRLevelControlClusterStopParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRLevelControlClusterStopWithOnOffParams extends NSObject implements NSCopying {

	static alloc(): MTRLevelControlClusterStopWithOnOffParams; // inherited from NSObject

	static new(): MTRLevelControlClusterStopWithOnOffParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	optionsMask: number;

	/**
	 * @since 16.1
	 */
	optionsOverride: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRLevelControlFeature {

	OnOff = 1,

	Lighting = 2,

	Frequency = 4
}

/**
 * @since 16.1
 */
declare const enum MTRLevelControlMoveMode {

	Up = 0,

	Down = 1
}

/**
 * @since 16.4
 * @deprecated 17.4
 */
declare const enum MTRLevelControlOptions {

	ExecuteIfOff = 1,

	CoupleColorTempToLevel = 2
}

/**
 * @since 17.4
 */
declare const enum MTRLevelControlOptionsBitmap {

	ExecuteIfOff = 1,

	CoupleColorTempToLevel = 2
}

/**
 * @since 16.1
 */
declare const enum MTRLevelControlStepMode {

	Up = 0,

	Down = 1
}

declare const enum MTRLogType {

	Error = 1,

	Progress = 2,

	Detail = 3
}

/**
 * @since 16.1
 */
declare class MTRLowPowerClusterSleepParams extends NSObject implements NSCopying {

	static alloc(): MTRLowPowerClusterSleepParams; // inherited from NSObject

	static new(): MTRLowPowerClusterSleepParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRManualSetupPayloadParser extends NSObject {

	static alloc(): MTRManualSetupPayloadParser; // inherited from NSObject

	static new(): MTRManualSetupPayloadParser; // inherited from NSObject

	constructor(o: { decimalStringRepresentation: string; });

	initWithDecimalStringRepresentation(decimalStringRepresentation: string): this;

	populatePayload(): MTRSetupPayload;
}

/**
 * @since 16.1
 */
declare class MTRMediaInputClusterHideInputStatusParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaInputClusterHideInputStatusParams; // inherited from NSObject

	static new(): MTRMediaInputClusterHideInputStatusParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRMediaInputClusterInputInfo extends MTRMediaInputClusterInputInfoStruct {

	static alloc(): MTRMediaInputClusterInputInfo; // inherited from NSObject

	static new(): MTRMediaInputClusterInputInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRMediaInputClusterInputInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRMediaInputClusterInputInfoStruct; // inherited from NSObject

	static new(): MTRMediaInputClusterInputInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	descriptionString: string;

	/**
	 * @since 16.4
	 */
	index: number;

	/**
	 * @since 16.4
	 */
	inputType: number;

	/**
	 * @since 16.4
	 */
	name: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaInputClusterRenameInputParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaInputClusterRenameInputParams; // inherited from NSObject

	static new(): MTRMediaInputClusterRenameInputParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	index: number;

	/**
	 * @since 16.1
	 */
	name: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaInputClusterSelectInputParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaInputClusterSelectInputParams; // inherited from NSObject

	static new(): MTRMediaInputClusterSelectInputParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	index: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaInputClusterShowInputStatusParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaInputClusterShowInputStatusParams; // inherited from NSObject

	static new(): MTRMediaInputClusterShowInputStatusParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRMediaInputFeature {

	NameUpdates = 1
}

/**
 * @since 16.1
 */
declare const enum MTRMediaInputInputType {

	Internal = 0,

	Aux = 1,

	Coax = 2,

	Composite = 3,

	HDMI = 4,

	Hdmi = 4,

	Input = 5,

	Line = 6,

	Optical = 7,

	Video = 8,

	SCART = 9,

	Scart = 9,

	USB = 10,

	Usb = 10,

	Other = 11
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterFastForwardParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterFastForwardParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterFastForwardParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterNextParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterNextParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterNextParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterPauseParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterPauseParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPauseParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterPlayParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterPlayParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPlayParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRMediaPlaybackClusterPlaybackPosition extends MTRMediaPlaybackClusterPlaybackPositionStruct {

	static alloc(): MTRMediaPlaybackClusterPlaybackPosition; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPlaybackPosition; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRMediaPlaybackClusterPlaybackPositionStruct extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterPlaybackPositionStruct; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPlaybackPositionStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	position: number;

	/**
	 * @since 16.4
	 */
	updatedAt: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterPlaybackResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterPlaybackResponseParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPlaybackResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	data: string;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterPreviousParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterPreviousParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterPreviousParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterRewindParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterRewindParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterRewindParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterSeekParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterSeekParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterSeekParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	position: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterSkipBackwardParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterSkipBackwardParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterSkipBackwardParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	deltaPositionMilliseconds: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterSkipForwardParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterSkipForwardParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterSkipForwardParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	deltaPositionMilliseconds: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRMediaPlaybackClusterStartOverParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterStartOverParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterStartOverParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRMediaPlaybackClusterStopParams extends NSObject implements NSCopying {

	static alloc(): MTRMediaPlaybackClusterStopParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterStopParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRMediaPlaybackClusterStopPlaybackParams extends MTRMediaPlaybackClusterStopParams {

	static alloc(): MTRMediaPlaybackClusterStopPlaybackParams; // inherited from NSObject

	static new(): MTRMediaPlaybackClusterStopPlaybackParams; // inherited from NSObject
}

/**
 * @since 16.2
 */
declare const enum MTRMediaPlaybackFeature {

	AdvancedSeek = 1,

	VariableSpeed = 2,

	TextTracks = 4,

	AudioTracks = 8,

	AudioAdvance = 16
}

/**
 * @since 16.1
 */
declare const enum MTRMediaPlaybackPlaybackState {

	Playing = 0,

	Paused = 1,

	NotPlaying = 2,

	Buffering = 3
}

/**
 * @since 16.1
 */
declare const enum MTRMediaPlaybackStatus {

	Success = 0,

	InvalidStateForCommand = 1,

	NotAllowed = 2,

	NotActive = 3,

	SpeedOutOfRange = 4,

	SeekOutOfRange = 5
}

/**
 * @since 17.6
 */
declare class MTRMetricData extends NSObject {

	static alloc(): MTRMetricData; // inherited from NSObject

	static new(): MTRMetricData; // inherited from NSObject

	readonly duration: number;

	readonly errorCode: number;

	readonly value: number;
}

/**
 * @since 17.6
 */
declare class MTRMetrics extends NSObject {

	static alloc(): MTRMetrics; // inherited from NSObject

	static new(): MTRMetrics; // inherited from NSObject

	readonly allKeys: NSArray<string>;

	readonly uniqueIdentifier: NSUUID;

	metricDataForKey(key: string): MTRMetricData;
}

/**
 * @since 16.1
 */
declare class MTRModeSelectClusterChangeToModeParams extends NSObject implements NSCopying {

	static alloc(): MTRModeSelectClusterChangeToModeParams; // inherited from NSObject

	static new(): MTRModeSelectClusterChangeToModeParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	newMode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRModeSelectClusterModeOptionStruct extends NSObject implements NSCopying {

	static alloc(): MTRModeSelectClusterModeOptionStruct; // inherited from NSObject

	static new(): MTRModeSelectClusterModeOptionStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	label: string;

	/**
	 * @since 16.1
	 */
	mode: number;

	/**
	 * @since 16.1
	 */
	semanticTags: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRModeSelectClusterSemanticTag extends MTRModeSelectClusterSemanticTagStruct {

	static alloc(): MTRModeSelectClusterSemanticTag; // inherited from NSObject

	static new(): MTRModeSelectClusterSemanticTag; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRModeSelectClusterSemanticTagStruct extends NSObject implements NSCopying {

	static alloc(): MTRModeSelectClusterSemanticTagStruct; // inherited from NSObject

	static new(): MTRModeSelectClusterSemanticTagStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	mfgCode: number;

	/**
	 * @since 16.4
	 */
	value: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRModeSelectFeature {

	OnOff = 1,

	DEPONOFF = 1
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
interface MTRNOCChainIssuer extends NSObjectProtocol {

	onNOCChainGenerationNeededAttestationInfoOnNOCChainGenerationComplete(csrInfo: CSRInfo, attestationInfo: AttestationInfo, onNOCChainGenerationComplete: (p1: NSData, p2: NSData, p3: NSData, p4: NSData, p5: number, p6: interop.Pointer | interop.Reference<NSError>) => void): void;
}
declare var MTRNOCChainIssuer: {

	prototype: MTRNOCChainIssuer;
};

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterAddOrUpdateThreadNetworkParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	operationalDataset: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterAddOrUpdateWiFiNetworkParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	credentials: NSData;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	ssid: NSData;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterConnectNetworkParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterConnectNetworkParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterConnectNetworkParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	networkID: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterConnectNetworkResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterConnectNetworkResponseParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterConnectNetworkResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	errorValue: number;

	/**
	 * @since 16.1
	 */
	networkingStatus: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterNetworkConfigResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterNetworkConfigResponseParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterNetworkConfigResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	networkIndex: number;

	/**
	 * @since 16.1
	 */
	networkingStatus: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRNetworkCommissioningClusterNetworkInfo extends MTRNetworkCommissioningClusterNetworkInfoStruct {

	static alloc(): MTRNetworkCommissioningClusterNetworkInfo; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterNetworkInfo; // inherited from NSObject
}

/**
 * @since 17.0
 */
declare class MTRNetworkCommissioningClusterNetworkInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterNetworkInfoStruct; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterNetworkInfoStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	connected: number;

	/**
	 * @since 17.0
	 */
	networkID: NSData;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterRemoveNetworkParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterRemoveNetworkParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterRemoveNetworkParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	networkID: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterReorderNetworkParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterReorderNetworkParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterReorderNetworkParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	/**
	 * @since 16.1
	 */
	networkID: NSData;

	/**
	 * @since 16.1
	 */
	networkIndex: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterScanNetworksParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterScanNetworksParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterScanNetworksParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	breadcrumb: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	ssid: NSData;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRNetworkCommissioningClusterScanNetworksResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterScanNetworksResponseParams; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterScanNetworksResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	networkingStatus: number;

	/**
	 * @since 16.1
	 */
	threadScanResults: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	wiFiScanResults: NSArray<any>;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRNetworkCommissioningClusterThreadInterfaceScanResult extends MTRNetworkCommissioningClusterThreadInterfaceScanResultStruct {

	static alloc(): MTRNetworkCommissioningClusterThreadInterfaceScanResult; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterThreadInterfaceScanResult; // inherited from NSObject
}

/**
 * @since 17.0
 */
declare class MTRNetworkCommissioningClusterThreadInterfaceScanResultStruct extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterThreadInterfaceScanResultStruct; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterThreadInterfaceScanResultStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	channel: number;

	/**
	 * @since 17.0
	 */
	extendedAddress: NSData;

	/**
	 * @since 17.0
	 */
	extendedPanId: number;

	/**
	 * @since 17.0
	 */
	lqi: number;

	/**
	 * @since 17.0
	 */
	networkName: string;

	/**
	 * @since 17.0
	 */
	panId: number;

	/**
	 * @since 17.0
	 */
	rssi: number;

	/**
	 * @since 17.0
	 */
	version: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRNetworkCommissioningClusterWiFiInterfaceScanResult extends MTRNetworkCommissioningClusterWiFiInterfaceScanResultStruct {

	static alloc(): MTRNetworkCommissioningClusterWiFiInterfaceScanResult; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterWiFiInterfaceScanResult; // inherited from NSObject
}

/**
 * @since 17.0
 */
declare class MTRNetworkCommissioningClusterWiFiInterfaceScanResultStruct extends NSObject implements NSCopying {

	static alloc(): MTRNetworkCommissioningClusterWiFiInterfaceScanResultStruct; // inherited from NSObject

	static new(): MTRNetworkCommissioningClusterWiFiInterfaceScanResultStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	bssid: NSData;

	/**
	 * @since 17.0
	 */
	channel: number;

	/**
	 * @since 17.0
	 */
	rssi: number;

	/**
	 * @since 17.0
	 */
	security: number;

	/**
	 * @since 17.0
	 */
	ssid: NSData;

	/**
	 * @since 17.0
	 */
	wiFiBand: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRNetworkCommissioningFeature {

	WiFiNetworkInterface = 1,

	ThreadNetworkInterface = 2,

	EthernetNetworkInterface = 4,

	PerDeviceCredentials = 8
}

/**
 * @since 16.1
 */
declare const enum MTRNetworkCommissioningStatus {

	Success = 0,

	OutOfRange = 1,

	BoundsExceeded = 2,

	NetworkIDNotFound = 3,

	DuplicateNetworkID = 4,

	NetworkNotFound = 5,

	RegulatoryError = 6,

	AuthFailure = 7,

	UnsupportedSecurity = 8,

	OtherConnectionFailure = 9,

	IPV6Failed = 10,

	IPBindFailed = 11,

	UnknownError = 12
}

/**
 * @since 16.1
 */
declare const enum MTRNetworkCommissioningWiFiBand {

	Band2G4 = 0,

	Band3G65 = 1,

	Band5G = 2,

	Band6G = 3,

	Band60G = 4,

	Band1G = 5
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRNetworkCommissioningWiFiSecurity {

	Unencrypted = 1,

	WEP = 2,

	WepPersonal = 2,

	WPAPersonal = 4,

	WpaPersonal = 4,

	WPA2Personal = 8,

	Wpa2Personal = 8,

	WPA3Personal = 16,

	Wpa3Personal = 16
}

/**
 * @since 17.0
 */
declare const enum MTRNetworkCommissioningWiFiSecurityBitmap {

	Unencrypted = 1,

	WEP = 2,

	WPAPersonal = 4,

	WPA2Personal = 8,

	WPA3Personal = 16,

	WPA3MatterPDC = 32
}

/**
 * @since 17.6
 */
declare const enum MTRNitrogenDioxideConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRNitrogenDioxideConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRNitrogenDioxideConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRNitrogenDioxideConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.1
 */
declare var MTRNullValueType: string;

/**
 * @since 16.1
 */
declare class MTROTAHeader extends NSObject {

	static alloc(): MTROTAHeader; // inherited from NSObject

	static new(): MTROTAHeader; // inherited from NSObject

	imageDigest: NSData;

	imageDigestType: MTROTAImageDigestType;

	maxApplicableVersion: number;

	minApplicableVersion: number;

	payloadSize: number;

	productID: number;

	releaseNotesURL: string;

	softwareVersion: number;

	softwareVersionString: string;

	vendorID: number;

	/**
	 * @since 16.4
	 */
	constructor(o: { data: NSData; });

	/**
	 * @since 16.4
	 */
	initWithData(data: NSData): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROTAHeaderParser extends NSObject {

	static alloc(): MTROTAHeaderParser; // inherited from NSObject

	static headerFromDataError(data: NSData): MTROTAHeader;

	static new(): MTROTAHeaderParser; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare const enum MTROTAImageDigestType {

	Sha256 = 1,

	Sha256_128 = 2,

	Sha256_120 = 3,

	Sha256_96 = 4,

	Sha256_64 = 5,

	Sha256_32 = 6,

	Sha384 = 7,

	Sha512 = 8,

	Sha3_224 = 9,

	Sha3_256 = 10,

	Sha3_384 = 11,

	Sha3_512 = 12
}

interface MTROTAProviderDelegate extends NSObjectProtocol {

	/**
	 * @since 16.4
	 */
	handleApplyUpdateRequestForNodeIDControllerParamsCompletion?(nodeID: number, controller: MTRDeviceController, params: MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams, completion: (p1: MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	handleApplyUpdateRequestForNodeIDControllerParamsCompletionHandler?(nodeID: number, controller: MTRDeviceController, params: MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	handleBDXQueryForNodeIDControllerBlockSizeBlockIndexBytesToSkipCompletion?(nodeID: number, controller: MTRDeviceController, blockSize: number, blockIndex: number, bytesToSkip: number, completion: (p1: NSData, p2: boolean) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	handleBDXQueryForNodeIDControllerBlockSizeBlockIndexBytesToSkipCompletionHandler?(nodeID: number, controller: MTRDeviceController, blockSize: number, blockIndex: number, bytesToSkip: number, completionHandler: (p1: NSData, p2: boolean) => void): void;

	/**
	 * @since 16.4
	 */
	handleBDXTransferSessionBeginForNodeIDControllerFileDesignatorOffsetCompletion?(nodeID: number, controller: MTRDeviceController, fileDesignator: string, offset: number, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	handleBDXTransferSessionBeginForNodeIDControllerFileDesignatorOffsetCompletionHandler?(nodeID: number, controller: MTRDeviceController, fileDesignator: string, offset: number, completionHandler: (p1: NSError) => void): void;

	handleBDXTransferSessionEndForNodeIDControllerError?(nodeID: number, controller: MTRDeviceController, error: NSError): void;

	/**
	 * @since 16.4
	 */
	handleNotifyUpdateAppliedForNodeIDControllerParamsCompletion?(nodeID: number, controller: MTRDeviceController, params: MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams, completion: (p1: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	handleNotifyUpdateAppliedForNodeIDControllerParamsCompletionHandler?(nodeID: number, controller: MTRDeviceController, params: MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams, completionHandler: (p1: NSError) => void): void;

	/**
	 * @since 16.4
	 */
	handleQueryImageForNodeIDControllerParamsCompletion?(nodeID: number, controller: MTRDeviceController, params: MTROTASoftwareUpdateProviderClusterQueryImageParams, completion: (p1: MTROTASoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	handleQueryImageForNodeIDControllerParamsCompletionHandler?(nodeID: number, controller: MTRDeviceController, params: MTROtaSoftwareUpdateProviderClusterQueryImageParams, completionHandler: (p1: MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams, p2: NSError) => void): void;
}
declare var MTROTAProviderDelegate: {

	prototype: MTROTAProviderDelegate;
};

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateProviderApplyUpdateAction {

	Proceed = 0,

	AwaitNextAction = 1,

	Discontinue = 2
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	newVersion: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	updateToken: NSData;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	action: number;

	/**
	 * @since 16.4
	 */
	delayedActionTime: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	updateToken: NSData;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateProviderClusterQueryImageParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateProviderClusterQueryImageParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateProviderClusterQueryImageParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	hardwareVersion: number;

	/**
	 * @since 16.4
	 */
	location: string;

	/**
	 * @since 16.4
	 */
	metadataForProvider: NSData;

	/**
	 * @since 16.4
	 */
	productID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	productId: number;

	/**
	 * @since 16.4
	 */
	protocolsSupported: NSArray<any>;

	/**
	 * @since 16.4
	 */
	requestorCanConsent: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	vendorID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	vendorId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateProviderClusterQueryImageResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateProviderClusterQueryImageResponseParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateProviderClusterQueryImageResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	delayedActionTime: number;

	/**
	 * @since 16.4
	 */
	imageURI: string;

	/**
	 * @since 16.4
	 */
	metadataForRequestor: NSData;

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	/**
	 * @since 16.4
	 */
	softwareVersionString: string;

	/**
	 * @since 16.4
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	updateToken: NSData;

	/**
	 * @since 16.4
	 */
	userConsentNeeded: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateProviderDownloadProtocol {

	BDXSynchronous = 0,

	BDXAsynchronous = 1,

	HTTPS = 2,

	VendorSpecific = 3
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateProviderOTAApplyUpdateAction {

	Proceed = 0,

	AwaitNextAction = 1,

	Discontinue = 2
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateProviderOTADownloadProtocol {

	BDXSynchronous = 0,

	BDXAsynchronous = 1,

	HTTPS = 2,

	VendorSpecific = 3
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateProviderOTAQueryStatus {

	UpdateAvailable = 0,

	Busy = 1,

	NotAvailable = 2,

	DownloadProtocolNotSupported = 3
}

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateProviderStatus {

	UpdateAvailable = 0,

	Busy = 1,

	NotAvailable = 2,

	DownloadProtocolNotSupported = 3
}

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorAnnouncementReason {

	SimpleAnnouncement = 0,

	UpdateAvailable = 1,

	UrgentUpdateAvailable = 2
}

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorChangeReason {

	Unknown = 0,

	Success = 1,

	Failure = 2,

	TimeOut = 3,

	DelayByProvider = 4
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams; // inherited from NSObject

	static new(): MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	announcementReason: number;

	/**
	 * @since 16.4
	 */
	endpoint: number;

	/**
	 * @since 16.4
	 */
	metadataForNode: NSData;

	/**
	 * @since 16.4
	 */
	providerNodeID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	providerNodeId: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	vendorID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	vendorId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateRequestorClusterDownloadErrorEvent extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateRequestorClusterDownloadErrorEvent; // inherited from NSObject

	static new(): MTROTASoftwareUpdateRequestorClusterDownloadErrorEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	bytesDownloaded: number;

	/**
	 * @since 16.4
	 */
	platformCode: number;

	/**
	 * @since 16.4
	 */
	progressPercent: number;

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateRequestorClusterProviderLocation extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateRequestorClusterProviderLocation; // inherited from NSObject

	static new(): MTROTASoftwareUpdateRequestorClusterProviderLocation; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	endpoint: number;

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	/**
	 * @since 16.4
	 */
	providerNodeID: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateRequestorClusterStateTransitionEvent extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateRequestorClusterStateTransitionEvent; // inherited from NSObject

	static new(): MTROTASoftwareUpdateRequestorClusterStateTransitionEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	newState: number;

	/**
	 * @since 16.4
	 */
	previousState: number;

	/**
	 * @since 16.4
	 */
	reason: number;

	/**
	 * @since 16.4
	 */
	targetSoftwareVersion: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTROTASoftwareUpdateRequestorClusterVersionAppliedEvent extends NSObject implements NSCopying {

	static alloc(): MTROTASoftwareUpdateRequestorClusterVersionAppliedEvent; // inherited from NSObject

	static new(): MTROTASoftwareUpdateRequestorClusterVersionAppliedEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	productID: number;

	/**
	 * @since 16.4
	 */
	softwareVersion: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorOTAAnnouncementReason {

	SimpleAnnouncement = 0,

	UpdateAvailable = 1,

	UrgentUpdateAvailable = 2
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorOTAChangeReason {

	Unknown = 0,

	Success = 1,

	Failure = 2,

	TimeOut = 3,

	DelayByProvider = 4
}

/**
 * @since 16.4
 * @deprecated 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorOTAUpdateState {

	Unknown = 0,

	Idle = 1,

	Querying = 2,

	DelayedOnQuery = 3,

	Downloading = 4,

	Applying = 5,

	DelayedOnApply = 6,

	RollingBack = 7,

	DelayedOnUserConsent = 8
}

/**
 * @since 17.2
 */
declare const enum MTROTASoftwareUpdateRequestorUpdateState {

	Unknown = 0,

	Idle = 1,

	Querying = 2,

	DelayedOnQuery = 3,

	Downloading = 4,

	Applying = 5,

	DelayedOnApply = 6,

	RollingBack = 7,

	DelayedOnUserConsent = 8
}

/**
 * @since 16.5
 */
declare const enum MTROccupancySensingOccupancyBitmap {

	Occupied = 1
}

/**
 * @since 16.5
 */
declare const enum MTROccupancySensingOccupancySensorType {

	PIR = 0,

	Ultrasonic = 1,

	PIRAndUltrasonic = 2,

	PhysicalContact = 3
}

/**
 * @since 16.5
 */
declare const enum MTROccupancySensingOccupancySensorTypeBitmap {

	PIR = 1,

	Ultrasonic = 2,

	PhysicalContact = 4
}

/**
 * @since 16.1
 */
declare var MTROctetStringValueType: string;

/**
 * @since 16.1
 */
declare class MTROnOffClusterOffParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterOffParams; // inherited from NSObject

	static new(): MTROnOffClusterOffParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROnOffClusterOffWithEffectParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterOffWithEffectParams; // inherited from NSObject

	static new(): MTROnOffClusterOffWithEffectParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	effectId: number;

	/**
	 * @since 16.4
	 */
	effectIdentifier: number;

	/**
	 * @since 16.1
	 */
	effectVariant: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROnOffClusterOnParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterOnParams; // inherited from NSObject

	static new(): MTROnOffClusterOnParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROnOffClusterOnWithRecallGlobalSceneParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterOnWithRecallGlobalSceneParams; // inherited from NSObject

	static new(): MTROnOffClusterOnWithRecallGlobalSceneParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROnOffClusterOnWithTimedOffParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterOnWithTimedOffParams; // inherited from NSObject

	static new(): MTROnOffClusterOnWithTimedOffParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	offWaitTime: number;

	/**
	 * @since 16.1
	 */
	onOffControl: number;

	/**
	 * @since 16.1
	 */
	onTime: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROnOffClusterToggleParams extends NSObject implements NSCopying {

	static alloc(): MTROnOffClusterToggleParams; // inherited from NSObject

	static new(): MTROnOffClusterToggleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.2
 */
declare const enum MTROnOffControl {

	AcceptOnlyWhenOn = 1
}

/**
 * @since 17.2
 */
declare const enum MTROnOffControlBitmap {

	AcceptOnlyWhenOn = 1
}

/**
 * @since 16.1
 */
declare const enum MTROnOffDelayedAllOffEffectVariant {

	VariantDelayedOffFastFade = 0,

	VariantFadeToOffIn0p8Seconds = 0,

	VariantNoFade = 1,

	VariantDelayedOffSlowFade = 2,

	Variant50PercentDimDownIn0p8SecondsThenFadeToOffIn12Seconds = 2
}

/**
 * @since 16.1
 */
declare const enum MTROnOffDyingLightEffectVariant {

	VariantDyingLightFadeOff = 0,

	Variant20PercenterDimUpIn0p5SecondsThenFadeToOffIn1Second = 0
}

/**
 * @since 16.1
 */
declare const enum MTROnOffEffectIdentifier {

	DelayedAllOff = 0,

	DyingLight = 1
}

/**
 * @since 16.1
 */
declare const enum MTROnOffFeature {

	Lighting = 1,

	DeadFrontBehavior = 2,

	DeadFront = 2,

	OffOnly = 4
}

/**
 * @since 16.1
 */
declare const enum MTROnOffStartUpOnOff {

	Off = 0,

	On = 1,

	Toggle = 2,

	TogglePreviousOnOff = 2
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTROnboardingPayloadParser extends NSObject {

	static alloc(): MTROnboardingPayloadParser; // inherited from NSObject

	static new(): MTROnboardingPayloadParser; // inherited from NSObject

	static setupPayloadForOnboardingPayloadError(onboardingPayload: string): MTRSetupPayload;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTROnboardingPayloadType {

	QRCode = 0,

	ManualCode = 1,

	NFC = 2
}

/**
 * @since 16.4
 */
declare class MTROperationalCSRInfo extends NSObject {

	static alloc(): MTROperationalCSRInfo; // inherited from NSObject

	static new(): MTROperationalCSRInfo; // inherited from NSObject

	readonly attestationSignature: NSData;

	readonly csr: NSData;

	readonly csrElementsTLV: NSData;

	readonly csrNonce: NSData;

	/**
	 * @since 16.4
	 * @deprecated 17.0
	 */
	constructor(o: { CSR: NSData; csrNonce: NSData; csrElementsTLV: NSData; attestationSignature: NSData; });

	/**
	 * @since 17.0
	 */
	constructor(o: { CSRElementsTLV: NSData; attestationSignature: NSData; });

	/**
	 * @since 17.0
	 */
	constructor(o: { CSRNonce: NSData; csrElementsTLV: NSData; attestationSignature: NSData; });

	/**
	 * @since 17.0
	 */
	constructor(o: { CSRResponseParams: MTROperationalCredentialsClusterCSRResponseParams; });

	/**
	 * @since 16.4
	 * @deprecated 17.0
	 */
	initWithCSRCsrNonceCsrElementsTLVAttestationSignature(csr: NSData, csrNonce: NSData, csrElementsTLV: NSData, attestationSignature: NSData): this;

	/**
	 * @since 17.0
	 */
	initWithCSRElementsTLVAttestationSignature(csrElementsTLV: NSData, attestationSignature: NSData): this;

	/**
	 * @since 17.0
	 */
	initWithCSRNonceCsrElementsTLVAttestationSignature(csrNonce: NSData, csrElementsTLV: NSData, attestationSignature: NSData): this;

	/**
	 * @since 17.0
	 */
	initWithCSRResponseParams(responseParams: MTROperationalCredentialsClusterCSRResponseParams): this;
}

/**
 * @since 16.4
 */
declare class MTROperationalCertificateChain extends NSObject {

	static alloc(): MTROperationalCertificateChain; // inherited from NSObject

	static new(): MTROperationalCertificateChain; // inherited from NSObject

	adminSubject: number;

	intermediateCertificate: NSData;

	operationalCertificate: NSData;

	rootCertificate: NSData;

	constructor(o: { operationalCertificate: NSData; intermediateCertificate: NSData; rootCertificate: NSData; adminSubject: number; });

	initWithOperationalCertificateIntermediateCertificateRootCertificateAdminSubject(operationalCertificate: NSData, intermediateCertificate: NSData, rootCertificate: NSData, adminSubject: number): this;
}

/**
 * @since 16.4
 */
interface MTROperationalCertificateIssuer {

	shouldSkipAttestationCertificateValidation: boolean;

	issueOperationalCertificateForRequestAttestationInfoControllerCompletion(csrInfo: MTROperationalCSRInfo, attestationInfo: MTRDeviceAttestationInfo, controller: MTRDeviceController, completion: (p1: MTROperationalCertificateChain, p2: NSError) => void): void;
}
declare var MTROperationalCertificateIssuer: {

	prototype: MTROperationalCertificateIssuer;
};

/**
 * @since 16.4
 */
declare const enum MTROperationalCredentialsCertificateChainType {

	DACCertificate = 1,

	PAICertificate = 2
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterAddNOCParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterAddNOCParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterAddNOCParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	adminVendorId: number;

	/**
	 * @since 16.1
	 */
	caseAdminSubject: number;

	/**
	 * @since 16.1
	 */
	icacValue: NSData;

	/**
	 * @since 16.1
	 */
	ipkValue: NSData;

	/**
	 * @since 16.1
	 */
	nocValue: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterAddTrustedRootCertificateParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterAddTrustedRootCertificateParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterAddTrustedRootCertificateParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	rootCACertificate: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rootCertificate: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterAttestationRequestParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterAttestationRequestParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterAttestationRequestParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	attestationNonce: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterAttestationResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterAttestationResponseParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterAttestationResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	attestationElements: NSData;

	/**
	 * @since 16.4
	 */
	attestationSignature: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	signature: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterCSRRequestParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterCSRRequestParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterCSRRequestParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	csrNonce: NSData;

	/**
	 * @since 16.1
	 */
	isForUpdateNOC: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterCSRResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterCSRResponseParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterCSRResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	attestationSignature: NSData;

	/**
	 * @since 16.1
	 */
	nocsrElements: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterCertificateChainRequestParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterCertificateChainRequestParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterCertificateChainRequestParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	certificateType: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterCertificateChainResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterCertificateChainResponseParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterCertificateChainResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	certificate: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROperationalCredentialsClusterFabricDescriptor extends MTROperationalCredentialsClusterFabricDescriptorStruct {

	static alloc(): MTROperationalCredentialsClusterFabricDescriptor; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterFabricDescriptor; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTROperationalCredentialsClusterFabricDescriptorStruct extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterFabricDescriptorStruct; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterFabricDescriptorStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	fabricID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	fabricId: number;

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	/**
	 * @since 16.4
	 */
	label: string;

	/**
	 * @since 16.4
	 */
	nodeID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	nodeId: number;

	/**
	 * @since 16.4
	 */
	rootPublicKey: NSData;

	/**
	 * @since 16.4
	 */
	vendorID: number;

	/**
	 * @since 16.4
	 * @deprecated 16.4
	 */
	vendorId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterNOCResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterNOCResponseParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterNOCResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	debugText: string;

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	statusCode: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterNOCStruct extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterNOCStruct; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterNOCStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	/**
	 * @since 16.1
	 */
	icac: NSData;

	/**
	 * @since 16.1
	 */
	noc: NSData;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterRemoveFabricParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterRemoveFabricParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterRemoveFabricParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	fabricIndex: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterUpdateFabricLabelParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterUpdateFabricLabelParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterUpdateFabricLabelParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	label: string;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTROperationalCredentialsClusterUpdateNOCParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalCredentialsClusterUpdateNOCParams; // inherited from NSObject

	static new(): MTROperationalCredentialsClusterUpdateNOCParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	icacValue: NSData;

	/**
	 * @since 16.1
	 */
	nocValue: NSData;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTROperationalCredentialsNodeOperationalCertStatus {

	OK = 0,

	InvalidPublicKey = 1,

	InvalidNodeOpId = 2,

	InvalidNOC = 3,

	MissingCsr = 4,

	TableFull = 5,

	InvalidAdminSubject = 6,

	FabricConflict = 9,

	LabelConflict = 10,

	InvalidFabricIndex = 11
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROperationalCredentialsOperationalCertStatus {

	SUCCESS = 0,

	InvalidPublicKey = 1,

	InvalidNodeOpId = 2,

	InvalidNOC = 3,

	MissingCsr = 4,

	TableFull = 5,

	InvalidAdminSubject = 6,

	FabricConflict = 9,

	LabelConflict = 10,

	InvalidFabricIndex = 11
}

/**
 * @since 17.4
 */
declare const enum MTROperationalState {

	Stopped = 0,

	Running = 1,

	Paused = 2,

	Error = 3
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterErrorStateStruct extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterErrorStateStruct; // inherited from NSObject

	static new(): MTROperationalStateClusterErrorStateStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	errorStateDetails: string;

	/**
	 * @since 17.4
	 */
	errorStateID: number;

	/**
	 * @since 17.4
	 */
	errorStateLabel: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterOperationCompletionEvent extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterOperationCompletionEvent; // inherited from NSObject

	static new(): MTROperationalStateClusterOperationCompletionEvent; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	completionErrorCode: number;

	/**
	 * @since 17.4
	 */
	pausedTime: number;

	/**
	 * @since 17.4
	 */
	totalOperationalTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterOperationalCommandResponseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterOperationalCommandResponseParams; // inherited from NSObject

	static new(): MTROperationalStateClusterOperationalCommandResponseParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	commandResponseState: MTROperationalStateClusterErrorStateStruct;

	/**
	 * @since 17.4
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.4
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterOperationalErrorEvent extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterOperationalErrorEvent; // inherited from NSObject

	static new(): MTROperationalStateClusterOperationalErrorEvent; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	errorState: MTROperationalStateClusterErrorStateStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterOperationalStateStruct extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterOperationalStateStruct; // inherited from NSObject

	static new(): MTROperationalStateClusterOperationalStateStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	operationalStateID: number;

	/**
	 * @since 17.4
	 */
	operationalStateLabel: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterPauseParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterPauseParams; // inherited from NSObject

	static new(): MTROperationalStateClusterPauseParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterResumeParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterResumeParams; // inherited from NSObject

	static new(): MTROperationalStateClusterResumeParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterStartParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterStartParams; // inherited from NSObject

	static new(): MTROperationalStateClusterStartParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTROperationalStateClusterStopParams extends NSObject implements NSCopying {

	static alloc(): MTROperationalStateClusterStopParams; // inherited from NSObject

	static new(): MTROperationalStateClusterStopParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare const enum MTROperationalStateErrorState {

	NoError = 0,

	UnableToStartOrResume = 1,

	UnableToCompleteOperation = 2,

	CommandInvalidInState = 3
}

/**
 * @since 16.1
 */
declare class MTROptionalQRCodeInfo extends NSObject implements NSCopying {

	static alloc(): MTROptionalQRCodeInfo; // inherited from NSObject

	static new(): MTROptionalQRCodeInfo; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	infoType: number;

	readonly integerValue: number;

	readonly stringValue: string;

	readonly tag: number;

	/**
	 * @since 16.4
	 */
	readonly type: MTROptionalQRCodeInfoType;

	/**
	 * @since 17.6
	 */
	constructor(o: { tag: number; int32Value: number; });

	/**
	 * @since 17.6
	 */
	constructor(o: { tag: number; stringValue: string; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.6
	 */
	initWithTagInt32Value(tag: number, value: number): this;

	/**
	 * @since 17.6
	 */
	initWithTagStringValue(tag: number, value: string): this;

	/**
	 * @since 16.1
	 * @deprecated 17.6
	 */
	setIntegerValue(integerValue: number): void;

	/**
	 * @since 16.1
	 * @deprecated 17.6
	 */
	setStringValue(stringValue: string): void;

	/**
	 * @since 16.1
	 * @deprecated 17.6
	 */
	setTag(tag: number): void;

	/**
	 * @since 16.1
	 * @deprecated 17.6
	 */
	setType(type: MTROptionalQRCodeInfoType): void;
}

declare const enum MTROptionalQRCodeInfoType {

	Unknown = 0,

	String = 1,

	Int32 = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams extends MTROTASoftwareUpdateProviderClusterApplyUpdateRequestParams {

	static alloc(): MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateProviderClusterApplyUpdateRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams extends MTROTASoftwareUpdateProviderClusterApplyUpdateResponseParams {

	static alloc(): MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateProviderClusterApplyUpdateResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams extends MTROTASoftwareUpdateProviderClusterNotifyUpdateAppliedParams {

	static alloc(): MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateProviderClusterNotifyUpdateAppliedParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateProviderClusterQueryImageParams extends MTROTASoftwareUpdateProviderClusterQueryImageParams {

	static alloc(): MTROtaSoftwareUpdateProviderClusterQueryImageParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateProviderClusterQueryImageParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams extends MTROTASoftwareUpdateProviderClusterQueryImageResponseParams {

	static alloc(): MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateProviderClusterQueryImageResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateProviderOTAApplyUpdateAction {

	Proceed = 0,

	AwaitNextAction = 1,

	Discontinue = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateProviderOTADownloadProtocol {

	BDXSynchronous = 0,

	BDXAsynchronous = 1,

	HTTPS = 2,

	VendorSpecific = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateProviderOTAQueryStatus {

	UpdateAvailable = 0,

	Busy = 1,

	NotAvailable = 2,

	DownloadProtocolNotSupported = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateRequestorClusterAnnounceOtaProviderParams extends MTROTASoftwareUpdateRequestorClusterAnnounceOTAProviderParams {

	static alloc(): MTROtaSoftwareUpdateRequestorClusterAnnounceOtaProviderParams; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateRequestorClusterAnnounceOtaProviderParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateRequestorClusterDownloadErrorEvent extends MTROTASoftwareUpdateRequestorClusterDownloadErrorEvent {

	static alloc(): MTROtaSoftwareUpdateRequestorClusterDownloadErrorEvent; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateRequestorClusterDownloadErrorEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateRequestorClusterProviderLocation extends MTROTASoftwareUpdateRequestorClusterProviderLocation {

	static alloc(): MTROtaSoftwareUpdateRequestorClusterProviderLocation; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateRequestorClusterProviderLocation; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateRequestorClusterStateTransitionEvent extends MTROTASoftwareUpdateRequestorClusterStateTransitionEvent {

	static alloc(): MTROtaSoftwareUpdateRequestorClusterStateTransitionEvent; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateRequestorClusterStateTransitionEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTROtaSoftwareUpdateRequestorClusterVersionAppliedEvent extends MTROTASoftwareUpdateRequestorClusterVersionAppliedEvent {

	static alloc(): MTROtaSoftwareUpdateRequestorClusterVersionAppliedEvent; // inherited from NSObject

	static new(): MTROtaSoftwareUpdateRequestorClusterVersionAppliedEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateRequestorOTAAnnouncementReason {

	SimpleAnnouncement = 0,

	UpdateAvailable = 1,

	UrgentUpdateAvailable = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateRequestorOTAChangeReason {

	Unknown = 0,

	Success = 1,

	Failure = 2,

	TimeOut = 3,

	DelayByProvider = 4
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTROtaSoftwareUpdateRequestorOTAUpdateState {

	Unknown = 0,

	Idle = 1,

	Querying = 2,

	DelayedOnQuery = 3,

	Downloading = 4,

	Applying = 5,

	DelayedOnApply = 6,

	RollingBack = 7,

	DelayedOnUserConsent = 8
}

/**
 * @since 17.6
 */
declare const enum MTROzoneConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTROzoneConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTROzoneConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTROzoneConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 17.6
 */
declare const enum MTRPM10ConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRPM10ConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRPM10ConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRPM10ConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 17.6
 */
declare const enum MTRPM1ConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRPM1ConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRPM1ConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRPM1ConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 17.6
 */
declare const enum MTRPM25ConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRPM25ConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRPM25ConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRPM25ConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRPairingStatus {

	Unknown = 0,

	Success = 1,

	Failed = 2,

	DiscoveringMoreDevices = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
interface MTRPersistentStorageDelegate extends MTRStorage {
}
declare var MTRPersistentStorageDelegate: {

	prototype: MTRPersistentStorageDelegate;
};

/**
 * @since 16.5
 */
declare const enum MTRPowerSourceBatApprovedChemistry {

	Unspecified = 0,

	Alkaline = 1,

	LithiumCarbonFluoride = 2,

	LithiumChromiumOxide = 3,

	LithiumCopperOxide = 4,

	LithiumIronDisulfide = 5,

	LithiumManganeseDioxide = 6,

	LithiumThionylChloride = 7,

	Magnesium = 8,

	MercuryOxide = 9,

	NickelOxyhydride = 10,

	SilverOxide = 11,

	ZincAir = 12,

	ZincCarbon = 13,

	ZincChloride = 14,

	ZincManganeseDioxide = 15,

	LeadAcid = 16,

	LithiumCobaltOxide = 17,

	LithiumIon = 18,

	LithiumIonPolymer = 19,

	LithiumIronPhosphate = 20,

	LithiumSulfur = 21,

	LithiumTitanate = 22,

	NickelCadmium = 23,

	NickelHydrogen = 24,

	NickelIron = 25,

	NickelMetalHydride = 26,

	NickelZinc = 27,

	SilverZinc = 28,

	SodiumIon = 29,

	SodiumSulfur = 30,

	ZincBromide = 31,

	ZincCerium = 32
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceBatChargeFault {

	Unspecified = 0,

	Unspecfied = 0,

	AmbientTooHot = 1,

	AmbientTooCold = 2,

	BatteryTooHot = 3,

	BatteryTooCold = 4,

	BatteryAbsent = 5,

	BatteryOverVoltage = 6,

	BatteryUnderVoltage = 7,

	ChargerOverVoltage = 8,

	ChargerUnderVoltage = 9,

	SafetyTimeout = 10
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceBatChargeLevel {

	OK = 0,

	Ok = 0,

	Warning = 1,

	Critical = 2
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceBatChargeState {

	Unknown = 0,

	IsCharging = 1,

	IsAtFullCharge = 2,

	IsNotCharging = 3
}

/**
 * @since 16.5
 */
declare const enum MTRPowerSourceBatCommonDesignation {

	DesignationUnspecified = 0,

	DesignationAAA = 1,

	DesignationAA = 2,

	DesignationC = 3,

	DesignationD = 4,

	Designation4v5 = 5,

	Designation6v0 = 6,

	Designation9v0 = 7,

	Designation12AA = 8,

	DesignationAAAA = 9,

	DesignationA = 10,

	DesignationB = 11,

	DesignationF = 12,

	DesignationN = 13,

	DesignationNo6 = 14,

	DesignationSubC = 15,

	DesignationA23 = 16,

	DesignationA27 = 17,

	DesignationBA5800 = 18,

	DesignationDuplex = 19,

	Designation4SR44 = 20,

	Designation523 = 21,

	Designation531 = 22,

	Designation15v0 = 23,

	Designation22v5 = 24,

	Designation30v0 = 25,

	Designation45v0 = 26,

	Designation67v5 = 27,

	DesignationJ = 28,

	DesignationCR123A = 29,

	DesignationCR2 = 30,

	Designation2CR5 = 31,

	DesignationCRP2 = 32,

	DesignationCRV3 = 33,

	DesignationSR41 = 34,

	DesignationSR43 = 35,

	DesignationSR44 = 36,

	DesignationSR45 = 37,

	DesignationSR48 = 38,

	DesignationSR54 = 39,

	DesignationSR55 = 40,

	DesignationSR57 = 41,

	DesignationSR58 = 42,

	DesignationSR59 = 43,

	DesignationSR60 = 44,

	DesignationSR63 = 45,

	DesignationSR64 = 46,

	DesignationSR65 = 47,

	DesignationSR66 = 48,

	DesignationSR67 = 49,

	DesignationSR68 = 50,

	DesignationSR69 = 51,

	DesignationSR516 = 52,

	DesignationSR731 = 53,

	DesignationSR712 = 54,

	DesignationLR932 = 55,

	DesignationA5 = 56,

	DesignationA10 = 57,

	DesignationA13 = 58,

	DesignationA312 = 59,

	DesignationA675 = 60,

	DesignationAC41E = 61,

	Designation10180 = 62,

	Designation10280 = 63,

	Designation10440 = 64,

	Designation14250 = 65,

	Designation14430 = 66,

	Designation14500 = 67,

	Designation14650 = 68,

	Designation15270 = 69,

	Designation16340 = 70,

	DesignationRCR123A = 71,

	Designation17500 = 72,

	Designation17670 = 73,

	Designation18350 = 74,

	Designation18500 = 75,

	Designation18650 = 76,

	Designation19670 = 77,

	Designation25500 = 78,

	Designation26650 = 79,

	Designation32600 = 80
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceBatFault {

	Unspecified = 0,

	Unspecfied = 0,

	OverTemp = 1,

	UnderTemp = 2
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceBatReplaceability {

	Unspecified = 0,

	NotReplaceable = 1,

	UserReplaceable = 2,

	FactoryReplaceable = 3
}

/**
 * @since 16.4
 */
declare class MTRPowerSourceClusterBatChargeFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterBatChargeFaultChangeEvent; // inherited from NSObject

	static new(): MTRPowerSourceClusterBatChargeFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRPowerSourceClusterBatChargeFaultChangeType extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterBatChargeFaultChangeType; // inherited from NSObject

	static new(): MTRPowerSourceClusterBatChargeFaultChangeType; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRPowerSourceClusterBatFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterBatFaultChangeEvent; // inherited from NSObject

	static new(): MTRPowerSourceClusterBatFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRPowerSourceClusterBatFaultChangeType extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterBatFaultChangeType; // inherited from NSObject

	static new(): MTRPowerSourceClusterBatFaultChangeType; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRPowerSourceClusterWiredFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterWiredFaultChangeEvent; // inherited from NSObject

	static new(): MTRPowerSourceClusterWiredFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRPowerSourceClusterWiredFaultChangeType extends NSObject implements NSCopying {

	static alloc(): MTRPowerSourceClusterWiredFaultChangeType; // inherited from NSObject

	static new(): MTRPowerSourceClusterWiredFaultChangeType; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceFeature {

	Wired = 1,

	Battery = 2,

	Rechargeable = 4,

	Replaceable = 8
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceStatus {

	Unspecified = 0,

	Unspecfied = 0,

	Active = 1,

	Standby = 2,

	Unavailable = 3
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceWiredCurrentType {

	AC = 0,

	DC = 1
}

/**
 * @since 16.1
 */
declare const enum MTRPowerSourceWiredFault {

	Unspecified = 0,

	Unspecfied = 0,

	OverVoltage = 1,

	UnderVoltage = 2
}

/**
 * @since 17.0
 */
declare const enum MTRPressureMeasurementFeature {

	Extended = 1
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare const enum MTRPressureMeasurementPressureFeature {

	Extended = 1,

	EXT = 1
}

/**
 * @since 17.6
 */
declare var MTRPreviousDataKey: string;

/**
 * @since 17.0
 */
declare class MTRProductIdentity extends NSObject {

	static alloc(): MTRProductIdentity; // inherited from NSObject

	static new(): MTRProductIdentity; // inherited from NSObject

	readonly productID: number;

	readonly vendorID: number;

	constructor(o: { vendorID: number; productID: number; });

	initWithVendorIDProductID(vendorID: number, productID: number): this;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterAirDetectionEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterAirDetectionEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterAirDetectionEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterDryRunningEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterDryRunningEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterDryRunningEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterElectronicFatalFailureEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterElectronicFatalFailureEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterElectronicFatalFailureEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterElectronicNonFatalFailureEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterElectronicNonFatalFailureEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterElectronicNonFatalFailureEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterElectronicTemperatureHighEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterElectronicTemperatureHighEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterElectronicTemperatureHighEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterGeneralFaultEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterGeneralFaultEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterGeneralFaultEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterLeakageEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterLeakageEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterLeakageEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterMotorTemperatureHighEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterMotorTemperatureHighEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterMotorTemperatureHighEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterPowerMissingPhaseEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterPowerMissingPhaseEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterPowerMissingPhaseEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterPumpBlockedEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterPumpBlockedEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterPumpBlockedEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterPumpMotorFatalFailureEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterPumpMotorFatalFailureEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterPumpMotorFatalFailureEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterSensorFailureEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterSensorFailureEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterSensorFailureEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterSupplyVoltageHighEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterSupplyVoltageHighEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterSupplyVoltageHighEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterSupplyVoltageLowEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterSupplyVoltageLowEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterSupplyVoltageLowEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterSystemPressureHighEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterSystemPressureHighEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterSystemPressureHighEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterSystemPressureLowEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterSystemPressureLowEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterSystemPressureLowEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRPumpConfigurationAndControlClusterTurbineOperationEvent extends NSObject implements NSCopying {

	static alloc(): MTRPumpConfigurationAndControlClusterTurbineOperationEvent; // inherited from NSObject

	static new(): MTRPumpConfigurationAndControlClusterTurbineOperationEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.5
 */
declare const enum MTRPumpConfigurationAndControlControlMode {

	ConstantSpeed = 0,

	ConstantPressure = 1,

	ProportionalPressure = 2,

	ConstantFlow = 3,

	ConstantTemperature = 5,

	Automatic = 7
}

/**
 * @since 17.0
 */
declare const enum MTRPumpConfigurationAndControlFeature {

	ConstantPressure = 1,

	CompensatedPressure = 2,

	ConstantFlow = 4,

	ConstantSpeed = 8,

	ConstantTemperature = 16,

	Automatic = 32,

	LocalOperation = 64
}

/**
 * @since 16.5
 */
declare const enum MTRPumpConfigurationAndControlOperationMode {

	Normal = 0,

	Minimum = 1,

	Maximum = 2,

	Local = 3
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRPumpConfigurationAndControlPumpControlMode {

	ConstantSpeed = 0,

	ConstantPressure = 1,

	ProportionalPressure = 2,

	ConstantFlow = 3,

	ConstantTemperature = 5,

	Automatic = 7
}

/**
 * @since 16.4
 * @deprecated 17.0
 */
declare const enum MTRPumpConfigurationAndControlPumpFeature {

	ConstantPressure = 1,

	CompensatedPressure = 2,

	ConstantFlow = 4,

	ConstantSpeed = 8,

	ConstantTemperature = 16,

	Automatic = 32,

	LocalOperation = 64,

	Local = 64
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRPumpConfigurationAndControlPumpOperationMode {

	Normal = 0,

	Minimum = 1,

	Maximum = 2,

	Local = 3
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRPumpConfigurationAndControlPumpStatus {

	DeviceFault = 1,

	Supplyfault = 2,

	SpeedLow = 4,

	SpeedHigh = 8,

	LocalOverride = 16,

	Running = 32,

	RemotePressure = 64,

	RemoteFlow = 128,

	RemoteTemperature = 256
}

/**
 * @since 16.5
 */
declare const enum MTRPumpConfigurationAndControlPumpStatusBitmap {

	DeviceFault = 1,

	SupplyFault = 2,

	Supplyfault = 2,

	SpeedLow = 4,

	SpeedHigh = 8,

	LocalOverride = 16,

	Running = 32,

	RemotePressure = 64,

	RemoteFlow = 128,

	RemoteTemperature = 256
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRQRCodeSetupPayloadParser extends NSObject {

	static alloc(): MTRQRCodeSetupPayloadParser; // inherited from NSObject

	static new(): MTRQRCodeSetupPayloadParser; // inherited from NSObject

	constructor(o: { base38Representation: string; });

	initWithBase38Representation(base38Representation: string): this;

	populatePayload(): MTRSetupPayload;
}

/**
 * @since 17.4
 */
declare class MTRRVCCleanModeClusterChangeToModeParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCCleanModeClusterChangeToModeParams; // inherited from NSObject

	static new(): MTRRVCCleanModeClusterChangeToModeParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	newMode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCCleanModeClusterChangeToModeResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCCleanModeClusterChangeToModeResponseParams; // inherited from NSObject

	static new(): MTRRVCCleanModeClusterChangeToModeResponseParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	status: number;

	/**
	 * @since 17.4
	 */
	statusText: string;

	/**
	 * @since 17.4
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.4
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.4
 */
declare class MTRRVCCleanModeClusterModeOptionStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCCleanModeClusterModeOptionStruct; // inherited from NSObject

	static new(): MTRRVCCleanModeClusterModeOptionStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	label: string;

	/**
	 * @since 17.4
	 */
	mode: number;

	/**
	 * @since 17.4
	 */
	modeTags: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCCleanModeClusterModeTagStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCCleanModeClusterModeTagStruct; // inherited from NSObject

	static new(): MTRRVCCleanModeClusterModeTagStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	mfgCode: number;

	/**
	 * @since 17.4
	 */
	value: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare const enum MTRRVCCleanModeFeature {

	DirectModeChange = 65536
}

/**
 * @since 17.4
 */
declare const enum MTRRVCCleanModeModeTag {

	Auto = 0,

	Quick = 1,

	Quiet = 2,

	LowNoise = 3,

	LowEnergy = 4,

	Vacation = 5,

	Min = 6,

	Max = 7,

	Night = 8,

	Day = 9,

	DeepClean = 16384,

	Vacuum = 16385,

	Mop = 16386
}

/**
 * @since 17.4
 */
declare const enum MTRRVCCleanModeStatusCode {

	CleaningInProgress = 64
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterErrorStateStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterErrorStateStruct; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterErrorStateStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	errorStateDetails: string;

	/**
	 * @since 17.4
	 */
	errorStateID: number;

	/**
	 * @since 17.4
	 */
	errorStateLabel: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterOperationCompletionEvent extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterOperationCompletionEvent; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterOperationCompletionEvent; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	completionErrorCode: number;

	/**
	 * @since 17.4
	 */
	pausedTime: number;

	/**
	 * @since 17.4
	 */
	totalOperationalTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterOperationalCommandResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterOperationalCommandResponseParams; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterOperationalCommandResponseParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	commandResponseState: MTRRVCOperationalStateClusterErrorStateStruct;

	/**
	 * @since 17.4
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.4
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterOperationalErrorEvent extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterOperationalErrorEvent; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterOperationalErrorEvent; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	errorState: MTRRVCOperationalStateClusterErrorStateStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterOperationalStateStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterOperationalStateStruct; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterOperationalStateStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	operationalStateID: number;

	/**
	 * @since 17.4
	 */
	operationalStateLabel: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterPauseParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterPauseParams; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterPauseParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCOperationalStateClusterResumeParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCOperationalStateClusterResumeParams; // inherited from NSObject

	static new(): MTRRVCOperationalStateClusterResumeParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare const enum MTRRVCOperationalStateErrorState {

	NoError = 0,

	UnableToStartOrResume = 1,

	UnableToCompleteOperation = 2,

	CommandInvalidInState = 3,

	FailedToFindChargingDock = 64,

	Stuck = 65,

	DustBinMissing = 66,

	DustBinFull = 67,

	WaterTankEmpty = 68,

	WaterTankMissing = 69,

	WaterTankLidOpen = 70,

	MopCleaningPadMissing = 71
}

/**
 * @since 17.4
 */
declare const enum MTRRVCOperationalStateOperationalState {

	Stopped = 0,

	Running = 1,

	Paused = 2,

	Error = 3,

	SeekingCharger = 64,

	Charging = 65,

	Docked = 66
}

/**
 * @since 17.4
 */
declare class MTRRVCRunModeClusterChangeToModeParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCRunModeClusterChangeToModeParams; // inherited from NSObject

	static new(): MTRRVCRunModeClusterChangeToModeParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	newMode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCRunModeClusterChangeToModeResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRRVCRunModeClusterChangeToModeResponseParams; // inherited from NSObject

	static new(): MTRRVCRunModeClusterChangeToModeResponseParams; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	status: number;

	/**
	 * @since 17.4
	 */
	statusText: string;

	/**
	 * @since 17.4
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.4
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 17.4
 */
declare class MTRRVCRunModeClusterModeOptionStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCRunModeClusterModeOptionStruct; // inherited from NSObject

	static new(): MTRRVCRunModeClusterModeOptionStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	label: string;

	/**
	 * @since 17.4
	 */
	mode: number;

	/**
	 * @since 17.4
	 */
	modeTags: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare class MTRRVCRunModeClusterModeTagStruct extends NSObject implements NSCopying {

	static alloc(): MTRRVCRunModeClusterModeTagStruct; // inherited from NSObject

	static new(): MTRRVCRunModeClusterModeTagStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	mfgCode: number;

	/**
	 * @since 17.4
	 */
	value: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.4
 */
declare const enum MTRRVCRunModeFeature {

	DirectModeChange = 65536
}

/**
 * @since 17.4
 */
declare const enum MTRRVCRunModeModeTag {

	Auto = 0,

	Quick = 1,

	Quiet = 2,

	LowNoise = 3,

	LowEnergy = 4,

	Vacation = 5,

	Min = 6,

	Max = 7,

	Night = 8,

	Day = 9,

	Idle = 16384,

	Cleaning = 16385,

	Mapping = 16386
}

/**
 * @since 17.4
 */
declare const enum MTRRVCRunModeStatusCode {

	Stuck = 65,

	DustBinMissing = 66,

	DustBinFull = 67,

	WaterTankEmpty = 68,

	WaterTankMissing = 69,

	WaterTankLidOpen = 70,

	MopCleaningPadMissing = 71,

	BatteryLow = 72
}

/**
 * @since 17.6
 */
declare const enum MTRRadonConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRRadonConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRRadonConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRRadonConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.1
 */
declare class MTRReadParams extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTRReadParams; // inherited from NSObject

	static new(): MTRReadParams; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	assumeUnknownAttributesReportable: boolean;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fabricFiltered: number;

	/**
	 * @since 16.4
	 */
	filterByFabric: boolean;

	/**
	 * @since 16.4
	 */
	minEventNumber: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 18.2
 */
declare function MTRRequestCommandNameForID(clusterID: MTRClusterIDType, commandID: MTRCommandIDType): string;

/**
 * @since 18.2
 */
declare function MTRResponseCommandNameForID(clusterID: MTRClusterIDType, commandID: MTRCommandIDType): string;

/**
 * @since 17.6
 */
declare class MTRServerAttribute extends NSObject {

	static alloc(): MTRServerAttribute; // inherited from NSObject

	static new(): MTRServerAttribute; // inherited from NSObject

	static newFeatureMapAttributeWithInitialValue(value: number): MTRServerAttribute;

	readonly attributeID: number;

	readonly requiredReadPrivilege: MTRAccessControlEntryPrivilege;

	readonly value: NSDictionary<string, any>;

	readonly writable: boolean;

	constructor(o: { readonlyAttributeWithID: number; initialValue: NSDictionary<string, any>; requiredPrivilege: MTRAccessControlEntryPrivilege; });

	initReadonlyAttributeWithIDInitialValueRequiredPrivilege(attributeID: number, value: NSDictionary<string, any>, requiredPrivilege: MTRAccessControlEntryPrivilege): this;

	setValue(value: NSDictionary<string, any>): boolean;
}

/**
 * @since 17.6
 */
declare class MTRServerCluster extends NSObject {

	static alloc(): MTRServerCluster; // inherited from NSObject

	static new(): MTRServerCluster; // inherited from NSObject

	static newDescriptorCluster(): MTRServerCluster;

	readonly accessGrants: NSArray<MTRAccessGrant>;

	readonly attributes: NSArray<MTRServerAttribute>;

	readonly clusterID: number;

	readonly clusterRevision: number;

	constructor(o: { clusterID: number; revision: number; });

	addAccessGrant(accessGrant: MTRAccessGrant): void;

	addAttribute(attribute: MTRServerAttribute): boolean;

	initWithClusterIDRevision(clusterID: number, revision: number): this;

	removeAccessGrant(accessGrant: MTRAccessGrant): void;
}

/**
 * @since 17.6
 */
declare class MTRServerEndpoint extends NSObject {

	static alloc(): MTRServerEndpoint; // inherited from NSObject

	static new(): MTRServerEndpoint; // inherited from NSObject

	readonly accessGrants: NSArray<MTRAccessGrant>;

	readonly deviceTypes: NSArray<MTRDeviceTypeRevision>;

	readonly endpointID: number;

	readonly serverClusters: NSArray<MTRServerCluster>;

	constructor(o: { endpointID: number; deviceTypes: NSArray<MTRDeviceTypeRevision> | MTRDeviceTypeRevision[]; });

	addAccessGrant(accessGrant: MTRAccessGrant): void;

	addServerCluster(serverCluster: MTRServerCluster): boolean;

	initWithEndpointIDDeviceTypes(endpointID: number, deviceTypes: NSArray<MTRDeviceTypeRevision> | MTRDeviceTypeRevision[]): this;

	removeAccessGrant(accessGrant: MTRAccessGrant): void;
}

/**
 * @since 16.4
 */
declare function MTRSetLogCallback(logTypeThreshold: MTRLogType, callback: (p1: MTRLogType, p2: string, p3: string) => void): void;

/**
 * @since 17.6
 */
declare function MTRSetMessageReliabilityParameters(idleRetransmitMs: number, activeRetransmitMs: number, activeThresholdMs: number, additionalRetransmitDelayMs: number): void;

/**
 * @since 16.1
 */
declare class MTRSetupPayload extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTRSetupPayload; // inherited from NSObject

	static generateRandomPIN(): number;

	/**
	 * @since 16.2
	 */
	static generateRandomSetupPasscode(): number;

	static new(): MTRSetupPayload; // inherited from NSObject

	/**
	 * @since 16.2
	 * @deprecated 17.6
	 */
	static setupPayloadWithOnboardingPayloadError(onboardingPayload: string): MTRSetupPayload;

	commissioningFlow: MTRCommissioningFlow;

	/**
	 * @since 16.4
	 */
	discoveryCapabilities: MTRDiscoveryCapabilities;

	discriminator: number;

	hasShortDiscriminator: boolean;

	productID: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	rendezvousInformation: number;

	serialNumber: string;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	setUpPINCode: number;

	/**
	 * @since 16.4
	 */
	setupPasscode: number;

	/**
	 * @since 17.6
	 */
	readonly vendorElements: NSArray<MTROptionalQRCodeInfo>;

	vendorID: number;

	version: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	/**
	 * @since 17.6
	 */
	constructor(o: { payload: string; });

	/**
	 * @since 16.2
	 */
	constructor(o: { setupPasscode: number; discriminator: number; });

	/**
	 * @since 17.6
	 */
	addOrReplaceVendorElement(element: MTROptionalQRCodeInfo): void;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	/**
	 * @since 16.1
	 * @deprecated 17.6
	 */
	getAllOptionalVendorData(): NSArray<MTROptionalQRCodeInfo>;

	initWithCoder(coder: NSCoder): this;

	/**
	 * @since 17.6
	 */
	initWithPayload(payload: string): this;

	/**
	 * @since 16.2
	 */
	initWithSetupPasscodeDiscriminator(setupPasscode: number, discriminator: number): this;

	manualEntryCode(): string;

	/**
	 * @since 17.6
	 */
	qrCodeString(): string;

	/**
	 * @since 17.6
	 */
	removeVendorElementWithTag(tag: number): void;

	/**
	 * @since 17.6
	 */
	vendorElementWithTag(tag: number): MTROptionalQRCodeInfo;
}

/**
 * @since 16.1
 */
declare var MTRSignedIntegerValueType: string;

/**
 * @since 16.4
 */
declare var MTRSizeThreadExtendedPANID: number;

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare var MTRSizeThreadExtendedPanId: number;

/**
 * @since 16.1
 */
declare var MTRSizeThreadMasterKey: number;

/**
 * @since 16.1
 */
declare var MTRSizeThreadNetworkName: number;

/**
 * @since 16.4
 */
declare var MTRSizeThreadPANID: number;

/**
 * @since 16.1
 */
declare var MTRSizeThreadPSKc: number;

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmAlarmState {

	Normal = 0,

	Warning = 1,

	Critical = 2
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterAlarmMutedEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterAlarmMutedEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterAlarmMutedEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterAllClearEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterAllClearEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterAllClearEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterCOAlarmEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterCOAlarmEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterCOAlarmEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmSeverityLevel: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterEndOfServiceEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterEndOfServiceEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterEndOfServiceEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterHardwareFaultEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterHardwareFaultEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterHardwareFaultEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterInterconnectCOAlarmEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterInterconnectCOAlarmEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterInterconnectCOAlarmEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmSeverityLevel: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterInterconnectSmokeAlarmEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterInterconnectSmokeAlarmEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterInterconnectSmokeAlarmEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmSeverityLevel: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterLowBatteryEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterLowBatteryEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterLowBatteryEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmSeverityLevel: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterMuteEndedEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterMuteEndedEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterMuteEndedEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterSelfTestCompleteEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterSelfTestCompleteEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterSelfTestCompleteEvent; // inherited from NSObject

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterSelfTestRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterSelfTestRequestParams; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterSelfTestRequestParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRSmokeCOAlarmClusterSmokeAlarmEvent extends NSObject implements NSCopying {

	static alloc(): MTRSmokeCOAlarmClusterSmokeAlarmEvent; // inherited from NSObject

	static new(): MTRSmokeCOAlarmClusterSmokeAlarmEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	alarmSeverityLevel: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmContaminationState {

	Normal = 0,

	Low = 1,

	Warning = 2,

	Critical = 3
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmEndOfService {

	Normal = 0,

	Expired = 1
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmExpressedState {

	Normal = 0,

	SmokeAlarm = 1,

	COAlarm = 2,

	BatteryAlert = 3,

	Testing = 4,

	HardwareFault = 5,

	EndOfService = 6,

	InterconnectSmoke = 7,

	InterconnectCO = 8
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmFeature {

	SmokeAlarm = 1,

	COAlarm = 2
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmMuteState {

	NotMuted = 0,

	Muted = 1
}

/**
 * @since 17.6
 */
declare const enum MTRSmokeCOAlarmSensitivity {

	High = 0,

	Standard = 1,

	Low = 2
}

/**
 * @since 16.1
 */
declare class MTRSoftwareDiagnosticsClusterResetWatermarksParams extends NSObject implements NSCopying {

	static alloc(): MTRSoftwareDiagnosticsClusterResetWatermarksParams; // inherited from NSObject

	static new(): MTRSoftwareDiagnosticsClusterResetWatermarksParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSoftwareDiagnosticsClusterSoftwareFaultEvent extends NSObject implements NSCopying {

	static alloc(): MTRSoftwareDiagnosticsClusterSoftwareFaultEvent; // inherited from NSObject

	static new(): MTRSoftwareDiagnosticsClusterSoftwareFaultEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	faultRecording: NSData;

	/**
	 * @since 16.1
	 */
	id: number;

	/**
	 * @since 16.1
	 */
	name: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRSoftwareDiagnosticsClusterThreadMetrics extends MTRSoftwareDiagnosticsClusterThreadMetricsStruct {

	static alloc(): MTRSoftwareDiagnosticsClusterThreadMetrics; // inherited from NSObject

	static new(): MTRSoftwareDiagnosticsClusterThreadMetrics; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRSoftwareDiagnosticsClusterThreadMetricsStruct extends NSObject implements NSCopying {

	static alloc(): MTRSoftwareDiagnosticsClusterThreadMetricsStruct; // inherited from NSObject

	static new(): MTRSoftwareDiagnosticsClusterThreadMetricsStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	id: number;

	/**
	 * @since 16.4
	 */
	name: string;

	/**
	 * @since 16.4
	 */
	stackFreeCurrent: number;

	/**
	 * @since 16.4
	 */
	stackFreeMinimum: number;

	/**
	 * @since 16.4
	 */
	stackSize: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRSoftwareDiagnosticsFeature {

	Watermarks = 1,

	WaterMarks = 1
}

/**
 * @since 16.4
 */
interface MTRStorage extends NSObjectProtocol {

	removeStorageDataForKey(key: string): boolean;

	setStorageDataForKey(value: NSData, key: string): boolean;

	storageDataForKey(key: string): NSData;
}
declare var MTRStorage: {

	prototype: MTRStorage;
};

/**
 * @since 17.6
 */
declare const enum MTRStorageSecurityLevel {

	Secure = 0,

	NotSecure = 1
}

/**
 * @since 17.6
 */
declare const enum MTRStorageSharingType {

	NotShared = 0,

	SameIdentity = 1,

	SameACLs = 2,

	SameFabric = 3
}

/**
 * @since 16.1
 */
declare var MTRStructureValueType: string;

/**
 * @since 16.1
 */
declare class MTRSubscribeParams extends MTRReadParams implements NSCopying, NSSecureCoding {

	static alloc(): MTRSubscribeParams; // inherited from NSObject

	static new(): MTRSubscribeParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	autoResubscribe: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	keepPreviousSubscriptions: number;

	/**
	 * @since 16.4
	 */
	maxInterval: number;

	/**
	 * @since 16.4
	 */
	minInterval: number;

	/**
	 * @since 16.4
	 */
	replaceExistingSubscriptions: boolean;

	/**
	 * @since 16.4
	 */
	reportEventsUrgently: boolean;

	/**
	 * @since 16.4
	 */
	resubscribeAutomatically: boolean;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	constructor(o: { minInterval: number; maxInterval: number; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;

	initWithMinIntervalMaxInterval(minInterval: number, maxInterval: number): this;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterInitialPressEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterInitialPressEvent; // inherited from NSObject

	static new(): MTRSwitchClusterInitialPressEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	newPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterLongPressEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterLongPressEvent; // inherited from NSObject

	static new(): MTRSwitchClusterLongPressEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	newPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterLongReleaseEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterLongReleaseEvent; // inherited from NSObject

	static new(): MTRSwitchClusterLongReleaseEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	previousPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterMultiPressCompleteEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterMultiPressCompleteEvent; // inherited from NSObject

	static new(): MTRSwitchClusterMultiPressCompleteEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	newPosition: number;

	/**
	 * @since 16.4
	 */
	previousPosition: number;

	/**
	 * @since 16.1
	 */
	totalNumberOfPressesCounted: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterMultiPressOngoingEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterMultiPressOngoingEvent; // inherited from NSObject

	static new(): MTRSwitchClusterMultiPressOngoingEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	currentNumberOfPressesCounted: number;

	/**
	 * @since 16.1
	 */
	newPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterShortReleaseEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterShortReleaseEvent; // inherited from NSObject

	static new(): MTRSwitchClusterShortReleaseEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	previousPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRSwitchClusterSwitchLatchedEvent extends NSObject implements NSCopying {

	static alloc(): MTRSwitchClusterSwitchLatchedEvent; // inherited from NSObject

	static new(): MTRSwitchClusterSwitchLatchedEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	newPosition: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.2
 */
declare const enum MTRSwitchFeature {

	LatchingSwitch = 1,

	MomentarySwitch = 2,

	MomentarySwitchRelease = 4,

	MomentarySwitchLongPress = 8,

	MomentarySwitchMultiPress = 16,

	ActionSwitch = 32
}

/**
 * @since 16.1
 */
declare class MTRTargetNavigatorClusterNavigateTargetParams extends NSObject implements NSCopying {

	static alloc(): MTRTargetNavigatorClusterNavigateTargetParams; // inherited from NSObject

	static new(): MTRTargetNavigatorClusterNavigateTargetParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	data: string;

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	target: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRTargetNavigatorClusterNavigateTargetResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRTargetNavigatorClusterNavigateTargetResponseParams; // inherited from NSObject

	static new(): MTRTargetNavigatorClusterNavigateTargetResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	data: string;

	/**
	 * @since 16.1
	 */
	status: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTargetNavigatorClusterTargetInfo extends MTRTargetNavigatorClusterTargetInfoStruct {

	static alloc(): MTRTargetNavigatorClusterTargetInfo; // inherited from NSObject

	static new(): MTRTargetNavigatorClusterTargetInfo; // inherited from NSObject
}

/**
 * @since 16.4
 */
declare class MTRTargetNavigatorClusterTargetInfoStruct extends NSObject implements NSCopying {

	static alloc(): MTRTargetNavigatorClusterTargetInfoStruct; // inherited from NSObject

	static new(): MTRTargetNavigatorClusterTargetInfoStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	identifier: number;

	/**
	 * @since 16.4
	 */
	name: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRTargetNavigatorStatus {

	Success = 0,

	TargetNotFound = 1,

	NotAllowed = 2
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterBitmap16MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 16384
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterBitmap32MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 1073741824
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterBitmap64MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 4611686018427387904
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterBitmap8MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 64
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterBooleanResponseParams extends MTRUnitTestingClusterBooleanResponseParams {

	static alloc(): MTRTestClusterClusterBooleanResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterBooleanResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterDoubleNestedStructList extends MTRUnitTestingClusterDoubleNestedStructList {

	static alloc(): MTRTestClusterClusterDoubleNestedStructList; // inherited from NSObject

	static new(): MTRTestClusterClusterDoubleNestedStructList; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterNestedStruct extends MTRUnitTestingClusterNestedStruct {

	static alloc(): MTRTestClusterClusterNestedStruct; // inherited from NSObject

	static new(): MTRTestClusterClusterNestedStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	c: MTRTestClusterClusterSimpleStruct;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterNestedStructList extends MTRUnitTestingClusterNestedStructList {

	static alloc(): MTRTestClusterClusterNestedStructList; // inherited from NSObject

	static new(): MTRTestClusterClusterNestedStructList; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	c: MTRTestClusterClusterSimpleStruct;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterNullablesAndOptionalsStruct extends MTRUnitTestingClusterNullablesAndOptionalsStruct {

	static alloc(): MTRTestClusterClusterNullablesAndOptionalsStruct; // inherited from NSObject

	static new(): MTRTestClusterClusterNullablesAndOptionalsStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nullableOptionalStruct: MTRTestClusterClusterSimpleStruct;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	nullableStruct: MTRTestClusterClusterSimpleStruct;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	optionalStruct: MTRTestClusterClusterSimpleStruct;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterSimpleStruct extends MTRUnitTestingClusterSimpleStruct {

	static alloc(): MTRTestClusterClusterSimpleStruct; // inherited from NSObject

	static new(): MTRTestClusterClusterSimpleStruct; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterSimpleStructEchoRequestParams extends MTRUnitTestingClusterSimpleStructEchoRequestParams {

	static alloc(): MTRTestClusterClusterSimpleStructEchoRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterSimpleStructEchoRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterSimpleStructResponseParams extends MTRUnitTestingClusterSimpleStructResponseParams {

	static alloc(): MTRTestClusterClusterSimpleStructResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterSimpleStructResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestAddArgumentsParams extends MTRUnitTestingClusterTestAddArgumentsParams {

	static alloc(): MTRTestClusterClusterTestAddArgumentsParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestAddArgumentsParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestAddArgumentsResponseParams extends MTRUnitTestingClusterTestAddArgumentsResponseParams {

	static alloc(): MTRTestClusterClusterTestAddArgumentsResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestAddArgumentsResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestComplexNullableOptionalRequestParams extends MTRUnitTestingClusterTestComplexNullableOptionalRequestParams {

	static alloc(): MTRTestClusterClusterTestComplexNullableOptionalRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestComplexNullableOptionalRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestComplexNullableOptionalResponseParams extends MTRUnitTestingClusterTestComplexNullableOptionalResponseParams {

	static alloc(): MTRTestClusterClusterTestComplexNullableOptionalResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestComplexNullableOptionalResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEmitTestEventRequestParams extends MTRUnitTestingClusterTestEmitTestEventRequestParams {

	static alloc(): MTRTestClusterClusterTestEmitTestEventRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEmitTestEventRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEmitTestEventResponseParams extends MTRUnitTestingClusterTestEmitTestEventResponseParams {

	static alloc(): MTRTestClusterClusterTestEmitTestEventResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEmitTestEventResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEmitTestFabricScopedEventRequestParams extends MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams {

	static alloc(): MTRTestClusterClusterTestEmitTestFabricScopedEventRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEmitTestFabricScopedEventRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEmitTestFabricScopedEventResponseParams extends MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams {

	static alloc(): MTRTestClusterClusterTestEmitTestFabricScopedEventResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEmitTestFabricScopedEventResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEnumsRequestParams extends MTRUnitTestingClusterTestEnumsRequestParams {

	static alloc(): MTRTestClusterClusterTestEnumsRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEnumsRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEnumsResponseParams extends MTRUnitTestingClusterTestEnumsResponseParams {

	static alloc(): MTRTestClusterClusterTestEnumsResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEnumsResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestEventEvent extends MTRUnitTestingClusterTestEventEvent {

	static alloc(): MTRTestClusterClusterTestEventEvent; // inherited from NSObject

	static new(): MTRTestClusterClusterTestEventEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	arg4: MTRTestClusterClusterSimpleStruct;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestFabricScoped extends MTRUnitTestingClusterTestFabricScoped {

	static alloc(): MTRTestClusterClusterTestFabricScoped; // inherited from NSObject

	static new(): MTRTestClusterClusterTestFabricScoped; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	fabricSensitiveStruct: MTRTestClusterClusterSimpleStruct;
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestFabricScopedEventEvent extends MTRUnitTestingClusterTestFabricScopedEventEvent {

	static alloc(): MTRTestClusterClusterTestFabricScopedEventEvent; // inherited from NSObject

	static new(): MTRTestClusterClusterTestFabricScopedEventEvent; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListInt8UArgumentRequestParams extends MTRUnitTestingClusterTestListInt8UArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestListInt8UArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListInt8UArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListInt8UReverseRequestParams extends MTRUnitTestingClusterTestListInt8UReverseRequestParams {

	static alloc(): MTRTestClusterClusterTestListInt8UReverseRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListInt8UReverseRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListInt8UReverseResponseParams extends MTRUnitTestingClusterTestListInt8UReverseResponseParams {

	static alloc(): MTRTestClusterClusterTestListInt8UReverseResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListInt8UReverseResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListNestedStructListArgumentRequestParams extends MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestListNestedStructListArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListNestedStructListArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListStructArgumentRequestParams extends MTRUnitTestingClusterTestListStructArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestListStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListStructArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestListStructOctet extends MTRUnitTestingClusterTestListStructOctet {

	static alloc(): MTRTestClusterClusterTestListStructOctet; // inherited from NSObject

	static new(): MTRTestClusterClusterTestListStructOctet; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestNestedStructArgumentRequestParams extends MTRUnitTestingClusterTestNestedStructArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestNestedStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestNestedStructArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestNestedStructListArgumentRequestParams extends MTRUnitTestingClusterTestNestedStructListArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestNestedStructListArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestNestedStructListArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestNotHandledParams extends MTRUnitTestingClusterTestNotHandledParams {

	static alloc(): MTRTestClusterClusterTestNotHandledParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestNotHandledParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestNullableOptionalRequestParams extends MTRUnitTestingClusterTestNullableOptionalRequestParams {

	static alloc(): MTRTestClusterClusterTestNullableOptionalRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestNullableOptionalRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestNullableOptionalResponseParams extends MTRUnitTestingClusterTestNullableOptionalResponseParams {

	static alloc(): MTRTestClusterClusterTestNullableOptionalResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestNullableOptionalResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestParams extends MTRUnitTestingClusterTestParams {

	static alloc(): MTRTestClusterClusterTestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestSimpleArgumentRequestParams extends MTRUnitTestingClusterTestSimpleArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestSimpleArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestSimpleArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestSimpleArgumentResponseParams extends MTRUnitTestingClusterTestSimpleArgumentResponseParams {

	static alloc(): MTRTestClusterClusterTestSimpleArgumentResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestSimpleArgumentResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestSimpleOptionalArgumentRequestParams extends MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestSimpleOptionalArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestSimpleOptionalArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestSpecificParams extends MTRUnitTestingClusterTestSpecificParams {

	static alloc(): MTRTestClusterClusterTestSpecificParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestSpecificParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestSpecificResponseParams extends MTRUnitTestingClusterTestSpecificResponseParams {

	static alloc(): MTRTestClusterClusterTestSpecificResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestSpecificResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestStructArgumentRequestParams extends MTRUnitTestingClusterTestStructArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestStructArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestStructArrayArgumentRequestParams extends MTRUnitTestingClusterTestStructArrayArgumentRequestParams {

	static alloc(): MTRTestClusterClusterTestStructArrayArgumentRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestStructArrayArgumentRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestStructArrayArgumentResponseParams extends MTRUnitTestingClusterTestStructArrayArgumentResponseParams {

	static alloc(): MTRTestClusterClusterTestStructArrayArgumentResponseParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestStructArrayArgumentResponseParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTestUnknownCommandParams extends MTRUnitTestingClusterTestUnknownCommandParams {

	static alloc(): MTRTestClusterClusterTestUnknownCommandParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTestUnknownCommandParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare class MTRTestClusterClusterTimedInvokeRequestParams extends MTRUnitTestingClusterTimedInvokeRequestParams {

	static alloc(): MTRTestClusterClusterTimedInvokeRequestParams; // inherited from NSObject

	static new(): MTRTestClusterClusterTimedInvokeRequestParams; // inherited from NSObject
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterSimple {

	Unspecified = 0,

	ValueA = 1,

	ValueB = 2,

	ValueC = 3
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRTestClusterSimpleBitmap {

	ValueA = 1,

	ValueB = 2,

	ValueC = 4
}

/**
 * @since 16.1
 */
declare class MTRThermostatClusterClearWeeklyScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterClearWeeklyScheduleParams; // inherited from NSObject

	static new(): MTRThermostatClusterClearWeeklyScheduleParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThermostatClusterGetWeeklyScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterGetWeeklyScheduleParams; // inherited from NSObject

	static new(): MTRThermostatClusterGetWeeklyScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	daysToReturn: number;

	/**
	 * @since 16.1
	 */
	modeToReturn: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThermostatClusterGetWeeklyScheduleResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterGetWeeklyScheduleResponseParams; // inherited from NSObject

	static new(): MTRThermostatClusterGetWeeklyScheduleResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	dayOfWeekForSequence: number;

	/**
	 * @since 16.1
	 */
	modeForSequence: number;

	/**
	 * @since 16.1
	 */
	numberOfTransitionsForSequence: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitions: NSArray<any>;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.1
 */
declare class MTRThermostatClusterSetWeeklyScheduleParams extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterSetWeeklyScheduleParams; // inherited from NSObject

	static new(): MTRThermostatClusterSetWeeklyScheduleParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	dayOfWeekForSequence: number;

	/**
	 * @since 16.1
	 */
	modeForSequence: number;

	/**
	 * @since 16.1
	 */
	numberOfTransitionsForSequence: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.1
	 */
	transitions: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThermostatClusterSetpointRaiseLowerParams extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterSetpointRaiseLowerParams; // inherited from NSObject

	static new(): MTRThermostatClusterSetpointRaiseLowerParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	amount: number;

	/**
	 * @since 16.1
	 */
	mode: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare class MTRThermostatClusterThermostatScheduleTransition extends MTRThermostatClusterWeeklyScheduleTransitionStruct {

	static alloc(): MTRThermostatClusterThermostatScheduleTransition; // inherited from NSObject

	static new(): MTRThermostatClusterThermostatScheduleTransition; // inherited from NSObject
}

/**
 * @since 17.4
 */
declare class MTRThermostatClusterWeeklyScheduleTransitionStruct extends NSObject implements NSCopying {

	static alloc(): MTRThermostatClusterWeeklyScheduleTransitionStruct; // inherited from NSObject

	static new(): MTRThermostatClusterWeeklyScheduleTransitionStruct; // inherited from NSObject

	/**
	 * @since 17.4
	 */
	coolSetpoint: number;

	/**
	 * @since 17.4
	 */
	heatSetpoint: number;

	/**
	 * @since 17.4
	 */
	transitionTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRThermostatControlSequence {

	CoolingOnly = 0,

	CoolingWithReheat = 1,

	HeatingOnly = 2,

	HeatingWithReheat = 3,

	CoolingAndHeating = 4,

	CoolingAndHeatingWithReheat = 5
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatControlSequenceOfOperation {

	CoolingOnly = 0,

	CoolingWithReheat = 1,

	HeatingOnly = 2,

	HeatingWithReheat = 3,

	CoolingAndHeating = 4,

	CoolingAndHeatingWithReheat = 5
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRThermostatDayOfWeek {

	Sunday = 1,

	Monday = 2,

	Tuesday = 4,

	Wednesday = 8,

	Thursday = 16,

	Friday = 32,

	Saturday = 64,

	Away = 128,

	AwayOrVacation = 128
}

/**
 * @since 16.1
 */
declare const enum MTRThermostatFeature {

	Heating = 1,

	Cooling = 2,

	Occupancy = 4,

	ScheduleConfiguration = 8,

	Schedule = 8,

	Setback = 16,

	AutoMode = 32,

	Automode = 32,

	LocalTemperatureNotExposed = 64,

	MatterScheduleConfiguration = 128,

	Presets = 256
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRThermostatModeForSequence {

	HeatSetpointPresent = 1,

	HeatSetpointFieldPresent = 1,

	CoolSetpointPresent = 2,

	CoolSetpointFieldPresent = 2
}

/**
 * @since 16.1
 */
declare const enum MTRThermostatRunningMode {

	Off = 0,

	Cool = 3,

	Heat = 4
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatScheduleDayOfWeekBitmap {

	Sunday = 1,

	Monday = 2,

	Tuesday = 4,

	Wednesday = 8,

	Thursday = 16,

	Friday = 32,

	Saturday = 64,

	Away = 128
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatScheduleModeBitmap {

	HeatSetpointPresent = 1,

	CoolSetpointPresent = 2
}

/**
 * @since 16.1
 * @deprecated 17.4
 */
declare const enum MTRThermostatSetpointAdjustMode {

	Heat = 0,

	HeatSetpoint = 0,

	Cool = 1,

	CoolSetpoint = 1,

	Both = 2,

	HeatAndCoolSetpoints = 2
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatSetpointRaiseLowerMode {

	Heat = 0,

	Cool = 1,

	Both = 2
}

/**
 * @since 16.1
 */
declare const enum MTRThermostatSystemMode {

	Off = 0,

	Auto = 1,

	Cool = 3,

	Heat = 4,

	EmergencyHeat = 5,

	EmergencyHeating = 5,

	Precooling = 6,

	FanOnly = 7,

	Dry = 8,

	Sleep = 9
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatUserInterfaceConfigurationKeypadLockout {

	NoLockout = 0,

	Lockout1 = 1,

	Lockout2 = 2,

	Lockout3 = 3,

	Lockout4 = 4,

	Lockout5 = 5
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatUserInterfaceConfigurationScheduleProgrammingVisibility {

	ScheduleProgrammingPermitted = 0,

	ScheduleProgrammingDenied = 1
}

/**
 * @since 17.4
 */
declare const enum MTRThermostatUserInterfaceConfigurationTemperatureDisplayMode {

	Celsius = 0,

	Fahrenheit = 1
}

/**
 * @since 16.1
 */
declare class MTRThreadNetworkDiagnosticsClusterConnectionStatusEvent extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterConnectionStatusEvent; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterConnectionStatusEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	connectionStatus: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRThreadNetworkDiagnosticsClusterNeighborTable extends MTRThreadNetworkDiagnosticsClusterNeighborTableStruct {

	static alloc(): MTRThreadNetworkDiagnosticsClusterNeighborTable; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterNeighborTable; // inherited from NSObject
}

/**
 * @since 17.0
 */
declare class MTRThreadNetworkDiagnosticsClusterNeighborTableStruct extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterNeighborTableStruct; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterNeighborTableStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	age: number;

	/**
	 * @since 17.0
	 */
	averageRssi: number;

	/**
	 * @since 17.0
	 */
	extAddress: number;

	/**
	 * @since 17.0
	 */
	frameErrorRate: number;

	/**
	 * @since 17.0
	 */
	fullNetworkData: number;

	/**
	 * @since 17.0
	 */
	fullThreadDevice: number;

	/**
	 * @since 17.0
	 */
	isChild: number;

	/**
	 * @since 17.0
	 */
	lastRssi: number;

	/**
	 * @since 17.0
	 */
	linkFrameCounter: number;

	/**
	 * @since 17.0
	 */
	lqi: number;

	/**
	 * @since 17.0
	 */
	messageErrorRate: number;

	/**
	 * @since 17.0
	 */
	mleFrameCounter: number;

	/**
	 * @since 17.0
	 */
	rloc16: number;

	/**
	 * @since 17.0
	 */
	rxOnWhenIdle: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThreadNetworkDiagnosticsClusterNetworkFaultChangeEvent extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterNetworkFaultChangeEvent; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterNetworkFaultChangeEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	current: NSArray<any>;

	/**
	 * @since 16.1
	 */
	previous: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterOperationalDatasetComponents; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	activeTimestampPresent: number;

	/**
	 * @since 16.1
	 */
	channelMaskPresent: number;

	/**
	 * @since 16.1
	 */
	channelPresent: number;

	/**
	 * @since 16.1
	 */
	delayPresent: number;

	/**
	 * @since 16.1
	 */
	extendedPanIdPresent: number;

	/**
	 * @since 16.1
	 */
	masterKeyPresent: number;

	/**
	 * @since 16.1
	 */
	meshLocalPrefixPresent: number;

	/**
	 * @since 16.1
	 */
	networkNamePresent: number;

	/**
	 * @since 16.1
	 */
	panIdPresent: number;

	/**
	 * @since 16.1
	 */
	pendingTimestampPresent: number;

	/**
	 * @since 16.1
	 */
	pskcPresent: number;

	/**
	 * @since 16.1
	 */
	securityPolicyPresent: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThreadNetworkDiagnosticsClusterResetCountsParams extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 17.0
 */
declare class MTRThreadNetworkDiagnosticsClusterRouteTable extends MTRThreadNetworkDiagnosticsClusterRouteTableStruct {

	static alloc(): MTRThreadNetworkDiagnosticsClusterRouteTable; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterRouteTable; // inherited from NSObject
}

/**
 * @since 17.0
 */
declare class MTRThreadNetworkDiagnosticsClusterRouteTableStruct extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterRouteTableStruct; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterRouteTableStruct; // inherited from NSObject

	/**
	 * @since 17.0
	 */
	age: number;

	/**
	 * @since 17.0
	 */
	allocated: number;

	/**
	 * @since 17.0
	 */
	extAddress: number;

	/**
	 * @since 17.0
	 */
	linkEstablished: number;

	/**
	 * @since 17.0
	 */
	lqiIn: number;

	/**
	 * @since 17.0
	 */
	lqiOut: number;

	/**
	 * @since 17.0
	 */
	nextHop: number;

	/**
	 * @since 17.0
	 */
	pathCost: number;

	/**
	 * @since 17.0
	 */
	rloc16: number;

	/**
	 * @since 17.0
	 */
	routerId: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRThreadNetworkDiagnosticsClusterSecurityPolicy extends NSObject implements NSCopying {

	static alloc(): MTRThreadNetworkDiagnosticsClusterSecurityPolicy; // inherited from NSObject

	static new(): MTRThreadNetworkDiagnosticsClusterSecurityPolicy; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	flags: number;

	/**
	 * @since 16.1
	 */
	rotationTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTRThreadNetworkDiagnosticsConnectionStatus {

	Connected = 0,

	NotConnected = 1
}

/**
 * @since 16.1
 */
declare const enum MTRThreadNetworkDiagnosticsFeature {

	PacketCounts = 1,

	ErrorCounts = 2,

	MLECounts = 4,

	MACCounts = 8
}

/**
 * @since 16.1
 */
declare const enum MTRThreadNetworkDiagnosticsNetworkFault {

	Unspecified = 0,

	LinkDown = 1,

	HardwareFailure = 2,

	NetworkJammed = 3
}

/**
 * @since 16.1
 */
declare const enum MTRThreadNetworkDiagnosticsRoutingRole {

	Unspecified = 0,

	Unassigned = 1,

	SleepyEndDevice = 2,

	EndDevice = 3,

	REED = 4,

	Router = 5,

	Leader = 6
}

/**
 * @since 16.1
 * @deprecated 16.4
 */
declare const enum MTRThreadNetworkDiagnosticsThreadConnectionStatus {

	Connected = 0,

	NotConnected = 1
}

/**
 * @since 16.1
 */
declare class MTRThreadOperationalDataset extends NSObject {

	static alloc(): MTRThreadOperationalDataset; // inherited from NSObject

	static new(): MTRThreadOperationalDataset; // inherited from NSObject

	readonly PSKc: NSData;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	channel: number;

	/**
	 * @since 16.4
	 */
	readonly channelNumber: number;

	readonly extendedPANID: NSData;

	readonly masterKey: NSData;

	readonly networkName: string;

	readonly panID: NSData;

	constructor(o: { data: NSData; });

	/**
	 * @since 16.4
	 */
	constructor(o: { networkName: string; extendedPANID: NSData; masterKey: NSData; PSKc: NSData; channelNumber: number; panID: NSData; });

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	constructor(o: { networkName: string; extendedPANID: NSData; masterKey: NSData; PSKc: NSData; channel: number; panID: NSData; });

	data(): NSData;

	initWithData(data: NSData): this;

	/**
	 * @since 16.4
	 */
	initWithNetworkNameExtendedPANIDMasterKeyPSKcChannelNumberPanID(networkName: string, extendedPANID: NSData, masterKey: NSData, PSKc: NSData, channelNumber: number, panID: NSData): this;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	initWithNetworkNameExtendedPANIDMasterKeyPSKcChannelPanID(networkName: string, extendedPANID: NSData, masterKey: NSData, PSKc: NSData, channel: number, panID: NSData): this;
}

/**
 * @since 16.1
 */
declare const enum MTRTimeFormatLocalizationCalendarType {

	Buddhist = 0,

	Chinese = 1,

	Coptic = 2,

	Ethiopian = 3,

	Gregorian = 4,

	Hebrew = 5,

	Indian = 6,

	Islamic = 7,

	Japanese = 8,

	Korean = 9,

	Persian = 10,

	Taiwanese = 11,

	UseActiveLocale = 255
}

/**
 * @since 17.1
 */
declare const enum MTRTimeFormatLocalizationFeature {

	CalendarFormat = 1
}

/**
 * @since 16.1
 */
declare const enum MTRTimeFormatLocalizationHourFormat {

	Format12hr = 0,

	Format24hr = 1,

	FormatUseActiveLocale = 255
}

/**
 * @since 16.5
 */
declare class MTRTimeSynchronizationClusterDSTOffsetStruct extends NSObject implements NSCopying {

	static alloc(): MTRTimeSynchronizationClusterDSTOffsetStruct; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterDSTOffsetStruct; // inherited from NSObject

	/**
	 * @since 16.5
	 */
	offset: number;

	/**
	 * @since 16.5
	 */
	validStarting: number;

	/**
	 * @since 16.5
	 */
	validUntil: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare class MTRTimeSynchronizationClusterDstOffsetType extends MTRTimeSynchronizationClusterDSTOffsetStruct {

	static alloc(): MTRTimeSynchronizationClusterDstOffsetType; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterDstOffsetType; // inherited from NSObject
}

/**
 * @since 17.2
 */
declare class MTRTimeSynchronizationClusterSetUTCTimeParams extends NSObject implements NSCopying {

	static alloc(): MTRTimeSynchronizationClusterSetUTCTimeParams; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterSetUTCTimeParams; // inherited from NSObject

	/**
	 * @since 17.2
	 */
	granularity: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 17.2
	 */
	timeSource: number;

	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.2
	 */
	utcTime: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRTimeSynchronizationClusterSetUtcTimeParams extends MTRTimeSynchronizationClusterSetUTCTimeParams {

	static alloc(): MTRTimeSynchronizationClusterSetUtcTimeParams; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterSetUtcTimeParams; // inherited from NSObject
}

/**
 * @since 16.5
 */
declare class MTRTimeSynchronizationClusterTimeZoneStruct extends NSObject implements NSCopying {

	static alloc(): MTRTimeSynchronizationClusterTimeZoneStruct; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterTimeZoneStruct; // inherited from NSObject

	/**
	 * @since 16.5
	 */
	name: string;

	/**
	 * @since 16.5
	 */
	offset: number;

	/**
	 * @since 16.5
	 */
	validAt: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare class MTRTimeSynchronizationClusterTimeZoneType extends MTRTimeSynchronizationClusterTimeZoneStruct {

	static alloc(): MTRTimeSynchronizationClusterTimeZoneType; // inherited from NSObject

	static new(): MTRTimeSynchronizationClusterTimeZoneType; // inherited from NSObject
}

/**
 * @since 16.1
 */
declare const enum MTRTimeSynchronizationGranularity {

	NoTimeGranularity = 0,

	MinutesGranularity = 1,

	SecondsGranularity = 2,

	MillisecondsGranularity = 3,

	MicrosecondsGranularity = 4
}

/**
 * @since 16.1
 */
declare const enum MTRTimeSynchronizationTimeSource {

	None = 0,

	Unknown = 1,

	Admin = 2,

	NodeTimeCluster = 3,

	NonMatterSNTP = 4,

	NonFabricSntp = 4,

	NonMatterNTP = 5,

	NonFabricNtp = 5,

	MatterSNTP = 6,

	FabricSntp = 6,

	MatterNTP = 7,

	FabricNtp = 7,

	MixedNTP = 8,

	MixedNtp = 8,

	NonMatterSNTPNTS = 9,

	NonFabricSntpNts = 9,

	NonMatterNTPNTS = 10,

	NonFabricNtpNts = 10,

	MatterSNTPNTS = 11,

	FabricSntpNts = 11,

	MatterNTPNTS = 12,

	FabricNtpNts = 12,

	MixedNTPNTS = 13,

	MixedNtpNts = 13,

	CloudSource = 14,

	PTP = 15,

	Ptp = 15,

	GNSS = 16,

	Gnss = 16
}

/**
 * @since 17.6
 */
declare const enum MTRTotalVolatileOrganicCompoundsConcentrationMeasurementFeature {

	NumericMeasurement = 1,

	LevelIndication = 2,

	MediumLevel = 4,

	CriticalLevel = 8,

	PeakMeasurement = 16,

	AverageMeasurement = 32
}

/**
 * @since 17.6
 */
declare const enum MTRTotalVolatileOrganicCompoundsConcentrationMeasurementLevelValue {

	Unknown = 0,

	Low = 1,

	Medium = 2,

	High = 3,

	Critical = 4
}

/**
 * @since 17.6
 */
declare const enum MTRTotalVolatileOrganicCompoundsConcentrationMeasurementMeasurementMedium {

	Air = 0,

	Water = 1,

	Soil = 2
}

/**
 * @since 17.6
 */
declare const enum MTRTotalVolatileOrganicCompoundsConcentrationMeasurementMeasurementUnit {

	PPM = 0,

	PPB = 1,

	PPT = 2,

	MGM3 = 3,

	UGM3 = 4,

	NGM3 = 5,

	PM3 = 6,

	BQM3 = 7
}

/**
 * @since 16.4
 */
declare const enum MTRTransportType {

	Undefined = 0,

	UDP = 1,

	BLE = 2,

	TCP = 3
}

/**
 * @since 16.1
 */
declare var MTRTypeKey: string;

/**
 * @since 16.1
 */
declare var MTRUTF8StringValueType: string;

/**
 * @since 16.1
 */
declare const enum MTRUnitLocalizationFeature {

	TemperatureUnit = 1
}

/**
 * @since 16.1
 */
declare const enum MTRUnitLocalizationTempUnit {

	Fahrenheit = 0,

	Celsius = 1,

	Kelvin = 2
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingBitmap16MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 16384
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingBitmap32MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 1073741824
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingBitmap64MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 4611686018427387904
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingBitmap8MaskMap {

	MaskVal1 = 1,

	MaskVal2 = 2,

	MaskVal3 = 4,

	MaskVal4 = 64
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterBooleanResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterBooleanResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterBooleanResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	value: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterDoubleNestedStructList extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterDoubleNestedStructList; // inherited from NSObject

	static new(): MTRUnitTestingClusterDoubleNestedStructList; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	a: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterNestedStruct extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterNestedStruct; // inherited from NSObject

	static new(): MTRUnitTestingClusterNestedStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	a: number;

	/**
	 * @since 16.4
	 */
	b: number;

	/**
	 * @since 16.4
	 */
	c: MTRUnitTestingClusterSimpleStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterNestedStructList extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterNestedStructList; // inherited from NSObject

	static new(): MTRUnitTestingClusterNestedStructList; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	a: number;

	/**
	 * @since 16.4
	 */
	b: number;

	/**
	 * @since 16.4
	 */
	c: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	d: NSArray<any>;

	/**
	 * @since 16.4
	 */
	e: NSArray<any>;

	/**
	 * @since 16.4
	 */
	f: NSArray<any>;

	/**
	 * @since 16.4
	 */
	g: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterNullablesAndOptionalsStruct extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterNullablesAndOptionalsStruct; // inherited from NSObject

	static new(): MTRUnitTestingClusterNullablesAndOptionalsStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	nullableInt: number;

	/**
	 * @since 16.4
	 */
	nullableList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableOptionalInt: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableOptionalString: string;

	/**
	 * @since 16.4
	 */
	nullableOptionalStruct: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	nullableString: string;

	/**
	 * @since 16.4
	 */
	nullableStruct: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	optionalInt: number;

	/**
	 * @since 16.4
	 */
	optionalList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	optionalString: string;

	/**
	 * @since 16.4
	 */
	optionalStruct: MTRUnitTestingClusterSimpleStruct;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterSimpleStruct extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterSimpleStruct; // inherited from NSObject

	static new(): MTRUnitTestingClusterSimpleStruct; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	a: number;

	/**
	 * @since 16.4
	 */
	b: number;

	/**
	 * @since 16.4
	 */
	c: number;

	/**
	 * @since 16.4
	 */
	d: NSData;

	/**
	 * @since 16.4
	 */
	e: string;

	/**
	 * @since 16.4
	 */
	f: number;

	/**
	 * @since 16.4
	 */
	g: number;

	/**
	 * @since 16.4
	 */
	h: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterSimpleStructEchoRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterSimpleStructEchoRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterSimpleStructEchoRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: MTRUnitTestingClusterSimpleStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterSimpleStructResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterSimpleStructResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterSimpleStructResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestAddArgumentsParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestAddArgumentsParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestAddArgumentsParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	/**
	 * @since 16.4
	 */
	arg2: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestAddArgumentsResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestAddArgumentsResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestAddArgumentsResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	returnValue: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestComplexNullableOptionalRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestComplexNullableOptionalRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestComplexNullableOptionalRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	nullableInt: number;

	/**
	 * @since 16.4
	 */
	nullableList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableOptionalInt: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableOptionalString: string;

	/**
	 * @since 16.4
	 */
	nullableOptionalStruct: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	nullableString: string;

	/**
	 * @since 16.4
	 */
	nullableStruct: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	optionalInt: number;

	/**
	 * @since 16.4
	 */
	optionalList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	optionalString: string;

	/**
	 * @since 16.4
	 */
	optionalStruct: MTRUnitTestingClusterSimpleStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestComplexNullableOptionalResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestComplexNullableOptionalResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestComplexNullableOptionalResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	nullableIntValue: number;

	/**
	 * @since 16.4
	 */
	nullableIntWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableListValue: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableListWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalIntValue: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalIntWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalIntWasPresent: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalListValue: NSArray<any>;

	/**
	 * @since 16.4
	 */
	nullableOptionalListWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalListWasPresent: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalStringValue: string;

	/**
	 * @since 16.4
	 */
	nullableOptionalStringWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalStringWasPresent: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalStructValue: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	nullableOptionalStructWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalStructWasPresent: number;

	/**
	 * @since 16.4
	 */
	nullableStringValue: string;

	/**
	 * @since 16.4
	 */
	nullableStringWasNull: number;

	/**
	 * @since 16.4
	 */
	nullableStructValue: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	nullableStructWasNull: number;

	/**
	 * @since 16.4
	 */
	optionalIntValue: number;

	/**
	 * @since 16.4
	 */
	optionalIntWasPresent: number;

	/**
	 * @since 16.4
	 */
	optionalListValue: NSArray<any>;

	/**
	 * @since 16.4
	 */
	optionalListWasPresent: number;

	/**
	 * @since 16.4
	 */
	optionalStringValue: string;

	/**
	 * @since 16.4
	 */
	optionalStringWasPresent: number;

	/**
	 * @since 16.4
	 */
	optionalStructValue: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	optionalStructWasPresent: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEmitTestEventRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEmitTestEventRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEmitTestEventRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	/**
	 * @since 16.4
	 */
	arg2: number;

	/**
	 * @since 16.4
	 */
	arg3: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEmitTestEventResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEmitTestEventResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEmitTestEventResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	value: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEmitTestFabricScopedEventRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEmitTestFabricScopedEventResponseParams; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	value: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEnumsRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEnumsRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEnumsRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	/**
	 * @since 16.4
	 */
	arg2: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEnumsResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEnumsResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEnumsResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	/**
	 * @since 16.4
	 */
	arg2: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestEventEvent extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestEventEvent; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestEventEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	/**
	 * @since 16.4
	 */
	arg2: number;

	/**
	 * @since 16.4
	 */
	arg3: number;

	/**
	 * @since 16.4
	 */
	arg4: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	arg5: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg6: NSArray<any>;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestFabricScoped extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestFabricScoped; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestFabricScoped; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	/**
	 * @since 16.4
	 */
	fabricSensitiveCharString: string;

	/**
	 * @since 16.4
	 */
	fabricSensitiveInt8u: number;

	/**
	 * @since 16.4
	 */
	fabricSensitiveInt8uList: NSArray<any>;

	/**
	 * @since 16.4
	 */
	fabricSensitiveStruct: MTRUnitTestingClusterSimpleStruct;

	/**
	 * @since 16.4
	 */
	nullableFabricSensitiveInt8u: number;

	/**
	 * @since 16.4
	 */
	nullableOptionalFabricSensitiveInt8u: number;

	/**
	 * @since 16.4
	 */
	optionalFabricSensitiveInt8u: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestFabricScopedEventEvent extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestFabricScopedEventEvent; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestFabricScopedEventEvent; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	fabricIndex: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListInt8UArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListInt8UArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListInt8UArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListInt8UReverseRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListInt8UReverseRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListInt8UReverseRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListInt8UReverseResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListInt8UReverseResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListInt8UReverseResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListNestedStructListArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListStructArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListStructArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestListStructOctet extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestListStructOctet; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestListStructOctet; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	member1: number;

	/**
	 * @since 16.4
	 */
	member2: NSData;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestNestedStructArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestNestedStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestNestedStructArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: MTRUnitTestingClusterNestedStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestNestedStructListArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestNestedStructListArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestNestedStructListArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: MTRUnitTestingClusterNestedStructList;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestNotHandledParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestNotHandledParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestNotHandledParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestNullableOptionalRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestNullableOptionalRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestNullableOptionalRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestNullableOptionalResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestNullableOptionalResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestNullableOptionalResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	originalValue: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 16.4
	 */
	value: number;

	/**
	 * @since 16.4
	 */
	wasNull: number;

	/**
	 * @since 16.4
	 */
	wasPresent: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestSimpleArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestSimpleArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestSimpleArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestSimpleArgumentResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestSimpleArgumentResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestSimpleArgumentResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	returnValue: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestSimpleOptionalArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestSpecificParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestSpecificParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestSpecificParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestSpecificResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestSpecificResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestSpecificResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	returnValue: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestStructArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestStructArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestStructArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: MTRUnitTestingClusterSimpleStruct;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestStructArrayArgumentRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestStructArrayArgumentRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestStructArrayArgumentRequestParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg2: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg3: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg4: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg5: number;

	/**
	 * @since 16.4
	 */
	arg6: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestStructArrayArgumentResponseParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestStructArrayArgumentResponseParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestStructArrayArgumentResponseParams; // inherited from NSObject

	/**
	 * @since 16.4
	 */
	arg1: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg2: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg3: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg4: NSArray<any>;

	/**
	 * @since 16.4
	 */
	arg5: number;

	/**
	 * @since 16.4
	 */
	arg6: number;

	/**
	 * @since 16.1
	 * @deprecated 16.4
	 */
	timedInvokeTimeoutMs: number;

	/**
	 * @since 17.0
	 */
	constructor(o: { responseValue: NSDictionary<string, any>; });

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	/**
	 * @since 17.0
	 */
	initWithResponseValueError(responseValue: NSDictionary<string, any>): this;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTestUnknownCommandParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTestUnknownCommandParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTestUnknownCommandParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare class MTRUnitTestingClusterTimedInvokeRequestParams extends NSObject implements NSCopying {

	static alloc(): MTRUnitTestingClusterTimedInvokeRequestParams; // inherited from NSObject

	static new(): MTRUnitTestingClusterTimedInvokeRequestParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingSimple {

	Unspecified = 0,

	ValueA = 1,

	ValueB = 2,

	ValueC = 3
}

/**
 * @since 16.4
 */
declare const enum MTRUnitTestingSimpleBitmap {

	ValueA = 1,

	ValueB = 2,

	ValueC = 4
}

/**
 * @since 16.1
 */
declare var MTRUnsignedIntegerValueType: string;

/**
 * @since 16.1
 */
declare class MTRUserLabelClusterLabelStruct extends NSObject implements NSCopying {

	static alloc(): MTRUserLabelClusterLabelStruct; // inherited from NSObject

	static new(): MTRUserLabelClusterLabelStruct; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	label: string;

	/**
	 * @since 16.1
	 */
	value: string;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare var MTRValueKey: string;

/**
 * @since 17.6
 */
declare class MTRValveConfigurationAndControlClusterCloseParams extends NSObject implements NSCopying {

	static alloc(): MTRValveConfigurationAndControlClusterCloseParams; // inherited from NSObject

	static new(): MTRValveConfigurationAndControlClusterCloseParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRValveConfigurationAndControlClusterOpenParams extends NSObject implements NSCopying {

	static alloc(): MTRValveConfigurationAndControlClusterOpenParams; // inherited from NSObject

	static new(): MTRValveConfigurationAndControlClusterOpenParams; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	openDuration: number;

	serverSideProcessingTimeout: number;

	/**
	 * @since 17.6
	 */
	targetLevel: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRValveConfigurationAndControlClusterValveFaultEvent extends NSObject implements NSCopying {

	static alloc(): MTRValveConfigurationAndControlClusterValveFaultEvent; // inherited from NSObject

	static new(): MTRValveConfigurationAndControlClusterValveFaultEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	valveFault: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare class MTRValveConfigurationAndControlClusterValveStateChangedEvent extends NSObject implements NSCopying {

	static alloc(): MTRValveConfigurationAndControlClusterValveStateChangedEvent; // inherited from NSObject

	static new(): MTRValveConfigurationAndControlClusterValveStateChangedEvent; // inherited from NSObject

	/**
	 * @since 17.6
	 */
	valveLevel: number;

	/**
	 * @since 17.6
	 */
	valveState: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 17.6
 */
declare const enum MTRValveConfigurationAndControlFeature {

	TimeSync = 1,

	Level = 2
}

/**
 * @since 17.6
 */
declare const enum MTRValveConfigurationAndControlStatusCode {

	FailureDueToFault = 2
}

/**
 * @since 17.6
 */
declare const enum MTRValveConfigurationAndControlValveFaultBitmap {

	GeneralFault = 1,

	Blocked = 2,

	Leaking = 4,

	NotConnected = 8,

	ShortCircuit = 16,

	CurrentExceeded = 32
}

/**
 * @since 17.6
 */
declare const enum MTRValveConfigurationAndControlValveState {

	Closed = 0,

	Open = 1,

	Transitioning = 2
}

/**
 * @since 16.1
 */
declare const enum MTRWiFiNetworkDiagnosticsAssociationFailureCause {

	Unknown = 0,

	AssociationFailed = 1,

	AuthenticationFailed = 2,

	SsidNotFound = 3
}

/**
 * @since 16.1
 */
declare class MTRWiFiNetworkDiagnosticsClusterAssociationFailureEvent extends NSObject implements NSCopying {

	static alloc(): MTRWiFiNetworkDiagnosticsClusterAssociationFailureEvent; // inherited from NSObject

	static new(): MTRWiFiNetworkDiagnosticsClusterAssociationFailureEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 * @deprecated 17.4
	 */
	associationFailure: number;

	/**
	 * @since 17.4
	 */
	associationFailureCause: number;

	/**
	 * @since 16.1
	 */
	status: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWiFiNetworkDiagnosticsClusterConnectionStatusEvent extends NSObject implements NSCopying {

	static alloc(): MTRWiFiNetworkDiagnosticsClusterConnectionStatusEvent; // inherited from NSObject

	static new(): MTRWiFiNetworkDiagnosticsClusterConnectionStatusEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	connectionStatus: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWiFiNetworkDiagnosticsClusterDisconnectionEvent extends NSObject implements NSCopying {

	static alloc(): MTRWiFiNetworkDiagnosticsClusterDisconnectionEvent; // inherited from NSObject

	static new(): MTRWiFiNetworkDiagnosticsClusterDisconnectionEvent; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	reasonCode: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWiFiNetworkDiagnosticsClusterResetCountsParams extends NSObject implements NSCopying {

	static alloc(): MTRWiFiNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	static new(): MTRWiFiNetworkDiagnosticsClusterResetCountsParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.5
 */
declare const enum MTRWiFiNetworkDiagnosticsConnectionStatus {

	Connected = 0,

	NotConnected = 1
}

/**
 * @since 16.4
 */
declare const enum MTRWiFiNetworkDiagnosticsFeature {

	PacketCounts = 1,

	ErrorCounts = 2
}

/**
 * @since 16.1
 */
declare const enum MTRWiFiNetworkDiagnosticsSecurityType {

	Unspecified = 0,

	None = 1,

	WEP = 2,

	WPA = 3,

	WPA2 = 4,

	WPA3 = 5
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRWiFiNetworkDiagnosticsWiFiConnectionStatus {

	Connected = 0,

	NotConnected = 1
}

/**
 * @since 16.5
 */
declare const enum MTRWiFiNetworkDiagnosticsWiFiVersion {

	A = 0,

	B = 1,

	G = 2,

	N = 3,

	Ac = 4,

	Ax = 5,

	Ah = 6
}

/**
 * @since 16.1
 * @deprecated 16.5
 */
declare const enum MTRWiFiNetworkDiagnosticsWiFiVersionType {

	TypeA = 0,

	Type80211a = 0,

	TypeB = 1,

	Type80211b = 1,

	TypeG = 2,

	Type80211g = 2,

	TypeN = 3,

	Type80211n = 3,

	TypeAc = 4,

	Type80211ac = 4,

	TypeAx = 5,

	Type80211ax = 5
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterDownOrCloseParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterDownOrCloseParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterDownOrCloseParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterGoToLiftPercentageParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterGoToLiftPercentageParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterGoToLiftPercentageParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	liftPercent100thsValue: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterGoToLiftValueParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterGoToLiftValueParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterGoToLiftValueParams; // inherited from NSObject

	/**
	 * @since 16.1
	 */
	liftValue: number;

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterGoToTiltPercentageParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterGoToTiltPercentageParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterGoToTiltPercentageParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	tiltPercent100thsValue: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterGoToTiltValueParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterGoToTiltValueParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterGoToTiltValueParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	/**
	 * @since 16.1
	 */
	tiltValue: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterStopMotionParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterStopMotionParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterStopMotionParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare class MTRWindowCoveringClusterUpOrOpenParams extends NSObject implements NSCopying {

	static alloc(): MTRWindowCoveringClusterUpOrOpenParams; // inherited from NSObject

	static new(): MTRWindowCoveringClusterUpOrOpenParams; // inherited from NSObject

	serverSideProcessingTimeout: number;

	timedInvokeTimeoutMs: number;

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringConfigStatus {

	Operational = 1,

	OnlineReserved = 2,

	LiftMovementReversed = 4,

	LiftPositionAware = 8,

	TiltPositionAware = 16,

	LiftEncoderControlled = 32,

	TiltEncoderControlled = 64
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringEndProductType {

	RollerShade = 0,

	RomanShade = 1,

	BalloonShade = 2,

	WovenWood = 3,

	PleatedShade = 4,

	CellularShade = 5,

	LayeredShade = 6,

	LayeredShade2D = 7,

	SheerShade = 8,

	TiltOnlyInteriorBlind = 9,

	InteriorBlind = 10,

	VerticalBlindStripCurtain = 11,

	InteriorVenetianBlind = 12,

	ExteriorVenetianBlind = 13,

	LateralLeftCurtain = 14,

	LateralRightCurtain = 15,

	CentralCurtain = 16,

	RollerShutter = 17,

	ExteriorVerticalScreen = 18,

	AwningTerracePatio = 19,

	AwningVerticalScreen = 20,

	TiltOnlyPergola = 21,

	SwingingShutter = 22,

	SlidingShutter = 23,

	Unknown = 255
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringFeature {

	Lift = 1,

	Tilt = 2,

	PositionAwareLift = 4,

	AbsolutePosition = 8,

	PositionAwareTilt = 16
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringMode {

	MotorDirectionReversed = 1,

	CalibrationMode = 2,

	MaintenanceMode = 4,

	LedFeedback = 8
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringOperationalStatus {

	Global = 3,

	Lift = 12,

	Tilt = 48
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringSafetyStatus {

	RemoteLockout = 1,

	TamperDetection = 2,

	FailedCommunication = 4,

	PositionFailure = 8,

	ThermalProtection = 16,

	ObstacleDetected = 32,

	Power = 64,

	StopInput = 128,

	MotorJammed = 256,

	HardwareFailure = 512,

	ManualOperation = 1024,

	Protection = 2048
}

/**
 * @since 16.1
 */
declare const enum MTRWindowCoveringType {

	RollerShade = 0,

	RollerShade2Motor = 1,

	RollerShadeExterior = 2,

	RollerShadeExterior2Motor = 3,

	Drapery = 4,

	Awning = 5,

	Shutter = 6,

	TiltBlindTiltOnly = 7,

	TiltBlindLiftAndTilt = 8,

	ProjectorScreen = 9,

	Unknown = 255
}

/**
 * @since 16.1
 */
declare class MTRWriteParams extends NSObject implements NSCopying, NSSecureCoding {

	static alloc(): MTRWriteParams; // inherited from NSObject

	static new(): MTRWriteParams; // inherited from NSObject

	dataVersion: number;

	timedWriteTimeout: number;

	static readonly supportsSecureCoding: boolean; // inherited from NSSecureCoding

	constructor(o: { coder: NSCoder; }); // inherited from NSCoding

	copyWithZone(zone: interop.Pointer | interop.Reference<any>): any;

	encodeWithCoder(coder: NSCoder): void;

	initWithCoder(coder: NSCoder): this;
}

/**
 * @since 18.2
 */
interface MTRXPCClientProtocol extends MTRXPCClientProtocol_MTRDevice, MTRXPCClientProtocol_MTRDeviceController, NSObjectProtocol {
}
declare var MTRXPCClientProtocol: {

	prototype: MTRXPCClientProtocol;
};

/**
 * @since 18.2
 */
interface MTRXPCClientProtocol_MTRDevice extends NSObjectProtocol {

	deviceBecameActive(nodeID: number): void;

	deviceCachePrimed(nodeID: number): void;

	deviceConfigurationChanged(nodeID: number): void;

	deviceInternalStateUpdated(nodeID: number, dictionary: NSDictionary<any, any>): void;

	deviceReceivedAttributeReport(nodeID: number, attributeReport: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): void;

	deviceReceivedEventReport(nodeID: number, eventReport: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[]): void;

	deviceStateChanged(nodeID: number, state: MTRDeviceState): void;
}
declare var MTRXPCClientProtocol_MTRDevice: {

	prototype: MTRXPCClientProtocol_MTRDevice;
};

/**
 * @since 18.2
 */
interface MTRXPCClientProtocol_MTRDeviceController extends NSObjectProtocol {
}
declare var MTRXPCClientProtocol_MTRDeviceController: {

	prototype: MTRXPCClientProtocol_MTRDeviceController;
};

/**
 * @since 18.2
 */
declare class MTRXPCDeviceControllerParameters extends MTRDeviceControllerAbstractParameters {

	static alloc(): MTRXPCDeviceControllerParameters; // inherited from NSObject

	static new(): MTRXPCDeviceControllerParameters; // inherited from NSObject

	/**
	 * @since 18.2
	 */
	readonly uniqueIdentifier: NSUUID;

	/**
	 * @since 18.2
	 */
	readonly xpcConnectionBlock: () => NSXPCConnection;

	constructor(o: { XPConnectionBlock: () => NSXPCConnection; uniqueIdentifier: NSUUID; });

	initWithXPConnectionBlockUniqueIdentifier(xpcConnectionBlock: () => NSXPCConnection, uniqueIdentifier: NSUUID): this;
}

/**
 * @since 18.2
 */
interface MTRXPCServerProtocol extends MTRXPCServerProtocol_MTRDevice, MTRXPCServerProtocol_MTRDeviceController, NSObjectProtocol {

	deviceControllerCheckInWithContext?(controller: NSUUID, context: NSDictionary<any, any>): void;

	deviceControllerUpdateControllerConfiguration?(controller: NSUUID, controllerState: NSDictionary<any, any>): void;
}
declare var MTRXPCServerProtocol: {

	prototype: MTRXPCServerProtocol;
};

/**
 * @since 18.2
 */
interface MTRXPCServerProtocol_MTRDevice extends NSObjectProtocol {

	deviceControllerNodeIDDownloadLogOfTypeTimeoutCompletion?(controller: NSUUID, nodeID: number, type: MTRDiagnosticLogType, timeout: number, completion: (p1: NSURL, p2: NSError) => void): void;

	deviceControllerNodeIDGetDeviceCachePrimedWithReply(controller: NSUUID, nodeID: number, reply: (p1: boolean) => void): void;

	deviceControllerNodeIDGetEstimatedStartTimeWithReply(controller: NSUUID, nodeID: number, reply: (p1: Date) => void): void;

	deviceControllerNodeIDGetEstimatedSubscriptionLatencyWithReply(controller: NSUUID, nodeID: number, reply: (p1: number) => void): void;

	deviceControllerNodeIDGetStateWithReply(controller: NSUUID, nodeID: number, reply: (p1: MTRDeviceState) => void): void;

	deviceControllerNodeIDInvokeCommandWithEndpointIDClusterIDCommandIDCommandFieldsExpectedValuesExpectedValueIntervalTimedInvokeTimeoutServerSideProcessingTimeoutCompletion(controller: NSUUID, nodeID: number, endpointID: number, clusterID: number, commandID: number, commandFields: any, expectedValues: NSArray<NSDictionary<string, any>> | NSDictionary<string, any>[], expectedValueInterval: number, timeout: number, serverSideProcessingTimeout: number, completion: (p1: NSArray<NSDictionary<string, any>>, p2: NSError) => void): void;

	deviceControllerNodeIDOpenCommissioningWindowWithSetupPasscodeDiscriminatorDurationCompletion(controller: NSUUID, nodeID: number, setupPasscode: number, discriminator: number, duration: number, completion: (p1: MTRSetupPayload, p2: NSError) => void): void;

	deviceControllerNodeIDReadAttributePathsWithReply(controller: NSUUID, nodeID: number, attributePaths: NSArray<MTRAttributeRequestPath> | MTRAttributeRequestPath[], reply: (p1: NSArray<NSDictionary<string, any>>) => void): void;

	deviceControllerNodeIDReadAttributeWithEndpointIDClusterIDAttributeIDParamsWithReply(controller: NSUUID, nodeID: number, endpointID: number, clusterID: number, attributeID: number, params: MTRReadParams, reply: (p1: NSDictionary<string, any>) => void): void;

	deviceControllerNodeIDWriteAttributeWithEndpointIDClusterIDAttributeIDValueExpectedValueIntervalTimedWriteTimeout(controller: NSUUID, nodeID: number, endpointID: number, clusterID: number, attributeID: number, value: any, expectedValueInterval: number, timeout: number): void;

	downloadLogOfTypeNodeIDTimeoutCompletion(type: MTRDiagnosticLogType, nodeID: number, timeout: number, completion: (p1: NSURL, p2: NSError) => void): void;
}
declare var MTRXPCServerProtocol_MTRDevice: {

	prototype: MTRXPCServerProtocol_MTRDevice;
};

/**
 * @since 18.2
 */
interface MTRXPCServerProtocol_MTRDeviceController extends NSObjectProtocol {

	deviceControllerControllerNodeIDWithReply?(controller: NSUUID, reply: (p1: number) => void): void;

	deviceControllerGetIsRunningWithReply?(controller: NSUUID, reply: (p1: boolean) => void): void;

	deviceControllerGetUniqueIdentifierWithReply?(controller: NSUUID, reply: (p1: NSUUID) => void): void;

	deviceControllerRegisterNodeID?(controller: NSUUID, nodeID: number): void;

	deviceControllerUnregisterNodeID?(controller: NSUUID, nodeID: number): void;
}
declare var MTRXPCServerProtocol_MTRDeviceController: {

	prototype: MTRXPCServerProtocol_MTRDeviceController;
};
